DO $$
    declare interval_data text = '1month';
    declare inserted int = 0;
begin
insert into call_center.cc_calls_history (id, direction, destination, parent_id, app_id, from_type, from_name, from_number,
                                          from_id, to_type, to_name, to_number, to_id, payload, domain_id, cause, sip_code,
                                          bridged_id, gateway_id, user_id, queue_id, team_id, agent_id, attempt_id, member_id,
                                          description, tags, answered_at, bridged_at, hangup_at, created_at, hangup_by,
                                          rating, notes, transfer_from, transfer_to, amd_result, amd_duration, grantee_id,
                                          hold, agent_ids, user_ids, queue_ids, gateway_ids, team_ids, params, blind_transfer,
                                          amd_ai_result, amd_ai_logs, amd_ai_positive, hold_sec, duration, stored_at, talk_sec)
select id::uuid,
       direction,
       destination,
       parent_id::uuid,
       app_id,
       from_type,
       from_name,
       from_number,
       from_id,
       to_type,
       to_name,
       to_number,
       to_id,
       payload,
       domain_id,
       cause,
       sip_code,
       bridged_id::uuid,
       gateway_id,
       user_id,
       queue_id,
       team_id,
       agent_id,
       attempt_id,
       member_id,
       description,
       tags,
       answered_at,
       bridged_at,
       hangup_at,
       created_at,
       hangup_by,
       rating,
       notes,
       transfer_from::uuid,
       transfer_to::uuid,
       amd_result,
       amd_duration,
       grantee_id,
       hold,
       agent_ids,
       user_ids,
       queue_ids,
       gateway_ids,
       team_ids,
       params,
       blind_transfer,
       amd_ai_result,
       amd_ai_logs,
       amd_ai_positive,
       hold_sec,
       duration,
       stored_at,
       talk_sec
from call_center.cc_calls_history_old,
     lateral (select coalesce(min(created_at), now()) x
              from call_center.cc_calls_history) st
where created_at >= st.x - interval_data::interval
    and created_at < st.x;

GET DIAGNOSTICS inserted = ROW_COUNT;
raise info '%', inserted;
END$$;
