--
-- PostgreSQL database dump
--

-- Dumped from database version 15.5 (Debian 15.5-0+deb12u1)
-- Dumped by pg_dump version 15.5 (Debian 15.5-0+deb12u1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: timescaledb; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS timescaledb WITH SCHEMA public;


--
-- Name: EXTENSION timescaledb; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION timescaledb IS 'Enables scalable inserts and complex queries for time-series data';


--
-- Name: call_center; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA call_center;


--
-- Name: chat; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA chat;


--
-- Name: contacts; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA contacts;


--
-- Name: directory; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA directory;


--
-- Name: flow; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA flow;


--
-- Name: logger; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA logger;


--
-- Name: storage; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA storage;


--
-- Name: btree_gin; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS btree_gin WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION btree_gin; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION btree_gin IS 'support for indexing common datatypes in GIN';


--
-- Name: cc_sql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS cc_sql WITH SCHEMA call_center;


--
-- Name: EXTENSION cc_sql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION cc_sql IS 'Webitel contact center extension';


--
-- Name: citext; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS citext WITH SCHEMA public;


--
-- Name: EXTENSION citext; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION citext IS 'data type for case-insensitive character strings';


--
-- Name: dblink; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS dblink WITH SCHEMA public;


--
-- Name: EXTENSION dblink; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION dblink IS 'connect to other PostgreSQL databases from within a database';


--
-- Name: intarray; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS intarray WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION intarray; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION intarray IS 'functions, operators, and index support for 1-D arrays of integers';


--
-- Name: pg_trgm; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS pg_trgm WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION pg_trgm; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION pg_trgm IS 'text similarity measurement and index searching based on trigrams';


--
-- Name: pgcrypto; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS pgcrypto WITH SCHEMA public;


--
-- Name: EXTENSION pgcrypto; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION pgcrypto IS 'cryptographic functions';


--
-- Name: tablefunc; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS tablefunc WITH SCHEMA public;


--
-- Name: EXTENSION tablefunc; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION tablefunc IS 'functions that manipulate whole tables, including crosstab';


--
-- Name: uuid-ossp; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS "uuid-ossp" WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION "uuid-ossp"; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION "uuid-ossp" IS 'generate universally unique identifiers (UUIDs)';


--
-- Name: calendar_accept_time; Type: TYPE; Schema: call_center; Owner: -
--

CREATE TYPE call_center.calendar_accept_time AS (
	disabled boolean,
	day smallint,
	start_time_of_day smallint,
	end_time_of_day smallint
);


--
-- Name: calendar_except_date; Type: TYPE; Schema: call_center; Owner: -
--

CREATE TYPE call_center.calendar_except_date AS (
	disabled boolean,
	date bigint,
	name character varying,
	repeat boolean
);


--
-- Name: cc_agent_in_attempt; Type: TYPE; Schema: call_center; Owner: -
--

CREATE TYPE call_center.cc_agent_in_attempt AS (
	attempt_id bigint,
	agent_id bigint
);


--
-- Name: cc_communication_type_l; Type: TYPE; Schema: call_center; Owner: -
--

CREATE TYPE call_center.cc_communication_type_l AS (
	type_id integer,
	l interval[]
);


--
-- Name: cc_member_destination_view; Type: TYPE; Schema: call_center; Owner: -
--

CREATE TYPE call_center.cc_member_destination_view AS (
	id smallint,
	destination character varying,
	resource jsonb,
	type jsonb,
	priority integer,
	state smallint,
	description character varying,
	last_activity_at bigint,
	attempts integer,
	last_cause character varying,
	display character varying
);


--
-- Name: calendar_accept_time; Type: TYPE; Schema: flow; Owner: -
--

CREATE TYPE flow.calendar_accept_time AS (
	disabled boolean,
	day smallint,
	start_time_of_day smallint,
	end_time_of_day smallint
);


--
-- Name: calendar_except_date; Type: TYPE; Schema: flow; Owner: -
--

CREATE TYPE flow.calendar_except_date AS (
	disabled boolean,
	date bigint,
	name character varying,
	repeat boolean
);


--
-- Name: appointment_widget(character varying); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.appointment_widget(_uri character varying) RETURNS TABLE(profile jsonb, list jsonb)
    LANGUAGE sql ROWS 1
    AS $$
with profile as (
        select
           (config['queue']->>'id')::int as queue_id,
           (config['communicationType']->>'id')::int as communication_type,
           (config->>'duration')::interval as duration,
           (config->>'days')::int as days,
           (config->>'availableAgents')::int as available_agents,
           string_to_array((b.metadata->>'allow_origin'), ',') as allow_origins,
           q.calendar_id,
           b.id,
           b.uri,
           b.dc as domain_id,
           c.timezone_id,
           tz.sys_name as timezone
        from chat.bot b
            inner join lateral (select (b.metadata->>'appointment')::jsonb as config) as cfx on true
            inner join call_center.cc_queue q on q.id = (config['queue']->>'id')::int
            inner join flow.calendar c on c.id = q.calendar_id
            inner join flow.calendar_timezones tz on tz.id = c.timezone_id
        where b.uri = _uri and b.enabled
        limit 1
    ), d as materialized (
        select  q.queue_id,
                q.duration,
                q.available_agents,
                q.timezone,
                x,
               (extract(isodow from x::timestamp)  ) - 1 as day,
               dy.*,
               min(dy.ss::time) over () mins,
               max(dy.se::time) over () maxe
        from profile  q ,
            flow.calendar_day_range(q.calendar_id, least(q.days, 7)) x
            left join lateral (
                select t.*, tz.sys_name, c.excepts
                from flow.calendar c
                    inner join flow.calendar_timezones tz on tz.id = c.timezone_id
                    inner join lateral unnest(c.accepts::flow.calendar_accept_time[]) t on true
                where c.id = q.calendar_id
                    and not t.disabled
                order by 1 asc
        ) y on y.day = (extract(isodow from x)  ) - 1
        left join lateral (
            select (x + (y.start_time_of_day || 'm')::interval)::timestamp as ss,
                case when date_bin(q.duration, (x + (y.end_time_of_day || 'm')::interval)::timestamp, x::timestamp) < (x + (y.end_time_of_day || 'm')::interval)::timestamp
                    then date_bin(q.duration, (x + (y.end_time_of_day || 'm')::interval)::timestamp, x::timestamp) - q.duration
                    else date_bin(q.duration, (x + (y.end_time_of_day || 'm')::interval)::timestamp, x::timestamp) - q.duration end as se
        ) dy on true
    )
    , min_max as materialized (
        select
            queue_id,
            x,
            duration,
            min(ss)  min_ss,
            max(se)  max_se
        from d
        group by 1, 2, 3
    )
    ,res as materialized (
        select
        mem.*
        from min_max
            left join lateral (
                select
                    date_bin(min_max.duration, coalesce(ready_at, created_at), coalesce(ready_at, created_at)::date)::timestamp d,
                    count(*) cnt
                from call_center.cc_member m
                where m.stop_at isnull
                    and m.queue_id = min_max.queue_id
                    and coalesce(ready_at, created_at) between min_max.min_ss and min_max.max_se
                group by 1
            ) mem on true
        where mem notnull
    )
    , list as (
        select
            d.*,
            res.*,
            xx,
            case when xx < now() at time zone d.timezone or coalesce(res.cnt, 0) >= d.available_agents or xx < d.ss or xx > d.se then true
                else false end as reserved
        from d
            left join generate_series((d.x || ' ' || d.mins)::timestamp, (d.x || ' ' || d.maxe)::timestamp, d.duration) xx on true
            left join res on res.d = xx
        limit 10080
    )
    , ranges AS (
        select
            to_char(list.x::date,'YYYY-MM-DD')::text as date,
            jsonb_agg(jsonb_build_object('time', to_char(list.xx::time, 'HH24:MI'), 'reserved', list.reserved) order by list.x, list.xx) as times
        from list
        group by 1
    )
    select
        row_to_json(p) as profile,
        jsonb_agg(row_to_json(r)) as list
    from profile p
        left join lateral (
            select *
            from ranges
        ) r on true
    group by p
$$;


--
-- Name: cc_agent_init_channel(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_agent_init_channel() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
        insert into call_center.cc_agent_channel (agent_id, channel, state)
        select new.id, c, 'waiting'
        from unnest('{chat,call,task}'::text[]) c;
        RETURN NEW;
    END;
$$;


--
-- Name: cc_agent_set_channel_waiting(integer, character varying); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_agent_set_channel_waiting(agent_id_ integer, channel_ character varying) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare attempt_id_ int8;
        state_ varchar;
        joined_at_ timestamptz;
begin
    select a.id, a.state
    into attempt_id_, state_
    from call_center.cc_member_attempt a
    where a.agent_id = agent_id_ and a.state != 'leaving' and a.channel = channel_;

    if attempt_id_ notnull then
        raise exception 'agent % has task % in the status of %', agent_id_, attempt_id_, state_;
    end if;

    update call_center.cc_agent_channel c
    set state = 'waiting',
        joined_at = now(),
        queue_id = null,
        attempt_id = null,
        timeout = null
    where c.agent_id = agent_id_ and c.state in ('wrap_time', 'missed') and c.channel = channel_
    returning joined_at into joined_at_;

    return row(joined_at_);
end;
$$;


--
-- Name: cc_agent_set_login(integer, boolean); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_agent_set_login(agent_id_ integer, on_demand_ boolean DEFAULT false) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    res_ jsonb;
    user_id_
         int8;
begin
    update call_center.cc_agent
    set status            = 'online', -- enum added
        status_payload    = null,
        on_demand         = on_demand_,
--         updated_at = case when on_demand != on_demand_ then cc_view_timestamp(now()) else updated_at end,
        last_state_change = now()     -- todo rename to status
    where call_center.cc_agent.id = agent_id_
    returning user_id into user_id_;

    if
        NOT (exists(select 1
                    from directory.wbt_user_presence p
                    where user_id = user_id_
                      and open > 0
                      and status in ('sip', 'web'))
            or exists(SELECT 1
                      FROM directory.wbt_session s
                      WHERE ((user_id IS NOT NULL) AND (NULLIF((props ->> 'pn-rpid'::text), ''::text) IS NOT NULL))
                        and s.user_id = user_id_::int8
                        and s.access notnull
                        AND s.expires > now() at time zone 'UTC')) then
        raise exception 'not found: sip, web or pn';
    end if;

    with chls as (
        update call_center.cc_agent_channel c
            set state = case when x.x = 1 then c.state else 'waiting' end,
                online = true,
                no_answers = 0,
                timeout = case when x.x = 1 then c.timeout else null end
            from call_center.cc_agent_channel c2
                left join LATERAL (
                    select a.channel, 1 x
                    from call_center.cc_member_attempt a
                    where a.agent_id = agent_id_
                      and a.channel = c2.channel
                    limit 1
                    ) x
                on true
            where c2.agent_id = agent_id_
                and (c.agent_id, c.channel) = (c2.agent_id, c2.channel)
            returning jsonb_build_object('channel'
                , c.channel
                , 'joined_at'
                , call_center.cc_view_timestamp(c.joined_at)
                , 'state'
                , c.state
                , 'no_answers'
                , c.no_answers) xx
    )
    select jsonb_agg(chls.xx)
    from chls
    into res_;

    return row (res_::jsonb, call_center.cc_view_timestamp(now()));
end;
$$;


--
-- Name: cc_arr_type_to_jsonb(anyarray); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_arr_type_to_jsonb(anyarray) RETURNS jsonb
    LANGUAGE sql IMMUTABLE
    AS $_$
select jsonb_agg(row_to_json(a))
    from unnest($1) a;
$_$;


--
-- Name: cc_array_merge(anyarray, anyarray); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_array_merge(arr1 anyarray, arr2 anyarray) RETURNS anyarray
    LANGUAGE sql IMMUTABLE
    AS $$
select array_agg(distinct elem order by elem)
    from (
        select unnest(arr1) elem
        union
        select unnest(arr2)
    ) s
$$;


--
-- Name: cc_attempt_abandoned(bigint, integer, integer, jsonb, boolean, boolean, boolean, character varying, integer, boolean); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_abandoned(attempt_id_ bigint, _max_count integer DEFAULT 0, _next_after integer DEFAULT 0, vars_ jsonb DEFAULT NULL::jsonb, _per_number boolean DEFAULT false, exclude_dest boolean DEFAULT false, redial boolean DEFAULT false, _description character varying DEFAULT NULL::character varying, _sticky_agent_id integer DEFAULT NULL::integer, _display boolean DEFAULT false) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    attempt  call_center.cc_member_attempt%rowtype;
    member_stop_cause varchar;
begin
    update call_center.cc_member_attempt
        set leaving_at = now(),
            last_state_change = now(),
            result = case when offering_at isnull and resource_id notnull then 'failed' else 'abandoned' end,
            state = 'leaving',
            description = case when _description notnull then _description else description end
    where id = attempt_id_
    returning * into attempt;

    if attempt.member_id notnull then
        update call_center.cc_member
        set last_hangup_at  = (extract(EPOCH from now() ) * 1000)::int8,
            last_agent      = coalesce(attempt.agent_id, last_agent),
            stop_at = case when (stop_cause notnull or
                                 case when _per_number is true then (attempt.waiting_other_numbers > 0 or (_max_count > 0 and coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < _max_count)) else (_max_count > 0 and (attempts + 1 < _max_count)) end
                                 )  then stop_at else  attempt.leaving_at end,
            stop_cause = case when (stop_cause notnull or
                                 case when _per_number is true then (attempt.waiting_other_numbers > 0 or (_max_count > 0 and coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < _max_count)) else (_max_count > 0 and (attempts + 1 < _max_count)) end
                                 ) then stop_cause else attempt.result end,
            ready_at = now() + (_next_after || ' sec')::interval,
            communications =  jsonb_set(communications, (array[attempt.communication_idx::int])::text[], communications->(attempt.communication_idx::int) ||
                jsonb_build_object('last_activity_at', (case when redial is true then 0 else extract(epoch  from attempt.leaving_at) * 1000 end )::int8::text::jsonb) ||
                jsonb_build_object('attempt_id', attempt_id_) ||
                jsonb_build_object('attempts', coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1) ||
                case when exclude_dest or (_per_number is true and coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 >= _max_count) then jsonb_build_object('stop_at', (extract(EPOCH from now() ) * 1000)::int8) else '{}'::jsonb end
            ),
            variables = case when vars_ notnull then coalesce(variables::jsonb, '{}') || vars_ else variables end,
            attempts        = attempts + 1,                     --TODO
            agent_id = case when _sticky_agent_id notnull then _sticky_agent_id else agent_id end
        where id = attempt.member_id
        returning stop_cause into member_stop_cause;
    end if;


    return row(attempt.last_state_change::timestamptz, member_stop_cause::varchar, attempt.result::varchar);
end;
$$;


--
-- Name: cc_attempt_agent_cancel(bigint, character varying, character varying, integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_agent_cancel(attempt_id_ bigint, result_ character varying, agent_status_ character varying, agent_hold_sec_ integer) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    attempt call_center.cc_member_attempt%rowtype;
    no_answers_ int4;
begin
    update call_center.cc_member_attempt
        set leaving_at = now(),
            result = result_,
            state = 'leaving'
    where id = attempt_id_
    returning * into attempt;

    if attempt.agent_id notnull then
        update call_center.cc_agent_channel c
        set state = agent_status_,
            joined_at = attempt.leaving_at,
            no_answers = no_answers + 1,
            timeout = case when agent_hold_sec_ > 0 then (now() + (agent_hold_sec_::varchar || ' sec')::interval) else null end
        where c.agent_id = attempt.agent_id and c.channel = attempt.channel
        returning no_answers into no_answers_;

    end if;

    return row(attempt.leaving_at, no_answers_);
end;
$$;


--
-- Name: cc_attempt_bridged(bigint); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_bridged(attempt_id_ bigint) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    attempt call_center.cc_member_attempt%rowtype;
begin

    update call_center.cc_member_attempt
    set state = 'bridged',
        bridged_at = now(),
        last_state_change = now()
    where id = attempt_id_
    returning * into attempt;


    if attempt.agent_id notnull then
        update call_center.cc_agent_channel ch
        set state = attempt.state,
            no_answers = 0,
            joined_at = attempt.bridged_at,
            last_bridged_at = now()
        where  ch.agent_id = attempt.agent_id and ch.channel = attempt.channel;
    end if;

    return row(attempt.last_state_change::timestamptz);
end;
$$;


--
-- Name: cc_attempt_distribute_cancel(bigint, character varying, integer, boolean, jsonb); Type: PROCEDURE; Schema: call_center; Owner: -
--

CREATE PROCEDURE call_center.cc_attempt_distribute_cancel(IN attempt_id_ bigint, IN description_ character varying, IN next_distribute_sec_ integer, IN stop_ boolean, IN vars_ jsonb)
    LANGUAGE plpgsql
    AS $$
declare
    attempt  call_center.cc_member_attempt%rowtype;
begin
    update call_center.cc_member_attempt
        set leaving_at = now(),
            description = description_,
            last_state_change = now(),
            result = 'cancel', --TODO
            state = 'leaving'
    where id = attempt_id_
    returning * into attempt;

    update call_center.cc_member
    set last_hangup_at  = (extract(EPOCH from now() ) * 1000)::int8,
        last_agent      = coalesce(attempt.agent_id, last_agent),
        variables = case when vars_ notnull  then coalesce(variables, '{}'::jsonb) || vars_ else variables end,
        ready_at = case when next_distribute_sec_ > 0 then now() + (next_distribute_sec_::text || ' sec')::interval else now() end,
        stop_at = case when stop_ is true and stop_at isnull then attempt.leaving_at else stop_at end,
        stop_cause = case when stop_ is true and stop_cause isnull then attempt.result else stop_cause end
    where id = attempt.member_id;

end;
$$;


--
-- Name: cc_attempt_end_reporting(bigint, character varying, character varying, timestamp with time zone, timestamp with time zone, integer, jsonb, integer, integer, boolean, boolean); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_end_reporting(attempt_id_ bigint, status_ character varying, description_ character varying DEFAULT NULL::character varying, expire_at_ timestamp with time zone DEFAULT NULL::timestamp with time zone, next_offering_at_ timestamp with time zone DEFAULT NULL::timestamp with time zone, sticky_agent_id_ integer DEFAULT NULL::integer, variables_ jsonb DEFAULT NULL::jsonb, max_attempts_ integer DEFAULT 0, wait_between_retries_ integer DEFAULT 60, exclude_dest boolean DEFAULT NULL::boolean, _per_number boolean DEFAULT false) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    attempt call_center.cc_member_attempt%rowtype;
    agent_timeout_ timestamptz;
    time_ int8 = extract(EPOCH  from now()) * 1000;
    user_id_ int8 = null;
    domain_id_ int8;
    wrap_time_ int;
    other_cnt_ int;
    stop_cause_ varchar;
    agent_channel_ varchar;
begin

    if next_offering_at_ notnull and not attempt.result in ('success', 'cancel') and next_offering_at_ < now() then
        -- todo move to application
        raise exception 'bad parameter: next distribute at';
    end if;


    update call_center.cc_member_attempt
    set state  =  'leaving',
        reporting_at = now(),
        leaving_at = case when leaving_at isnull then now() else leaving_at end,
        result = status_,
        description = description_
    where id = attempt_id_ and state != 'leaving'
    returning * into attempt;

    if attempt.id isnull then
        return null;
--         raise exception  'not found %', attempt_id_;
    end if;

    if attempt.member_id notnull then
        update call_center.cc_member m
        set last_hangup_at  = time_,
            variables = case when variables_ notnull then coalesce(m.variables::jsonb, '{}') || variables_ else m.variables end,
            expire_at = case when expire_at_ isnull then m.expire_at else expire_at_ end,
            agent_id = case when sticky_agent_id_ isnull then m.agent_id else sticky_agent_id_ end,

            stop_at = case when next_offering_at_ notnull or
                                m.stop_at notnull or
                                (not attempt.result in ('success', 'cancel') and
                                 case when _per_number is true then (attempt.waiting_other_numbers > 0 or (max_attempts_ > 0 and coalesce((m.communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < max_attempts_)) else (max_attempts_ > 0 and (m.attempts + 1 < max_attempts_)) end
                                    )
                               then m.stop_at else  attempt.leaving_at end,
            stop_cause = case when next_offering_at_ notnull or
                                   m.stop_at notnull or
                                   (not attempt.result in ('success', 'cancel') and
                                    case when _per_number is true then (attempt.waiting_other_numbers > 0 or (max_attempts_ > 0 and coalesce((m.communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < max_attempts_)) else (max_attempts_ > 0 and (m.attempts + 1 < max_attempts_)) end
                                       )
                                  then m.stop_cause else  attempt.result end,

            ready_at = case when next_offering_at_ notnull then next_offering_at_ at time zone tz.names[1]
                            else now() + (wait_between_retries_ || ' sec')::interval end,

            last_agent      = coalesce(attempt.agent_id, m.last_agent),
            communications =  jsonb_set(m.communications, (array[attempt.communication_idx::int])::text[], m.communications->(attempt.communication_idx::int) ||
                                                                                                           jsonb_build_object('last_activity_at', case when next_offering_at_ notnull then '0'::text::jsonb else time_::text::jsonb end) ||
                                                                                                           jsonb_build_object('attempt_id', attempt_id_) ||
                                                                                                           jsonb_build_object('attempts', coalesce((m.communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1) ||
                                                                                                           case when exclude_dest or
                                                                                                                     (_per_number is true and coalesce((m.communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 >= max_attempts_) then jsonb_build_object('stop_at', time_) else '{}'::jsonb end
                ),
            attempts        = m.attempts + 1                     --TODO
        from call_center.cc_member m2
                 left join flow.calendar_timezone_offsets tz on tz.id = m2.sys_offset_id
        where m.id = attempt.member_id and m.id = m2.id
        returning m.stop_cause into stop_cause_;
    end if;

    if attempt.agent_id notnull then
        select a.user_id, a.domain_id, case when a.on_demand then null else coalesce(tm.wrap_up_time, 0) end,
               case when attempt.channel = 'chat' then (select count(1)
                                                        from call_center.cc_member_attempt aa
                                                        where aa.agent_id = attempt.agent_id and aa.id != attempt.id and aa.state != 'leaving') else 0 end as other
        into user_id_, domain_id_, wrap_time_, other_cnt_
        from call_center.cc_agent a
                 left join call_center.cc_team tm on tm.id = attempt.team_id
        where a.id = attempt.agent_id;

        if other_cnt_ > 0 then
            update call_center.cc_agent_channel c
            set last_bucket_id = coalesce(attempt.bucket_id, last_bucket_id)
            where (c.agent_id, c.channel) = (attempt.agent_id, attempt.channel)
            returning null, channel into agent_timeout_, agent_channel_;
        elseif wrap_time_ > 0 or wrap_time_ isnull then
            update call_center.cc_agent_channel c
            set state = 'wrap_time',
                joined_at = now(),
                timeout = case when wrap_time_ > 0 then now() + (wrap_time_ || ' sec')::interval end,
                last_bucket_id = coalesce(attempt.bucket_id, last_bucket_id)
            where (c.agent_id, c.channel) = (attempt.agent_id, attempt.channel)
            returning timeout, channel into agent_timeout_, agent_channel_;
        else
            update call_center.cc_agent_channel c
            set state = 'waiting',
                joined_at = now(),
                timeout = null,
                last_bucket_id = coalesce(attempt.bucket_id, last_bucket_id),
                queue_id = null
            where (c.agent_id, c.channel) = (attempt.agent_id, attempt.channel)
            returning timeout, channel into agent_timeout_, agent_channel_;
        end if;
    end if;

    return row(call_center.cc_view_timestamp(now()),
        attempt.channel,
        attempt.queue_id,
        attempt.agent_call_id,
        attempt.agent_id,
        user_id_,
        domain_id_,
        call_center.cc_view_timestamp(agent_timeout_),
        stop_cause_,
        attempt.member_id
        );
end;
$$;


--
-- Name: cc_attempt_flip_next_resource(bigint, integer[]); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_flip_next_resource(attempt_id_ bigint, skip_resources integer[]) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare destination_ varchar;
        type_id_ int4;
        queue_id_ int4;
        cur_res_id_ int4;

        resource_id_ int4;
        resource_updated_at_ int8;
        gateway_updated_at_ int8;
        allow_call_ bool;
        call_id_ varchar;
begin
    select a.destination->>'destination', (a.destination->'type'->>'id')::int, a.queue_id, a.resource_id
    from call_center.cc_member_attempt a
    where a.id = attempt_id_
    into destination_, type_id_, queue_id_, cur_res_id_;

    with r as (
        select r.id,
               r.updated_at                                 as resource_updated_at,
               call_center.cc_view_timestamp(gw.updated_at) as gateway_updated_at,
               r."limit" - coalesce(used.cnt, 0) > 0 as allow_call
        from call_center.cc_queue_resource qr
                 inner join call_center.cc_outbound_resource_group rq on rq.id = qr.resource_group_id
                 inner join call_center.cc_outbound_resource_in_group rig on rig.group_id = rq.id
                 inner join call_center.cc_outbound_resource r on r.id = rig.resource_id
                 inner join directory.sip_gateway gw on gw.id = r.gateway_id
                 LEFT JOIN LATERAL ( SELECT count(*) AS cnt
                                     FROM (SELECT 1 AS cnt
                                           FROM call_center.cc_member_attempt c_1
                                           WHERE c_1.resource_id = r.id
                                             AND (c_1.state::text <> ALL
                                                  (ARRAY ['leaving'::character varying::text, 'processing'::character varying::text]))) c) used on true
        where qr.queue_id = queue_id_
          and rq.communication_id = type_id_
          and (array_length(coalesce(r.patterns::text[], '{}'), 1) isnull or exists(select 1 from unnest(r.patterns::text[]) pts
                                                                                    where destination_ similar to regexp_replace(regexp_replace(pts, 'x|X', '_', 'gi'), '\+', '\+', 'gi')))
          and r.enabled
          and not r.id = any(call_center.cc_array_merge(array[cur_res_id_::int], skip_resources))
        order by r."limit" - coalesce(used.cnt, 0) > 0 desc nulls last, rig.priority desc
        limit 1
    )
    update call_center.cc_member_attempt a
    set resource_id = r.id,
        member_call_id = uuid_generate_v4()
    from r
    where a.id = attempt_id_
    returning r.id, r.resource_updated_at, r.gateway_updated_at, r.allow_call, a.member_call_id
        into resource_id_, resource_updated_at_, gateway_updated_at_, allow_call_, call_id_;

    return row(resource_id_, resource_updated_at_, gateway_updated_at_, allow_call_, call_id_);
end
$$;


--
-- Name: cc_attempt_leaving(bigint, character varying, character varying, integer, jsonb, integer, integer, boolean, character varying, integer, boolean); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_leaving(attempt_id_ bigint, result_ character varying, agent_status_ character varying, agent_hold_sec_ integer, vars_ jsonb DEFAULT NULL::jsonb, max_attempts_ integer DEFAULT 0, wait_between_retries_ integer DEFAULT 60, per_number_ boolean DEFAULT false, _description character varying DEFAULT NULL::character varying, _sticky_agent_id integer DEFAULT NULL::integer, _display boolean DEFAULT false) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    attempt call_center.cc_member_attempt%rowtype;
    no_answers_ int;
    member_stop_cause varchar;
begin
    /*
     FIXME
     */
    update call_center.cc_member_attempt
    set leaving_at = now(),
        result = result_,
        state = 'leaving',
        description = case when _description notnull then _description else description end
    where id = attempt_id_
    returning * into attempt;

    if attempt.member_id notnull then
        update call_center.cc_member m
        set last_hangup_at  = extract(EPOCH from now())::int8 * 1000,
            last_agent      = coalesce(attempt.agent_id, last_agent),

            stop_at = case when stop_at notnull or
                                (not attempt.result in ('success', 'cancel') and
                                 case when per_number_ is true then (attempt.waiting_other_numbers > 0 or (max_attempts_ > 0 and coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < max_attempts_)) else (max_attempts_ > 0 and (attempts + 1 < max_attempts_)) end
                                    )
                               then stop_at else  attempt.leaving_at end,
            stop_cause = case when stop_at notnull or
                                   (not attempt.result in ('success', 'cancel') and
                                    case when per_number_ is true then (attempt.waiting_other_numbers > 0 or (max_attempts_ > 0 and coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < max_attempts_)) else (max_attempts_ > 0 and (attempts + 1 < max_attempts_)) end
                                       )
                                  then stop_cause else  attempt.result end,

            ready_at = now() + (coalesce(wait_between_retries_, 0) || ' sec')::interval,

            communications =  jsonb_set(communications, (array[attempt.communication_idx::int])::text[], communications->(attempt.communication_idx::int) ||
                                                                                                         jsonb_build_object('last_activity_at', (extract(epoch  from attempt.leaving_at) * 1000)::int8::text::jsonb) ||
                                                                                                         jsonb_build_object('attempt_id', attempt_id_) ||
                                                                                                         jsonb_build_object('attempts', coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1) ||
                                                                                                         case when (per_number_ is true and coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 >= max_attempts_) then jsonb_build_object('stop_at', (extract(EPOCH from now() ) * 1000)::int8) else '{}'::jsonb end
                ),
            attempts        = attempts + 1,
            variables = case when vars_ notnull then coalesce(variables::jsonb, '{}') || vars_ else variables end,
            agent_id = case when _sticky_agent_id notnull then _sticky_agent_id else agent_id end
        where id = attempt.member_id
        returning stop_cause into member_stop_cause;
    end if;

    if attempt.agent_id notnull then
        update call_center.cc_agent_channel c
        set state = case when agent_hold_sec_ > 0 then 'wrap_time' else 'waiting' end,
            joined_at = now(),
            no_answers = case when attempt.bridged_at notnull then 0 else no_answers + 1 end,
            timeout = case when agent_hold_sec_ > 0 then (now() + (agent_hold_sec_::varchar || ' sec')::interval) else null end
        where c.agent_id = attempt.agent_id and c.channel = attempt.channel
        returning no_answers into no_answers_;

    end if;

    return row(attempt.leaving_at, no_answers_, member_stop_cause);
end;
$$;


--
-- Name: cc_attempt_missed_agent(bigint, integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_missed_agent(attempt_id_ bigint, agent_hold_ integer) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    last_state_change_ timestamptz;
    channel_ varchar;
    agent_id_ int4;
    no_answers_ int4;
begin
    update call_center.cc_member_attempt  n
    set state = 'wait_agent',
        last_state_change = now(),
        agent_id = null ,
        team_id = null,
        agent_call_id = null
    from call_center.cc_member_attempt a
    where a.id = n.id and a.id = attempt_id_
    returning n.last_state_change, a.agent_id, n.channel into last_state_change_, agent_id_, channel_;

    if agent_id_ notnull then
        update call_center.cc_agent_channel c
        set state = 'missed',
            joined_at = last_state_change_,
            timeout  = now() + (agent_hold_::varchar || ' sec')::interval,
            no_answers = (no_answers + 1),
            last_missed_at = now()
        where c.agent_id = agent_id_ and c.channel = channel_
        returning no_answers into no_answers_;
    end if;

    return row(last_state_change_, no_answers_);
end;
$$;


--
-- Name: cc_attempt_offering(bigint, integer, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_offering(attempt_id_ bigint, agent_id_ integer, agent_call_id_ character varying, member_call_id_ character varying, dest_ character varying, displ_ character varying) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    attempt call_center.cc_member_attempt%rowtype;
begin

    update call_center.cc_member_attempt
    set state             = 'offering',
        last_state_change = now(),
--         destination = dest_,
        display = displ_,
        offering_at       = now(),
        agent_id          = case when agent_id isnull and agent_id_::int notnull then agent_id_ else agent_id end,
        agent_call_id     = case
                                when agent_call_id isnull and agent_call_id_::varchar notnull then agent_call_id_
                                else agent_call_id end,
        -- todo for queue preview
        member_call_id    = case
                                when member_call_id isnull and member_call_id_ notnull then member_call_id_
                                else member_call_id end
    where id = attempt_id_
    returning * into attempt;


    if attempt.agent_id notnull then
        update call_center.cc_agent_channel ch
        set state            = 'offering',
            joined_at        = now(),
            last_offering_at = now(),
            queue_id         = attempt.queue_id,
            attempt_id         = case when attempt.channel = 'call' then attempt.id else null end,
            last_bucket_id   = coalesce(attempt.bucket_id, last_bucket_id)
        where (ch.agent_id, ch.channel) = (attempt.agent_id, attempt.channel);
    end if;

    return row (attempt.last_state_change::timestamptz);
end;
$$;


--
-- Name: cc_attempt_schema_result(bigint, character varying, character varying, timestamp with time zone, timestamp with time zone, integer, jsonb, integer, integer, boolean, boolean); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_schema_result(attempt_id_ bigint, status_ character varying, description_ character varying DEFAULT NULL::character varying, expire_at_ timestamp with time zone DEFAULT NULL::timestamp with time zone, next_offering_at_ timestamp with time zone DEFAULT NULL::timestamp with time zone, sticky_agent_id_ integer DEFAULT NULL::integer, variables_ jsonb DEFAULT NULL::jsonb, max_attempts_ integer DEFAULT 0, wait_between_retries_ integer DEFAULT 60, exclude_dest boolean DEFAULT NULL::boolean, _per_number boolean DEFAULT false) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    attempt  call_center.cc_member_attempt%rowtype;
    stop_cause_ varchar;
    time_ int8 = extract(EPOCH  from now()) * 1000;
begin
    update call_center.cc_member_attempt
        set result = case when status_ notnull then status_ else result end,
            description = case when description_ notnull then description_ else description end,
            schema_processing = false
    where id = attempt_id_
    returning * into attempt;

    if attempt.member_id notnull then
        update call_center.cc_member m
        set last_hangup_at  = time_,
            variables = case when variables_ notnull then coalesce(m.variables::jsonb, '{}') || variables_ else m.variables end,
            expire_at = case when expire_at_ isnull then m.expire_at else expire_at_ end,
            agent_id = case when sticky_agent_id_ isnull then m.agent_id else sticky_agent_id_ end,

            stop_at = case when next_offering_at_ notnull or
                                m.stop_at notnull or
                                (not attempt.result in ('success', 'cancel') and
                                 case when _per_number is true then (attempt.waiting_other_numbers > 0 or (max_attempts_ > 0 and coalesce((m.communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < max_attempts_)) else (max_attempts_ > 0 and (m.attempts + 1 < max_attempts_)) end
                                 )
                then m.stop_at else  attempt.leaving_at end,
            stop_cause = case when next_offering_at_ notnull or
                                m.stop_at notnull or
                                (not attempt.result in ('success', 'cancel') and
                                   case when _per_number is true then (attempt.waiting_other_numbers > 0 or (max_attempts_ > 0 and coalesce((m.communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < max_attempts_)) else (max_attempts_ > 0 and (m.attempts + 1 < max_attempts_)) end
                                 )
                then m.stop_cause else  attempt.result end,

            ready_at = case when next_offering_at_ notnull then next_offering_at_ at time zone tz.names[1]
                else now() + (wait_between_retries_ || ' sec')::interval end,

            last_agent      = coalesce(attempt.agent_id, m.last_agent),
            communications =  jsonb_set(m.communications, (array[attempt.communication_idx::int])::text[], m.communications->(attempt.communication_idx::int) ||
                jsonb_build_object('last_activity_at', case when next_offering_at_ notnull then '0'::text::jsonb else time_::text::jsonb end) ||
                jsonb_build_object('attempt_id', attempt_id_) ||
                jsonb_build_object('attempts', coalesce((m.communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1) ||
                case when exclude_dest or
                          (_per_number is true and coalesce((m.communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 >= max_attempts_) then jsonb_build_object('stop_at', time_) else '{}'::jsonb end
            ),
            attempts        = m.attempts + 1                     --TODO
        from call_center.cc_member m2
            left join flow.calendar_timezone_offsets tz on tz.id = m2.sys_offset_id
        where m.id = attempt.member_id and m.id = m2.id
        returning m.stop_cause into stop_cause_;
    end if;


    return row(attempt.last_state_change::timestamptz, stop_cause_::varchar, attempt.result::varchar);
end;
$$;


--
-- Name: cc_attempt_timeout(bigint, character varying, integer, integer, boolean, boolean); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_timeout(attempt_id_ bigint, agent_status_ character varying, agent_hold_sec_ integer, max_attempts_ integer DEFAULT 0, per_number_ boolean DEFAULT false, do_leaving_ boolean DEFAULT false) RETURNS timestamp with time zone
    LANGUAGE plpgsql
    AS $$
declare
    attempt call_center.cc_member_attempt%rowtype;
begin
    update call_center.cc_member_attempt
        set reporting_at = now(),
            result = 'timeout',
            state = 'leaving',
            schema_processing = do_leaving_
    where id = attempt_id_
    returning * into attempt;

    if not do_leaving_  is true then
        update call_center.cc_member
        set last_hangup_at  = extract(EPOCH from now())::int8 * 1000,
            last_agent      = coalesce(attempt.agent_id, last_agent),


                stop_at = case when stop_at notnull or
                                    (not attempt.result in ('success', 'cancel') and
                                     case when per_number_ is true then (attempt.waiting_other_numbers > 0 or (max_attempts_ > 0 and coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < max_attempts_)) else (max_attempts_ > 0 and (attempts + 1 < max_attempts_)) end
                                     )
                    then stop_at else  attempt.leaving_at end,
                stop_cause = case when stop_at notnull or
                                    (not attempt.result in ('success', 'cancel') and
                                       case when per_number_ is true then (attempt.waiting_other_numbers > 0 or (max_attempts_ > 0 and coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 < max_attempts_)) else (max_attempts_ > 0 and (attempts + 1 < max_attempts_)) end
                                     )
                    then stop_cause else  attempt.result end,

            ready_at = now() + (coalesce(q._next_after, 0) || ' sec')::interval,

            communications =  jsonb_set(communications, (array[attempt.communication_idx::int])::text[], communications->(attempt.communication_idx::int) ||
                    jsonb_build_object('last_activity_at', (extract(epoch  from attempt.leaving_at) * 1000)::int8::text::jsonb) ||
                    jsonb_build_object('attempt_id', attempt_id_) ||
                    jsonb_build_object('attempts', coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1) ||
                    case when (per_number_ is true and coalesce((communications#>(format('{%s,attempts}', attempt.communication_idx::int)::text[]))::int, 0) + 1 >= max_attempts_) then jsonb_build_object('stop_at', (extract(EPOCH from now() ) * 1000)::int8) else '{}'::jsonb end
                ),
            attempts        = attempts + 1
        from (
            -- fixme
            select coalesce(cast((q.payload->>'max_attempts') as int), 0) as _max_count, coalesce(cast((q.payload->>'wait_between_retries') as int), 0) as _next_after
            from call_center.cc_queue q
            where q.id = attempt.queue_id
        ) q
        where id = attempt.member_id;
    end if;

    if attempt.agent_id notnull then
        update call_center.cc_agent_channel c
        set state = agent_status_,
            joined_at = now(),
            timeout = case when agent_hold_sec_ > 0 then (now() + (agent_hold_sec_::varchar || ' sec')::interval) else null end
        where c.agent_id = attempt.agent_id and c.channel = attempt.channel;

    end if;

    return now();
end;
$$;


--
-- Name: cc_attempt_transferred_from(bigint, bigint, integer, character varying); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_transferred_from(attempt_id_ bigint, to_attempt_id_ bigint, to_agent_id_ integer, agent_sess_id_ character varying) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    attempt call_center.cc_member_attempt%rowtype;
        user_id_ int8 = null;
    domain_id_ int8;
    wrap_time_ int;
     agent_timeout_ timestamptz;
begin

    update call_center.cc_member_attempt
    set transferred_agent_id = agent_id,
        agent_id = to_agent_id_,
        agent_call_id = agent_sess_id_
    where id = attempt_id_
    returning * into attempt;

    insert into call_center.cc_member_attempt_transferred (from_id, to_id, from_agent_id, to_agent_id)
    values (to_attempt_id_, attempt_id_, attempt.transferred_agent_id, attempt.agent_id);

    if attempt.transferred_agent_id notnull then
        select a.user_id, a.domain_id, case when a.on_demand then null else coalesce(tm.wrap_up_time, 0) end
        into user_id_, domain_id_, wrap_time_
        from call_center.cc_agent a
            left join call_center.cc_team tm on tm.id = attempt.team_id
        where a.id = attempt.transferred_agent_id;

        if wrap_time_ > 0 or wrap_time_ isnull then
            update call_center.cc_agent_channel c
            set state = 'wrap_time',
                joined_at = now(),
                timeout = case when wrap_time_ > 0 then now() + (wrap_time_ || ' sec')::interval end,
                last_bucket_id = coalesce(attempt.bucket_id, last_bucket_id)
            where (c.agent_id, c.channel) = (attempt.transferred_agent_id, attempt.channel)
            returning timeout into agent_timeout_;
        else
            update call_center.cc_agent_channel c
            set state = 'waiting',
                joined_at = now(),
                timeout = null,
                channel = null,
                last_bucket_id = coalesce(attempt.bucket_id, last_bucket_id),
                queue_id = null
            where (c.agent_id, c.channel) = (attempt.transferred_agent_id, attempt.channel)
            returning timeout into agent_timeout_;
        end if;
    end if;


    return row(attempt.last_state_change::timestamptz);
end;
$$;


--
-- Name: cc_attempt_transferred_to(bigint, bigint); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_attempt_transferred_to(attempt_id_ bigint, to_attempt_id_ bigint) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    attempt call_center.cc_member_attempt%rowtype;
begin

    update call_center.cc_member_attempt
    set transferred_attempt_id = to_attempt_id_,
        result = 'transferred',
        leaving_at = now(),
        last_state_change = now(),
        state = 'leaving'
    where id = attempt_id_
    returning * into attempt;

    return row(attempt.last_state_change::timestamptz);
end;
$$;


--
-- Name: cc_call_active_numbers(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_call_active_numbers() RETURNS SETOF character varying
    LANGUAGE plpgsql
    AS $$
declare
        c call_center.cc_calls;
BEGIN

    for c in select *
            from call_center.cc_calls cc where cc.hangup_at isnull and not cc.direction isnull
            and ( (cc.gateway_id notnull and cc.direction = 'outbound') or (cc.gateway_id notnull and cc.direction = 'inbound') )
            for update skip locked
    loop
        if c.gateway_id notnull and c.direction = 'outbound' then
            return next c.to_number;
        elseif c.gateway_id notnull and c.direction = 'inbound' then
            return next c.from_number;
        end if;

    end loop;
    END;
$$;


SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- Name: cc_calls; Type: TABLE; Schema: call_center; Owner: -
--

CREATE UNLOGGED TABLE call_center.cc_calls (
    id uuid NOT NULL,
    direction character varying,
    destination character varying,
    parent_id uuid,
    state character varying NOT NULL,
    app_id character varying NOT NULL,
    from_type character varying,
    from_name character varying,
    from_number character varying,
    from_id character varying,
    to_type character varying,
    to_name character varying,
    to_number character varying,
    to_id character varying,
    payload jsonb,
    domain_id bigint NOT NULL,
    hold_sec integer DEFAULT 0 NOT NULL,
    cause character varying,
    sip_code smallint,
    bridged_id uuid,
    user_id bigint,
    gateway_id bigint,
    queue_id integer,
    agent_id integer,
    team_id integer,
    attempt_id bigint,
    member_id bigint,
    type character varying DEFAULT 'call'::character varying,
    "timestamp" timestamp with time zone,
    answered_at timestamp with time zone,
    bridged_at timestamp with time zone,
    hangup_at timestamp with time zone,
    created_at timestamp with time zone,
    hangup_by character varying,
    transfer_from uuid,
    transfer_to uuid,
    amd_result character varying,
    amd_duration interval,
    tags character varying[],
    region_id integer,
    grantee_id integer,
    hold jsonb,
    params jsonb,
    blind_transfer character varying,
    talk_sec integer DEFAULT 0 NOT NULL,
    amd_ai_result character varying,
    amd_ai_logs character varying[],
    amd_ai_positive boolean,
    contact_id bigint
)
WITH (fillfactor='20', log_autovacuum_min_duration='0', autovacuum_analyze_scale_factor='0.05', autovacuum_enabled='1', autovacuum_vacuum_cost_delay='20', autovacuum_vacuum_threshold='100', autovacuum_vacuum_scale_factor='0.01');


--
-- Name: cc_call_get_owner_leg(call_center.cc_calls); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_call_get_owner_leg(c_ call_center.cc_calls, OUT number_ character varying, OUT name_ character varying, OUT type_ character varying, OUT id_ character varying) RETURNS record
    LANGUAGE plpgsql IMMUTABLE
    AS $$
begin
    if c_.direction = 'inbound' or (c_.direction = 'outbound' and c_.gateway_id notnull ) then
        number_ := c_.to_number;
--         number_ := 'xxxxxx';
        name_ := c_.to_name;
        type_ := c_.to_type;
        id_ := c_.to_id;
    else
        number_ := c_.from_number;
        name_ := c_.from_name;
        type_ := c_.from_type;
        id_ := c_.from_id;

    end if;
end;
$$;


--
-- Name: cc_call_set_bridged(uuid, character varying, timestamp with time zone, character varying, bigint, uuid); Type: PROCEDURE; Schema: call_center; Owner: -
--

CREATE PROCEDURE call_center.cc_call_set_bridged(IN call_id_ uuid, IN state_ character varying, IN timestamp_ timestamp with time zone, IN app_id_ character varying, IN domain_id_ bigint, IN call_bridged_id_ uuid)
    LANGUAGE plpgsql
    AS $$
declare
        transfer_to_ uuid;
        transfer_from_ uuid;
begin
    update call_center.cc_calls cc
    set bridged_id = c.bridged_id,
        state      = state_,
        timestamp  = timestamp_,
        to_number  = case
                         when (cc.direction = 'inbound' and cc.parent_id isnull) or (cc.direction = 'outbound' and cc.gateway_id isnull )
                             then c.number_
                         else to_number end,
        to_name    = case
                         when (cc.direction = 'inbound' and cc.parent_id isnull) or (cc.direction = 'outbound' and cc.gateway_id isnull )
                             then c.name_
                         else to_name end,
        to_type    = case
                         when (cc.direction = 'inbound' and cc.parent_id isnull) or (cc.direction = 'outbound' and cc.gateway_id isnull )
                             then c.type_
                         else to_type end,
        to_id      = case
                         when (cc.direction = 'inbound' and cc.parent_id isnull) or (cc.direction = 'outbound'  and cc.gateway_id isnull )
                             then c.id_
                         else to_id end
    from (
             select b.id,
                    b.bridged_id as transfer_to,
                    b2.id parent_id,
                    b2.id bridged_id,
                    b2o.*
             from call_center.cc_calls b
                      left join call_center.cc_calls b2 on b2.id = call_id_::uuid
                      left join lateral call_center.cc_call_get_owner_leg(b2) b2o on true
             where b.id = call_bridged_id_
         ) c
    where c.id = cc.id
    returning c.transfer_to into transfer_to_;


    update call_center.cc_calls cc
    set bridged_id    = c.bridged_id,
        state         = state_,
        timestamp     = timestamp_,
        parent_id     = case
                            when c.is_leg_a is true and cc.parent_id notnull and cc.parent_id != c.bridged_id then c.bridged_id
                            else cc.parent_id end,
        transfer_from = case
                            when cc.parent_id notnull and cc.parent_id != c.bridged_id then cc.parent_id
                            else cc.transfer_from end,
        transfer_to = transfer_to_,
        to_number     = case
                            when (cc.direction = 'inbound' and cc.parent_id isnull) or (cc.direction = 'outbound')
                                then c.number_
                            else to_number end,
        to_name       = case
                            when (cc.direction = 'inbound' and cc.parent_id isnull) or (cc.direction = 'outbound')
                                then c.name_
                            else to_name end,
        to_type       = case
                            when (cc.direction = 'inbound' and cc.parent_id isnull) or (cc.direction = 'outbound')
                                then c.type_
                            else to_type end,
        to_id         = case
                            when (cc.direction = 'inbound' and cc.parent_id isnull) or (cc.direction = 'outbound')
                                then c.id_
                            else to_id end
    from (
             select b.id,
                    b2.id parent_id,
                    b2.id bridged_id,
                    b.parent_id isnull as is_leg_a,
                    b2o.*
             from call_center.cc_calls b
                      left join call_center.cc_calls b2 on b2.id = call_bridged_id_
                      left join lateral call_center.cc_call_get_owner_leg(b2) b2o on true
             where b.id = call_id_::uuid
         ) c
    where c.id = cc.id
    returning cc.transfer_from into transfer_from_;

    update call_center.cc_calls set
     transfer_from =  case when id = transfer_from_ then transfer_to_ end,
     transfer_to =  case when id = transfer_to_ then transfer_from_ end
    where id in (transfer_from_, transfer_to_);

end;
$$;


--
-- Name: cc_calls_history_drop_partition(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_calls_history_drop_partition() RETURNS void
    LANGUAGE plpgsql
    AS $$
    declare
        r record;
        sql varchar;
begin
        for r in (SELECT table_name
FROM information_schema.tables
WHERE table_schema = 'call_center'
    and table_name ilike 'cc_calls_history_%')
        loop
            sql = format('drop table call_center.%s', r.table_name);
            execute sql;
--             raise notice '%', sql;
        end loop;

end;
$$;


--
-- Name: cc_calls_history_populate_partition(date, date); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_calls_history_populate_partition(from_date date, to_date date) RETURNS void
    LANGUAGE plpgsql
    AS $$
    declare
        r record;
        sql varchar;
begin
        for r in (select x::date::text x1, (x::date + interval '1month')::date x2,
       replace(x::date::text, '-', '_') || '_' || replace((x::date + interval '1month')::date::text, '-', '_') as suff_name
from generate_series(from_date, to_date, interval '1 month') x
where not exists(SELECT table_name
FROM information_schema.tables
WHERE table_schema = 'call_center'
    and table_name = 'cc_calls_history_' || replace(x::date::text, '-', '_') || '_' || replace((x::date + interval '1month')::date::text, '-', '_') ))
        loop
            sql = format('create table call_center.cc_calls_history_%s
partition of call_center.cc_calls_history
for values from (%s) to (%s)', r.suff_name,
                quote_literal(r.x1),
                quote_literal(r.x2)
            );
            execute sql;
            raise notice '%', sql;
        end loop;

end;
$$;


--
-- Name: cc_calls_rbac_queues(bigint, bigint, integer[]); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_calls_rbac_queues(_domain_id bigint, _user_id bigint, _groups integer[]) RETURNS integer[]
    LANGUAGE sql IMMUTABLE
    AS $$
    with x as (select a.user_id, a.id agent_id, a.supervisor, a.domain_id
               from directory.wbt_user u
                        inner join call_center.cc_agent a on a.user_id = u.id and a.domain_id = u.dc
               where u.id = _user_id
                 and u.dc = _domain_id)
    select array_agg(distinct t.queue_id)
    from (select qs.queue_id::int as queue_id
    from x
             left join lateral (
        select a.id, a.auditor_ids && array [x.user_id] aud
        from call_center.cc_agent a
        where (a.user_id = x.user_id or (a.supervisor_ids && array [x.agent_id] and a.supervisor))
        union
        distinct
        select a.id, a.auditor_ids && array [x.user_id] aud
        from call_center.cc_team t
                 inner join call_center.cc_agent a on a.team_id = t.id
        where t.admin_ids && array [x.agent_id]
        ) a on true
             inner join call_center.cc_skill_in_agent sa on sa.agent_id = a.id
             inner join call_center.cc_queue_skill qs
                        on qs.skill_id = sa.skill_id and sa.capacity between qs.min_capacity and qs.max_capacity
    where sa.enabled
      and qs.enabled
    union distinct
    select q.id
    from call_center.cc_queue q
    where q.domain_id = _domain_id
      and q.grantee_id = any (_groups)) t
$$;


--
-- Name: cc_calls_rbac_users(bigint, bigint); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_calls_rbac_users(_domain_id bigint, _user_id bigint) RETURNS integer[]
    LANGUAGE sql IMMUTABLE
    AS $$
    with x as materialized (
        select a.user_id, a.id agent_id, a.supervisor, a.domain_id
        from directory.wbt_user u
                 inner join call_center.cc_agent a on a.user_id = u.id
        where u.id = _user_id
          and u.dc = _domain_id
    )
    select array_agg(distinct a.user_id::int) users
    from x
             left join lateral (
        select a.user_id, a.auditor_ids && array [x.user_id] aud
        from call_center.cc_agent a
        where a.domain_id = x.domain_id
          and (a.user_id = x.user_id or (a.supervisor_ids && array [x.agent_id] and a.supervisor) or
               a.auditor_ids && array [x.user_id])

        union
        distinct

        select a.user_id, a.auditor_ids && array [x.user_id] aud
        from call_center.cc_team t
                 inner join call_center.cc_agent a on a.team_id = t.id
        where t.admin_ids && array [x.agent_id]
          and x.domain_id = t.domain_id
        ) a on true
$$;


--
-- Name: cc_calls_set_timing(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_calls_set_timing() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN

    if new.state = 'active' then
        if new.answered_at isnull then
            new.answered_at = new.timestamp;

            if new.direction = 'inbound' and new.parent_id notnull and new.bridged_at isnull then
                new.bridged_at = new.answered_at;
            end if;

        else if old.state = 'hold' then
            new.hold_sec =  coalesce(old.hold_sec, 0) + extract ('epoch' from new.timestamp - old.timestamp)::double precision;
            if new.hold isnull then
                new.hold = '[]';
            end if;

            new.hold = new.hold || jsonb_build_object(
                'start', (extract(epoch from old.timestamp)::double precision * 1000)::int8,
                'finish', (extract(epoch from new.timestamp)::double precision * 1000)::int8,
                'sec', extract ('epoch' from new.timestamp - old.timestamp)::int8
            );


--             if new.parent_id notnull then
--                 update cc_calls set hold_sec  = hold_sec + new.hold_sec  where id = new.parent_id;
--             end if;
        end if;

        end if;
    else if (new.state = 'bridge' ) then
        new.bridged_at = coalesce(new.bridged_at, new.timestamp);
    else if new.state = 'hangup' then
        new.hangup_at = new.timestamp;
        -- TODO
        if old.state = 'hold' then
            new.hold_sec =  coalesce(old.hold_sec, 0) + extract ('epoch' from new.timestamp - old.timestamp)::double precision;
            if new.hold isnull then
                new.hold = '[]';
            end if;

            new.hold = new.hold || jsonb_build_object(
                'start', (extract(epoch from old.timestamp)::double precision * 1000)::int8,
                'finish', (extract(epoch from new.timestamp)::double precision * 1000)::int8,
                'sec', extract ('epoch' from new.timestamp - old.timestamp)::int8
            );


--             if new.parent_id notnull then
--                 update cc_calls set hold_sec  = hold_sec + new.hold_sec  where id = new.parent_id;
--             end if;
        end if;
    end if;
    end if;
    end if;

    RETURN new;
END
$$;


--
-- Name: cc_communication_set_def(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_communication_set_def() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
begin
    if new.default is distinct from old."default" or new.channel is distinct from old."channel"  then
        update call_center.cc_communication c
        set  "default" = false
        where c.domain_id = new.domain_id and c.id != new.id and c.channel = new.channel;
    end if;
    return new;
end;
$$;


--
-- Name: cc_confirm_agent_attempt(bigint, bigint); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_confirm_agent_attempt(_agent_id bigint, _attempt_id bigint) RETURNS SETOF character varying
    LANGUAGE plpgsql
    AS $$
BEGIN
    return query update call_center.cc_member_attempt
    set result = case when id = _attempt_id then null else 'cancel' end,
        leaving_at = case when id = _attempt_id then null else now() end
    where agent_id = _agent_id and not exists(
       select 1
       from call_center.cc_member_attempt a
       where a.agent_id = _agent_id and a.leaving_at notnull and a.result = 'cancel'
       for update
    )
    returning member_call_id;
END;
$$;


--
-- Name: cc_cron_next_after_now(character varying, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_cron_next_after_now(expression character varying, shed timestamp without time zone, nowtz timestamp without time zone) RETURNS timestamp without time zone
    LANGUAGE plpgsql
    AS $$
    declare n timestamp = (call_center.cc_cron_next(expression, shed))::timestamp;
    declare i int = 0;
begin
        if n < nowtz then
            n = nowtz;
        end if;

        while n <= nowtz and i < 1000 loop -- TODO
            n = (call_center.cc_cron_next(expression, n) )::timestamp;
            i = i + 1;
        end loop;


        return n;
end;
$$;


--
-- Name: cc_distribute(boolean); Type: PROCEDURE; Schema: call_center; Owner: -
--

CREATE PROCEDURE call_center.cc_distribute(IN disable_omnichannel boolean)
    LANGUAGE plpgsql
    AS $$
begin
    if NOT pg_try_advisory_xact_lock(132132117) then
        raise exception 'LOCK';
    end if;

    with dis as MATERIALIZED (
        select x.*, a.team_id
        from call_center.cc_sys_distribute(disable_omnichannel) x (agent_id int, queue_id int, bucket_id int, ins bool, id int8, resource_id int,
                                                                   resource_group_id int, comm_idx int)
                 left join call_center.cc_agent a on a.id= x.agent_id
    )
       , ins as (
        insert into call_center.cc_member_attempt (channel, member_id, queue_id, resource_id, agent_id, bucket_id, destination,
                                                   communication_idx, member_call_id, team_id, resource_group_id, domain_id, import_id, sticky_agent_id)
            select case when q.type = 7 then 'task' else 'call' end, --todo
                   dis.id,
                   dis.queue_id,
                   dis.resource_id,
                   dis.agent_id,
                   dis.bucket_id,
                   x,
                   dis.comm_idx,
                   uuid_generate_v4(),
                   dis.team_id,
                   dis.resource_group_id,
                   q.domain_id,
                   m.import_id,
                   case when q.type = 5 and q.sticky_agent then dis.agent_id end
            from dis
                     inner join call_center.cc_queue q on q.id = dis.queue_id
                     inner join call_center.cc_member m on m.id = dis.id
                     inner join lateral jsonb_extract_path(m.communications, (dis.comm_idx)::text) x on true
            where dis.ins
    )
    update call_center.cc_member_attempt a
    set agent_id = t.agent_id,
        team_id = t.team_id
    from (
             select dis.id, dis.agent_id, dis.team_id
             from dis
                      inner join call_center.cc_agent a on a.id = dis.agent_id
                      left join call_center.cc_queue q on q.id = dis.queue_id
             where not dis.ins is true
               and (q.type is null or q.type in (6, 7) or not exists(select 1 from call_center.cc_calls cc where cc.user_id = a.user_id and cc.hangup_at isnull ))
         ) t
    where t.id = a.id
      and a.agent_id isnull;

end;
$$;


--
-- Name: cc_distribute_direct_member_to_queue(character varying, bigint, integer, bigint); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_distribute_direct_member_to_queue(_node_name character varying, _member_id bigint, _communication_id integer, _agent_id bigint) RETURNS TABLE(id bigint, member_id bigint, result character varying, queue_id integer, queue_updated_at bigint, queue_count integer, queue_active_count integer, queue_waiting_count integer, resource_id integer, resource_updated_at bigint, gateway_updated_at bigint, destination jsonb, variables jsonb, name character varying, member_call_id character varying, agent_id bigint, agent_updated_at bigint, team_updated_at bigint, seq integer, communication_idx integer)
    LANGUAGE plpgsql
    AS $$
BEGIN
    return query with attempts as (
        insert into call_center.cc_member_attempt (state, queue_id, member_id, destination, communication_idx, node_id, agent_id, resource_id,
                                       bucket_id, seq, team_id, domain_id)
            select 1,
                   m.queue_id,
                   m.id,
                   m.communications -> (_communication_id::int2),
                   (_communication_id::int2),
                   _node_name,
                   _agent_id,
                   r.resource_id,
                   m.bucket_id,
                   m.attempts + 1,
                   q.team_id,
                   q.domain_id
            from call_center.cc_member m
                     inner join call_center.cc_queue q on q.id = m.queue_id
                     inner join lateral (
                select (t::call_center.cc_sys_distribute_type).resource_id
                from call_center.cc_sys_queue_distribute_resources r,
                     unnest(r.types) t
                where r.queue_id = m.queue_id
                  and (t::call_center.cc_sys_distribute_type).type_id =
                      (m.communications -> (_communication_id::int2) -> 'type' -> 'id')::int4
                limit 1
                ) r on true
                     left join call_center.cc_outbound_resource cor on cor.id = r.resource_id
            where m.id = _member_id
              and m.communications -> (_communication_id::int2) notnull
              and not exists(select 1 from call_center.cc_member_attempt ma  where ma.member_id = _member_id )
            returning call_center.cc_member_attempt.*
    )
                 select a.id,
                        a.member_id,
                        null::varchar          result,
                        a.queue_id,
                        cq.updated_at as       queue_updated_at,
                        0::integer             queue_count,
                        0::integer             queue_active_count,
                        0::integer             queue_waiting_count,
                        a.resource_id::integer resource_id,
                        r.updated_at::bigint   resource_updated_at,
                        null::bigint           gateway_updated_at,
                        a.destination          destination,
                        cm.variables,
                        cm.name,
                        null::varchar,
                        a.agent_id::bigint     agent_id,
                        ag.updated_at::bigint  agent_updated_at,
                        t.updated_at::bigint   team_updated_at,
                        a.seq::int seq,
                        a.communication_idx::int communication_idx
                 from attempts a
                          left join call_center.cc_member cm on a.member_id = cm.id
                          inner join call_center.cc_queue cq on a.queue_id = cq.id
                          left join call_center.cc_outbound_resource r on r.id = a.resource_id
                          left join call_center.cc_agent ag on ag.id = a.agent_id
                          inner join call_center.cc_team t on t.id = ag.team_id;

    --raise notice '%', _attempt_id;

END;
$$;


--
-- Name: cc_distribute_inbound_call_to_agent(character varying, character varying, jsonb, integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_distribute_inbound_call_to_agent(_node_name character varying, _call_id character varying, variables_ jsonb, _agent_id integer DEFAULT NULL::integer) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    _domain_id int8;
    _team_updated_at int8;
    _agent_updated_at int8;
    _team_id_ int;

    _call record;
    _attempt record;

    _a_status varchar;
    _a_state varchar;
    _number varchar;
    _busy_ext bool;
BEGIN

  select *
  from call_center.cc_calls c
  where c.id = _call_id::uuid
--   for update
  into _call;

  if _call.id isnull or _call.direction isnull then
      raise exception 'not found call';
  end if;

    if _call.id isnull or _call.direction isnull then
      raise exception 'not found call';
  ELSIF _call.direction <> 'outbound' then
      _number = _call.from_number;
  else
      _number = _call.destination;
  end if;

  select
    a.team_id,
    t.updated_at,
    a.status,
    cac.state,
    a.domain_id,
    (a.updated_at - extract(epoch from u.updated_at))::int8,
    exists (select 1 from call_center.cc_calls c where c.user_id = a.user_id and c.queue_id isnull and c.hangup_at isnull ) busy_ext
  from call_center.cc_agent a
      inner join call_center.cc_team t on t.id = a.team_id
      inner join call_center.cc_agent_channel cac on a.id = cac.agent_id and cac.channel = 'call'
      inner join directory.wbt_user u on u.id = a.user_id
  where a.id = _agent_id -- check attempt
    and length(coalesce(u.extension, '')) > 0
  for update
  into _team_id_,
      _team_updated_at,
      _a_status,
      _a_state,
      _domain_id,
      _agent_updated_at,
      _busy_ext
      ;

  if _call.domain_id != _domain_id then
      raise exception 'the queue on another domain';
  end if;

  if _team_id_ isnull then
      raise exception 'not found agent';
  end if;

  if not _a_status = 'online' then
      raise exception 'agent not in online';
  end if;

  if _a_state != 'waiting'  then
      raise exception 'agent is busy';
  end if;

  if _busy_ext then
      raise exception 'agent has external call';
  end if;


  insert into call_center.cc_member_attempt (domain_id, state, team_id, member_call_id, destination, node_id, agent_id, parent_id)
  values (_domain_id, 'waiting', _team_id_, _call_id, jsonb_build_object('destination', _number),
              _node_name, _agent_id, _call.attempt_id)
  returning * into _attempt;

  update call_center.cc_calls
  set team_id = _team_id_,
      attempt_id = _attempt.id,
      payload    = case when jsonb_typeof(variables_::jsonb) = 'object' then variables_ else coalesce(payload, '{}') end
  where id = _call_id::uuid
  returning * into _call;

  if _call.id isnull or _call.direction isnull then
      raise exception 'not found call';
  end if;

  return row(
      _attempt.id::int8,
      _attempt.destination::jsonb,
      variables_::jsonb,
      _call.from_name::varchar,
      _team_id_::int,
      _team_updated_at::int8,
      _agent_updated_at::int8,

      _call.id::varchar,
      _call.state::varchar,
      _call.direction::varchar,
      _call.destination::varchar,
      call_center.cc_view_timestamp(_call.timestamp)::int8,
      _call.app_id::varchar,
      _number::varchar,
            case when (_call.direction <> 'outbound'
                    and _call.to_name::varchar <> ''
                    and _call.to_name::varchar notnull)
        then _call.from_name::varchar
        else _call.to_name::varchar end,
      call_center.cc_view_timestamp(_call.answered_at)::int8,
      call_center.cc_view_timestamp(_call.bridged_at)::int8,
      call_center.cc_view_timestamp(_call.created_at)::int8
  );
END;
$$;


--
-- Name: cc_distribute_inbound_call_to_queue(character varying, bigint, character varying, jsonb, integer, integer, integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_distribute_inbound_call_to_queue(_node_name character varying, _queue_id bigint, _call_id character varying, variables_ jsonb, bucket_id_ integer, _priority integer DEFAULT 0, _sticky_agent_id integer DEFAULT NULL::integer) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
_timezone_id             int4;
    _discard_abandoned_after int4;
    _weight                  int4;
    dnc_list_id_ int4;
    _domain_id               int8;
    _calendar_id             int4;
    _queue_updated_at        int8;
    _team_updated_at         int8;
    _team_id_                int;
    _list_comm_id            int8;
    _enabled                 bool;
    _q_type                  smallint;
    _sticky                  bool;
    _call                    record;
    _attempt                 record;
    _number                  varchar;
    _name                  varchar;
    _max_waiting_size        int;
    _grantee_id              int8;
BEGIN
select c.timezone_id,
       (payload ->> 'discard_abandoned_after')::int discard_abandoned_after,
        c.domain_id,
       q.dnc_list_id,
       q.calendar_id,
       q.updated_at,
       ct.updated_at,
       q.team_id,
       q.enabled,
       q.type,
       q.sticky_agent,
       (payload ->> 'max_waiting_size')::int        max_size,
        q.grantee_id
from call_center.cc_queue q
         inner join flow.calendar c on q.calendar_id = c.id
         left join call_center.cc_team ct on q.team_id = ct.id
where q.id = _queue_id
    into _timezone_id, _discard_abandoned_after, _domain_id, dnc_list_id_, _calendar_id, _queue_updated_at,
        _team_updated_at, _team_id_, _enabled, _q_type, _sticky, _max_waiting_size, _grantee_id;

if
not _q_type = 1 then
        raise exception 'queue not inbound';
end if;

    if
not _enabled = true then
        raise exception 'queue disabled';
end if;

select *
from call_center.cc_calls c
where c.id = _call_id::uuid
--   for update
    into _call;

if
_call.domain_id != _domain_id then
        raise exception 'the queue on another domain';
end if;

    if
_call.id isnull or _call.direction isnull then
        raise exception 'not found call';
    ELSIF
_call.direction <> 'outbound' or _call.user_id notnull then
        _number = _call.from_number;
        _name = _call.from_name;
else
        _number = _call.destination;
end if;

--   raise  exception '%', _name;


    if
not exists(select accept
                   from flow.calendar_check_timing(_domain_id, _calendar_id, null)
                            as x (name varchar, excepted varchar, accept bool, expire bool)
                   where accept
                     and excepted is null
                     and not expire)
    then
        raise exception 'number % calendar not working [%]', _number, _calendar_id;
end if;


    if
_max_waiting_size > 0 then
        if (select count(*)
            from call_center.cc_member_attempt aa
            where aa.queue_id = _queue_id
              and aa.bridged_at isnull
              and aa.leaving_at isnull
              and (bucket_id_ isnull or aa.bucket_id = bucket_id_)) >= _max_waiting_size then
            raise exception using
                errcode = 'MAXWS',
                message = 'Queue maximum waiting size';
end if;
end if;

    if
dnc_list_id_ notnull then
select clc.id
into _list_comm_id
from call_center.cc_list_communications clc
where (clc.list_id = dnc_list_id_
  and clc.number = _number)
    limit 1;
end if;

    if
_list_comm_id notnull then
        raise exception 'number % banned', _number;
end if;

    if
_discard_abandoned_after > 0 then
select case
           when log.result = 'abandoned' then
               extract(epoch from now() - log.leaving_at)::int8 + coalesce(_priority, 0)
                   else coalesce(_priority, 0)
end
from call_center.cc_member_attempt_history log
        where log.leaving_at >= (now() - (_discard_abandoned_after || ' sec')::interval)
          and log.queue_id = _queue_id
          and log.destination ->> 'destination' = _number
        order by log.leaving_at desc
        limit 1
        into _weight;
end if;

    if
_sticky_agent_id notnull and _sticky then
        if not exists(select 1
                      from call_center.cc_agent a
                      where a.id = _sticky_agent_id
                        and a.domain_id = _domain_id
                        and a.status = 'online'
                        and exists(select 1
                                   from call_center.cc_skill_in_agent sa
                                            inner join call_center.cc_queue_skill qs
                                                       on qs.skill_id = sa.skill_id and qs.queue_id = _queue_id
                                   where sa.agent_id = _sticky_agent_id
                                     and sa.enabled
                                     and sa.capacity between qs.min_capacity and qs.max_capacity)
            ) then
            _sticky_agent_id = null;
end if;
else
        _sticky_agent_id = null;
end if;

insert into call_center.cc_member_attempt (domain_id, state, queue_id, team_id, member_id, bucket_id, weight,
                                           member_call_id, destination, node_id, sticky_agent_id,
                                           list_communication_id,
                                           parent_id)
values (_domain_id, 'waiting', _queue_id, _team_id_, null, bucket_id_, coalesce(_weight, _priority), _call_id,
        jsonb_build_object('destination', _number, 'name', coalesce(_name, _number)),
        _node_name, _sticky_agent_id, null, _call.attempt_id)
    returning * into _attempt;

update call_center.cc_calls
set queue_id   = _attempt.queue_id,
    team_id    = _team_id_,
    attempt_id = _attempt.id,
    payload    = case when jsonb_typeof(variables_::jsonb) = 'object' then variables_ else coalesce(payload, '{}') end, --coalesce(variables_, '{}'),
    grantee_id = _grantee_id
where id = _call_id::uuid
    returning * into _call;

if
_call.id isnull or _call.direction isnull then
        raise exception 'not found call';
end if;

return row (
        _attempt.id::int8,
        _attempt.queue_id::int,
        _queue_updated_at::int8,
        _attempt.destination::jsonb,
        variables_::jsonb,
        _call.from_name::varchar,
        _team_updated_at::int8,
        _call.id::varchar,
        _call.state::varchar,
        _call.direction::varchar,
        _call.destination::varchar,
        call_center.cc_view_timestamp(_call.timestamp)::int8,
        _call.app_id::varchar,
        _number::varchar,
        case
            when (_call.direction <> 'outbound'
                and _call.to_name:: varchar <> ''
                and _call.to_name:: varchar notnull)
                then _call.from_name::varchar
            else _call.to_name::varchar end,
        call_center.cc_view_timestamp(_call.answered_at)::int8,
        call_center.cc_view_timestamp(_call.bridged_at)::int8,
        call_center.cc_view_timestamp(_call.created_at)::int8
    );

END;
$$;


--
-- Name: cc_distribute_inbound_chat_to_queue(character varying, bigint, character varying, jsonb, integer, integer, integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_distribute_inbound_chat_to_queue(_node_name character varying, _queue_id bigint, _conversation_id character varying, variables_ jsonb, bucket_id_ integer, _priority integer DEFAULT 0, _sticky_agent_id integer DEFAULT NULL::integer) RETURNS record
    LANGUAGE plpgsql
    AS $$
declare
    _timezone_id int4;
    _discard_abandoned_after int4;
    _weight int4;
    dnc_list_id_ int4;
    _domain_id int8;
    _calendar_id int4;
    _queue_updated_at int8;
    _team_updated_at int8;
    _team_id_ int;
    _enabled bool;
    _q_type smallint;
    _attempt record;
    _con_created timestamptz;
    _con_name varchar;
    _con_type varchar;
    _last_msg varchar;
    _client_name varchar;
    _inviter_channel_id varchar;
    _inviter_user_id varchar;
    _sticky bool;
    _max_waiting_size int;
BEGIN
    select c.timezone_id,
           (coalesce(payload->>'discard_abandoned_after', '0'))::int discard_abandoned_after,
           c.domain_id,
           q.dnc_list_id,
           q.calendar_id,
           q.updated_at,
           ct.updated_at,
           q.team_id,
           q.enabled,
           q.type,
           q.sticky_agent,
           (payload->>'max_waiting_size')::int max_size
    from call_center.cc_queue q
             inner join flow.calendar c on q.calendar_id = c.id
             left join call_center.cc_team ct on q.team_id = ct.id
    where  q.id = _queue_id
    into _timezone_id, _discard_abandoned_after, _domain_id, dnc_list_id_, _calendar_id, _queue_updated_at,
        _team_updated_at, _team_id_, _enabled, _q_type, _sticky, _max_waiting_size;

    if not _q_type = 6 then
        raise exception 'queue type not inbound chat';
    end if;

    if not _enabled = true then
        raise exception 'queue disabled';
    end if;

    if not exists(select accept
                  from flow.calendar_check_timing(_domain_id, _calendar_id, null)
                           as x (name varchar, excepted varchar, accept bool, expire bool)
                  where accept and excepted is null and not expire) then
        raise exception 'conversation [%] calendar not working [%] [%]', _conversation_id, _calendar_id, _queue_id;
    end if;

    if _max_waiting_size > 0 then
        if (select count(*) from call_center.cc_member_attempt aa
            where aa.queue_id = _queue_id
              and aa.bridged_at isnull
              and aa.leaving_at isnull
              and (bucket_id_ isnull or aa.bucket_id = bucket_id_)) >= _max_waiting_size then
            raise exception using
                errcode='MAXWS',
                message='Queue maximum waiting size';
        end if;
    end if;

    select cli.external_id,
           c.created_at,
           c.id::varchar inviter_channel_id,
           c.user_id,
           c.name,
           lst.message,
           c.type
    from chat.channel c
             left join chat.client cli on cli.id = c.user_id
             left join lateral (
        select coalesce(m.text, m.file_name, 'empty') message
        from chat.message m
        where m.conversation_id = _conversation_id::uuid
        order by created_at desc
        limit 1
        ) lst on true -- todo
    where c.closed_at isnull
      and c.conversation_id = _conversation_id::uuid
      and not c.internal
    into _con_name, _con_created, _inviter_channel_id, _inviter_user_id, _client_name, _last_msg, _con_type;

    if coalesce(_inviter_channel_id, '') = '' or coalesce(_inviter_user_id, '') = '' isnull then
        raise exception using
            errcode='VALID',
            message='Bad request inviter_channel_id or user_id';
    end if;

    --TODO
--   select clc.id
--     into _list_comm_id
--     from cc_list_communications clc
--     where (clc.list_id = dnc_list_id_ and clc.number = _call.from_number)
--   limit 1;

--   if _list_comm_id notnull then
--           insert into cc_member_attempt(channel, queue_id, state, leaving_at, member_call_id, result, list_communication_id)
--           values ('call', _queue_id, 'leaving', now(), _call_id, 'banned', _list_comm_id);
--           raise exception 'number % banned', _call.from_number;
--   end if;

    if  _discard_abandoned_after > 0 then
        select
            case when log.result = 'abandoned' then
                         extract(epoch from now() - log.leaving_at)::int8 + coalesce(_priority, 0)
                 else coalesce(_priority, 0) end
        from call_center.cc_member_attempt_history log
        where log.leaving_at >= (now() -  (_discard_abandoned_after || ' sec')::interval)
          and log.queue_id = _queue_id
          and log.destination->>'destination' = _con_name
        order by log.leaving_at desc
        limit 1
        into _weight;
    end if;

    if _sticky_agent_id notnull and _sticky then
        if not exists(select 1
                      from call_center.cc_agent a
                      where a.id = _sticky_agent_id
                        and a.domain_id = _domain_id
                        and a.status = 'online'
                        and exists(select 1
                                   from call_center.cc_skill_in_agent sa
                                            inner join call_center.cc_queue_skill qs
                                                       on qs.skill_id = sa.skill_id and qs.queue_id = _queue_id
                                   where sa.agent_id = _sticky_agent_id
                                     and sa.enabled
                                     and sa.capacity between qs.min_capacity and qs.max_capacity)
            ) then
            _sticky_agent_id = null;
        end if;
    else
        _sticky_agent_id = null;
    end if;

    insert into call_center.cc_member_attempt (domain_id, channel, state, queue_id, member_id, bucket_id, weight, member_call_id, destination, node_id, sticky_agent_id, list_communication_id)
    values (_domain_id, 'chat', 'waiting', _queue_id, null, bucket_id_, coalesce(_weight, _priority), _conversation_id::varchar,
            jsonb_build_object('destination', _con_name, 'name', _client_name, 'msg', _last_msg, 'chat', _con_type),
            _node_name, _sticky_agent_id, (select clc.id
                                           from call_center.cc_list_communications clc
                                           where (clc.list_id = dnc_list_id_ and clc.number = _conversation_id)))
    returning * into _attempt;


    return row(
        _attempt.id::int8,
        _attempt.queue_id::int,
        _queue_updated_at::int8,
        _attempt.destination::jsonb,
                coalesce((variables_::jsonb), '{}'::jsonb) || jsonb_build_object('inviter_channel_id', _inviter_channel_id) || jsonb_build_object('inviter_user_id', _inviter_user_id),
        _conversation_id::varchar,
        _team_updated_at::int8,

        _conversation_id::varchar,
        call_center.cc_view_timestamp(_con_created)::int8
        );
END;
$$;


--
-- Name: cc_distribute_members_list(integer, integer, smallint, boolean, smallint[], integer, integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_distribute_members_list(_queue_id integer, _bucket_id integer, strategy smallint, wait_between_retries_desc boolean DEFAULT false, l smallint[] DEFAULT '{}'::smallint[], lim integer DEFAULT 40, offs integer DEFAULT 0) RETURNS SETOF bigint
    LANGUAGE plpgsql STABLE
    AS $_$
begin return query
    select m.id::int8
    from call_center.cc_member m
    where m.queue_id = _queue_id
        and m.stop_at isnull
        and m.skill_id isnull
        and case when _bucket_id isnull then m.bucket_id isnull else m.bucket_id = _bucket_id end
        and (m.expire_at isnull or m.expire_at > now())
        and (m.ready_at isnull or m.ready_at < now())
        and not m.search_destinations && array(select call_center.cc_call_active_numbers())
        and m.id not in (select distinct a.member_id from call_center.cc_member_attempt a where a.member_id notnull)
        and m.sys_offset_id = any($5::int2[])
    order by m.bucket_id nulls last,
             m.skill_id,
             m.agent_id,
             m.priority desc,
             case when coalesce(wait_between_retries_desc, false) then m.ready_at end desc nulls last ,
             case when not coalesce(wait_between_retries_desc, false) then m.ready_at end asc nulls last ,

             case when coalesce(strategy, 0) = 1 then m.id end desc ,
             case when coalesce(strategy, 0) != 1 then m.id end asc
    limit lim
    offset offs
--     for update of m skip locked
        ;
end
$_$;


--
-- Name: cc_epoch_to_timestamp(bigint); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_epoch_to_timestamp(bigint) RETURNS timestamp with time zone
    LANGUAGE plpgsql IMMUTABLE
    AS $_$
begin
    return to_timestamp($1/1000);
end;
$_$;


--
-- Name: cc_get_lookup(bigint, character varying); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_get_lookup(_id bigint, _name character varying) RETURNS jsonb
    LANGUAGE plpgsql IMMUTABLE
    AS $$
BEGIN
    if _id isnull then
        return null;
    else
        return json_build_object('id', _id, 'name', _name)::jsonb;
    end if;
END;
$$;


--
-- Name: cc_get_time(character varying, character varying); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_get_time(_t character varying, _def_t character varying) RETURNS integer
    LANGUAGE plpgsql IMMUTABLE
    AS $$
BEGIN
  return (to_char(current_timestamp AT TIME ZONE coalesce(_t, _def_t), 'SSSS') :: int / 60)::int;
END;
$$;


--
-- Name: cc_is_lookup(text, text); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_is_lookup(_table_name text, _col_name text) RETURNS boolean
    LANGUAGE plpgsql IMMUTABLE
    AS $$
begin
    return exists(select 1
from information_schema.columns
where table_name = _table_name
    and column_name = _col_name
    and data_type in ('json', 'jsonb'));
end;
$$;


--
-- Name: cc_jsonb_show_fields(jsonb, character varying[]); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_jsonb_show_fields(j jsonb, keys character varying[]) RETURNS jsonb
    LANGUAGE sql
    AS $$select json_object_agg(key, value)
     from jsonb_each(j)
     where key = any(keys)$$;


--
-- Name: cc_list_statistics_trigger_deleted(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_list_statistics_trigger_deleted() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN

    insert into call_center.cc_list_statistics (list_id, count)
    select l.list_id, l.cnt
    from (
             select l.list_id, count(*) cnt
             from deleted l
                inner join call_center.cc_list li on li.id = l.list_id
             group by l.list_id
         ) l
    on conflict (list_id)
        do update
        set count = call_center.cc_list_statistics.count - EXCLUDED.count ;

    RETURN NULL;
END
$$;


--
-- Name: cc_list_statistics_trigger_inserted(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_list_statistics_trigger_inserted() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
    insert into call_center.cc_list_statistics (list_id, count)
    select l.list_id, l.cnt
    from (
             select l.list_id, count(*) cnt
             from inserted l
             group by l.list_id
         ) l
    on conflict (list_id)
        do update
        set count = EXCLUDED.count + call_center.cc_list_statistics.count;
    RETURN NULL;
END
$$;


--
-- Name: cc_member_attempt_log_day_f(integer, integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_attempt_log_day_f(queue_id integer, bucket_id integer) RETURNS integer
    LANGUAGE sql IMMUTABLE STRICT
    AS $_$
    SELECT sum(l.count)::int4 AS cnt
     FROM call_center.cc_member_attempt_log_day l
     WHERE $2 IS NOT NULL and l.queue_id = $1::int
       AND l.bucket_id = $2::int4
$_$;


--
-- Name: cc_member_communication_types(jsonb); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_communication_types(jsonb) RETURNS integer[]
    LANGUAGE sql IMMUTABLE
    AS $_$
    SELECT array_agg(x->'type')::int[] || ARRAY[]::int[] FROM jsonb_array_elements($1) t(x);
$_$;


--
-- Name: cc_member_communications(jsonb); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_communications(jsonb) RETURNS jsonb
    LANGUAGE sql IMMUTABLE
    AS $_$
select (select json_agg(x)
                from (
                         select x ->> 'destination'                destination,
                                call_center.cc_get_lookup(c.id, c.name)       as type,
                                (x -> 'priority')::int          as priority,
                                (x -> 'state')::int             as state,
                                x -> 'description'              as description,
                                (x -> 'last_activity_at')::int8 as last_activity_at,
                                (x -> 'attempts')::int          as attempts,
                                x ->> 'last_cause'              as last_cause,
                                call_center.cc_get_lookup(r.id, r.name)       as resource,
                                x ->> 'display'                 as display,
                                x ->> 'dtmf'                 as dtmf,
                                (x -> 'stop_at')::int8                 as stop_at
                         from jsonb_array_elements($1) x
                                  left join call_center.cc_communication c on c.id = (x -> 'type' -> 'id')::int
                                  left join call_center.cc_outbound_resource r on r.id = (x -> 'resource' -> 'id')::int
                     ) x)::jsonb
$_$;


--
-- Name: cc_member_destination_views_to_json(call_center.cc_member_destination_view[]); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_destination_views_to_json(in_ call_center.cc_member_destination_view[]) RETURNS jsonb
    LANGUAGE sql IMMUTABLE
    AS $$
select jsonb_agg(x)
    from unnest(in_) x
$$;


--
-- Name: cc_member_set_sys_destinations_tg(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_set_sys_destinations_tg() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
    if new.stop_cause notnull then
        new.ready_at = null;
    end if;

    if new.communications notnull and jsonb_typeof(new.communications) = 'array' then
        new.sys_destinations = (select array(select call_center.cc_destination_in(idx::int4 - 1, (x -> 'type' ->> 'id')::int4, (x ->> 'last_activity_at')::int8,  (x -> 'resource' ->> 'id')::int, (x ->> 'priority')::int)
         from jsonb_array_elements(new.communications) with ordinality as x(x, idx)
         where coalesce((x.x -> 'stop_at')::int8, 0) = 0
         and idx > -1
            order by coalesce((x ->> 'priority')::int, 0) desc, (x ->> 'last_activity_at')::int8 asc nulls first ));

        new.search_destinations = (select array_agg( x->>'destination'::varchar)
            from jsonb_array_elements(new.communications) x);

        if new.stop_at isnull and coalesce(array_length(new.sys_destinations, 1), 0 ) = 0 then
            new.stop_at = now();
            new.stop_cause = 'no_communications';
        end if;

    else
        new.sys_destinations = null;
        new.search_destinations = null;
    end if;

    return new;
END
$$;


--
-- Name: cc_member_statistic_skill_trigger_deleted(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_statistic_skill_trigger_deleted() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN

    insert into call_center.cc_queue_skill_statistics (queue_id, skill_id, member_count, member_waiting)
    select t.queue_id, t.skill_id, t.cnt, t.cntwait
    from (
             select queue_id, skill_id, count(*) cnt, count(*) filter ( where m.stop_at isnull ) cntwait
             from deleted m
             group by queue_id, skill_id
         ) t
    where t.skill_id notnull
    on conflict (queue_id, skill_id)
        do update
        set member_count   = call_center.cc_queue_skill_statistics.member_count - EXCLUDED.member_count,
            member_waiting = call_center.cc_queue_skill_statistics.member_waiting - EXCLUDED.member_waiting
    ;

    RETURN NULL;
END
$$;


--
-- Name: cc_member_statistic_skill_trigger_inserted(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_statistic_skill_trigger_inserted() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
    insert into call_center.cc_queue_skill_statistics (queue_id, skill_id, member_count, member_waiting)
    select t.queue_id, t.skill_id, t.cnt, t.cntwait
    from (
             select queue_id, skill_id, count(*) cnt, count(*) filter ( where m.stop_at isnull ) cntwait
             from inserted m
             where m.skill_id notnull
             group by queue_id, skill_id
         ) t
    on conflict (queue_id, skill_id)
        do update
        set member_count   = EXCLUDED.member_count + call_center.cc_queue_skill_statistics.member_count,
            member_waiting = EXCLUDED.member_waiting + call_center.cc_queue_skill_statistics.member_waiting;

    RETURN NULL;
END
$$;


--
-- Name: cc_member_statistic_skill_trigger_updated(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_statistic_skill_trigger_updated() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
    insert into call_center.cc_queue_skill_statistics (queue_id, skill_id, member_count, member_waiting)
    select t.queue_id, t.skill_id, t.cnt, t.cntwait
    from (
        select queue_id, skill_id, sum(cnt) cnt, sum(cntwait) cntwait
        from (
             select m.queue_id,
                    m.skill_id,
                    -1 * count(*) cnt,
                    -1 * count(*) filter ( where m.stop_at isnull ) cntwait
             from old_data m
             group by m.queue_id, m.skill_id

             union all
            select m.queue_id,
                   m.skill_id,
                   count(*) cnt,
                   count(*) filter ( where m.stop_at isnull ) cntwait
             from new_data m
--              where m.skill_id notnull
             group by m.queue_id, m.skill_id
        ) o
        group by queue_id, skill_id
    ) t
        where t.skill_id notnull
    on conflict (queue_id, skill_id) do update
        set member_waiting = excluded.member_waiting + call_center.cc_queue_skill_statistics.member_waiting,
            member_count = excluded.member_count + call_center.cc_queue_skill_statistics.member_count
    ;

   RETURN NULL;
END
$$;


--
-- Name: cc_member_statistic_trigger_deleted(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_statistic_trigger_deleted() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN

    insert into call_center.cc_queue_statistics (bucket_id, queue_id, member_count, member_waiting)
    select t.bucket_id, t.queue_id, t.cnt, t.cntwait
    from (
             select queue_id, bucket_id, count(*) cnt, count(*) filter ( where m.stop_at isnull ) cntwait
             from deleted m
                inner join call_center.cc_queue q on q.id = m.queue_id
             group by queue_id, bucket_id
         ) t
    on conflict (queue_id, coalesce(bucket_id, 0))
        do update
        set member_count   = call_center.cc_queue_statistics.member_count - EXCLUDED.member_count,
            member_waiting = call_center.cc_queue_statistics.member_waiting - EXCLUDED.member_waiting;

    RETURN NULL;
END
$$;


--
-- Name: cc_member_statistic_trigger_inserted(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_statistic_trigger_inserted() RETURNS trigger
    LANGUAGE plpgsql
    AS $_$
BEGIN
    if exists(select 1
        from inserted m,
             (select c.domain_id, array_agg(c.id) ids
        from call_center.cc_communication c group by 1) c
        where m.domain_id = c.domain_id
            and array_length(TRANSLATE(jsonb_path_query_array(communications, '$[*].type.id')::text , '[]','{}')::INT[] - c.ids, 1)  > 0)
    then
        raise exception 'bad communication type.id' using errcode = '23503';
    end if;

    insert into call_center.cc_queue_statistics (queue_id, bucket_id, member_count, member_waiting)
    select t.queue_id, t.bucket_id, t.cnt, t.cntwait
    from (
             select queue_id, bucket_id, count(*) cnt, count(*) filter ( where m.stop_at isnull ) cntwait
             from inserted m
             group by queue_id, bucket_id
         ) t
    on conflict (queue_id, coalesce(bucket_id, 0))
        do update
        set member_count   = EXCLUDED.member_count + call_center.cc_queue_statistics.member_count,
            member_waiting = EXCLUDED.member_waiting + call_center.cc_queue_statistics.member_waiting;


    --    raise notice '% % %', TG_TABLE_NAME, TG_OP, (select count(*) from inserted );
--    PERFORM pg_notify(TG_TABLE_NAME, TG_OP);
    RETURN NULL;
END
$_$;


--
-- Name: cc_member_statistic_trigger_updated(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_statistic_trigger_updated() RETURNS trigger
    LANGUAGE plpgsql
    AS $_$
BEGIN
    if exists(select 1
        from new_data m,
             (select c.domain_id, array_agg(c.id) ids
        from call_center.cc_communication c group by 1) c
        where m.domain_id = c.domain_id
            and array_length(TRANSLATE(jsonb_path_query_array(communications, '$[*].type.id')::text , '[]','{}')::INT[] - c.ids, 1)  > 0)
    then
        raise exception 'bad communication type.id' using errcode = '23503';
    end if;

    insert into call_center.cc_queue_statistics (queue_id, bucket_id, member_count, member_waiting)
    select t.queue_id, t.bucket_id, t.cnt, t.cntwait
    from (
        select queue_id, bucket_id, sum(cnt) cnt, sum(cntwait) cntwait
        from (
             select m.queue_id,
                    m.bucket_id,
                    -1 * count(*) cnt,
                    -1 * count(*) filter ( where m.stop_at isnull ) cntwait
             from old_data m
             group by m.queue_id, m.bucket_id

             union all
            select m.queue_id,
                    m.bucket_id   bucket_id ,
                    count(*) cnt,
                    count(*) filter ( where m.stop_at isnull ) cntwait
             from new_data m
             group by m.queue_id, m.bucket_id
        ) o
        group by queue_id, bucket_id
    ) t
    --where t.cntwait != 0
    on conflict (queue_id, coalesce(bucket_id, 0)) do update
        set member_waiting = excluded.member_waiting + call_center.cc_queue_statistics.member_waiting,
            member_count = excluded.member_count + call_center.cc_queue_statistics.member_count;

   RETURN NULL;
END
$_$;


--
-- Name: cc_member_sys_offset_id_trigger_inserted(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_sys_offset_id_trigger_inserted() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare res int4[];
BEGIN
    if new.timezone_id isnull or new.timezone_id = 0 then
        res = call_center.cc_queue_default_timezone_offset_id(new.queue_id);
        new.timezone_id = res[1];
        new.sys_offset_id = res[2];
    else
        new.sys_offset_id = call_center.cc_timezone_offset_id(new.timezone_id);
    end if;

    if new.timezone_id isnull or new.sys_offset_id isnull then
        raise exception 'not found timezone';
    end if;

    RETURN new;
END
$$;


--
-- Name: cc_member_sys_offset_id_trigger_update(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_member_sys_offset_id_trigger_update() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare res int4[];
BEGIN
    new.sys_offset_id = call_center.cc_timezone_offset_id(new.timezone_id);

    if new.timezone_id isnull or new.sys_offset_id isnull then
        raise exception 'not found timezone';
    end if;

    RETURN new;
END
$$;


--
-- Name: cc_offline_members_ids(bigint, integer, integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_offline_members_ids(_domain_id bigint, _agent_id integer, _lim integer) RETURNS SETOF bigint
    LANGUAGE plpgsql IMMUTABLE
    AS $$
begin
    return query
        with queues as (
            select  q_1.domain_id,
                    q_1.id,
                    q_1.calendar_id,
                    q_1.type,
                    q_1.sticky_agent,
                    q_1.recall_calendar,
                    CASE
                        WHEN q_1.sticky_agent THEN COALESCE(((q_1.payload -> 'sticky_agent_sec'::text))::integer, 30)
                        ELSE NULL::integer
                        END AS sticky_agent_sec,
                    CASE
                        WHEN ((q_1.strategy)::text = 'lifo'::text) THEN 1
                        WHEN ((q_1.strategy)::text = 'strict_fifo'::text) THEN 2
                        ELSE 0
                        END AS strategy,
                    q_1.priority,
                    q_1.team_id,
                    ((q_1.payload -> 'max_calls'::text))::integer AS lim,
                    ((q_1.payload -> 'wait_between_retries_desc'::text))::boolean AS wait_between_retries_desc,
                    COALESCE(((q_1.payload -> 'strict_circuit'::text))::boolean, false) AS strict_circuit,
                    array_agg(ROW((m.bucket_id)::integer, (m.member_waiting)::integer, m.op)::call_center.cc_sys_distribute_bucket ORDER BY cbiq.priority DESC NULLS LAST, cbiq.ratio DESC NULLS LAST, m.bucket_id)
                    filter ( where  coalesce(m.bucket_id, 0) = any(bb.bb)) AS buckets,
                    m.op
            FROM ((( WITH mem AS MATERIALIZED (
                SELECT a.queue_id,
                       a.bucket_id,
                       count(*) AS member_waiting,
                       false AS op
                FROM call_center.cc_member_attempt a
                WHERE ((a.bridged_at IS NULL) AND (a.leaving_at IS NULL) AND ((a.state)::text = 'wait_agent'::text))
                GROUP BY a.queue_id, a.bucket_id
                UNION ALL
                SELECT q_2.queue_id,
                       q_2.bucket_id,
                       q_2.member_waiting,
                       true AS op
                FROM call_center.cc_queue_statistics q_2
                WHERE (q_2.member_waiting > 0)
            )
                     SELECT rank() OVER (PARTITION BY mem.queue_id ORDER BY mem.op) AS pos,
                            mem.queue_id,
                            mem.bucket_id,
                            mem.member_waiting,
                            mem.op
                     FROM mem) m
                JOIN call_center.cc_queue q_1 ON ((q_1.id = m.queue_id)))
                LEFT JOIN call_center.cc_bucket_in_queue cbiq ON (((cbiq.queue_id = m.queue_id) AND (cbiq.bucket_id = m.bucket_id))))
                     cross join lateral (
                select cqs.queue_id, array_agg(distinct coalesce(bb, 0)) bb
                from call_center.cc_skill_in_agent sa
                         inner join call_center.cc_queue_skill cqs on cqs.skill_id = sa.skill_id
                    and sa.capacity between cqs.min_capacity and cqs.max_capacity
                         left join lateral unnest(cqs.bucket_ids) bb on true
                where  sa.enabled and cqs.enabled and sa.agent_id = _agent_id
                group by 1
                ) bb
            WHERE ((m.member_waiting > 0) AND q_1.enabled AND  (m.pos = 1) AND ((cbiq.bucket_id IS NULL) OR (NOT cbiq.disabled)))
              and q_1.type = 0
              and q_1.domain_id = _domain_id
              and q_1.id = bb.queue_id
            GROUP BY q_1.domain_id, q_1.id, q_1.calendar_id, q_1.type, m.op
        ), calend AS MATERIALIZED (
            SELECT c.id AS calendar_id,
                   queues.id AS queue_id,
                   CASE
                       WHEN (queues.recall_calendar AND (NOT (tz.offset_id = ANY (array_agg(DISTINCT o1.id))))) THEN ((array_agg(DISTINCT o1.id))::int2[] + (tz.offset_id)::int2)
                       ELSE (array_agg(DISTINCT o1.id))::int2[]
                       END AS l,
                   (queues.recall_calendar AND (NOT (tz.offset_id = ANY (array_agg(DISTINCT o1.id))))) AS recall_calendar
            FROM ((((flow.calendar c
                LEFT JOIN flow.calendar_timezones tz ON ((tz.id = c.timezone_id)))
                JOIN queues ON ((queues.calendar_id = c.id)))
                JOIN LATERAL unnest(c.accepts) a(disabled, day, start_time_of_day, end_time_of_day) ON (true))
                JOIN flow.calendar_timezone_offsets o1 ON ((((a.day + 1) = (date_part('isodow'::text, timezone(o1.names[1], now())))::integer) AND (((to_char(timezone(o1.names[1], now()), 'SSSS'::text))::integer / 60) >= a.start_time_of_day) AND (((to_char(timezone(o1.names[1], now()), 'SSSS'::text))::integer / 60) <= a.end_time_of_day))))
            WHERE (NOT (a.disabled IS TRUE))
            GROUP BY c.id, queues.id, queues.recall_calendar, tz.offset_id
        ), resources AS MATERIALIZED (
            SELECT l_1.queue_id,
                   array_agg(ROW(cor.communication_id, (cor.id)::bigint, ((l_1.l & (l2.x)::integer[]))::smallint[], (cor.resource_group_id)::integer)::call_center.cc_sys_distribute_type) AS types,
                   array_agg(ROW((cor.id)::bigint, ((cor."limit" - used.cnt))::integer, cor.patterns)::call_center.cc_sys_distribute_resource) AS resources,
                   call_center.cc_array_merge_agg((l_1.l & (l2.x)::integer[])) AS offset_ids
            FROM (((calend l_1
                JOIN ( SELECT corg.queue_id,
                              corg.priority,
                              corg.resource_group_id,
                              corg.communication_id,
                              corg."time",
                              (corg.cor).id AS id,
                              (corg.cor)."limit" AS "limit",
                              (corg.cor).enabled AS enabled,
                              (corg.cor).updated_at AS updated_at,
                              (corg.cor).rps AS rps,
                              (corg.cor).domain_id AS domain_id,
                              (corg.cor).reserve AS reserve,
                              (corg.cor).variables AS variables,
                              (corg.cor).number AS number,
                              (corg.cor).max_successively_errors AS max_successively_errors,
                              (corg.cor).name AS name,
                              (corg.cor).last_error_id AS last_error_id,
                              (corg.cor).successively_errors AS successively_errors,
                              (corg.cor).created_at AS created_at,
                              (corg.cor).created_by AS created_by,
                              (corg.cor).updated_by AS updated_by,
                              (corg.cor).error_ids AS error_ids,
                              (corg.cor).gateway_id AS gateway_id,
                              (corg.cor).email_profile_id AS email_profile_id,
                              (corg.cor).payload AS payload,
                              (corg.cor).description AS description,
                              (corg.cor).patterns AS patterns,
                              (corg.cor).failure_dial_delay AS failure_dial_delay,
                              (corg.cor).last_error_at AS last_error_at
                       FROM (calend calend_1
                           JOIN ( SELECT DISTINCT cqr.queue_id,
                                                  corig.priority,
                                                  corg_1.id AS resource_group_id,
                                                  corg_1.communication_id,
                                                  corg_1."time",
                                                  CASE
                                                      WHEN (cor_1.enabled AND gw.enable) THEN ROW(cor_1.id, cor_1."limit", cor_1.enabled, cor_1.updated_at, cor_1.rps, cor_1.domain_id, cor_1.reserve, cor_1.variables, cor_1.number, cor_1.max_successively_errors, cor_1.name, cor_1.last_error_id, cor_1.successively_errors, cor_1.created_at, cor_1.created_by, cor_1.updated_by, cor_1.error_ids, cor_1.gateway_id, cor_1.email_profile_id, cor_1.payload, cor_1.description, cor_1.patterns, cor_1.failure_dial_delay, cor_1.last_error_at, NULL::jsonb)::call_center.cc_outbound_resource
                                                      WHEN (cor2.enabled AND gw2.enable) THEN ROW(cor2.id, cor2."limit", cor2.enabled, cor2.updated_at, cor2.rps, cor2.domain_id, cor2.reserve, cor2.variables, cor2.number, cor2.max_successively_errors, cor2.name, cor2.last_error_id, cor2.successively_errors, cor2.created_at, cor2.created_by, cor2.updated_by, cor2.error_ids, cor2.gateway_id, cor2.email_profile_id, cor2.payload, cor2.description, cor2.patterns, cor2.failure_dial_delay, cor2.last_error_at, NULL::jsonb)::call_center.cc_outbound_resource
                                                      ELSE NULL::call_center.cc_outbound_resource
                                                      END AS cor
                                  FROM ((((((call_center.cc_queue_resource cqr
                                      JOIN call_center.cc_outbound_resource_group corg_1 ON ((cqr.resource_group_id = corg_1.id)))
                                      JOIN call_center.cc_outbound_resource_in_group corig ON ((corg_1.id = corig.group_id)))
                                      JOIN call_center.cc_outbound_resource cor_1 ON ((cor_1.id = (corig.resource_id)::integer)))
                                      JOIN directory.sip_gateway gw ON ((gw.id = cor_1.gateway_id)))
                                      LEFT JOIN call_center.cc_outbound_resource cor2 ON (((cor2.id = corig.reserve_resource_id) AND cor2.enabled)))
                                      LEFT JOIN directory.sip_gateway gw2 ON (((gw2.id = cor2.gateway_id) AND cor2.enabled)))
                                  WHERE (
                                            CASE
                                                WHEN (cor_1.enabled AND gw.enable) THEN cor_1.id
                                                WHEN (cor2.enabled AND gw2.enable) THEN cor2.id
                                                ELSE NULL::integer
                                                END IS NOT NULL)
                                  ORDER BY cqr.queue_id, corig.priority DESC) corg ON ((corg.queue_id = calend_1.queue_id)))) cor ON ((cor.queue_id = l_1.queue_id)))
                JOIN LATERAL ( WITH times AS (
                    SELECT ((e.value -> 'start_time_of_day'::text))::integer AS start,
                           ((e.value -> 'end_time_of_day'::text))::integer AS "end"
                    FROM jsonb_array_elements(cor."time") e(value)
                )
                               SELECT array_agg(DISTINCT t.id) AS x
                               FROM flow.calendar_timezone_offsets t,
                                    times,
                                    LATERAL ( SELECT timezone(t.names[1], CURRENT_TIMESTAMP) AS t) with_timezone
                               WHERE ((((to_char(with_timezone.t, 'SSSS'::text))::integer / 60) >= times.start) AND (((to_char(with_timezone.t, 'SSSS'::text))::integer / 60) <= times."end"))) l2 ON ((l2.* IS NOT NULL)))
                LEFT JOIN LATERAL ( SELECT count(*) AS cnt
                                    FROM ( SELECT 1 AS cnt
                                           FROM call_center.cc_member_attempt c_1
                                           WHERE ((c_1.resource_id = cor.id) AND ((c_1.state)::text <> ALL (ARRAY[('leaving'::character varying)::text, ('processing'::character varying)::text])))) c) used ON (true))
            WHERE (cor.enabled AND ((cor.last_error_at IS NULL) OR (cor.last_error_at <= (now() - ((cor.failure_dial_delay || ' s'::text))::interval))) AND ((cor."limit" - used.cnt) > 0))
            GROUP BY l_1.queue_id
        )
           , request as  (
            SELECT distinct q.id,
                            (q.strategy)::int2 AS strategy,
                            q.team_id,
                            bs.bucket_id::int as bucket_id,
                            r.types,
                            r.resources,
                            q.priority,
                            q.sticky_agent,
                            q.sticky_agent_sec,
                            calend.recall_calendar,
                            q.wait_between_retries_desc,
                            q.strict_circuit,
                            calend.l
            FROM (((queues q
                LEFT JOIN calend ON ((calend.queue_id = q.id)))
                LEFT JOIN resources r ON ((q.op AND (r.queue_id = q.id))))
                LEFT JOIN LATERAL ( SELECT count(*) AS usage
                                    FROM call_center.cc_member_attempt a
                                    WHERE ((a.queue_id = q.id) AND ((a.state)::text <> 'leaving'::text))) l ON ((q.lim > 0)))
                     join lateral unnest(q.buckets) bs on true
            where r.* IS NOT NULL
        )
        select x
        from request
                 left join lateral call_center.cc_distribute_members_list(request.id::int, request.bucket_id::int,
                                                                          request.strategy::int2, request.wait_between_retries_desc, request.l::int2[], _lim::int) x on true
        order by request.priority desc
        limit _lim;
end
$$;


--
-- Name: cc_outbound_resource_display_changed(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_outbound_resource_display_changed() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
        update call_center.cc_outbound_resource r
        set updated_at = (extract(epoch from now()) * 1000)::int8
        where r.id = coalesce(NEW.resource_id, OLD.resource_id);

        RETURN NEW;
    END;
$$;


--
-- Name: cc_outbound_resource_timing(jsonb); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_outbound_resource_timing(jsonb) RETURNS smallint[]
    LANGUAGE plpgsql IMMUTABLE STRICT
    AS $_$
declare res_ smallint[];
BEGIN
    with times as (
        select (e->'start_time_of_day')::int as start, (e->'end_time_of_day')::int as end
        from jsonb_array_elements($1) e
    )
    select array_agg(distinct t.id) x
    into res_
    from flow.calendar_timezone_offsets t,
         lateral (select current_timestamp AT TIME ZONE t.names[1] t) with_timezone
    where exists (select 1 from times where (to_char(with_timezone.t, 'SSSS') :: int / 60) between times.start and times.end);

    return res_;
END;
$_$;


--
-- Name: cc_queue_default_timezone_offset_id(integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_queue_default_timezone_offset_id(integer) RETURNS integer[]
    LANGUAGE sql IMMUTABLE
    AS $_$
select array[c.timezone_id, z.offset_id]::int4[]
    from call_center.cc_queue q
        inner join flow.calendar c on c.id = q.calendar_id
        inner join flow.calendar_timezones z on z.id = c.timezone_id
    where q.id = $1;
$_$;


--
-- Name: cc_queue_event_changed_tg(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_queue_event_changed_tg() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
    IF (TG_OP = 'DELETE') THEN
        update call_center.cc_queue
        set updated_at = (extract(epoch from now()) * 1000)::int8
        where id = old.queue_id;

        return old;
    else
        update call_center.cc_queue
        set updated_at = (extract(epoch from new.updated_at) * 1000)::int8,
            updated_by = new.updated_by
        where id = new.queue_id;

        return new;
    end if;
END;
$$;


--
-- Name: cc_resource_set_error(bigint, bigint, character varying, character varying); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_resource_set_error(_id bigint, _routing_id bigint, _error_id character varying, _strategy character varying) RETURNS record
    LANGUAGE plpgsql
    AS $$
DECLARE _res record;
  _stopped boolean;
  _successively_errors smallint;
  _un_reserved_id bigint;
BEGIN

  update call_center.cc_outbound_resource
  set last_error_id = _error_id,
      last_error_at = now(),
    successively_errors = case when successively_errors + 1 >= max_successively_errors then 0 else successively_errors + 1 end,
    enabled = case when successively_errors + 1 >= max_successively_errors then false else enabled end
  where id = _id and "enabled" is true
  returning not enabled, successively_errors
      into _stopped, _successively_errors
  ;

  select _successively_errors::smallint, _stopped::boolean, _un_reserved_id::bigint into _res;
  return _res;
END;
$$;


--
-- Name: cc_scheduler_jobs(); Type: PROCEDURE; Schema: call_center; Owner: -
--

CREATE PROCEDURE call_center.cc_scheduler_jobs()
    LANGUAGE plpgsql
    AS $$
begin

    if NOT pg_try_advisory_xact_lock(132132118) then
        raise exception 'LOCKED cc_scheduler_jobs';
end if;

with del as (
delete from call_center.cc_trigger_job
where stopped_at notnull
        returning id, trigger_id, state, created_at, started_at, stopped_at, parameters, error, result, node_id, domain_id
    )
insert into call_center.cc_trigger_job_log (id, trigger_id, state, created_at, started_at, stopped_at, parameters, error, result, node_id, domain_id)
select id, trigger_id, state, created_at, started_at, stopped_at, parameters, error, result, node_id, domain_id
from del
;

with u as (
update call_center.cc_trigger t2
set schedule_at = (t.new_schedule_at)::timestamp
from (select t.id,
    jsonb_build_object('variables', t.variables,
    'schema_id', t.schema_id,
    'timeout', t.timeout_sec
    ) as                                      params,
    call_center.cc_cron_next_after_now(t.expression, (t.schedule_at)::timestamp, (now() at time zone tz.sys_name)::timestamp) new_schedule_at,
    t.domain_id,
    (t.schedule_at)::timestamp as old_schedule_at,
    (now() at time zone tz.sys_name)::timestamp - (t.schedule_at)::timestamp < interval '5m' valid
    from call_center.cc_trigger t
    inner join flow.calendar_timezones tz on tz.id = t.timezone_id
    where t.enabled
    and (t.schedule_at)::timestamp <= (now() at time zone tz.sys_name)::timestamp
    and not exists(select 1 from call_center.cc_trigger_job tj where tj.trigger_id = t.id and tj.state = 0)
    for update of t skip locked) t
where t2.id = t.id
    returning t.*
    )
insert
into call_center.cc_trigger_job(trigger_id, parameters, domain_id)
select id, params, domain_id
from u
where u.valid;
end;
$$;


--
-- Name: cc_set_active_members(character varying); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_set_active_members(node character varying) RETURNS TABLE(id bigint, member_id bigint, result character varying, queue_id integer, queue_updated_at bigint, queue_count integer, queue_active_count integer, queue_waiting_count integer, resource_id integer, resource_updated_at bigint, gateway_updated_at bigint, destination jsonb, variables jsonb, name character varying, member_call_id character varying, agent_id integer, agent_updated_at bigint, team_updated_at bigint, list_communication_id bigint, seq integer, communication_idx integer, timezone character varying)
    LANGUAGE plpgsql
    AS $$
BEGIN
    return query update call_center.cc_member_attempt a
        set state = case when c.member_id isnull then 'leaving' else
            case when c.queue_type in (3, 4) then 'offering' else 'waiting' end
            end
            ,node_id = node
            ,last_state_change = now()
            ,list_communication_id = lc.id
            ,seq = coalesce(c.attempts, -1) + 1
            ,waiting_other_numbers = coalesce(c.waiting_other_numbers, 0)
            ,result = case when c.member_id isnull then 'cancel' else a.result end
            ,leaving_at = case when c.member_id isnull then now() end
        from (
            select c.id,
                   cq.updated_at                                            as queue_updated_at,
                   r.updated_at::bigint as resource_updated_at,
                   call_center.cc_view_timestamp(gw.updated_at at time zone 'utc')::bigint             as gateway_updated_at,
                   c.destination                                            as destination,
                   cm.variables                                             as variables,
                   cm.name                                                  as member_name,
                   c.state                                                  as state,
                   cqs.member_count                                         as queue_cnt,
                   0                                                        as queue_active_cnt,
                   cqs.member_waiting                                       as queue_waiting_cnt,
                   (ca.updated_at - extract(epoch from u.updated_at))::int8 as agent_updated_at,
                   tm.updated_at                                            as team_updated_at,
                   cq.dnc_list_id,
                   cm.attempts,
                   x.cnt                                                    as waiting_other_numbers,
                   cq.type                                                  as queue_type,
                   cm.id as member_id,
                   tz.sys_name::varchar as member_timezone
            from call_center.cc_member_attempt c
                     left join call_center.cc_member cm on c.member_id = cm.id
                     left join lateral (
                select count(*) cnt
                from jsonb_array_elements(cm.communications) WITH ORDINALITY AS x(c, n)
                where coalesce((x.c -> 'stop_at')::int8, 0) < 1
                  and x.n != (c.communication_idx + 1)
                ) x on c.member_id notnull
                     inner join call_center.cc_queue cq on c.queue_id = cq.id
                     left join call_center.cc_team tm on tm.id = c.team_id
                     left join call_center.cc_outbound_resource r on r.id = c.resource_id
                     left join directory.sip_gateway gw on gw.id = r.gateway_id
                     left join call_center.cc_agent ca on c.agent_id = ca.id
                     left join call_center.cc_queue_statistics cqs on cq.id = cqs.queue_id
                     left join directory.wbt_user u on u.id = ca.user_id
                     left join flow.calendar cr on cr.id = cq.calendar_id
                     left join flow.calendar_timezones tz on tz.id = coalesce(cm.timezone_id, cr.timezone_id)
            where c.state = 'idle'
              and c.leaving_at isnull
            order by cq.priority desc, c.weight desc
                for update of c, cq skip locked
        ) c
            left join call_center.cc_list_communications lc on lc.list_id = c.dnc_list_id and
                                                               lc.number = c.destination ->> 'destination'
        where a.id = c.id --and node = 'call_center-igor'
        returning
            a.id::bigint as id,
            a.member_id::bigint as member_id,
            a.result as result,
            a.queue_id::int as qeueue_id,
            c.queue_updated_at::bigint as queue_updated_at,
            c.queue_cnt::int,
            c.queue_active_cnt::int,
            c.queue_waiting_cnt::int,
            a.resource_id::int as resource_id,
            greatest(c.resource_updated_at::bigint, c.gateway_updated_at::bigint) as resource_updated_at,
            greatest(c.resource_updated_at::bigint, c.gateway_updated_at::bigint) as gateway_updated_at,
            c.destination,
            coalesce(c.variables, '{}') ,
            coalesce(c.member_name, ''),
            a.member_call_id,
            a.agent_id,
            c.agent_updated_at,
            c.team_updated_at,
            a.list_communication_id,
            a.seq,
            a.communication_idx,
            c.member_timezone;
END;
$$;


--
-- Name: cc_set_agent_change_status(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_set_agent_change_status() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
    -- FIXME
    if TG_OP = 'INSERT' then
        return new;
    end if;

    -- TODO del me
    insert into call_center.cc_agent_state_history (agent_id, joined_at, state, duration, payload)
    values (old.id, old.last_state_change, old.status,  new.last_state_change - old.last_state_change, old.status_payload);


    insert into call_center.cc_agent_status_log (agent_id, joined_at, status, duration, payload)
    values (old.id, old.last_state_change, old.status,  new.last_state_change - old.last_state_change, old.status_payload);
    RETURN new;
END;
$$;


--
-- Name: cc_set_agent_channel_change_status(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_set_agent_channel_change_status() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
        -- FIXME
    if TG_OP = 'INSERT' then
        return new;
    end if;
  if new.online != old.online and new.state = 'waiting' then
      new.joined_at := now();
      if new.online then
          return new;
      end if;
  end if;

  --
  if new.state = 'waiting' then
      new.lose_attempt = 0;
      new.queue_id := null;
      new.attempt_id := null;
  end if;

  --fixme error when agent set offline/pause in active call
  if new.joined_at - old.joined_at = interval '0' then
        return new;
  end if;

  new.channel_changed_at = now();

  insert into call_center.cc_agent_state_history (agent_id, joined_at, state, channel, duration, queue_id, attempt_id)
  values (old.agent_id, old.joined_at, old.state, old.channel, new.joined_at - old.joined_at, old.queue_id, old.attempt_id);

  RETURN new;
END;
$$;


--
-- Name: cc_team_agents_by_bucket(character varying, integer, integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_team_agents_by_bucket(ch_ character varying, team_id_ integer, bucket_id integer) RETURNS integer[]
    LANGUAGE plpgsql
    AS $_$
declare res int4[];
begin
    select array_agg(a.id order by b.lvl asc, a.last_state_change)
    into res
    from call_center.cc_agent_channel cac
             inner join call_center.cc_agent a on a.id = cac.agent_id
             inner join call_center.cc_sys_agent_group_team_bucket b on b.agent_id = cac.agent_id
    where (cac.agent_id, cac.channel) = (a.id, $1) and cac.state = 'waiting' and cac.timeout isnull
      and a.status = 'online'
      and b.team_id = $2::int4
      and not exists(select 1 from call_center.cc_member_attempt att where att.agent_id = cac.agent_id)
      and case when $3 isnull then true else b.bucket_id = $3 end ;

    return res;
end;
$_$;


--
-- Name: cc_timezone_offset_id(integer); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_timezone_offset_id(integer) RETURNS smallint
    LANGUAGE sql IMMUTABLE
    AS $_$
select z.offset_id
    from flow.calendar_timezones z
    where z.id = $1;
$_$;


--
-- Name: cc_trigger_ins_upd(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_trigger_ins_upd() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
        if call_center.cc_cron_valid(NEW.expression) is not true then
            raise exception 'invalid expression %', NEW.expression using errcode ='20808';
        end if;

        if old.enabled != new.enabled or old.expression != new.expression or old.timezone_id != new.timezone_id then
            select
                call_center.cc_cron_next_after_now(new.expression, (now() at time zone tz.sys_name)::timestamp, (now() at time zone tz.sys_name)::timestamp)
            into new.schedule_at
            from flow.calendar_timezones tz
            where tz.id = NEW.timezone_id;
        end if;

        RETURN NEW;
    END;
$$;


--
-- Name: cc_un_reserve_members_with_resources(character varying, character varying); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_un_reserve_members_with_resources(node character varying, res character varying) RETURNS integer
    LANGUAGE plpgsql
    AS $$
DECLARE
    count integer;
BEGIN
    update call_center.cc_member_attempt
      set state  =  'leaving',
          leaving_at = now(),
          result = res
    where leaving_at isnull and node_id = node and state = 'idle';

    get diagnostics count = row_count;
    return count;
END;
$$;


--
-- Name: cc_update_array_elements(jsonb, text[], jsonb); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_update_array_elements(target jsonb, path text[], new_value jsonb) RETURNS jsonb
    LANGUAGE sql
    AS $$
    -- aggregate the jsonb from parts created in LATERAL
    SELECT jsonb_agg(updated_jsonb)
    -- split the target array to individual objects...
    FROM jsonb_array_elements(target) individual_object,
    -- operate on each object and apply jsonb_set to it. The results are aggregated in SELECT
    LATERAL jsonb_set(individual_object, path, new_value) updated_jsonb
  $$;


--
-- Name: cc_view_timestamp(timestamp with time zone); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_view_timestamp(t timestamp with time zone) RETURNS bigint
    LANGUAGE plpgsql IMMUTABLE
    AS $$
begin
    if t isnull then
        return 0::int8;
    else
        return (extract(EPOCH from t) * 1000)::int8;
    end if;
end;
$$;


--
-- Name: cc_wrap_over_dial(numeric, numeric, numeric, numeric, numeric); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.cc_wrap_over_dial(over numeric DEFAULT 1, current numeric DEFAULT 0, target numeric DEFAULT 5, max numeric DEFAULT 7, q numeric DEFAULT 10) RETURNS numeric
    LANGUAGE plpgsql IMMUTABLE
    AS $$
declare dx numeric;
begin
    if current >= max then
        return 1;
    end if;

    dx = target - current;
    if dx = 0 then
        dx = 0.99;
    end if;

    if dx > 0 then
        return over + ( (over * dx * q) / 100 );
    else
        return (over * (((max - current) * (100 + q )) / max) ) / 100;
    end if;
end;
$$;


--
-- Name: rbac_users_from_group(character varying, bigint, smallint, integer[]); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.rbac_users_from_group(_class_name character varying, _domain_id bigint, _access smallint, _groups integer[]) RETURNS integer[]
    LANGUAGE sql IMMUTABLE
    AS $$
    select array_agg(distinct am.member_id::int)
    from directory.wbt_class c
        inner join directory.wbt_default_acl a on a.object = c.id
        join directory.wbt_auth_member am on am.role_id = a.grantor
    where c.name = _class_name
      and c.dc = _domain_id
      and a.access&_access = _access and a.subject = any(_groups)
$$;


--
-- Name: tg_obj_default_rbac(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE FUNCTION call_center.tg_obj_default_rbac() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
BEGIN

        EXECUTE format(
'INSERT INTO %I.%I AS acl (dc, object, grantor, subject, access)
 SELECT $1, $2, rbac.grantor, rbac.subject, rbac.access
   FROM (
    -- NEW object OWNER access SUPER(255) mode (!)
    SELECT $3, $3, (255)::int2
     UNION ALL
    SELECT DISTINCT ON (rbac.subject)
      -- [WHO] grants MAX of WINDOW subset access level
        first_value(rbac.grantor) OVER sub
      -- [WHOM] role/user administrative unit
      , rbac.subject
      -- [GRANT] ALL of WINDOW subset access mode(s)
      , bit_or(rbac.access) OVER sub

      FROM directory.wbt_default_acl AS rbac
      JOIN directory.wbt_class AS oc ON (oc.dc, oc.name) = ($1, %L)
      -- EXISTS( OWNER membership WITH grantor role )
      -- JOIN directory.wbt_auth_member AS sup ON (sup.role_id, sup.member_id) = (rbac.grantor, $3)
     WHERE rbac.object = oc.id
       AND rbac.subject <> $3
        -- EXISTS( OWNER membership WITH grantor user/role )
       AND (rbac.grantor = $3 OR EXISTS(SELECT true
             FROM directory.wbt_auth_member sup
            WHERE sup.member_id = $3
              AND sup.role_id = rbac.grantor
           ))
    WINDOW sub AS (PARTITION BY rbac.subject ORDER BY rbac.access DESC)

   ) AS rbac(grantor, subject, access)',

--   ON CONFLICT (object, subject)
--   DO UPDATE SET
--     grantor = EXCLUDED.grantor,
--     access = EXCLUDED.access',

            tg_table_schema,
            tg_table_name||'_acl',
            tg_argv[0]::name -- objclass: directory.wbt_class.name
        )
    --      :srv,   :oid,   :rid
    USING NEW.domain_id, NEW.id, NEW.created_by;
    -- FOR EACH ROW
    RETURN NEW;

END
$_$;


--
-- Name: tg_obj_default_rbac(); Type: FUNCTION; Schema: directory; Owner: -
--

CREATE FUNCTION directory.tg_obj_default_rbac() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
BEGIN

    EXECUTE format(
'INSERT INTO %I.%I AS acl (dc, object, grantor, subject, access)
 SELECT $1, $2, rbac.grantor, rbac.subject, rbac.access
   FROM (
    -- NEW object OWNER access SUPER(255) mode (!)
    SELECT $3, $3, (255)::int2
     UNION ALL
    SELECT DISTINCT ON (rbac.subject)
      -- [WHO] grants MAX of WINDOW subset access level
        first_value(rbac.grantor) OVER sub
      -- [WHOM] role/user administrative unit
      , rbac.subject
      -- [GRANT] ALL of WINDOW subset access mode(s)
      , bit_or(rbac.access) OVER sub

      FROM directory.wbt_default_acl AS rbac
      JOIN directory.wbt_class AS oc ON (oc.dc, oc.name) = ($1, %L)
      -- EXISTS( OWNER membership WITH grantor role )
      -- JOIN directory.wbt_auth_member AS sup ON (sup.role_id, sup.member_id) = (rbac.grantor, $3)
     WHERE rbac.object = oc.id
       AND rbac.subject <> $3
        -- EXISTS( OWNER membership WITH grantor user/role )
       AND (rbac.grantor = $3 OR EXISTS(SELECT true
             FROM directory.wbt_auth_member sup
            WHERE sup.member_id = $3
              AND sup.role_id = rbac.grantor
           ))
    WINDOW sub AS (PARTITION BY rbac.subject ORDER BY rbac.access DESC)

   ) AS rbac(grantor, subject, access)',

--   ON CONFLICT (object, subject)
--   DO UPDATE SET
--     grantor = EXCLUDED.grantor,
--     access = EXCLUDED.access',

            tg_table_schema,
            tg_table_name||'_acl',
            tg_argv[0]::name -- objclass: directory.wbt_class.name
        )
    --      :srv,   :oid,   :rid
    USING NEW.dc, NEW.id, NEW.created_by;
    -- FOR EACH ROW
    RETURN NEW;

END
$_$;


--
-- Name: tg_stmt_default_rbac(); Type: FUNCTION; Schema: directory; Owner: -
--

CREATE FUNCTION directory.tg_stmt_default_rbac() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
    -- CHECK has records (?)
    PERFORM FROM inserted
    WHERE created_by NOTNULL
    LIMIT 1;

    -- raise notice 'tgr_stmt_default_rbac';

    IF FOUND THEN
        EXECUTE format(
'INSERT INTO %I.%I AS acl (dc, object, grantor, subject, access)
 SELECT obj.dc, obj.id, rbac.grantor, rbac.subject, rbac.access
   FROM inserted AS obj -- REFERENCING NEW TABLE AS inserted
   JOIN directory.wbt_class AS oc ON (oc.dc, oc.name) = (obj.dc, %L)
   JOIN LATERAL (
    -- NEW object OWNER access SUPER(255) mode (!)
    SELECT obj.created_by, obj.created_by, (255)::int2
     UNION ALL
    SELECT DISTINCT ON (rbac.subject)
      -- [WHO] grants MAX of WINDOW subset access level
        first_value(rbac.grantor) OVER sub
      -- [WHOM] role/user administrative unit
      , rbac.subject
      -- [GRANT] ALL of WINDOW subset access mode(s)
      , bit_or(rbac.access) OVER sub

      FROM directory.wbt_default_acl AS rbac
      -- EXISTS( OWNER membership WITH grantor role )
      -- JOIN directory.wbt_auth_member AS sup ON (sup.role_id, sup.member_id) = (rbac.grantor, obj.created_by)
     WHERE rbac.object = oc.id
       AND rbac.subject <> obj.created_by
        -- EXISTS( OWNER membership WITH grantor user/role )
       AND (rbac.grantor = obj.created_by OR EXISTS(SELECT true
             FROM directory.wbt_auth_member sup
            WHERE sup.member_id = obj.created_by
              AND sup.role_id = rbac.grantor
           ))
    WINDOW sub AS (PARTITION BY rbac.subject ORDER BY rbac.access DESC)

   ) AS rbac(grantor, subject, access) ON true',

--   ON CONFLICT (object, subject)
--   DO UPDATE SET
--     grantor = EXCLUDED.grantor,
--     access = EXCLUDED.access',

            tg_table_schema,
            tg_table_name||'_acl',
            tg_argv[0]::name -- objclass: directory.wbt_class.name
        );
    --      :srv,   :oid,   :rid
    -- USING NEW.dc, NEW.id, NEW.created_by;
    -- RETURN NEW;

    END IF;
    RETURN NULL; -- FOR STATEMENT
END
$$;


--
-- Name: arr_type_to_jsonb(anyarray); Type: FUNCTION; Schema: flow; Owner: -
--

CREATE FUNCTION flow.arr_type_to_jsonb(anyarray) RETURNS jsonb
    LANGUAGE sql IMMUTABLE
    AS $_$
select jsonb_agg(row_to_json(a))
    from unnest($1) a;
$_$;


--
-- Name: calendar_accepts_to_jsonb(flow.calendar_accept_time[]); Type: FUNCTION; Schema: flow; Owner: -
--

CREATE FUNCTION flow.calendar_accepts_to_jsonb(flow.calendar_accept_time[]) RETURNS jsonb
    LANGUAGE sql IMMUTABLE
    AS $_$
select jsonb_agg(x.r)
    from (
             select row_to_json(a) r
             from unnest($1) a
    ) x;
$_$;


--
-- Name: calendar_check_timing(bigint, integer, character varying); Type: FUNCTION; Schema: flow; Owner: -
--

CREATE FUNCTION flow.calendar_check_timing(domain_id_ bigint, calendar_id_ integer, name_ character varying) RETURNS record
    LANGUAGE plpgsql IMMUTABLE
    AS $$
declare
        res record;
begin
    select c.name,
           (
               select x.name
               from unnest(c.excepts) as x
               where not x.disabled is true
                 and case
                         when x.repeat is true then
                                 to_char((current_timestamp AT TIME ZONE ct.sys_name)::date, 'MM-DD') =
                                 to_char((to_timestamp(x.date / 1000) at time zone ct.sys_name)::date, 'MM-DD')
                         else
                                 (current_timestamp AT TIME ZONE ct.sys_name)::date =
                                 (to_timestamp(x.date / 1000) at time zone ct.sys_name)::date
                   end
               limit 1
           )                     excepted,
           exists(
                   select 1
                   from unnest(c.accepts) as x
                   where not x.disabled is true
                     and x.day + 1 = extract(isodow from current_timestamp AT TIME ZONE ct.sys_name)::int
                     and (to_char(current_timestamp AT TIME ZONE ct.sys_name, 'SSSS') :: int / 60) between x.start_time_of_day and x.end_time_of_day
               )                 accept,
           case
               when c.start_at > 0 and c.end_at > 0 then
                   not current_date AT TIME ZONE ct.sys_name between (to_timestamp(c.start_at / 1000) at time zone ct.sys_name)::date and (to_timestamp(c.end_at / 1000) at time zone ct.sys_name)::date
               else false end as expire
    into res
    from flow.calendar c
             inner join flow.calendar_timezones ct on c.timezone_id = ct.id
    where c.domain_id = domain_id_
      and (
        c.id = calendar_id_ or c.name = name_
        )
    limit 1;

    return res;
end;
$$;


--
-- Name: calendar_day_range(integer, integer); Type: FUNCTION; Schema: flow; Owner: -
--

CREATE FUNCTION flow.calendar_day_range(calendar_id integer, days integer) RETURNS SETOF date
    LANGUAGE plpgsql IMMUTABLE
    AS $$
declare i int = 0;
    declare y int = 0;
    declare r record;
    declare d timestamp = null;
begin
        select c.excepts, c.accepts, tz.sys_name
        into r
        from  flow.calendar c
            inner join flow.calendar_timezones tz on tz.id = c.timezone_id
        where c.id = calendar_id
        limit 1
        ;

        while r notnull and i < days and y < 1000 loop
            d = (now() at time zone r.sys_name + (y || 'd')::interval)::timestamp;
            y = y + 1;

            if exists(select 1 from unnest(r.accepts) x
                where not x.disabled and x.day = (extract(isodow from d)  ) - 1)
               and not exists(
                    select 1
                       from unnest(r.excepts) as x
                       where not x.disabled is true
                         and case
                                 when x.repeat is true then
                                         to_char((d AT TIME ZONE r.sys_name)::date, 'MM-DD') =
                                         to_char((to_timestamp(x.date / 1000) at time zone r.sys_name)::date, 'MM-DD')
                                 else
                                         (d AT TIME ZONE r.sys_name)::date =
                                         (to_timestamp(x.date / 1000) at time zone r.sys_name)::date
                           end
                ) then
                i = i + 1;
                return next d::timestamp;
            end if;
        end loop;
end;
$$;


--
-- Name: calendar_json_to_accepts(jsonb); Type: FUNCTION; Schema: flow; Owner: -
--

CREATE FUNCTION flow.calendar_json_to_accepts(jsonb) RETURNS flow.calendar_accept_time[]
    LANGUAGE sql IMMUTABLE
    AS $_$
select array(
       select row ((x -> 'disabled')::bool, (x -> 'day')::smallint, (x -> 'start_time_of_day')::smallint, (x -> 'end_time_of_day')::smallint)::flow.calendar_accept_time
       from jsonb_array_elements($1) x
       order by x -> 'day', x -> 'start_time_of_day'
   )::flow.calendar_accept_time[]
$_$;


--
-- Name: calendar_json_to_excepts(jsonb); Type: FUNCTION; Schema: flow; Owner: -
--

CREATE FUNCTION flow.calendar_json_to_excepts(jsonb) RETURNS flow.calendar_except_date[]
    LANGUAGE sql IMMUTABLE
    AS $_$
select array(
       select row ((x -> 'disabled')::bool, (x -> 'date')::int8, (x ->> 'name')::varchar, (x -> 'repeat')::bool)::flow.calendar_except_date
       from jsonb_array_elements($1) x
       order by x -> 'date'
   )::flow.calendar_except_date[]
$_$;


--
-- Name: get_lookup(bigint, character varying); Type: FUNCTION; Schema: flow; Owner: -
--

CREATE FUNCTION flow.get_lookup(_id bigint, _name character varying) RETURNS jsonb
    LANGUAGE plpgsql IMMUTABLE
    AS $$
BEGIN
    if _id isnull then
        return null;
    else
        return json_build_object('id', _id, 'name', _name)::jsonb;
    end if;
END;
$$;


--
-- Name: tg_obj_default_rbac(); Type: FUNCTION; Schema: flow; Owner: -
--

CREATE FUNCTION flow.tg_obj_default_rbac() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
BEGIN

    EXECUTE format(
'INSERT INTO %I.%I AS acl (dc, object, grantor, subject, access)
 SELECT $1, $2, rbac.grantor, rbac.subject, rbac.access
   FROM (
    -- NEW object OWNER access SUPER(255) mode (!)
    SELECT $3, $3, (255)::int2
     UNION ALL
    SELECT DISTINCT ON (rbac.subject)
      -- [WHO] grants MAX of WINDOW subset access level
        first_value(rbac.grantor) OVER sub
      -- [WHOM] role/user administrative unit
      , rbac.subject
      -- [GRANT] ALL of WINDOW subset access mode(s)
      , bit_or(rbac.access) OVER sub

      FROM directory.wbt_default_acl AS rbac
      JOIN directory.wbt_class AS oc ON (oc.dc, oc.name) = ($1, %L)
      -- EXISTS( OWNER membership WITH grantor role )
      -- JOIN directory.wbt_auth_member AS sup ON (sup.role_id, sup.member_id) = (rbac.grantor, $3)
     WHERE rbac.object = oc.id
       AND rbac.subject <> $3
        -- EXISTS( OWNER membership WITH grantor user/role )
       AND (rbac.grantor = $3 OR EXISTS(SELECT true
             FROM directory.wbt_auth_member sup
            WHERE sup.member_id = $3
              AND sup.role_id = rbac.grantor
           ))
    WINDOW sub AS (PARTITION BY rbac.subject ORDER BY rbac.access DESC)

   ) AS rbac(grantor, subject, access)',

--   ON CONFLICT (object, subject)
--   DO UPDATE SET
--     grantor = EXCLUDED.grantor,
--     access = EXCLUDED.access',

            tg_table_schema,
            tg_table_name||'_acl',
            tg_argv[0]::name -- objclass: directory.wbt_class.name
        )
    --      :srv,   :oid,   :rid
    USING NEW.domain_id, NEW.id, NEW.created_by;
    -- FOR EACH ROW
    RETURN NEW;

END
$_$;


--
-- Name: get_rec_name(bigint, character varying, character varying); Type: FUNCTION; Schema: logger; Owner: -
--

CREATE FUNCTION logger.get_rec_name(rec bigint, schema_name character varying, table_name character varying) RETURNS character varying
    LANGUAGE plpgsql IMMUTABLE
    AS $_$
    declare r varchar;
begin
     execute (format('select name from %s.%s where id = $1',
         quote_ident(schema_name), quote_ident(table_name))) into r using rec;
     return r;
end;
$_$;


--
-- Name: tg_obj_default_rbac(); Type: FUNCTION; Schema: logger; Owner: -
--

CREATE FUNCTION logger.tg_obj_default_rbac() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
BEGIN

    EXECUTE format(
'INSERT INTO %I.%I AS acl (dc, object, grantor, subject, access)
 SELECT $1, $2, rbac.grantor, rbac.subject, rbac.access
   FROM (
    -- NEW object OWNER access SUPER(255) mode (!)
    SELECT $3, $3, (255)::int2
     UNION ALL
    SELECT DISTINCT ON (rbac.subject)
      -- [WHO] grants MAX of WINDOW subset access level
        first_value(rbac.grantor) OVER sub
      -- [WHOM] role/user administrative unit
      , rbac.subject
      -- [GRANT] ALL of WINDOW subset access mode(s)
      , bit_or(rbac.access) OVER sub

      FROM directory.wbt_default_acl AS rbac
      JOIN directory.wbt_class AS oc ON (oc.dc, oc.name) = ($1, %L)
      -- EXISTS( OWNER membership WITH grantor role )
      -- JOIN directory.wbt_auth_member AS sup ON (sup.role_id, sup.member_id) = (rbac.grantor, $3)
     WHERE rbac.object = oc.id
       AND rbac.subject <> $3
        -- EXISTS( OWNER membership WITH grantor user/role )
       AND (rbac.grantor = $3 OR EXISTS(SELECT true
             FROM directory.wbt_auth_member sup
            WHERE sup.member_id = $3
              AND sup.role_id = rbac.grantor
           ))
    WINDOW sub AS (PARTITION BY rbac.subject ORDER BY rbac.access DESC)

   ) AS rbac(grantor, subject, access)',

--   ON CONFLICT (object, subject)
--   DO UPDATE SET
--     grantor = EXCLUDED.grantor,
--     access = EXCLUDED.access',

            tg_table_schema,
            tg_table_name||'_acl',
            tg_argv[0]::name -- objclass: directory.wbt_class.name
        )
    --      :srv,   :oid,   :rid
    USING NEW.domain_id, NEW.id, NEW.created_by;
    -- FOR EACH ROW
    RETURN NEW;

END
$_$;


--
-- Name: billis_next_call_time(integer, character varying); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.billis_next_call_time(calendar_id integer, tz character varying) RETURNS timestamp with time zone
    LANGUAGE plpgsql IMMUTABLE
    AS $$
    declare y int = 0;
    declare r record;
    declare st timestamptz = null;
    declare hash jsonb[] = null;
    declare el jsonb = null;
begin
        select c.excepts, c.accepts
        into r
        from  flow.calendar c
            inner join flow.calendar_timezones tz on tz.id = c.timezone_id
        where c.id = calendar_id
        limit 1
        ;

        select array_agg(val order by x)
        into hash
        from (
            select x,
               jsonb_agg(case when a notnull then array[a.start_time_of_day, a.end_time_of_day] end order by a.start_time_of_day) val
            from generate_series(0, 6) x
                left join flow.calendar c on true
                left join lateral unnest(c.accepts) a on a.day = x and not a.disabled
            where c.id = calendar_id
            group by 1
            order by x
        ) t;

        st := now() at time zone tz;

        while r notnull and y < 10 loop
            y := y + 1;

            for el in select e from jsonb_array_elements(hash[extract(isodow from st AT TIME ZONE tz)::int]) e loop
                raise notice 'debug: el % > % [%]', el, extract(isodow from st AT TIME ZONE tz)::int, to_char(st, 'SSSS') :: int / 60;
                if (to_char(st, 'SSSS') :: int / 60) >= (el[0])::int and (to_char(st, 'SSSS') :: int / 60) <= (el[1])::int then
--                     raise notice 'correct time';
                    return now() at time zone tz;
                elseif (to_char(st, 'SSSS') :: int / 60) < (el[0])::int then
                    raise notice 'new time %', st + (((el[0])::int - (to_char(st, 'SSSS') :: int / 60)::int)::text || ' minute')::interval;
                    return st + (((el[0])::int - (to_char(st, 'SSSS') :: int / 60)::int)::text || ' minute')::interval;
                end if;
            end loop;

            st = (st::date + time '23:59:59.999999' at time zone tz) + interval '1s';
--             raise notice 'debug: change date > % new day %', st, extract(isodow from st AT TIME ZONE tz)::int;
        end loop;

        raise exception 'not found';
end;
$$;


--
-- Name: cc_member_statistic_trigger_inserted(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.cc_member_statistic_trigger_inserted() RETURNS trigger
    LANGUAGE plpgsql
    AS $_$
BEGIN
    if exists(select 1
        from inserted m,
             (select c.domain_id, array_agg(c.id) ids
        from call_center.cc_communication c group by 1) c
        where m.domain_id = c.domain_id
            and array_length(TRANSLATE(jsonb_path_query_array(communications, '$[*].type.id')::text , '[]','{}')::INT[] - c.ids, 1)  > 0)
    then
        raise exception 'bad communication type.id' using errcode = '23503';
    end if;

    insert into call_center.cc_queue_statistics (queue_id, bucket_id, member_count, member_waiting)
    select t.queue_id, t.bucket_id, t.cnt, t.cntwait
    from (
             select queue_id, bucket_id, count(*) cnt, count(*) filter ( where m.stop_at isnull ) cntwait
             from inserted m
             group by queue_id, bucket_id
         ) t
    on conflict (queue_id, coalesce(bucket_id, 0))
        do update
        set member_count   = EXCLUDED.member_count + call_center.cc_queue_statistics.member_count,
            member_waiting = EXCLUDED.member_waiting + call_center.cc_queue_statistics.member_waiting;


    --    raise notice '% % %', TG_TABLE_NAME, TG_OP, (select count(*) from inserted );
--    PERFORM pg_notify(TG_TABLE_NAME, TG_OP);
    RETURN NULL;
END
$_$;


--
-- Name: cc_member_statistic_trigger_updated(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.cc_member_statistic_trigger_updated() RETURNS trigger
    LANGUAGE plpgsql
    AS $_$
BEGIN
    if exists(select 1
        from new_data m,
             (select c.domain_id, array_agg(c.id) ids
        from call_center.cc_communication c group by 1) c
        where m.domain_id = c.domain_id
            and array_length(TRANSLATE(jsonb_path_query_array(communications, '$[*].type.id')::text , '[]','{}')::INT[] - c.ids, 1)  > 0)
    then
        raise exception 'bad communication type.id' using errcode = '23503';
    end if;

    insert into call_center.cc_queue_statistics (queue_id, bucket_id, member_count, member_waiting)
    select t.queue_id, t.bucket_id, t.cnt, t.cntwait
    from (
        select queue_id, bucket_id, sum(cnt) cnt, sum(cntwait) cntwait
        from (
             select m.queue_id,
                    m.bucket_id,
                    -1 * count(*) cnt,
                    -1 * count(*) filter ( where m.stop_at isnull ) cntwait
             from old_data m
             group by m.queue_id, m.bucket_id

             union all
            select m.queue_id,
                    m.bucket_id   bucket_id ,
                    count(*) cnt,
                    count(*) filter ( where m.stop_at isnull ) cntwait
             from new_data m
             group by m.queue_id, m.bucket_id
        ) o
        group by queue_id, bucket_id
    ) t
    --where t.cntwait != 0
    on conflict (queue_id, coalesce(bucket_id, 0)) do update
        set member_waiting = excluded.member_waiting + call_center.cc_queue_statistics.member_waiting,
            member_count = excluded.member_count + call_center.cc_queue_statistics.member_count;

   RETURN NULL;
END
$_$;


--
-- Name: cc_report_join_ivr(jsonb); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.cc_report_join_ivr(r jsonb) RETURNS character varying
    LANGUAGE plpgsql IMMUTABLE
    AS $_$
    declare res varchar;
        len int;
begin
    len = jsonb_array_length(r);
    if r isnull or  len isnull or len = 0  then
        return '';
    end if;

    select coalesce(string_agg(x::text, ' -> '), '') a
    from jsonb_array_elements($1) x
    into res;

    return res;
end;
$_$;


--
-- Name: cc_upgrade_wrap_set_sql(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.cc_upgrade_wrap_set_sql(sh character varying, tbl character varying, seq character varying) RETURNS bigint
    LANGUAGE plpgsql
    AS $$
    declare
        res int8;
        BEGIN
            EXECUTE format('SELECT max(id) from %s.%s', quote_ident(sh), quote_ident(tbl)) into res;
            if res notnull and res > 0 then
                EXECUTE format('ALTER SEQUENCE %s RESTART WITH %s', quote_ident(seq), res + 1);
            end if;

            return res;
        END;
$$;


--
-- Name: grafana_array_params(character varying); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.grafana_array_params(i character varying) RETURNS integer[]
    LANGUAGE plpgsql
    AS $$
begin
    if i isnull then
        return null;
    end if;

    if not i ilike '{%' then
        return ('{' || replace(i, '"', '') || '}')::int[];
    end if;

    return replace(i, '"', '')::int[];
end;
$$;


--
-- Name: migrate_from_db(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.migrate_from_db() RETURNS void
    LANGUAGE plpgsql
    AS $$
    declare s text;
begin
    for s in select format('insert into %s (%s) SELECT * FROM dblink(''otherdb'', ''%s'') as t(%s)', x.tbl, x.clm, x.s, x.types)
from (
    select 'select ' || x.clm || ' from ' || x.tbl as s, x.types, x.clm, x.tbl
    from (
        select t.schemaname || '.' || t.tablename as tbl, string_agg( '"' || column_name || '"', ', ') as clm, string_agg('"' || column_name || '"' || ' ' || case when udt_name[0] = '_' then substr(udt_name, 2, length(udt_name)) || '[]' else udt_name end, ', ') as types
        from webitel_dev.pg_catalog.pg_tables t
            left join information_schema.columns c on c.table_name = t.tablename and c.table_schema = t.schemaname
        where schemaname in ('call_center')
        group by 1
    ) x where x.tbl != 'call_center.cc_member'
) x LOOP
        execute s || ' ON CONFLICT DO NOTHING';
    end loop;
    exception
         when others then
        RAISE exception 'Error Name:% query %',SQLERRM, s;
end;
$$;


--
-- Name: cognitive_profile_services_set_def(); Type: FUNCTION; Schema: storage; Owner: -
--

CREATE FUNCTION storage.cognitive_profile_services_set_def() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
begin
    if new.default is distinct from old."default" or new.service is distinct from old."service"  then
        update storage.cognitive_profile_services c
            set  "default" = false
        where c.domain_id = new.domain_id and c.id != new.id and c.service = new.service;
    end if;
    return new;
end;
$$;


--
-- Name: file_decrement_profile_size(); Type: FUNCTION; Schema: storage; Owner: -
--

CREATE FUNCTION storage.file_decrement_profile_size() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
  update storage.file_backend_profiles p
      SET data_size = data_size - f.sum_size,
        data_count = data_count - f.count_files
      from (
             select
               profile_id,
               sum(size) * 0.000001 as sum_size,
               count(*) as count_files
             from tg_data
             group by profile_id
           ) as f
      where p.id = f.profile_id;
  RETURN NULL;
END;
$$;


--
-- Name: file_increment_profile_size(); Type: FUNCTION; Schema: storage; Owner: -
--

CREATE FUNCTION storage.file_increment_profile_size() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
  update storage.file_backend_profiles p
      SET data_size = data_size + f.sum_size,
      data_count = data_count + f.count_files
      from (
             select
               profile_id,
               sum(size) * 0.000001 as sum_size,
               count(*) as count_files
             from tg_data
             group by profile_id
           ) as f
      where p.id = f.profile_id;
  RETURN NULL;
END;
$$;


--
-- Name: file_statistics_trigger_deleted(); Type: FUNCTION; Schema: storage; Owner: -
--

CREATE FUNCTION storage.file_statistics_trigger_deleted() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN

    insert into storage.files_statistics (domain_id, profile_id, mime_type, count, size, not_exists_count)
    select s.domain_id, s.profile_id, s.mime_type, s.cnt, s.size, not_exists_count
    from (
        select f.domain_id, f.profile_id, f.mime_type, count(*) cnt, sum(f.size) size,
               count(*) filter ( where f.not_exists is true ) not_exists_count
        from deleted f
        group by f.domain_id, f.profile_id, f.mime_type
    ) s
    on conflict (domain_id, coalesce(profile_id, 0), mime_type)
            do update
            set count = storage.files_statistics.count - EXCLUDED.count,
                size = storage.files_statistics.size - EXCLUDED.size,
                not_exists_count = storage.files_statistics.not_exists_count - EXCLUDED.not_exists_count;

    RETURN NULL;
END
$$;


--
-- Name: file_statistics_trigger_inserted(); Type: FUNCTION; Schema: storage; Owner: -
--

CREATE FUNCTION storage.file_statistics_trigger_inserted() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
    insert into storage.files_statistics (domain_id, profile_id, mime_type, count, size, not_exists_count)
    select s.domain_id, s.profile_id, s.mime_type, s.cnt, s.size, not_exists_count
    from (
        select f.domain_id, f.profile_id, f.mime_type, count(*) cnt, sum(f.size) size,
               count(*) filter ( where f.not_exists is true ) not_exists_count
        from inserted f
        group by f.domain_id, f.profile_id, f.mime_type
    ) s
    on conflict (domain_id, coalesce(profile_id, 0), mime_type)
            do update
            set count   = EXCLUDED.count + storage.files_statistics.count,
                size = EXCLUDED.size + storage.files_statistics.size,
                not_exists_count = EXCLUDED.not_exists_count + storage.files_statistics.not_exists_count;
    RETURN NULL;
END
$$;


--
-- Name: file_trigger_decrement_profile_size(); Type: FUNCTION; Schema: storage; Owner: -
--

CREATE FUNCTION storage.file_trigger_decrement_profile_size() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
  update storage.file_backend_profiles p
      SET data_size = data_size - f.sum_size,
        data_count = data_count - f.count_files
      from (
             select
               profile_id,
               sum(size) * 0.000001 as sum_size,
               count(*) as count_files
             from deleted
             group by profile_id
           ) as f
      where p.id = f.profile_id;
  RETURN NULL;
END;
$$;


--
-- Name: file_trigger_increment_profile_size(); Type: FUNCTION; Schema: storage; Owner: -
--

CREATE FUNCTION storage.file_trigger_increment_profile_size() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
  update storage.file_backend_profiles p
      SET data_size = data_size + f.sum_size,
      data_count = data_count + f.count_files
      from (
             select
               profile_id,
               sum(size) * 0.000001 as sum_size,
               count(*) as count_files
             from inserted
             group by profile_id
           ) as f
      where p.id = f.profile_id;
  RETURN NULL;
END;
$$;


--
-- Name: get_lookup(bigint, character varying); Type: FUNCTION; Schema: storage; Owner: -
--

CREATE FUNCTION storage.get_lookup(_id bigint, _name character varying) RETURNS jsonb
    LANGUAGE plpgsql IMMUTABLE
    AS $$
BEGIN
    if _id isnull then
        return null;
    else
        return json_build_object('id', _id, 'name', _name)::jsonb;
    end if;
END;
$$;


--
-- Name: tg_obj_default_rbac(); Type: FUNCTION; Schema: storage; Owner: -
--

CREATE FUNCTION storage.tg_obj_default_rbac() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
BEGIN

    EXECUTE format(
'INSERT INTO %I.%I AS acl (dc, object, grantor, subject, access)
 SELECT $1, $2, rbac.grantor, rbac.subject, rbac.access
   FROM (
    -- NEW object OWNER access SUPER(255) mode (!)
    SELECT $3, $3, (255)::int2
     UNION ALL
    SELECT DISTINCT ON (rbac.subject)
      -- [WHO] grants MAX of WINDOW subset access level
        first_value(rbac.grantor) OVER sub
      -- [WHOM] role/user administrative unit
      , rbac.subject
      -- [GRANT] ALL of WINDOW subset access mode(s)
      , bit_or(rbac.access) OVER sub

      FROM directory.wbt_default_acl AS rbac
      JOIN directory.wbt_class AS oc ON (oc.dc, oc.name) = ($1, %L)
      -- EXISTS( OWNER membership WITH grantor role )
      -- JOIN directory.wbt_auth_member AS sup ON (sup.role_id, sup.member_id) = (rbac.grantor, $3)
     WHERE rbac.object = oc.id
       AND rbac.subject <> $3
        -- EXISTS( OWNER membership WITH grantor user/role )
       AND (rbac.grantor = $3 OR EXISTS(SELECT true
             FROM directory.wbt_auth_member sup
            WHERE sup.member_id = $3
              AND sup.role_id = rbac.grantor
           ))
    WINDOW sub AS (PARTITION BY rbac.subject ORDER BY rbac.access DESC)

   ) AS rbac(grantor, subject, access)',

--   ON CONFLICT (object, subject)
--   DO UPDATE SET
--     grantor = EXCLUDED.grantor,
--     access = EXCLUDED.access',

            tg_table_schema,
            tg_table_name||'_acl',
            tg_argv[0]::name -- objclass: directory.wbt_class.name
        )
    --      :srv,   :oid,   :rid
    USING NEW.domain_id, NEW.id, NEW.created_by;
    -- FOR EACH ROW
    RETURN NEW;

END
$_$;


--
-- Name: cc_array_merge_agg(anyarray); Type: AGGREGATE; Schema: call_center; Owner: -
--

CREATE AGGREGATE call_center.cc_array_merge_agg(anyarray) (
    SFUNC = call_center.cc_array_merge,
    STYPE = anyarray
);


--
-- Name: jsonb_concat_agg(jsonb); Type: AGGREGATE; Schema: call_center; Owner: -
--

CREATE AGGREGATE call_center.jsonb_concat_agg(jsonb) (
    SFUNC = jsonb_concat,
    STYPE = jsonb
);


--
-- Name: cc_agent; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_agent (
    id integer NOT NULL,
    user_id bigint NOT NULL,
    updated_at bigint DEFAULT 0 NOT NULL,
    status character varying(20) DEFAULT 'offline'::character varying NOT NULL,
    description character varying(250) DEFAULT ''::character varying NOT NULL,
    domain_id bigint NOT NULL,
    created_at bigint,
    created_by bigint,
    updated_by bigint,
    status_payload character varying,
    progressive_count integer DEFAULT 1,
    last_state_change timestamp with time zone DEFAULT now() NOT NULL,
    on_demand boolean DEFAULT false NOT NULL,
    allow_channels character varying[] DEFAULT '{call}'::character varying[],
    greeting_media_id integer,
    chat_count smallint DEFAULT 1,
    team_id integer,
    region_id integer,
    supervisor boolean DEFAULT false NOT NULL,
    supervisor_ids integer[],
    auditor_ids bigint[],
    CONSTRAINT cc_agent_chat_count_c CHECK ((chat_count > '-1'::integer)),
    CONSTRAINT cc_agent_progress_count_c CHECK ((progressive_count > '-1'::integer))
)
WITH (fillfactor='20', log_autovacuum_min_duration='0', autovacuum_vacuum_scale_factor='0.01', autovacuum_analyze_scale_factor='0.05', autovacuum_enabled='1', autovacuum_vacuum_cost_delay='20');


--
-- Name: cc_agent_acl; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_agent_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    object integer NOT NULL,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL
);


--
-- Name: cc_agent_acl_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_agent_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_agent_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_agent_acl_id_seq OWNED BY call_center.cc_agent_acl.id;


--
-- Name: cc_agent_attempt; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_agent_attempt (
    id bigint NOT NULL,
    queue_id bigint NOT NULL,
    agent_id bigint,
    attempt_id bigint NOT NULL
);


--
-- Name: cc_agent_attempt_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_agent_attempt_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_agent_attempt_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_agent_attempt_id_seq OWNED BY call_center.cc_agent_attempt.id;


--
-- Name: cc_agent_channel; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_agent_channel (
    agent_id integer NOT NULL,
    state character varying NOT NULL,
    channel character varying NOT NULL,
    joined_at timestamp with time zone DEFAULT now() NOT NULL,
    timeout timestamp with time zone,
    max_opened integer DEFAULT 1 NOT NULL,
    no_answers integer DEFAULT 0 NOT NULL,
    queue_id integer,
    last_offering_at timestamp with time zone,
    last_bridged_at timestamp with time zone,
    last_missed_at timestamp with time zone,
    last_bucket_id integer,
    channel_changed_at timestamp with time zone DEFAULT now() NOT NULL,
    online boolean DEFAULT false NOT NULL,
    lose_attempt integer DEFAULT 0 NOT NULL,
    attempt_id integer
)
WITH (fillfactor='20', log_autovacuum_min_duration='0', autovacuum_vacuum_scale_factor='0.01', autovacuum_analyze_scale_factor='0.05', autovacuum_enabled='1', autovacuum_vacuum_cost_delay='20');


--
-- Name: cc_agent_state_history; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_agent_state_history (
    id bigint NOT NULL,
    agent_id integer NOT NULL,
    joined_at timestamp with time zone DEFAULT now() NOT NULL,
    state character varying(20) NOT NULL,
    channel character varying,
    duration interval DEFAULT '00:00:00'::interval NOT NULL,
    payload character varying,
    queue_id integer,
    attempt_id integer
);


--
-- Name: cc_agent_history_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_agent_history_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_agent_history_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_agent_history_id_seq OWNED BY call_center.cc_agent_state_history.id;


--
-- Name: cc_agent_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_agent_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_agent_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_agent_id_seq OWNED BY call_center.cc_agent.id;


--
-- Name: cc_agent_in_queue_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_agent_in_queue_view AS
SELECT
    NULL::jsonb AS queue,
    NULL::integer AS priority,
    NULL::smallint AS type,
    NULL::character varying(20) AS strategy,
    NULL::boolean AS enabled,
    NULL::bigint AS count_members,
    NULL::bigint AS waiting_members,
    NULL::bigint AS active_members,
    NULL::integer AS queue_id,
    NULL::character varying AS queue_name,
    NULL::bigint AS team_id,
    NULL::bigint AS domain_id,
    NULL::integer AS agent_id,
    NULL::jsonb AS agents;


--
-- Name: wbt_auth; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_auth (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    auth name NOT NULL,
    name text,
    password text,
    can_login boolean DEFAULT false NOT NULL,
    tel_number name,
    usage text,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    created_by bigint,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_by bigint,
    deleted_at timestamp without time zone,
    deleted_by bigint,
    grants name[]
);


--
-- Name: TABLE wbt_auth; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_auth IS 'Webitel Administrative Roles';


--
-- Name: COLUMN wbt_auth.password; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_auth.password IS 'TOBE: removed';


--
-- Name: COLUMN wbt_auth.can_login; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_auth.can_login IS 'TOBE: removed';


--
-- Name: COLUMN wbt_auth.tel_number; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_auth.tel_number IS 'TOBE: removed';


--
-- Name: COLUMN wbt_auth.usage; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_auth.usage IS 'optional short usage description';


--
-- Name: COLUMN wbt_auth.grants; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_auth.grants IS 'set of unique permissions';


--
-- Name: wbt_auth_id_seq; Type: SEQUENCE; Schema: directory; Owner: -
--

CREATE SEQUENCE directory.wbt_auth_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: wbt_auth_id_seq; Type: SEQUENCE OWNED BY; Schema: directory; Owner: -
--

ALTER SEQUENCE directory.wbt_auth_id_seq OWNED BY directory.wbt_auth.id;


--
-- Name: wbt_user; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_user (
    id bigint DEFAULT nextval('directory.wbt_auth_id_seq'::regclass) NOT NULL,
    dc bigint NOT NULL,
    name text,
    email character varying(255),
    username name NOT NULL,
    password name NOT NULL,
    extension name,
    profile jsonb,
    dnd boolean DEFAULT false NOT NULL,
    online integer DEFAULT 0 NOT NULL,
    status text,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    created_by bigint,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_by bigint,
    deleted_at timestamp without time zone,
    deleted_by bigint,
    device_id bigint,
    envars jsonb
);


--
-- Name: COLUMN wbt_user.device_id; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user.device_id IS 'Default SIP Register Endpoint Credentials';


--
-- Name: cc_agent_with_user; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_agent_with_user AS
 SELECT a.id,
    call_center.cc_get_lookup((a.id)::bigint, (COALESCE(u.name, (u.username)::text))::character varying) AS "user"
   FROM (call_center.cc_agent a
     JOIN directory.wbt_user u ON (((u.id = a.user_id) AND (a.domain_id = u.dc))));


--
-- Name: cc_skill; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_skill (
    id integer NOT NULL,
    name character varying NOT NULL,
    domain_id bigint NOT NULL,
    description character varying DEFAULT ''::character varying NOT NULL
);


--
-- Name: cc_skill_in_agent; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_skill_in_agent (
    id integer NOT NULL,
    skill_id integer NOT NULL,
    agent_id integer NOT NULL,
    capacity smallint DEFAULT 0 NOT NULL,
    created_at bigint NOT NULL,
    created_by bigint,
    updated_at bigint NOT NULL,
    updated_by bigint,
    enabled boolean DEFAULT true NOT NULL
);


--
-- Name: cc_team; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_team (
    id bigint NOT NULL,
    domain_id bigint NOT NULL,
    name character varying(50) NOT NULL,
    description character varying DEFAULT ''::character varying NOT NULL,
    strategy character varying NOT NULL,
    max_no_answer smallint DEFAULT 0 NOT NULL,
    wrap_up_time smallint DEFAULT 0 NOT NULL,
    no_answer_delay_time smallint DEFAULT 0 NOT NULL,
    call_timeout smallint DEFAULT 0 NOT NULL,
    updated_at bigint DEFAULT 0 NOT NULL,
    created_at bigint,
    created_by bigint,
    updated_by bigint,
    admin_ids integer[],
    invite_chat_timeout smallint DEFAULT 30 NOT NULL,
    task_accept_timeout smallint DEFAULT 30 NOT NULL
);


--
-- Name: region; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.region (
    id integer NOT NULL,
    domain_id bigint NOT NULL,
    name character varying NOT NULL,
    description character varying,
    timezone_id integer NOT NULL
);


--
-- Name: media_files; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.media_files (
    id bigint NOT NULL,
    name character varying(100) NOT NULL,
    size bigint NOT NULL,
    mime_type character varying(120),
    properties jsonb,
    instance character varying(50),
    created_at bigint,
    updated_at bigint,
    domain_id bigint NOT NULL,
    created_by bigint,
    updated_by bigint
);


--
-- Name: cc_agent_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_agent_list AS
 SELECT a.domain_id,
    a.id,
    (COALESCE(((ct.name)::character varying)::name, (ct.username COLLATE "default")))::character varying AS name,
    a.status,
    a.description,
    ((date_part('epoch'::text, a.last_state_change) * (1000)::double precision))::bigint AS last_status_change,
    (date_part('epoch'::text, (now() - a.last_state_change)))::bigint AS status_duration,
    a.progressive_count,
    ch.x AS channel,
    (json_build_object('id', ct.id, 'name', COALESCE(((ct.name)::character varying)::name, ct.username)))::jsonb AS "user",
    call_center.cc_get_lookup((a.greeting_media_id)::bigint, g.name) AS greeting_media,
    a.allow_channels,
    a.chat_count,
    ( SELECT jsonb_agg(sag."user") AS jsonb_agg
           FROM call_center.cc_agent_with_user sag
          WHERE (sag.id = ANY (a.supervisor_ids))) AS supervisor,
    ( SELECT jsonb_agg(call_center.cc_get_lookup(aud.id, (COALESCE(aud.name, (aud.username)::text))::character varying)) AS jsonb_agg
           FROM directory.wbt_user aud
          WHERE (aud.id = ANY (a.auditor_ids))) AS auditor,
    call_center.cc_get_lookup(t.id, t.name) AS team,
    call_center.cc_get_lookup((r.id)::bigint, r.name) AS region,
    a.supervisor AS is_supervisor,
    ( SELECT jsonb_agg(call_center.cc_get_lookup((sa.skill_id)::bigint, cs.name)) AS jsonb_agg
           FROM (call_center.cc_skill_in_agent sa
             JOIN call_center.cc_skill cs ON ((sa.skill_id = cs.id)))
          WHERE (sa.agent_id = a.id)) AS skills,
    a.team_id,
    a.region_id,
    a.supervisor_ids,
    a.auditor_ids,
    a.user_id,
    ct.extension
   FROM (((((call_center.cc_agent a
     LEFT JOIN directory.wbt_user ct ON ((ct.id = a.user_id)))
     LEFT JOIN storage.media_files g ON ((g.id = a.greeting_media_id)))
     LEFT JOIN call_center.cc_team t ON ((t.id = a.team_id)))
     LEFT JOIN flow.region r ON ((r.id = a.region_id)))
     LEFT JOIN LATERAL ( SELECT jsonb_agg(json_build_object('channel', c.channel, 'online', true, 'state', c.state, 'joined_at', ((date_part('epoch'::text, c.joined_at) * (1000)::double precision))::bigint)) AS x
           FROM call_center.cc_agent_channel c
          WHERE (c.agent_id = a.id)) ch ON (true));


--
-- Name: cc_agent_status_log; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_agent_status_log (
    id bigint NOT NULL,
    agent_id integer NOT NULL,
    joined_at timestamp with time zone DEFAULT now() NOT NULL,
    status character varying NOT NULL,
    payload character varying,
    duration interval DEFAULT '00:00:00'::interval NOT NULL
);


--
-- Name: cc_agent_status_log_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_agent_status_log_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_agent_status_log_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_agent_status_log_id_seq OWNED BY call_center.cc_agent_status_log.id;


--
-- Name: calendar_timezones; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.calendar_timezones (
    id integer NOT NULL,
    name character varying(100) NOT NULL,
    utc_offset interval NOT NULL,
    offset_id smallint NOT NULL,
    sys_name text
);


--
-- Name: cc_agent_today_pause_cause; Type: MATERIALIZED VIEW; Schema: call_center; Owner: -
--

CREATE MATERIALIZED VIEW call_center.cc_agent_today_pause_cause AS
 SELECT a.id,
    ((now())::date + age(now(), (timezone(COALESCE(t.sys_name, 'UTC'::text), now()))::timestamp with time zone)) AS today,
    p.payload AS cause,
    p.d AS duration
   FROM (((call_center.cc_agent a
     LEFT JOIN flow.region r ON ((r.id = a.region_id)))
     LEFT JOIN flow.calendar_timezones t ON ((t.id = r.timezone_id)))
     LEFT JOIN LATERAL ( SELECT cc_agent_state_history.payload,
            sum(cc_agent_state_history.duration) AS d
           FROM call_center.cc_agent_state_history
          WHERE ((cc_agent_state_history.joined_at > ((now())::date + age(now(), (timezone(COALESCE(t.sys_name, 'UTC'::text), now()))::timestamp with time zone))) AND (cc_agent_state_history.agent_id = a.id) AND ((cc_agent_state_history.state)::text = 'pause'::text) AND (cc_agent_state_history.channel IS NULL))
          GROUP BY cc_agent_state_history.payload) p ON (true))
  WHERE (p.d IS NOT NULL)
  WITH NO DATA;


--
-- Name: cc_audit_rate; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_audit_rate (
    id bigint NOT NULL,
    domain_id bigint NOT NULL,
    form_id integer NOT NULL,
    created_at timestamp with time zone NOT NULL,
    created_by bigint,
    updated_at timestamp with time zone NOT NULL,
    updated_by bigint,
    answers jsonb,
    score_required numeric DEFAULT 0 NOT NULL,
    score_optional numeric DEFAULT 0 NOT NULL,
    comment text,
    call_id character varying,
    rated_user_id bigint NOT NULL
);


--
-- Name: cc_calls_history; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_calls_history (
    id uuid NOT NULL,
    direction character varying,
    destination character varying,
    parent_id uuid,
    app_id character varying NOT NULL,
    from_type character varying,
    from_name character varying,
    from_number character varying,
    from_id character varying,
    to_type character varying,
    to_name character varying,
    to_number character varying,
    to_id character varying,
    payload jsonb,
    domain_id bigint NOT NULL,
    hold_sec integer DEFAULT 0,
    cause character varying,
    sip_code integer,
    bridged_id uuid,
    gateway_id bigint,
    user_id integer,
    queue_id integer,
    team_id integer,
    agent_id integer,
    attempt_id bigint,
    member_id bigint,
    duration integer DEFAULT 0 NOT NULL,
    description character varying,
    tags character varying[],
    answered_at timestamp with time zone,
    bridged_at timestamp with time zone,
    hangup_at timestamp with time zone,
    created_at timestamp with time zone NOT NULL,
    hangup_by character varying,
    stored_at timestamp with time zone DEFAULT now() NOT NULL,
    rating smallint,
    notes text,
    transfer_from uuid,
    transfer_to uuid,
    amd_result character varying,
    amd_duration interval,
    grantee_id bigint,
    hold jsonb,
    agent_ids integer[],
    user_ids bigint[],
    queue_ids integer[],
    gateway_ids bigint[],
    team_ids integer[],
    params jsonb,
    blind_transfer character varying,
    talk_sec integer DEFAULT 0 NOT NULL,
    amd_ai_result character varying,
    amd_ai_logs character varying[],
    amd_ai_positive boolean,
    contact_id bigint,
    search_number text
);


--
-- Name: cc_member_attempt_history; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_member_attempt_history (
    id bigint NOT NULL,
    queue_id integer,
    member_id bigint,
    weight integer,
    resource_id integer,
    node_id character varying(20),
    result character varying(25) NOT NULL,
    agent_id integer,
    bucket_id bigint,
    display character varying(50),
    description character varying,
    list_communication_id bigint,
    joined_at timestamp with time zone NOT NULL,
    leaving_at timestamp with time zone,
    agent_call_id character varying,
    member_call_id character varying,
    offering_at timestamp with time zone,
    reporting_at timestamp with time zone,
    bridged_at timestamp with time zone,
    channel character varying,
    domain_id bigint NOT NULL,
    destination jsonb,
    seq integer DEFAULT 0 NOT NULL,
    team_id integer,
    resource_group_id integer,
    answered_at timestamp with time zone,
    region_id integer,
    supervisor_ids integer[],
    transferred_at timestamp with time zone,
    transferred_agent_id integer,
    transferred_attempt_id bigint,
    parent_id bigint,
    form_fields jsonb,
    import_id character varying(120)
);


--
-- Name: COLUMN cc_member_attempt_history.result; Type: COMMENT; Schema: call_center; Owner: -
--

COMMENT ON COLUMN call_center.cc_member_attempt_history.result IS 'fixme';


--
-- Name: cc_queue; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_queue (
    id integer NOT NULL,
    strategy character varying(20) NOT NULL,
    enabled boolean NOT NULL,
    payload jsonb,
    calendar_id integer NOT NULL,
    priority integer DEFAULT 0 NOT NULL,
    updated_at bigint DEFAULT ((date_part('epoch'::text, now()) * (1000)::double precision))::bigint NOT NULL,
    name character varying NOT NULL,
    variables jsonb DEFAULT '{}'::jsonb NOT NULL,
    domain_id bigint NOT NULL,
    dnc_list_id bigint,
    type smallint DEFAULT 1 NOT NULL,
    team_id bigint,
    created_at bigint NOT NULL,
    created_by bigint,
    updated_by bigint,
    schema_id integer,
    description character varying DEFAULT ''::character varying,
    ringtone_id integer,
    do_schema_id integer,
    after_schema_id integer,
    sticky_agent boolean DEFAULT false NOT NULL,
    processing boolean DEFAULT false NOT NULL,
    processing_sec integer DEFAULT 30 NOT NULL,
    processing_renewal_sec integer DEFAULT 0 NOT NULL,
    grantee_id bigint,
    recall_calendar boolean DEFAULT false,
    form_schema_id integer
);


--
-- Name: cc_agent_today_stats; Type: MATERIALIZED VIEW; Schema: call_center; Owner: -
--

CREATE MATERIALIZED VIEW call_center.cc_agent_today_stats AS
 WITH agents AS MATERIALIZED (
         SELECT a_1.id,
            usr.id AS user_id,
                CASE
                    WHEN (a_1.last_state_change < (d."from")::timestamp with time zone) THEN (d."from")::timestamp with time zone
                    WHEN (a_1.last_state_change < d."to") THEN a_1.last_state_change
                    ELSE a_1.last_state_change
                END AS cur_state_change,
            a_1.status,
            a_1.status_payload,
            a_1.last_state_change,
            (lasts.last_at)::timestamp with time zone AS last_at,
            lasts.state AS last_state,
            lasts.status_payload AS last_payload,
            COALESCE(top.top_at, a_1.last_state_change) AS top_at,
            COALESCE(top.state, a_1.status) AS top_state,
            COALESCE(top.status_payload, a_1.status_payload) AS top_payload,
            d."from",
            d."to",
            usr.dc AS domain_id,
            COALESCE(t.sys_name, 'UTC'::text) AS tz_name
           FROM ((((((call_center.cc_agent a_1
             RIGHT JOIN directory.wbt_user usr ON ((usr.id = a_1.user_id)))
             LEFT JOIN flow.region r ON ((r.id = a_1.region_id)))
             LEFT JOIN flow.calendar_timezones t ON ((t.id = r.timezone_id)))
             LEFT JOIN LATERAL ( SELECT now() AS "to",
                    ((now())::date + age(now(), (timezone(COALESCE(t.sys_name, 'UTC'::text), now()))::timestamp with time zone)) AS "from") d ON (true))
             LEFT JOIN LATERAL ( SELECT aa.state,
                    d."from" AS last_at,
                    aa.payload AS status_payload
                   FROM call_center.cc_agent_state_history aa
                  WHERE ((aa.agent_id = a_1.id) AND (aa.channel IS NULL) AND ((aa.state)::text = ANY (ARRAY[('pause'::character varying)::text, ('online'::character varying)::text, ('offline'::character varying)::text])) AND (aa.joined_at < (d."from")::timestamp with time zone))
                  ORDER BY aa.joined_at DESC
                 LIMIT 1) lasts ON ((a_1.last_state_change > d."from")))
             LEFT JOIN LATERAL ( SELECT a2.state,
                    d."to" AS top_at,
                    a2.payload AS status_payload
                   FROM call_center.cc_agent_state_history a2
                  WHERE ((a2.agent_id = a_1.id) AND (a2.channel IS NULL) AND ((a2.state)::text = ANY (ARRAY[('pause'::character varying)::text, ('online'::character varying)::text, ('offline'::character varying)::text])) AND (a2.joined_at > d."to"))
                  ORDER BY a2.joined_at
                 LIMIT 1) top ON (true))
        ), d AS MATERIALIZED (
         SELECT x.agent_id,
            x.joined_at,
            x.state,
            x.payload
           FROM ( SELECT a_1.agent_id,
                    a_1.joined_at,
                    a_1.state,
                    a_1.payload
                   FROM call_center.cc_agent_state_history a_1,
                    agents
                  WHERE ((a_1.agent_id = agents.id) AND (a_1.joined_at >= agents."from") AND (a_1.joined_at <= agents."to") AND (a_1.channel IS NULL) AND ((a_1.state)::text = ANY (ARRAY[('pause'::character varying)::text, ('online'::character varying)::text, ('offline'::character varying)::text])))
                UNION
                 SELECT agents.id,
                    agents.cur_state_change,
                    agents.status,
                    agents.status_payload
                   FROM agents
                  WHERE (1 = 1)) x
          ORDER BY x.joined_at DESC
        ), s AS MATERIALIZED (
         SELECT d.agent_id,
            d.joined_at,
            d.state,
            d.payload,
            (COALESCE(lag(d.joined_at) OVER (PARTITION BY d.agent_id ORDER BY d.joined_at DESC), now()) - d.joined_at) AS dur
           FROM d
          ORDER BY d.joined_at DESC
        ), eff AS (
         SELECT h.agent_id,
            sum((COALESCE(h.reporting_at, h.leaving_at) - h.bridged_at)) FILTER (WHERE (h.bridged_at IS NOT NULL)) AS aht,
            sum((h.reporting_at - h.leaving_at)) FILTER (WHERE ((h.reporting_at IS NOT NULL) AND ((h.reporting_at - h.leaving_at) > '00:00:00'::interval))) AS processing,
            sum(((h.reporting_at - h.leaving_at) - ((q.processing_sec || 's'::text))::interval)) FILTER (WHERE ((h.reporting_at IS NOT NULL) AND q.processing AND ((h.reporting_at - h.leaving_at) > (((q.processing_sec + 1) || 's'::text))::interval))) AS tpause
           FROM ((agents
             JOIN call_center.cc_member_attempt_history h ON ((h.agent_id = agents.id)))
             LEFT JOIN call_center.cc_queue q ON ((q.id = h.queue_id)))
          WHERE ((h.domain_id = agents.domain_id) AND (h.joined_at >= (agents."from")::timestamp with time zone) AND (h.joined_at <= agents."to") AND ((h.channel)::text = 'call'::text))
          GROUP BY h.agent_id
        ), attempts AS (
         SELECT cma.agent_id,
            count(*) FILTER (WHERE ((cma.bridged_at IS NOT NULL) AND ((cma.channel)::text = 'chat'::text))) AS chat_accepts,
            (avg(EXTRACT(epoch FROM (COALESCE(cma.reporting_at, cma.leaving_at) - cma.bridged_at))) FILTER (WHERE ((cma.bridged_at IS NOT NULL) AND ((cma.channel)::text = 'chat'::text))))::bigint AS chat_aht,
            count(*) FILTER (WHERE ((cma.bridged_at IS NOT NULL) AND ((cma.channel)::text = 'task'::text))) AS task_accepts
           FROM (agents
             JOIN call_center.cc_member_attempt_history cma ON ((cma.agent_id = agents.id)))
          WHERE ((cma.joined_at >= (agents."from")::timestamp with time zone) AND (cma.joined_at <= agents."to") AND (cma.domain_id = agents.domain_id) AND (cma.bridged_at IS NOT NULL) AND ((cma.channel)::text = ANY (ARRAY['chat'::text, 'task'::text])))
          GROUP BY cma.agent_id
        ), calls AS (
         SELECT h.user_id,
            count(*) FILTER (WHERE ((h.direction)::text = 'inbound'::text)) AS all_inb,
            count(*) FILTER (WHERE (h.bridged_at IS NOT NULL)) AS handled,
            count(*) FILTER (WHERE (((h.direction)::text = 'inbound'::text) AND (h.bridged_at IS NOT NULL))) AS inbound_bridged,
            count(*) FILTER (WHERE ((cq.type = 1) AND (h.bridged_at IS NOT NULL) AND (h.parent_id IS NOT NULL))) AS "inbound queue",
            count(*) FILTER (WHERE (((h.direction)::text = 'inbound'::text) AND (h.queue_id IS NULL))) AS "direct inbound",
            count(*) FILTER (WHERE ((h.parent_id IS NOT NULL) AND (h.bridged_at IS NOT NULL) AND (h.queue_id IS NULL) AND (pc.user_id IS NOT NULL))) AS internal_inb,
            count(*) FILTER (WHERE ((h.bridged_at IS NOT NULL) AND (h.queue_id IS NULL) AND (pc.user_id IS NOT NULL))) AS user_2user,
            count(*) FILTER (WHERE ((((h.direction)::text = 'inbound'::text) OR (cq.type = 3)) AND (h.bridged_at IS NULL))) AS missed,
            count(*) FILTER (WHERE (((h.direction)::text = 'inbound'::text) AND (h.bridged_at IS NULL) AND (h.queue_id IS NOT NULL) AND ((h.cause)::text = ANY (ARRAY[('NO_ANSWER'::character varying)::text, ('USER_BUSY'::character varying)::text])))) AS abandoned,
            count(*) FILTER (WHERE ((cq.type = ANY (ARRAY[(0)::smallint, (3)::smallint, (4)::smallint, (5)::smallint])) AND (h.bridged_at IS NOT NULL))) AS outbound_queue,
            count(*) FILTER (WHERE ((h.parent_id IS NULL) AND ((h.direction)::text = 'outbound'::text) AND (h.queue_id IS NULL))) AS "direct outboud",
            sum((h.hangup_at - h.created_at)) FILTER (WHERE (((h.direction)::text = 'outbound'::text) AND (h.queue_id IS NULL))) AS direct_out_dur,
            avg((h.hangup_at - h.bridged_at)) FILTER (WHERE ((h.bridged_at IS NOT NULL) AND ((h.direction)::text = 'inbound'::text) AND (h.parent_id IS NOT NULL))) AS "avg bill inbound",
            avg((h.hangup_at - h.bridged_at)) FILTER (WHERE ((h.bridged_at IS NOT NULL) AND ((h.direction)::text = 'outbound'::text))) AS "avg bill outbound",
            sum((h.hangup_at - h.bridged_at)) FILTER (WHERE (h.bridged_at IS NOT NULL)) AS "sum bill",
            avg((h.hangup_at - h.bridged_at)) FILTER (WHERE (h.bridged_at IS NOT NULL)) AS avg_talk,
            sum(((h.hold_sec || ' sec'::text))::interval) AS "sum hold",
            avg(((h.hold_sec || ' sec'::text))::interval) FILTER (WHERE (h.hold_sec > 0)) AS avg_hold,
            sum((COALESCE(h.answered_at, h.bridged_at, h.hangup_at) - h.created_at)) AS "Call initiation",
            sum((h.hangup_at - h.bridged_at)) FILTER (WHERE (h.bridged_at IS NOT NULL)) AS "Talk time",
            sum((h.hangup_at - h.bridged_at)) FILTER (WHERE ((h.bridged_at IS NOT NULL) AND (h.queue_id IS NOT NULL))) AS queue_talk_sec,
            sum((cc.reporting_at - cc.leaving_at)) FILTER (WHERE (cc.reporting_at IS NOT NULL)) AS "Post call",
            sum((h.hangup_at - h.bridged_at)) FILTER (WHERE ((h.bridged_at IS NOT NULL) AND ((cc.description)::text = 'Voice mail'::text))) AS vm
           FROM ((((agents
             JOIN call_center.cc_calls_history h ON ((h.user_id = agents.user_id)))
             LEFT JOIN call_center.cc_queue cq ON ((h.queue_id = cq.id)))
             LEFT JOIN call_center.cc_member_attempt_history cc ON (((cc.agent_call_id)::text = (h.id)::text)))
             LEFT JOIN call_center.cc_calls_history pc ON (((pc.id = h.parent_id) AND (pc.created_at > ((now())::date - '2 days'::interval)))))
          WHERE ((h.domain_id = agents.domain_id) AND (h.created_at > ((now())::date - '2 days'::interval)) AND (h.created_at >= (agents."from")::timestamp with time zone) AND (h.created_at <= agents."to"))
          GROUP BY h.user_id
        ), stats AS MATERIALIZED (
         SELECT s.agent_id,
            min(s.joined_at) FILTER (WHERE ((s.state)::text = ANY (ARRAY[('online'::character varying)::text, ('pause'::character varying)::text]))) AS login,
            max(s.joined_at) FILTER (WHERE ((s.state)::text = 'offline'::text)) AS logout,
            sum(s.dur) FILTER (WHERE ((s.state)::text = ANY (ARRAY[('online'::character varying)::text, ('pause'::character varying)::text]))) AS online,
            sum(s.dur) FILTER (WHERE ((s.state)::text = 'pause'::text)) AS pause,
            sum(s.dur) FILTER (WHERE (((s.state)::text = 'pause'::text) AND ((s.payload)::text = 'Навчання'::text))) AS study,
            sum(s.dur) FILTER (WHERE (((s.state)::text = 'pause'::text) AND ((s.payload)::text = 'Нарада'::text))) AS conference,
            sum(s.dur) FILTER (WHERE (((s.state)::text = 'pause'::text) AND ((s.payload)::text = 'Обід'::text))) AS lunch,
            sum(s.dur) FILTER (WHERE (((s.state)::text = 'pause'::text) AND ((s.payload)::text = 'Технічна перерва'::text))) AS tech
           FROM (((s
             LEFT JOIN agents ON ((agents.id = s.agent_id)))
             LEFT JOIN eff eff_1 ON ((eff_1.agent_id = s.agent_id)))
             LEFT JOIN calls ON ((calls.user_id = agents.user_id)))
          GROUP BY s.agent_id
        ), rate AS (
         SELECT a_1.user_id,
            count(*) AS count,
            avg(ar.score_required) AS score_required_avg,
            sum(ar.score_required) AS score_required_sum,
            avg(ar.score_optional) AS score_optional_avg,
            sum(ar.score_optional) AS score_optional_sum
           FROM (agents a_1
             JOIN call_center.cc_audit_rate ar ON ((ar.rated_user_id = a_1.user_id)))
          WHERE ((ar.created_at >= (date_trunc('month'::text, (now() AT TIME ZONE a_1.tz_name)) AT TIME ZONE a_1.tz_name)) AND (ar.created_at <= (((date_trunc('month'::text, (now() AT TIME ZONE a_1.tz_name)) + '1 mon'::interval) - '1 day 00:00:01'::interval) AT TIME ZONE a_1.tz_name)))
          GROUP BY a_1.user_id
        )
 SELECT a.id AS agent_id,
    a.user_id,
    a.domain_id,
    COALESCE(c.missed, (0)::bigint) AS call_missed,
    COALESCE(c.abandoned, (0)::bigint) AS call_abandoned,
    COALESCE(c.inbound_bridged, (0)::bigint) AS call_inbound,
    COALESCE(c.handled, (0)::bigint) AS call_handled,
    COALESCE((EXTRACT(epoch FROM c.avg_talk))::bigint, (0)::bigint) AS avg_talk_sec,
    COALESCE((EXTRACT(epoch FROM c.avg_hold))::bigint, (0)::bigint) AS avg_hold_sec,
    COALESCE((EXTRACT(epoch FROM c."Talk time"))::bigint, (0)::bigint) AS sum_talk_sec,
    COALESCE((EXTRACT(epoch FROM c.queue_talk_sec))::bigint, (0)::bigint) AS queue_talk_sec,
    LEAST(round(COALESCE(
        CASE
            WHEN ((stats.online > '00:00:00'::interval) AND (EXTRACT(epoch FROM (stats.online - COALESCE(stats.lunch, '00:00:00'::interval))) > (0)::numeric)) THEN (((((((COALESCE(EXTRACT(epoch FROM c."Call initiation"), (0)::numeric) + COALESCE(EXTRACT(epoch FROM c."Talk time"), (0)::numeric)) + COALESCE(EXTRACT(epoch FROM c."Post call"), (0)::numeric)) - COALESCE(EXTRACT(epoch FROM eff.tpause), (0)::numeric)) + EXTRACT(epoch FROM COALESCE(stats.study, '00:00:00'::interval))) + EXTRACT(epoch FROM COALESCE(stats.conference, '00:00:00'::interval))) / EXTRACT(epoch FROM (stats.online - COALESCE(stats.lunch, '00:00:00'::interval)))) * (100)::numeric)
            ELSE (0)::numeric
        END, (0)::numeric), 2), (100)::numeric) AS occupancy,
    round(COALESCE(
        CASE
            WHEN (stats.online > '00:00:00'::interval) THEN ((EXTRACT(epoch FROM (stats.online - COALESCE(stats.pause, '00:00:00'::interval))) / EXTRACT(epoch FROM stats.online)) * (100)::numeric)
            ELSE (0)::numeric
        END, (0)::numeric), 2) AS utilization,
    (GREATEST(round(COALESCE(
        CASE
            WHEN ((stats.online > '00:00:00'::interval) AND (EXTRACT(epoch FROM (stats.online - COALESCE(stats.lunch, '00:00:00'::interval))) > (0)::numeric)) THEN (EXTRACT(epoch FROM (stats.online - COALESCE(stats.lunch, '00:00:00'::interval))) - (((((COALESCE(EXTRACT(epoch FROM c."Call initiation"), (0)::numeric) + COALESCE(EXTRACT(epoch FROM c."Talk time"), (0)::numeric)) + COALESCE(EXTRACT(epoch FROM c."Post call"), (0)::numeric)) - COALESCE(EXTRACT(epoch FROM eff.tpause), (0)::numeric)) + EXTRACT(epoch FROM COALESCE(stats.study, '00:00:00'::interval))) + EXTRACT(epoch FROM COALESCE(stats.conference, '00:00:00'::interval))))
            ELSE (0)::numeric
        END, (0)::numeric), 2), (0)::numeric))::integer AS available,
    COALESCE((EXTRACT(epoch FROM c.vm))::bigint, (0)::bigint) AS voice_mail,
    COALESCE(ch.chat_aht, (0)::bigint) AS chat_aht,
    (((COALESCE(ch.task_accepts, (0)::bigint) + COALESCE(ch.chat_accepts, (0)::bigint)) + COALESCE(c.handled, (0)::bigint)) - COALESCE(c.user_2user, (0)::bigint)) AS task_accepts,
    (COALESCE(EXTRACT(epoch FROM (stats.online - COALESCE(stats.lunch, '00:00:00'::interval))), (0)::numeric))::bigint AS online,
    COALESCE(ch.chat_accepts, (0)::bigint) AS chat_accepts,
    COALESCE(rate.count, (0)::bigint) AS score_count,
    (COALESCE(EXTRACT(epoch FROM eff.processing), ((0)::bigint)::numeric))::integer AS processing,
    COALESCE(rate.score_optional_avg, (0)::numeric) AS score_optional_avg,
    COALESCE(rate.score_optional_sum, ((0)::bigint)::numeric) AS score_optional_sum,
    COALESCE(rate.score_required_avg, (0)::numeric) AS score_required_avg,
    COALESCE(rate.score_required_sum, ((0)::bigint)::numeric) AS score_required_sum
   FROM ((((((agents a
     LEFT JOIN call_center.cc_agent_with_user u ON ((u.id = a.id)))
     LEFT JOIN stats ON ((stats.agent_id = a.id)))
     LEFT JOIN eff ON ((eff.agent_id = a.id)))
     LEFT JOIN calls c ON ((c.user_id = a.user_id)))
     LEFT JOIN attempts ch ON ((ch.agent_id = a.id)))
     LEFT JOIN rate ON ((rate.user_id = a.user_id)))
  WITH NO DATA;


--
-- Name: cc_agent_waiting; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_agent_waiting AS
 SELECT a.id,
    COALESCE(u.name, (u.username)::text) AS name,
    u.extension AS desctination
   FROM (call_center.cc_agent a
     JOIN directory.wbt_user u ON ((u.id = a.user_id)))
  WHERE (((a.status)::text = 'online'::text) AND (NOT (EXISTS ( SELECT 1
           FROM call_center.cc_calls c
          WHERE ((c.user_id = u.id) AND (c.hangup_at IS NULL))))));


--
-- Name: cc_member_attempt_transferred; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_member_attempt_transferred (
    id bigint NOT NULL,
    from_id bigint NOT NULL,
    to_id bigint NOT NULL,
    transferred_at timestamp with time zone DEFAULT now() NOT NULL,
    from_agent_id integer NOT NULL,
    to_agent_id integer
);


--
-- Name: cc_attempt_transferred_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_attempt_transferred_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_attempt_transferred_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_attempt_transferred_id_seq OWNED BY call_center.cc_member_attempt_transferred.id;


--
-- Name: cc_audit_form; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_audit_form (
    id integer NOT NULL,
    domain_id bigint NOT NULL,
    name character varying NOT NULL,
    description character varying,
    enabled boolean DEFAULT false NOT NULL,
    created_by bigint,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    updated_by bigint NOT NULL,
    updated_at timestamp with time zone DEFAULT now(),
    questions jsonb,
    team_ids integer[],
    archive boolean DEFAULT false NOT NULL,
    editable boolean DEFAULT true NOT NULL
);


--
-- Name: cc_audit_form_acl; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_audit_form_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    object integer NOT NULL,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL
);


--
-- Name: cc_audit_form_acl_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_audit_form_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_audit_form_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_audit_form_acl_id_seq OWNED BY call_center.cc_audit_form_acl.id;


--
-- Name: cc_audit_form_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_audit_form_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_audit_form_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_audit_form_id_seq OWNED BY call_center.cc_audit_form.id;


--
-- Name: cc_audit_form_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_audit_form_view AS
 SELECT i.id,
    i.name,
    i.description,
    i.domain_id,
    i.created_at,
    call_center.cc_get_lookup(uc.id, (uc.name)::character varying) AS created_by,
    i.updated_at,
    call_center.cc_get_lookup(u.id, (u.name)::character varying) AS updated_by,
    ( SELECT jsonb_agg(call_center.cc_get_lookup(aud.id, (aud.name)::character varying)) AS jsonb_agg
           FROM call_center.cc_team aud
          WHERE (aud.id = ANY (i.team_ids))) AS teams,
    i.enabled,
    i.questions,
    i.team_ids,
    i.editable,
    i.archive
   FROM ((call_center.cc_audit_form i
     LEFT JOIN directory.wbt_user uc ON ((uc.id = i.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = i.updated_by)));


--
-- Name: cc_audit_rate_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_audit_rate_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_audit_rate_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_audit_rate_id_seq OWNED BY call_center.cc_audit_rate.id;


--
-- Name: cc_audit_rate_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_audit_rate_view AS
 SELECT r.id,
    r.domain_id,
    r.form_id,
    r.created_at,
    call_center.cc_get_lookup(uc.id, COALESCE((uc.name)::character varying, (uc.username)::character varying)) AS created_by,
    r.updated_at,
    call_center.cc_get_lookup(u.id, COALESCE((u.name)::character varying, (u.username)::character varying)) AS updated_by,
    call_center.cc_get_lookup(ur.id, (ur.name)::character varying) AS rated_user,
    call_center.cc_get_lookup((f.id)::bigint, f.name) AS form,
    r.answers,
    r.score_required,
    r.score_optional,
    r.comment,
    r.call_id,
    f.questions,
    r.rated_user_id
   FROM ((((call_center.cc_audit_rate r
     LEFT JOIN call_center.cc_audit_form f ON ((f.id = r.form_id)))
     LEFT JOIN directory.wbt_user ur ON ((ur.id = r.rated_user_id)))
     LEFT JOIN directory.wbt_user uc ON ((uc.id = r.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = r.updated_by)));


--
-- Name: cc_bucket; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_bucket (
    id bigint NOT NULL,
    name name NOT NULL,
    domain_id bigint NOT NULL,
    description character varying(200) DEFAULT ''::character varying NOT NULL,
    created_at bigint,
    created_by bigint,
    updated_at bigint,
    updated_by bigint
);


--
-- Name: cc_bucket_acl; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_bucket_acl (
    dc bigint NOT NULL,
    object integer NOT NULL,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL,
    grantor bigint
);


--
-- Name: cc_bucket_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_bucket_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_bucket_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_bucket_id_seq OWNED BY call_center.cc_bucket.id;


--
-- Name: cc_bucket_in_queue; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_bucket_in_queue (
    id integer NOT NULL,
    queue_id integer NOT NULL,
    ratio integer DEFAULT 0 NOT NULL,
    bucket_id integer NOT NULL,
    disabled boolean DEFAULT false NOT NULL,
    priority integer DEFAULT 0 NOT NULL
);


--
-- Name: cc_bucket_in_queue_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_bucket_in_queue_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_bucket_in_queue_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_bucket_in_queue_id_seq OWNED BY call_center.cc_bucket_in_queue.id;


--
-- Name: cc_bucket_in_queue_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_bucket_in_queue_view AS
 SELECT q.id,
    q.ratio,
    q.priority,
    call_center.cc_get_lookup(cb.id, ((cb.name)::text)::character varying) AS bucket,
    q.queue_id,
    q.bucket_id,
    cb.domain_id,
    cb.name AS bucket_name,
    q.disabled
   FROM (call_center.cc_bucket_in_queue q
     LEFT JOIN call_center.cc_bucket cb ON ((q.bucket_id = cb.id)));


--
-- Name: cc_bucket_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_bucket_view AS
 SELECT b.id,
    ((b.name)::character varying COLLATE "default") AS name,
    b.description,
    b.domain_id
   FROM call_center.cc_bucket b;


--
-- Name: cc_member; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_member (
    id integer NOT NULL,
    queue_id integer NOT NULL,
    priority smallint DEFAULT 0 NOT NULL,
    variables jsonb DEFAULT '{}'::jsonb,
    name character varying(250) DEFAULT ''::character varying NOT NULL,
    stop_cause character varying(50),
    attempts integer DEFAULT 0 NOT NULL,
    agent_id integer,
    communications jsonb,
    bucket_id integer,
    timezone_id integer,
    last_agent integer,
    sys_offset_id smallint,
    domain_id bigint NOT NULL,
    ready_at timestamp with time zone,
    stop_at timestamp with time zone,
    last_hangup_at bigint DEFAULT 0 NOT NULL,
    search_destinations character varying[],
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    expire_at timestamp with time zone,
    skill_id integer,
    import_id character varying(120),
    sys_destinations call_center.cc_destination[],
    CONSTRAINT cc_member_bucket_skill_check CHECK ((NOT ((bucket_id IS NOT NULL) AND (skill_id IS NOT NULL))))
)
WITH (fillfactor='20', log_autovacuum_min_duration='0', autovacuum_vacuum_scale_factor='0.01', autovacuum_analyze_scale_factor='0.05', autovacuum_vacuum_cost_delay='20', autovacuum_enabled='1', autovacuum_analyze_threshold='2000');
ALTER TABLE ONLY call_center.cc_member ALTER COLUMN communications SET STATISTICS 100;


--
-- Name: cc_member_attempt; Type: TABLE; Schema: call_center; Owner: -
--

CREATE UNLOGGED TABLE call_center.cc_member_attempt (
    id bigint NOT NULL,
    queue_id integer,
    member_id bigint,
    weight integer DEFAULT 0 NOT NULL,
    resource_id integer,
    node_id character varying(20),
    result character varying(200),
    agent_id integer,
    bucket_id bigint,
    display character varying(50),
    description character varying,
    list_communication_id bigint,
    joined_at timestamp with time zone DEFAULT now() NOT NULL,
    leaving_at timestamp with time zone,
    agent_call_id character varying,
    member_call_id character varying,
    offering_at timestamp with time zone,
    reporting_at timestamp with time zone,
    state character varying DEFAULT 'idle'::character varying NOT NULL,
    bridged_at timestamp with time zone,
    channel character varying DEFAULT 'call'::character varying NOT NULL,
    timeout timestamp with time zone,
    last_state_change timestamp with time zone DEFAULT now() NOT NULL,
    communication_idx integer DEFAULT 1 NOT NULL,
    resource_group_id integer,
    destination jsonb,
    seq integer DEFAULT 0 NOT NULL,
    answered_at timestamp with time zone,
    team_id integer,
    sticky_agent_id integer,
    domain_id bigint NOT NULL,
    transferred_at timestamp with time zone,
    transferred_agent_id integer,
    transferred_attempt_id bigint,
    parent_id bigint,
    waiting_other_numbers integer DEFAULT 0 NOT NULL,
    form_fields jsonb,
    form_view jsonb,
    import_id character varying(120),
    schema_processing boolean DEFAULT false
)
WITH (fillfactor='20', log_autovacuum_min_duration='0', autovacuum_analyze_scale_factor='0.05', autovacuum_enabled='1', autovacuum_vacuum_cost_delay='20', autovacuum_vacuum_threshold='100', autovacuum_vacuum_scale_factor='0.01');


--
-- Name: TABLE cc_member_attempt; Type: COMMENT; Schema: call_center; Owner: -
--

COMMENT ON TABLE call_center.cc_member_attempt IS 'todo';


--
-- Name: COLUMN cc_member_attempt.communication_idx; Type: COMMENT; Schema: call_center; Owner: -
--

COMMENT ON COLUMN call_center.cc_member_attempt.communication_idx IS 'fixme';


--
-- Name: sip_gateway; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.sip_gateway (
    id bigint NOT NULL,
    dc bigint,
    name character varying(255) NOT NULL,
    usage text,
    host character varying(255) NOT NULL,
    proxy character varying(255) NOT NULL,
    enable boolean DEFAULT false NOT NULL,
    register boolean DEFAULT false NOT NULL,
    account character varying(255),
    username character varying(64),
    password character varying(64),
    expires integer,
    binding_uri character varying(255),
    binding_params character varying(64),
    registrar character varying(255),
    scheme_id bigint,
    envar jsonb,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP,
    created_by bigint,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP,
    updated_by bigint,
    forced_socket character varying(64)
);


--
-- Name: COLUMN sip_gateway.host; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.sip_gateway.host IS 'opensips.registrar.sip: host[:port] local realm';


--
-- Name: COLUMN sip_gateway.proxy; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.sip_gateway.proxy IS 'opensips.registrant.registrar: [INVITE|REGISTER] remote realm';


--
-- Name: COLUMN sip_gateway.account; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.sip_gateway.account IS 'opensips.registrant.aor: register.to';


--
-- Name: COLUMN sip_gateway.registrar; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.sip_gateway.registrar IS 'opensips.registrant.registrar: [REGISTER] proxy';


--
-- Name: COLUMN sip_gateway.forced_socket; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.sip_gateway.forced_socket IS 'Socket for sending the REGISTER';


--
-- Name: cc_call_active_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_call_active_list AS
 SELECT c.id,
    c.app_id,
    c.state,
    c."timestamp",
    'call'::character varying AS type,
    c.parent_id,
    call_center.cc_get_lookup(u.id, (COALESCE(u.name, (u.username)::text))::character varying) AS "user",
    u.extension,
    call_center.cc_get_lookup(gw.id, gw.name) AS gateway,
    c.direction,
    c.destination,
    json_build_object('type', COALESCE(c.from_type, ''::character varying), 'number', COALESCE(c.from_number, ''::character varying), 'id', COALESCE(c.from_id, ''::character varying), 'name', COALESCE(c.from_name, ''::character varying)) AS "from",
        CASE
            WHEN ((c.to_number)::text <> ''::text) THEN json_build_object('type', COALESCE(c.to_type, ''::character varying), 'number', COALESCE(c.to_number, ''::character varying), 'id', COALESCE(c.to_id, ''::character varying), 'name', COALESCE(c.to_name, ''::character varying))
            ELSE NULL::json
        END AS "to",
        CASE
            WHEN (c.payload IS NULL) THEN '{}'::jsonb
            ELSE c.payload
        END AS variables,
    c.created_at,
    c.answered_at,
    c.bridged_at,
    c.hangup_at,
    (date_part('epoch'::text, (now() - c.created_at)))::bigint AS duration,
    COALESCE(c.hold_sec, 0) AS hold_sec,
    COALESCE(
        CASE
            WHEN (c.answered_at IS NOT NULL) THEN (date_part('epoch'::text, (c.answered_at - c.created_at)))::bigint
            ELSE (date_part('epoch'::text, (now() - c.created_at)))::bigint
        END, (0)::bigint) AS wait_sec,
        CASE
            WHEN (c.answered_at IS NOT NULL) THEN (date_part('epoch'::text, (now() - c.answered_at)))::bigint
            ELSE (0)::bigint
        END AS bill_sec,
    call_center.cc_get_lookup((cq.id)::bigint, cq.name) AS queue,
    call_center.cc_get_lookup((cm.id)::bigint, cm.name) AS member,
    call_center.cc_get_lookup(ct.id, ct.name) AS team,
    ca."user" AS agent,
    cma.joined_at,
    cma.leaving_at,
    cma.reporting_at,
    cma.bridged_at AS queue_bridged_at,
        CASE
            WHEN (cma.bridged_at IS NOT NULL) THEN (date_part('epoch'::text, (cma.bridged_at - cma.joined_at)))::integer
            ELSE (date_part('epoch'::text, (cma.leaving_at - cma.joined_at)))::integer
        END AS queue_wait_sec,
    (date_part('epoch'::text, (cma.leaving_at - cma.joined_at)))::integer AS queue_duration_sec,
    cma.result,
        CASE
            WHEN (cma.reporting_at IS NOT NULL) THEN (date_part('epoch'::text, (cma.reporting_at - now())))::integer
            ELSE 0
        END AS reporting_sec,
    c.agent_id,
    aa.team_id,
    c.user_id,
    c.queue_id,
    c.member_id,
    c.attempt_id,
    c.domain_id,
    c.gateway_id,
    c.from_number,
    c.to_number,
    cma.display,
    ( SELECT jsonb_agg(sag."user") AS jsonb_agg
           FROM call_center.cc_agent_with_user sag
          WHERE (sag.id = ANY (aa.supervisor_ids))) AS supervisor,
    aa.supervisor_ids,
    c.grantee_id,
    c.hold,
    c.blind_transfer,
    c.bridged_id
   FROM ((((((((call_center.cc_calls c
     LEFT JOIN call_center.cc_queue cq ON ((c.queue_id = cq.id)))
     LEFT JOIN call_center.cc_team ct ON ((c.team_id = ct.id)))
     LEFT JOIN call_center.cc_member cm ON ((c.member_id = cm.id)))
     LEFT JOIN call_center.cc_member_attempt cma ON ((cma.id = c.attempt_id)))
     LEFT JOIN call_center.cc_agent_with_user ca ON ((cma.agent_id = ca.id)))
     LEFT JOIN call_center.cc_agent aa ON ((aa.user_id = c.user_id)))
     LEFT JOIN directory.wbt_user u ON ((u.id = c.user_id)))
     LEFT JOIN directory.sip_gateway gw ON ((gw.id = c.gateway_id)))
  WHERE ((c.hangup_at IS NULL) AND (c.direction IS NOT NULL));


--
-- Name: cc_calls_annotation; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_calls_annotation (
    id bigint NOT NULL,
    call_id character varying NOT NULL,
    created_by bigint,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    note text NOT NULL,
    start_sec integer DEFAULT 0 NOT NULL,
    end_sec integer DEFAULT 0 NOT NULL,
    updated_by bigint,
    updated_at timestamp with time zone DEFAULT now() NOT NULL
);


--
-- Name: cc_call_annotation_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_call_annotation_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_call_annotation_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_call_annotation_id_seq OWNED BY call_center.cc_calls_annotation.id;


--
-- Name: cc_list; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_list (
    id bigint NOT NULL,
    name character varying(50) NOT NULL,
    type integer DEFAULT 0 NOT NULL,
    description character varying,
    domain_id bigint NOT NULL,
    created_at bigint NOT NULL,
    created_by bigint,
    updated_at bigint NOT NULL,
    updated_by bigint
);


--
-- Name: cc_call_list_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_call_list_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_call_list_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_call_list_id_seq OWNED BY call_center.cc_list.id;


--
-- Name: contact; Type: TABLE; Schema: contacts; Owner: -
--

CREATE TABLE contacts.contact (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    ver integer DEFAULT 0 NOT NULL,
    iss text,
    sub text,
    contact_id bigint,
    verified boolean DEFAULT false NOT NULL,
    common_name text NOT NULL,
    given_name text,
    family_name text,
    middle_name text,
    about text,
    updated_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    updated_by bigint,
    created_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    created_by bigint,
    deleted_at timestamp without time zone,
    deleted_by bigint
);


--
-- Name: COLUMN contact.ver; Type: COMMENT; Schema: contacts; Owner: -
--

COMMENT ON COLUMN contacts.contact.ver IS 'Sequence Number of the latest update';


--
-- Name: COLUMN contact.common_name; Type: COMMENT; Schema: contacts; Owner: -
--

COMMENT ON COLUMN contacts.contact.common_name IS '[PRE]Formatted FULL Name';


--
-- Name: COLUMN contact.about; Type: COMMENT; Schema: contacts; Owner: -
--

COMMENT ON COLUMN contacts.contact.about IS 'BIO about the contact person';


--
-- Name: file_jobs; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.file_jobs (
    id bigint NOT NULL,
    file_id bigint NOT NULL,
    state smallint DEFAULT 0 NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    updated_at timestamp with time zone DEFAULT now() NOT NULL,
    action character varying(15) NOT NULL,
    log jsonb,
    config jsonb,
    error character varying
);


--
-- Name: file_transcript; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.file_transcript (
    id bigint NOT NULL,
    file_id bigint,
    transcript text NOT NULL,
    log jsonb,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    profile_id integer NOT NULL,
    locale character varying DEFAULT 'none'::character varying NOT NULL,
    phrases jsonb,
    channels jsonb,
    uuid character varying NOT NULL,
    domain_id bigint
);


--
-- Name: files; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.files (
    id bigint NOT NULL,
    name character varying NOT NULL,
    size bigint NOT NULL,
    mime_type character varying,
    properties jsonb NOT NULL,
    instance character varying(50) NOT NULL,
    uuid character varying NOT NULL,
    profile_id integer,
    created_at bigint,
    removed boolean,
    not_exists boolean,
    domain_id bigint NOT NULL,
    view_name character varying
);


--
-- Name: cc_calls_history_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_calls_history_list AS
 SELECT c.id,
    c.app_id,
    'call'::character varying AS type,
    c.parent_id,
    c.transfer_from,
        CASE
            WHEN ((c.parent_id IS NOT NULL) AND (c.transfer_to IS NULL) AND ((c.id)::text <> (lega.bridged_id)::text)) THEN lega.bridged_id
            ELSE c.transfer_to
        END AS transfer_to,
    call_center.cc_get_lookup(u.id, (COALESCE(u.name, (u.username)::text))::character varying) AS "user",
        CASE
            WHEN (cq.type = ANY (ARRAY[4, 5])) THEN cag.extension
            ELSE u.extension
        END AS extension,
    call_center.cc_get_lookup(gw.id, gw.name) AS gateway,
    c.direction,
    c.destination,
    json_build_object('type', COALESCE(c.from_type, ''::character varying), 'number', COALESCE(c.from_number, ''::character varying), 'id', COALESCE(c.from_id, ''::character varying), 'name', COALESCE(c.from_name, ''::character varying)) AS "from",
    json_build_object('type', COALESCE(c.to_type, ''::character varying), 'number', COALESCE(c.to_number, ''::character varying), 'id', COALESCE(c.to_id, ''::character varying), 'name', COALESCE(c.to_name, ''::character varying)) AS "to",
    c.payload AS variables,
    c.created_at,
    c.answered_at,
    c.bridged_at,
    c.hangup_at,
    c.stored_at,
    COALESCE(c.hangup_by, ''::character varying) AS hangup_by,
    c.cause,
    (date_part('epoch'::text, (c.hangup_at - c.created_at)))::bigint AS duration,
    COALESCE(c.hold_sec, 0) AS hold_sec,
    COALESCE(
        CASE
            WHEN (c.answered_at IS NOT NULL) THEN (date_part('epoch'::text, (c.answered_at - c.created_at)))::bigint
            ELSE (date_part('epoch'::text, (c.hangup_at - c.created_at)))::bigint
        END, (0)::bigint) AS wait_sec,
        CASE
            WHEN (c.answered_at IS NOT NULL) THEN (date_part('epoch'::text, (c.hangup_at - c.answered_at)))::bigint
            ELSE (0)::bigint
        END AS bill_sec,
    c.sip_code,
    f.files,
    call_center.cc_get_lookup((cq.id)::bigint, cq.name) AS queue,
    call_center.cc_get_lookup(c.member_id, cm.name) AS member,
    call_center.cc_get_lookup(ct.id, ct.name) AS team,
    call_center.cc_get_lookup((aa.id)::bigint, (COALESCE(cag.username, (cag.name)::name))::character varying) AS agent,
    cma.joined_at,
    cma.leaving_at,
    cma.reporting_at,
    cma.bridged_at AS queue_bridged_at,
        CASE
            WHEN (cma.bridged_at IS NOT NULL) THEN (date_part('epoch'::text, (cma.bridged_at - cma.joined_at)))::integer
            ELSE (date_part('epoch'::text, (cma.leaving_at - cma.joined_at)))::integer
        END AS queue_wait_sec,
    (date_part('epoch'::text, (cma.leaving_at - cma.joined_at)))::integer AS queue_duration_sec,
    cma.result,
        CASE
            WHEN (cma.reporting_at IS NOT NULL) THEN (date_part('epoch'::text, (cma.reporting_at - cma.leaving_at)))::integer
            ELSE 0
        END AS reporting_sec,
    c.agent_id,
    c.team_id,
    c.user_id,
    c.queue_id,
    c.member_id,
    c.attempt_id,
    c.domain_id,
    c.gateway_id,
    c.from_number,
    c.to_number,
    c.tags,
    cma.display,
    (EXISTS ( SELECT 1
           FROM call_center.cc_calls_history hp
          WHERE ((c.parent_id IS NULL) AND (hp.parent_id = c.id)))) AS has_children,
    (COALESCE(regexp_replace((cma.description)::text, '^[\r\n\t ]*|[\r\n\t ]*$'::text, ''::text, 'g'::text), (''::character varying)::text))::character varying AS agent_description,
    c.grantee_id,
    ( SELECT jsonb_agg(x.hi ORDER BY (x.hi -> 'start'::text)) AS res
           FROM ( SELECT jsonb_array_elements(chh.hold) AS hi
                   FROM call_center.cc_calls_history chh
                  WHERE ((chh.parent_id = c.id) AND (chh.hold IS NOT NULL))
                UNION
                 SELECT jsonb_array_elements(c.hold) AS jsonb_array_elements) x
          WHERE (x.hi IS NOT NULL)) AS hold,
    c.gateway_ids,
    c.user_ids,
    c.agent_ids,
    c.queue_ids,
    c.team_ids,
    ( SELECT json_agg(row_to_json(annotations.*)) AS json_agg
           FROM ( SELECT a.id,
                    a.call_id,
                    a.created_at,
                    call_center.cc_get_lookup(cc_1.id, (COALESCE(cc_1.name, (cc_1.username)::text))::character varying) AS created_by,
                    a.updated_at,
                    call_center.cc_get_lookup(uc.id, (COALESCE(uc.name, (uc.username)::text))::character varying) AS updated_by,
                    a.note,
                    a.start_sec,
                    a.end_sec
                   FROM ((call_center.cc_calls_annotation a
                     LEFT JOIN directory.wbt_user cc_1 ON ((cc_1.id = a.created_by)))
                     LEFT JOIN directory.wbt_user uc ON ((uc.id = a.updated_by)))
                  WHERE ((a.call_id)::text = (c.id)::text)
                  ORDER BY a.created_at DESC) annotations) AS annotations,
    COALESCE(c.amd_result, c.amd_ai_result) AS amd_result,
    c.amd_duration,
    c.amd_ai_result,
    c.amd_ai_logs,
    c.amd_ai_positive,
    cq.type AS queue_type,
        CASE
            WHEN (c.parent_id IS NOT NULL) THEN ''::text
            WHEN ((c.cause)::text = ANY (ARRAY[('USER_BUSY'::character varying)::text, ('NO_ANSWER'::character varying)::text])) THEN 'not_answered'::text
            WHEN (((c.cause)::text = 'ORIGINATOR_CANCEL'::text) OR (((c.cause)::text = 'LOSE_RACE'::text) AND (cq.type = 4))) THEN 'cancelled'::text
            WHEN ((c.hangup_by)::text = 'F'::text) THEN 'ended'::text
            WHEN ((c.cause)::text = 'NORMAL_CLEARING'::text) THEN
            CASE
                WHEN ((((c.cause)::text = 'NORMAL_CLEARING'::text) AND ((c.direction)::text = 'outbound'::text) AND ((c.hangup_by)::text = 'A'::text) AND (c.user_id IS NOT NULL)) OR (((c.direction)::text = 'inbound'::text) AND ((c.hangup_by)::text = 'B'::text) AND (c.bridged_at IS NOT NULL)) OR (((c.direction)::text = 'outbound'::text) AND ((c.hangup_by)::text = 'B'::text) AND (cq.type = ANY (ARRAY[4, 5, 1])) AND (c.bridged_at IS NOT NULL))) THEN 'agent_dropped'::text
                ELSE 'client_dropped'::text
            END
            ELSE 'error'::text
        END AS hangup_disposition,
    c.blind_transfer,
    ( SELECT jsonb_agg(json_build_object('id', j.id, 'created_at', call_center.cc_view_timestamp(j.created_at), 'action', j.action, 'file_id', j.file_id, 'state', j.state, 'error', j.error, 'updated_at', call_center.cc_view_timestamp(j.updated_at))) AS jsonb_agg
           FROM storage.file_jobs j
          WHERE (j.file_id = ANY (f.file_ids))) AS files_job,
    ( SELECT json_agg(json_build_object('id', tr.id, 'locale', tr.locale, 'file_id', tr.file_id, 'file', call_center.cc_get_lookup(ff.id, ff.name))) AS data
           FROM (storage.file_transcript tr
             LEFT JOIN storage.files ff ON ((ff.id = tr.file_id)))
          WHERE ((tr.uuid)::text = (c.id)::text)
          GROUP BY (tr.uuid)::text) AS transcripts,
    c.talk_sec,
    call_center.cc_get_lookup(au.id, (au.name)::character varying) AS grantee,
    ar.id AS rate_id,
    call_center.cc_get_lookup(aru.id, COALESCE((aru.name)::character varying, (aru.username)::character varying)) AS rated_user,
    call_center.cc_get_lookup(arub.id, COALESCE((arub.name)::character varying, (arub.username)::character varying)) AS rated_by,
    ar.score_optional,
    ar.score_required,
    (EXISTS ( SELECT 1
           FROM call_center.cc_calls_history cr
          WHERE ((cr.id = c.bridged_id) AND (c.bridged_id IS NOT NULL) AND (c.blind_transfer IS NULL) AND (cr.blind_transfer IS NULL) AND (c.transfer_to IS NULL) AND (cr.transfer_to IS NULL) AND (c.transfer_from IS NULL) AND (cr.transfer_from IS NULL) AND (COALESCE(cr.user_id, c.user_id) IS NOT NULL)))) AS allow_evaluation,
    cma.form_fields,
    c.bridged_id,
    call_center.cc_get_lookup(cc.id, (cc.common_name)::character varying) AS contact,
    c.contact_id,
    c.search_number
   FROM (((((((((((((((call_center.cc_calls_history c
     LEFT JOIN LATERAL ( SELECT array_agg(f_1.id) AS file_ids,
            json_agg(jsonb_build_object('id', f_1.id, 'name', f_1.name, 'size', f_1.size, 'mime_type', f_1.mime_type, 'start_at', ((c.params -> 'record_start'::text))::bigint, 'stop_at', ((c.params -> 'record_stop'::text))::bigint)) AS files
           FROM ( SELECT f1.id,
                    f1.size,
                    f1.mime_type,
                    f1.name
                   FROM storage.files f1
                  WHERE ((f1.domain_id = c.domain_id) AND (NOT (f1.removed IS TRUE)) AND ((f1.uuid)::text = (c.id)::text))
                UNION ALL
                 SELECT f1.id,
                    f1.size,
                    f1.mime_type,
                    f1.name
                   FROM storage.files f1
                  WHERE ((f1.domain_id = c.domain_id) AND (NOT (f1.removed IS TRUE)) AND ((f1.uuid)::text = (c.parent_id)::text))) f_1) f ON (((c.answered_at IS NOT NULL) OR (c.bridged_at IS NOT NULL))))
     LEFT JOIN call_center.cc_queue cq ON ((c.queue_id = cq.id)))
     LEFT JOIN call_center.cc_team ct ON ((c.team_id = ct.id)))
     LEFT JOIN call_center.cc_member cm ON ((c.member_id = cm.id)))
     LEFT JOIN call_center.cc_member_attempt_history cma ON ((cma.id = c.attempt_id)))
     LEFT JOIN call_center.cc_agent aa ON ((cma.agent_id = aa.id)))
     LEFT JOIN directory.wbt_user cag ON ((cag.id = aa.user_id)))
     LEFT JOIN directory.wbt_user u ON ((u.id = c.user_id)))
     LEFT JOIN directory.sip_gateway gw ON ((gw.id = c.gateway_id)))
     LEFT JOIN directory.wbt_auth au ON ((au.id = c.grantee_id)))
     LEFT JOIN call_center.cc_calls_history lega ON (((c.parent_id IS NOT NULL) AND (lega.id = c.parent_id))))
     LEFT JOIN call_center.cc_audit_rate ar ON (((ar.call_id)::text = (c.id)::text)))
     LEFT JOIN directory.wbt_user aru ON (((ar.* IS NOT NULL) AND (aru.id = ar.rated_user_id))))
     LEFT JOIN directory.wbt_user arub ON (((ar.* IS NOT NULL) AND (arub.id = ar.created_by))))
     LEFT JOIN contacts.contact cc ON ((cc.id = c.contact_id)));


--
-- Name: cc_calls_transcribe; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_calls_transcribe (
    id bigint NOT NULL,
    call_id character varying NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    transcribe character varying
);


--
-- Name: cc_calls_transcribe_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_calls_transcribe_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_calls_transcribe_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_calls_transcribe_id_seq OWNED BY call_center.cc_calls_transcribe.id;


--
-- Name: cc_cluster; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_cluster (
    id integer NOT NULL,
    node_name character varying(20) NOT NULL,
    updated_at bigint NOT NULL,
    master boolean NOT NULL,
    started_at bigint DEFAULT 0 NOT NULL
);


--
-- Name: cc_cluster_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_cluster_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_cluster_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_cluster_id_seq OWNED BY call_center.cc_cluster.id;


--
-- Name: cc_communication; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_communication (
    id integer NOT NULL,
    name character varying(50) NOT NULL,
    code character varying(100) NOT NULL,
    channel character varying,
    domain_id bigint,
    description character varying(200) DEFAULT ''::character varying,
    "default" boolean DEFAULT false NOT NULL
);


--
-- Name: cc_communication_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_communication_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_communication_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_communication_id_seq OWNED BY call_center.cc_communication.id;


--
-- Name: cc_communication_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_communication_list AS
 SELECT c.id,
    c.name,
    c.code,
    c.description,
    c.channel,
    c."default",
    c.domain_id
   FROM call_center.cc_communication c;


--
-- Name: cc_distribute_stage_1; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_distribute_stage_1 AS
SELECT
    NULL::integer AS id,
    NULL::smallint AS type,
    NULL::smallint AS strategy,
    NULL::bigint AS team_id,
    NULL::call_center.cc_sys_distribute_bucket[] AS buckets,
    NULL::call_center.cc_sys_distribute_type[] AS types,
    NULL::call_center.cc_sys_distribute_resource[] AS resources,
    NULL::integer[] AS offset_ids,
    NULL::integer AS lim,
    NULL::bigint AS domain_id,
    NULL::integer AS priority,
    NULL::boolean AS sticky_agent,
    NULL::integer AS sticky_agent_sec,
    NULL::boolean AS recall_calendar,
    NULL::boolean AS wait_between_retries_desc,
    NULL::boolean AS strict_circuit,
    NULL::boolean AS ins,
    NULL::bigint AS min_wt;


--
-- Name: system_settings; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.system_settings (
    id integer NOT NULL,
    domain_id bigint NOT NULL,
    name character varying NOT NULL,
    value jsonb
);


--
-- Name: cc_distribute_stats; Type: MATERIALIZED VIEW; Schema: call_center; Owner: -
--

CREATE MATERIALIZED VIEW call_center.cc_distribute_stats AS
 SELECT s.queue_id,
    s.bucket_id,
    s.start_stat,
    s.stop_stat,
    s.call_attempts,
    s.avg_handle,
    s.med_handle,
    s.avg_member_answer,
    s.avg_member_answer_not_bridged,
    s.avg_member_answer_bridged,
    s.max_member_answer,
    s.connected_calls,
    s.bridged_calls,
    s.abandoned_calls,
    s.connection_rate,
    (call_center.cc_wrap_over_dial((s.over_dial)::numeric, (s.abandoned_rate)::numeric, COALESCE(((q.payload -> 'target_abandoned_rate'::text))::numeric, COALESCE(((q.payload -> 'max_abandoned_rate'::text))::numeric, 3.0)), COALESCE(((q.payload -> 'max_abandoned_rate'::text))::numeric, 3.0), COALESCE(((q.payload -> 'load_factor'::text))::numeric, 10.0)))::double precision AS over_dial,
    s.abandoned_rate,
    s.hit_rate,
    s.agents,
    s.aggent_ids
   FROM (((call_center.cc_queue q
     LEFT JOIN LATERAL ( SELECT
                CASE
                    WHEN ((jsonb_typeof(s_1.value) = 'boolean'::text) AND (s_1.value)::boolean) THEN true
                    ELSE false
                END AS amd_cancel_not_human
           FROM call_center.system_settings s_1
          WHERE ((s_1.domain_id = q.domain_id) AND ((s_1.name)::text = 'amd_cancel_not_human'::text))) sys ON (true))
     LEFT JOIN LATERAL ( SELECT
                CASE
                    WHEN sys.amd_cancel_not_human THEN tmp.v
                    ELSE (tmp.v || 'CANCEL'::text)
                END AS arr
           FROM ( SELECT
                        CASE
                            WHEN ((((q.payload -> 'amd'::text) -> 'allow_not_sure'::text))::boolean IS TRUE) THEN ARRAY['HUMAN'::text, 'NOTSURE'::text]
                            ELSE ARRAY['HUMAN'::text]
                        END AS v) tmp) amd ON (true))
     JOIN LATERAL ( SELECT att.queue_id,
            att.bucket_id,
            min(att.joined_at) AS start_stat,
            max(att.joined_at) AS stop_stat,
            count(*) AS call_attempts,
            COALESCE(avg(date_part('epoch'::text, (COALESCE(att.reporting_at, att.leaving_at) - att.offering_at))) FILTER (WHERE (att.bridged_at IS NOT NULL)), (0)::double precision) AS avg_handle,
            COALESCE(avg(DISTINCT (round(date_part('epoch'::text, (COALESCE(att.reporting_at, att.leaving_at) - att.offering_at))))::real) FILTER (WHERE (att.bridged_at IS NOT NULL)), (0)::double precision) AS med_handle,
            COALESCE(avg(date_part('epoch'::text, (ch.answered_at - att.joined_at))) FILTER (WHERE (ch.answered_at IS NOT NULL)), (0)::double precision) AS avg_member_answer,
            COALESCE(avg(date_part('epoch'::text, (ch.answered_at - att.joined_at))) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND (ch.bridged_at IS NULL))), (0)::double precision) AS avg_member_answer_not_bridged,
            COALESCE(avg(date_part('epoch'::text, (ch.answered_at - att.joined_at))) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND (ch.bridged_at IS NOT NULL))), (0)::double precision) AS avg_member_answer_bridged,
            COALESCE(max(date_part('epoch'::text, (ch.answered_at - att.joined_at))) FILTER (WHERE (ch.answered_at IS NOT NULL)), (0)::double precision) AS max_member_answer,
            count(*) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND amd_res.human)) AS connected_calls,
            count(*) FILTER (WHERE (att.bridged_at IS NOT NULL)) AS bridged_calls,
            count(*) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND (att.bridged_at IS NULL) AND amd_res.human)) AS abandoned_calls,
            ((count(*) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND amd_res.human)))::double precision / (count(*))::double precision) AS connection_rate,
                CASE
                    WHEN (((count(*) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND amd_res.human)))::double precision / (count(*))::double precision) > (0)::double precision) THEN ((1)::double precision / ((count(*) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND amd_res.human)))::double precision / (count(*))::double precision))
                    ELSE (((count(*) / GREATEST(count(DISTINCT att.agent_id), (1)::bigint)) - 1))::double precision
                END AS over_dial,
            COALESCE(((((count(*) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND (att.bridged_at IS NULL) AND amd_res.human)))::double precision - (COALESCE(((q.payload -> 'abandon_rate_adjustment'::text))::integer, 0))::double precision) / (NULLIF(count(*) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND amd_res.human)), 0))::double precision) * (100)::double precision), (0)::double precision) AS abandoned_rate,
            ((count(*) FILTER (WHERE ((ch.answered_at IS NOT NULL) AND amd_res.human)))::double precision / (count(*))::double precision) AS hit_rate,
            count(DISTINCT att.agent_id) AS agents,
            array_agg(DISTINCT att.agent_id) FILTER (WHERE (att.agent_id IS NOT NULL)) AS aggent_ids
           FROM ((call_center.cc_member_attempt_history att
             LEFT JOIN call_center.cc_calls_history ch ON (((ch.domain_id = att.domain_id) AND (ch.id = (att.member_call_id)::uuid) AND (ch.created_at > ((now())::date - '1 day'::interval)))))
             LEFT JOIN LATERAL ( SELECT (((ch.amd_result IS NULL) AND (ch.amd_ai_positive IS NULL)) OR ((ch.amd_result)::text = ANY (amd.arr)) OR (ch.amd_ai_positive IS TRUE)) AS human) amd_res ON (true))
          WHERE (((att.channel)::text = 'call'::text) AND (att.joined_at > (now() - ((COALESCE(((q.payload -> 'statistic_time'::text))::integer, 60) || ' min'::text))::interval)) AND (att.queue_id = q.id) AND (att.domain_id = q.domain_id))
          GROUP BY att.queue_id, att.bucket_id) s ON ((s.queue_id IS NOT NULL)))
  WHERE ((q.type = 5) AND q.enabled)
  WITH NO DATA;


--
-- Name: cc_email; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_email (
    id bigint NOT NULL,
    "from" character varying[] NOT NULL,
    "to" character varying[],
    profile_id integer NOT NULL,
    subject character varying,
    cc character varying[],
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    parent_id bigint,
    direction character varying,
    user_id bigint,
    attempt_id bigint,
    message_id character varying NOT NULL,
    sender character varying[],
    reply_to character varying[],
    in_reply_to character varying,
    variables jsonb,
    root_id character varying,
    flow_id integer,
    body text,
    html text,
    attachment_ids bigint[]
);


--
-- Name: cc_email_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_email_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_email_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_email_id_seq OWNED BY call_center.cc_email.id;


--
-- Name: cc_email_profile; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_email_profile (
    id integer NOT NULL,
    domain_id bigint NOT NULL,
    name character varying NOT NULL,
    description character varying DEFAULT ''::character varying NOT NULL,
    enabled boolean DEFAULT true NOT NULL,
    last_activity_at timestamp with time zone,
    fetch_err character varying,
    updated_at timestamp with time zone DEFAULT now() NOT NULL,
    fetch_interval integer DEFAULT 5 NOT NULL,
    state character varying DEFAULT 'idle'::character varying NOT NULL,
    flow_id integer,
    imap_host character varying,
    mailbox character varying,
    imap_port integer,
    smtp_port integer,
    login character varying,
    password character varying,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    created_by bigint,
    updated_by bigint,
    smtp_host character varying,
    params jsonb,
    auth_type character varying DEFAULT 'plain'::character varying NOT NULL,
    listen boolean DEFAULT false NOT NULL
);


--
-- Name: COLUMN cc_email_profile.fetch_interval; Type: COMMENT; Schema: call_center; Owner: -
--

COMMENT ON COLUMN call_center.cc_email_profile.fetch_interval IS 'sec; TODO add check > 5';


--
-- Name: acr_routing_scheme; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.acr_routing_scheme (
    id bigint NOT NULL,
    domain_id bigint NOT NULL,
    name character varying(100) NOT NULL,
    scheme jsonb NOT NULL,
    payload jsonb DEFAULT '{}'::jsonb NOT NULL,
    created_at bigint NOT NULL,
    created_by bigint,
    updated_at bigint NOT NULL,
    updated_by bigint,
    description character varying(200) DEFAULT ''::character varying NOT NULL,
    debug boolean DEFAULT false NOT NULL,
    state smallint,
    type character varying DEFAULT 'voice'::character varying NOT NULL,
    editor boolean DEFAULT false NOT NULL,
    tags character varying[]
);


--
-- Name: COLUMN acr_routing_scheme.state; Type: COMMENT; Schema: flow; Owner: -
--

COMMENT ON COLUMN flow.acr_routing_scheme.state IS 'draft / new / used';


--
-- Name: cc_email_profile_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_email_profile_list AS
 SELECT t.id,
    t.domain_id,
    call_center.cc_view_timestamp(t.created_at) AS created_at,
    call_center.cc_get_lookup(t.created_by, (cc.name)::character varying) AS created_by,
    call_center.cc_view_timestamp(t.updated_at) AS updated_at,
    call_center.cc_get_lookup(t.updated_by, (cu.name)::character varying) AS updated_by,
    call_center.cc_view_timestamp(t.last_activity_at) AS activity_at,
    t.name,
    t.imap_host,
    t.smtp_host,
    t.login,
    t.mailbox,
    t.smtp_port,
    t.imap_port,
    t.fetch_err AS fetch_error,
    t.fetch_interval,
    t.state,
    call_center.cc_get_lookup((t.flow_id)::bigint, s.name) AS schema,
    t.description,
    t.enabled,
    t.password,
    t.listen
   FROM (((call_center.cc_email_profile t
     LEFT JOIN directory.wbt_user cc ON ((cc.id = t.created_by)))
     LEFT JOIN directory.wbt_user cu ON ((cu.id = t.updated_by)))
     LEFT JOIN flow.acr_routing_scheme s ON ((s.id = t.flow_id)));


--
-- Name: cc_email_profiles_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_email_profiles_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_email_profiles_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_email_profiles_id_seq OWNED BY call_center.cc_email_profile.id;


--
-- Name: cc_inbound_stats; Type: MATERIALIZED VIEW; Schema: call_center; Owner: -
--

CREATE MATERIALIZED VIEW call_center.cc_inbound_stats AS
 SELECT h.queue_id,
    h.bucket_id,
    COALESCE(avg(date_part('epoch'::text, (COALESCE(h.bridged_at, h.reporting_at, h.leaving_at) - h.joined_at))) FILTER (WHERE (h.bridged_at IS NOT NULL)), (0)::double precision) AS ata,
    count(DISTINCT h.agent_id) AS agent_cnt,
    COALESCE(avg(date_part('epoch'::text, (COALESCE(h.reporting_at, h.leaving_at) - h.joined_at))) FILTER (WHERE (h.bridged_at IS NOT NULL)), (0)::double precision) AS aha,
    count(*) AS cnt,
    count(*) FILTER (WHERE (h.bridged_at IS NOT NULL)) AS cntb,
    (((count(*) FILTER (WHERE ((h.bridged_at - h.joined_at) < '00:00:20'::interval)))::double precision * (100)::double precision) / (count(*))::double precision) AS sl20,
    (((count(*) FILTER (WHERE ((h.bridged_at - h.joined_at) < '00:00:30'::interval)))::double precision * (100)::double precision) / (count(*))::double precision) AS sl30
   FROM call_center.cc_member_attempt_history h
  WHERE ((h.leaving_at > (now() - '01:00:00'::interval)) AND (h.queue_id = ANY (ARRAY( SELECT q.id
           FROM call_center.cc_queue q
          WHERE (q.enabled AND (q.type = 1))))))
  GROUP BY h.queue_id, h.bucket_id
  WITH NO DATA;


--
-- Name: cc_list_acl; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_list_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    object bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL
);


--
-- Name: cc_list_acl_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_list_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_list_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_list_acl_id_seq OWNED BY call_center.cc_list_acl.id;


--
-- Name: cc_list_communications; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_list_communications (
    list_id bigint NOT NULL,
    number character varying(25) NOT NULL,
    id bigint NOT NULL,
    description text,
    expire_at timestamp with time zone
);


--
-- Name: cc_list_communications_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_list_communications_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_list_communications_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_list_communications_id_seq OWNED BY call_center.cc_list_communications.id;


--
-- Name: cc_list_communications_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_list_communications_view AS
 SELECT i.id,
    i.number,
    i.description,
    i.list_id,
    cl.domain_id,
    i.expire_at
   FROM (call_center.cc_list_communications i
     LEFT JOIN call_center.cc_list cl ON ((cl.id = i.list_id)));


--
-- Name: cc_list_statistics; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_list_statistics (
    list_id integer NOT NULL,
    count integer DEFAULT 0 NOT NULL
);


--
-- Name: cc_list_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_list_view AS
 SELECT i.id,
    i.name,
    i.description,
    i.domain_id,
    i.created_at,
    call_center.cc_get_lookup(uc.id, (uc.name)::character varying) AS created_by,
    i.updated_at,
    call_center.cc_get_lookup(u.id, (u.name)::character varying) AS updated_by,
    COALESCE(cls.count, 0) AS count
   FROM (((call_center.cc_list i
     LEFT JOIN directory.wbt_user uc ON ((uc.id = i.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = i.updated_by)))
     LEFT JOIN call_center.cc_list_statistics cls ON ((i.id = cls.list_id)));


--
-- Name: cc_queue_skill; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_queue_skill (
    id integer NOT NULL,
    queue_id integer NOT NULL,
    skill_id integer NOT NULL,
    bucket_ids integer[],
    lvl smallint DEFAULT 0 NOT NULL,
    min_capacity smallint DEFAULT 0 NOT NULL,
    max_capacity smallint DEFAULT 100 NOT NULL,
    enabled boolean DEFAULT true NOT NULL
);


--
-- Name: cc_manual_queue_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_manual_queue_list AS
 WITH manual_queue AS MATERIALIZED (
         SELECT q.domain_id,
            q.id,
            call_center.cc_get_lookup((q.id)::bigint, q.name) AS queue,
            q.priority,
            q.sticky_agent,
            q.team_id,
            COALESCE(((q.payload -> 'max_wait_time'::text))::integer, 0) AS max_wait_time,
            COALESCE(((q.payload -> 'sticky_agent_sec'::text))::integer, 0) AS sticky_agent_sec
           FROM call_center.cc_queue q
          WHERE (COALESCE(((q.payload -> 'manual_distribution'::text))::boolean, false) AND q.enabled)
          ORDER BY q.domain_id
        ), queues AS MATERIALIZED (
         SELECT DISTINCT q.domain_id,
            q.queue,
            qs.queue_id,
            q.priority,
            bq.priority AS bucket_pri,
            q.max_wait_time,
            q.sticky_agent_sec,
            q.sticky_agent,
            b.b AS bucket_id,
            csia.agent_id,
            a.user_id,
            max(qs.lvl) AS lvl
           FROM (((((manual_queue q
             JOIN call_center.cc_queue_skill qs ON ((qs.queue_id = q.id)))
             JOIN call_center.cc_skill_in_agent csia ON ((csia.skill_id = qs.skill_id)))
             JOIN call_center.cc_agent a ON (((a.id = csia.agent_id) AND ((q.team_id IS NULL) OR (q.team_id = a.team_id)))))
             LEFT JOIN LATERAL unnest(qs.bucket_ids) b(b) ON (true))
             LEFT JOIN call_center.cc_bucket_in_queue bq ON (((bq.queue_id = q.id) AND (bq.bucket_id = b.b))))
          WHERE (qs.enabled AND csia.enabled AND (csia.capacity >= qs.min_capacity) AND (csia.capacity <= qs.max_capacity) AND (q.domain_id = a.domain_id) AND ((a.status)::text = 'online'::text))
          GROUP BY q.domain_id, q.queue, qs.queue_id, q.priority, bq.priority, q.max_wait_time, q.sticky_agent_sec, q.sticky_agent, b.b, csia.agent_id, a.user_id
        ), attempts AS MATERIALIZED (
         SELECT q.domain_id,
            q.queue,
            q.queue_id,
            q.priority,
            q.bucket_pri,
            q.max_wait_time,
            q.sticky_agent_sec,
            q.sticky_agent,
            q.bucket_id,
            q.agent_id,
            q.user_id,
            q.lvl,
            a.id AS attempt_id,
            a.joined_at,
            a.member_call_id AS session_id,
            (EXTRACT(epoch FROM (now() - a.joined_at)))::integer AS wait,
            a.destination AS communication,
            a.sticky_agent_id,
            a.channel,
            (((EXTRACT(epoch FROM (now() - a.joined_at)) / (q.max_wait_time)::numeric) * (100)::numeric))::integer AS deadline
           FROM (call_center.cc_member_attempt a
             JOIN queues q ON ((q.queue_id = a.queue_id)))
          WHERE ((a.domain_id = q.domain_id) AND (a.agent_id IS NULL) AND ((a.state)::text = 'wait_agent'::text) AND (a.queue_id = q.queue_id) AND (COALESCE(q.bucket_id, 0) = COALESCE(a.bucket_id, (0)::bigint)) AND ((a.sticky_agent_id IS NULL) OR (a.sticky_agent_id = q.agent_id) OR (a.joined_at < (now() - ((q.sticky_agent_sec || ' sec'::text))::interval))))
         FOR UPDATE OF a SKIP LOCKED
        )
 SELECT x.domain_id,
    array_agg(x.user_id) AS users,
    array_to_json(x.calls[1:10]) AS calls,
    array_to_json(x.chats[1:10]) AS chats
   FROM ( SELECT a.domain_id,
            a.user_id,
            array_agg(jsonb_build_object('attempt_id', a.attempt_id, 'wait', a.wait, 'communication', a.communication, 'queue', a.queue, 'bucket', call_center.cc_get_lookup(b.id, ((b.name)::text)::character varying), 'deadline', a.deadline, 'session_id', a.session_id) ORDER BY a.lvl, a.priority DESC, a.bucket_pri DESC NULLS LAST, a.wait DESC) FILTER (WHERE ((a.channel)::text = 'call'::text)) AS calls,
            array_agg(jsonb_build_object('attempt_id', a.attempt_id, 'wait', a.wait, 'communication', a.communication, 'queue', a.queue, 'bucket', call_center.cc_get_lookup(b.id, ((b.name)::text)::character varying), 'deadline', a.deadline, 'session_id', a.session_id) ORDER BY a.lvl, a.priority DESC, a.bucket_pri DESC NULLS LAST, a.wait DESC) FILTER (WHERE ((a.channel)::text = 'chat'::text)) AS chats
           FROM (attempts a
             LEFT JOIN call_center.cc_bucket b ON ((b.id = a.bucket_id)))
          GROUP BY a.domain_id, a.user_id) x
  GROUP BY x.domain_id, x.calls[1:10], x.chats[1:10];


--
-- Name: cc_member_attempt_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_member_attempt_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_member_attempt_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_member_attempt_id_seq OWNED BY call_center.cc_member_attempt.id;


--
-- Name: cc_member_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_member_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_member_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_member_id_seq OWNED BY call_center.cc_member.id;


--
-- Name: cc_member_messages; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_member_messages (
    id bigint NOT NULL,
    member_id bigint NOT NULL,
    communication_id bigint NOT NULL,
    state integer DEFAULT 0 NOT NULL,
    created_at bigint DEFAULT 0 NOT NULL,
    message bytea
);


--
-- Name: cc_member_messages_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_member_messages_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_member_messages_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_member_messages_id_seq OWNED BY call_center.cc_member_messages.id;


--
-- Name: cc_outbound_resource; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_outbound_resource (
    id integer NOT NULL,
    "limit" integer DEFAULT 0 NOT NULL,
    enabled boolean DEFAULT true NOT NULL,
    updated_at bigint NOT NULL,
    rps integer DEFAULT '-1'::integer,
    domain_id bigint NOT NULL,
    reserve boolean DEFAULT false,
    variables jsonb DEFAULT '{}'::jsonb NOT NULL,
    number character varying(20) NOT NULL,
    max_successively_errors integer DEFAULT 0,
    name character varying(50) NOT NULL,
    last_error_id character varying(50),
    successively_errors smallint DEFAULT 0 NOT NULL,
    created_at bigint NOT NULL,
    created_by bigint,
    updated_by bigint,
    error_ids character varying(50)[] DEFAULT '{}'::character varying[],
    gateway_id bigint,
    email_profile_id integer,
    payload jsonb,
    description character varying,
    patterns character varying[],
    failure_dial_delay integer DEFAULT 0,
    last_error_at timestamp with time zone,
    parameters jsonb
);


--
-- Name: cc_member_view_attempt; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_member_view_attempt AS
 SELECT t.id,
    t.state,
    call_center.cc_view_timestamp(t.last_state_change) AS last_state_change,
    call_center.cc_view_timestamp(t.joined_at) AS joined_at,
    call_center.cc_view_timestamp(t.offering_at) AS offering_at,
    call_center.cc_view_timestamp(t.bridged_at) AS bridged_at,
    call_center.cc_view_timestamp(t.reporting_at) AS reporting_at,
    call_center.cc_view_timestamp(t.leaving_at) AS leaving_at,
    call_center.cc_view_timestamp(t.timeout) AS timeout,
    t.channel,
    call_center.cc_get_lookup((t.queue_id)::bigint, cq.name) AS queue,
    call_center.cc_get_lookup(t.member_id, cm.name) AS member,
    t.member_call_id,
    COALESCE(cm.variables, '{}'::jsonb) AS variables,
    call_center.cc_get_lookup((t.agent_id)::bigint, (COALESCE(u.name, (u.username)::text))::character varying) AS agent,
    t.agent_call_id,
    t.weight AS "position",
    call_center.cc_get_lookup((t.resource_id)::bigint, r.name) AS resource,
    call_center.cc_get_lookup(t.bucket_id, (cb.name)::character varying) AS bucket,
    call_center.cc_get_lookup(t.list_communication_id, l.name) AS list,
    COALESCE(t.display, ''::character varying) AS display,
    t.destination,
    t.result,
    t.domain_id,
    t.queue_id,
    t.bucket_id,
    t.member_id,
    t.agent_id,
    t.joined_at AS joined_at_timestamp,
    t.seq AS attempts
   FROM (((((((call_center.cc_member_attempt t
     LEFT JOIN call_center.cc_queue cq ON ((t.queue_id = cq.id)))
     LEFT JOIN call_center.cc_member cm ON ((t.member_id = cm.id)))
     LEFT JOIN call_center.cc_agent a ON ((t.agent_id = a.id)))
     LEFT JOIN directory.wbt_user u ON (((u.id = a.user_id) AND (u.dc = a.domain_id))))
     LEFT JOIN call_center.cc_outbound_resource r ON ((r.id = t.resource_id)))
     LEFT JOIN call_center.cc_bucket cb ON ((cb.id = t.bucket_id)))
     LEFT JOIN call_center.cc_list l ON ((l.id = t.list_communication_id)));


--
-- Name: cc_member_view_attempt_history; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_member_view_attempt_history AS
 SELECT t.id,
    t.joined_at,
    t.offering_at,
    t.bridged_at,
    t.reporting_at,
    t.leaving_at,
    t.channel,
    call_center.cc_get_lookup((t.queue_id)::bigint, cq.name) AS queue,
    call_center.cc_get_lookup(t.member_id, cm.name) AS member,
    t.member_call_id,
    COALESCE(cm.variables, '{}'::jsonb) AS variables,
    call_center.cc_get_lookup((t.agent_id)::bigint, (COALESCE(u.name, (u.username)::text))::character varying) AS agent,
    t.agent_call_id,
    t.weight AS "position",
    call_center.cc_get_lookup((t.resource_id)::bigint, r.name) AS resource,
    call_center.cc_get_lookup(t.bucket_id, (cb.name)::character varying) AS bucket,
    call_center.cc_get_lookup(t.list_communication_id, l.name) AS list,
    COALESCE(t.display, ''::character varying) AS display,
    t.destination,
    t.result,
    t.domain_id,
    t.queue_id,
    t.bucket_id,
    t.member_id,
    t.agent_id,
    t.seq AS attempts,
    c.amd_result
   FROM ((((((((call_center.cc_member_attempt_history t
     LEFT JOIN call_center.cc_queue cq ON ((t.queue_id = cq.id)))
     LEFT JOIN call_center.cc_member cm ON ((t.member_id = cm.id)))
     LEFT JOIN call_center.cc_agent a ON ((t.agent_id = a.id)))
     LEFT JOIN directory.wbt_user u ON (((u.id = a.user_id) AND (u.dc = a.domain_id))))
     LEFT JOIN call_center.cc_outbound_resource r ON ((r.id = t.resource_id)))
     LEFT JOIN call_center.cc_bucket cb ON ((cb.id = t.bucket_id)))
     LEFT JOIN call_center.cc_list l ON ((l.id = t.list_communication_id)))
     LEFT JOIN call_center.cc_calls_history c ON (((c.domain_id = t.domain_id) AND (c.id = (t.member_call_id)::uuid))));


--
-- Name: cc_notification; Type: TABLE; Schema: call_center; Owner: -
--

CREATE UNLOGGED TABLE call_center.cc_notification (
    id bigint NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    created_by bigint,
    accepted_at timestamp with time zone,
    accepted_by bigint,
    closed_at timestamp with time zone,
    description character varying,
    for_users bigint[],
    action character varying NOT NULL,
    domain_id bigint NOT NULL,
    timeout timestamp with time zone,
    object_id character varying
);


--
-- Name: cc_notification_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_notification_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_notification_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_notification_id_seq OWNED BY call_center.cc_notification.id;


--
-- Name: cc_outbound_resource_acl; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_outbound_resource_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    object bigint NOT NULL,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL
);


--
-- Name: cc_outbound_resource_acl_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_outbound_resource_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_outbound_resource_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_outbound_resource_acl_id_seq OWNED BY call_center.cc_outbound_resource_acl.id;


--
-- Name: cc_outbound_resource_display; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_outbound_resource_display (
    id bigint NOT NULL,
    resource_id bigint NOT NULL,
    display character varying(50) NOT NULL
);


--
-- Name: cc_outbound_resource_display_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_outbound_resource_display_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_outbound_resource_display_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_outbound_resource_display_id_seq OWNED BY call_center.cc_outbound_resource_display.id;


--
-- Name: cc_outbound_resource_display_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_outbound_resource_display_view AS
 SELECT d.id,
    d.display,
    d.resource_id,
    cor.domain_id
   FROM (call_center.cc_outbound_resource_display d
     LEFT JOIN call_center.cc_outbound_resource cor ON ((d.resource_id = cor.id)));


--
-- Name: cc_outbound_resource_group; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_outbound_resource_group (
    id bigint NOT NULL,
    domain_id bigint NOT NULL,
    name character varying(50) NOT NULL,
    strategy character varying(10) NOT NULL,
    description character varying(200) DEFAULT ''::character varying NOT NULL,
    communication_id bigint NOT NULL,
    created_at bigint NOT NULL,
    created_by bigint,
    updated_at bigint NOT NULL,
    updated_by bigint,
    "time" jsonb
);


--
-- Name: cc_outbound_resource_group_acl; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_outbound_resource_group_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    object bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL
);


--
-- Name: cc_outbound_resource_group_acl_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_outbound_resource_group_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_outbound_resource_group_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_outbound_resource_group_acl_id_seq OWNED BY call_center.cc_outbound_resource_group_acl.id;


--
-- Name: cc_outbound_resource_group_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_outbound_resource_group_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_outbound_resource_group_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_outbound_resource_group_id_seq OWNED BY call_center.cc_outbound_resource_group.id;


--
-- Name: cc_outbound_resource_group_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_outbound_resource_group_view AS
 SELECT s.id,
    s.domain_id,
    s.name,
    s.strategy,
    s.description,
    call_center.cc_get_lookup((comm.id)::bigint, comm.name) AS communication,
    s.created_at,
    call_center.cc_get_lookup(c.id, (c.name)::character varying) AS created_by,
    s.updated_at,
    call_center.cc_get_lookup(u.id, (u.name)::character varying) AS updated_by,
    s.communication_id,
    s."time"
   FROM (((call_center.cc_outbound_resource_group s
     JOIN call_center.cc_communication comm ON ((comm.id = s.communication_id)))
     LEFT JOIN directory.wbt_user c ON ((c.id = s.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = s.updated_by)));


--
-- Name: cc_outbound_resource_in_group; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_outbound_resource_in_group (
    id bigint NOT NULL,
    resource_id bigint NOT NULL,
    group_id bigint NOT NULL,
    priority integer DEFAULT 0 NOT NULL,
    reserve_resource_id bigint
);


--
-- Name: cc_outbound_resource_in_group_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_outbound_resource_in_group_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_outbound_resource_in_group_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_outbound_resource_in_group_id_seq OWNED BY call_center.cc_outbound_resource_in_group.id;


--
-- Name: cc_outbound_resource_in_group_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_outbound_resource_in_group_view AS
 SELECT s.id,
    s.group_id,
    call_center.cc_get_lookup((cor.id)::bigint, cor.name) AS resource,
    call_center.cc_get_lookup((res.id)::bigint, res.name) AS reserve_resource,
    s.resource_id,
    cor.name AS resource_name,
    s.priority,
    cor.domain_id
   FROM (((call_center.cc_outbound_resource_in_group s
     LEFT JOIN call_center.cc_outbound_resource cor ON ((s.resource_id = cor.id)))
     LEFT JOIN call_center.cc_outbound_resource_group corg ON ((s.group_id = corg.id)))
     LEFT JOIN call_center.cc_outbound_resource res ON ((res.id = s.reserve_resource_id)));


--
-- Name: cc_outbound_resource_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_outbound_resource_view AS
 SELECT s.id,
    s."limit",
    s.enabled,
    s.updated_at,
    s.rps,
    s.domain_id,
    s.reserve,
    s.variables,
    s.number,
    s.max_successively_errors,
    s.name,
    s.error_ids,
    s.last_error_id,
    s.successively_errors,
    s.last_error_at,
    s.created_at,
    call_center.cc_get_lookup(c.id, (c.name)::character varying) AS created_by,
    call_center.cc_get_lookup(u.id, (u.name)::character varying) AS updated_by,
    call_center.cc_get_lookup(gw.id, gw.name) AS gateway,
    s.gateway_id,
    s.description,
    s.patterns,
    s.failure_dial_delay
   FROM (((call_center.cc_outbound_resource s
     LEFT JOIN directory.wbt_user c ON ((c.id = s.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = s.updated_by)))
     LEFT JOIN directory.sip_gateway gw ON ((gw.id = s.gateway_id)));


--
-- Name: cc_pause_cause; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_pause_cause (
    id integer NOT NULL,
    name character varying NOT NULL,
    limit_min integer DEFAULT 0 NOT NULL,
    allow_supervisor boolean DEFAULT true NOT NULL,
    allow_agent boolean DEFAULT true NOT NULL,
    domain_id bigint NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    updated_at timestamp with time zone DEFAULT now() NOT NULL,
    created_by bigint,
    updated_by bigint,
    description character varying DEFAULT ''::character varying NOT NULL,
    allow_admin boolean DEFAULT true NOT NULL
);


--
-- Name: cc_pause_cause_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_pause_cause_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_pause_cause_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_pause_cause_id_seq OWNED BY call_center.cc_pause_cause.id;


--
-- Name: cc_pause_cause_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_pause_cause_list AS
 SELECT s.id,
    s.created_at,
    call_center.cc_get_lookup(uc.id, (COALESCE(uc.name, (uc.username)::text))::character varying) AS created_by,
    s.updated_at,
    call_center.cc_get_lookup(uc.id, (COALESCE(uc.name, (uc.username)::text))::character varying) AS updated_by,
    s.name,
    s.description,
    s.limit_min,
    s.allow_agent,
    s.allow_supervisor,
    s.allow_admin,
    s.domain_id
   FROM ((call_center.cc_pause_cause s
     LEFT JOIN directory.wbt_user uc ON ((uc.id = s.created_by)))
     LEFT JOIN directory.wbt_user uu ON ((uu.id = s.updated_by)));


--
-- Name: cc_preset_query; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_preset_query (
    id integer NOT NULL,
    name character varying NOT NULL,
    user_id bigint NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    preset jsonb NOT NULL,
    description character varying,
    section character varying NOT NULL,
    domain_id bigint NOT NULL,
    updated_at timestamp with time zone NOT NULL
);


--
-- Name: cc_preset_query_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_preset_query_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_preset_query_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_preset_query_id_seq OWNED BY call_center.cc_preset_query.id;


--
-- Name: cc_preset_query_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_preset_query_list AS
 SELECT p.id,
    p.name,
    p.description,
    p.created_at,
    p.updated_at,
    p.section,
    p.preset,
    p.domain_id,
    p.user_id
   FROM call_center.cc_preset_query p;


--
-- Name: cc_queue_acl; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_queue_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL,
    object bigint NOT NULL
);


--
-- Name: cc_queue_acl_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_queue_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_queue_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_queue_acl_id_seq OWNED BY call_center.cc_queue_acl.id;


--
-- Name: cc_queue_events; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_queue_events (
    id integer NOT NULL,
    schema_id integer NOT NULL,
    event character varying NOT NULL,
    properties character varying[],
    queue_id integer NOT NULL,
    enabled boolean DEFAULT true NOT NULL,
    updated_by integer,
    updated_at timestamp with time zone
);


--
-- Name: cc_queue_events_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_queue_events_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_queue_events_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_queue_events_id_seq OWNED BY call_center.cc_queue_events.id;


--
-- Name: cc_queue_events_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_queue_events_list AS
 SELECT qe.id,
    call_center.cc_get_lookup((qe.schema_id)::bigint, s.name) AS schema,
    qe.event,
    qe.enabled,
    qe.queue_id,
    qe.schema_id
   FROM (call_center.cc_queue_events qe
     LEFT JOIN flow.acr_routing_scheme s ON ((s.id = qe.schema_id)));


--
-- Name: cc_queue_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_queue_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_queue_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_queue_id_seq OWNED BY call_center.cc_queue.id;


--
-- Name: cc_queue_statistics; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_queue_statistics (
    queue_id bigint NOT NULL,
    member_count integer DEFAULT 0 NOT NULL,
    member_waiting integer DEFAULT 0 NOT NULL,
    bucket_id bigint
)
WITH (fillfactor='20', log_autovacuum_min_duration='0', autovacuum_vacuum_scale_factor='0.01', autovacuum_analyze_scale_factor='0.05', autovacuum_enabled='1', autovacuum_vacuum_cost_delay='20');


--
-- Name: calendar; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.calendar (
    id integer NOT NULL,
    start_at bigint,
    end_at bigint,
    name character varying NOT NULL,
    domain_id bigint NOT NULL,
    description character varying(200),
    timezone_id integer NOT NULL,
    created_at bigint NOT NULL,
    created_by bigint,
    updated_at bigint NOT NULL,
    updated_by bigint,
    excepts flow.calendar_except_date[],
    accepts flow.calendar_accept_time[]
);


--
-- Name: cc_queue_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_queue_list AS
 SELECT q.id,
    q.strategy,
    q.enabled,
    q.payload,
    q.priority,
    q.updated_at,
    q.name,
    q.variables,
    q.domain_id,
    q.type,
    q.created_at,
    call_center.cc_get_lookup(uc.id, (uc.name)::character varying) AS created_by,
    call_center.cc_get_lookup(u.id, (u.name)::character varying) AS updated_by,
    call_center.cc_get_lookup((c.id)::bigint, c.name) AS calendar,
    call_center.cc_get_lookup(cl.id, cl.name) AS dnc_list,
    call_center.cc_get_lookup(ct.id, ct.name) AS team,
    call_center.cc_get_lookup((q.ringtone_id)::bigint, mf.name) AS ringtone,
    q.description,
    call_center.cc_get_lookup(s.id, s.name) AS schema,
    call_center.cc_get_lookup(ds.id, ds.name) AS do_schema,
    call_center.cc_get_lookup(afs.id, afs.name) AS after_schema,
    call_center.cc_get_lookup(fs.id, fs.name) AS form_schema,
    COALESCE(ss.member_count, (0)::bigint) AS count,
    COALESCE(ss.member_waiting, (0)::bigint) AS waiting,
    COALESCE(act.cnt, (0)::bigint) AS active,
    q.sticky_agent,
    q.processing,
    q.processing_sec,
    q.processing_renewal_sec,
    jsonb_build_object('enabled', q.processing, 'form_schema', call_center.cc_get_lookup(fs.id, fs.name), 'sec', q.processing_sec, 'renewal_sec', q.processing_renewal_sec) AS task_processing,
    call_center.cc_get_lookup(au.id, (au.name)::character varying) AS grantee
   FROM (((((((((((((call_center.cc_queue q
     LEFT JOIN flow.calendar c ON ((q.calendar_id = c.id)))
     LEFT JOIN directory.wbt_auth au ON ((au.id = q.grantee_id)))
     LEFT JOIN directory.wbt_user uc ON ((uc.id = q.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = q.updated_by)))
     LEFT JOIN flow.acr_routing_scheme s ON ((q.schema_id = s.id)))
     LEFT JOIN flow.acr_routing_scheme ds ON ((q.do_schema_id = ds.id)))
     LEFT JOIN flow.acr_routing_scheme afs ON ((q.after_schema_id = afs.id)))
     LEFT JOIN flow.acr_routing_scheme fs ON ((q.form_schema_id = fs.id)))
     LEFT JOIN call_center.cc_list cl ON ((q.dnc_list_id = cl.id)))
     LEFT JOIN call_center.cc_team ct ON ((q.team_id = ct.id)))
     LEFT JOIN storage.media_files mf ON ((q.ringtone_id = mf.id)))
     LEFT JOIN LATERAL ( SELECT sum(s_1.member_waiting) AS member_waiting,
            sum(s_1.member_count) AS member_count
           FROM call_center.cc_queue_statistics s_1
          WHERE (s_1.queue_id = q.id)) ss ON (true))
     LEFT JOIN LATERAL ( SELECT count(*) AS cnt
           FROM call_center.cc_member_attempt a
          WHERE ((a.queue_id = q.id) AND (a.leaving_at IS NULL) AND ((a.state)::text <> 'leaving'::text))) act ON (true));


--
-- Name: cc_queue_report_general; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_queue_report_general AS
SELECT
    NULL::jsonb AS queue,
    NULL::jsonb AS team,
    NULL::bigint AS waiting,
    NULL::bigint AS processed,
    NULL::bigint AS cnt,
    NULL::bigint AS calls,
    NULL::bigint AS abandoned,
    NULL::double precision AS bill_sec,
    NULL::double precision AS avg_wrap_sec,
    NULL::double precision AS avg_awt_sec,
    NULL::double precision AS max_awt_sec,
    NULL::double precision AS avg_asa_sec,
    NULL::double precision AS avg_aht_sec,
    NULL::integer AS queue_id,
    NULL::bigint AS team_id;


--
-- Name: cc_queue_resource; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_queue_resource (
    id bigint NOT NULL,
    queue_id bigint NOT NULL,
    resource_group_id bigint NOT NULL
);


--
-- Name: cc_queue_resource_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_queue_resource_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_queue_resource_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_queue_resource_id_seq OWNED BY call_center.cc_outbound_resource.id;


--
-- Name: cc_queue_resource_id_seq1; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_queue_resource_id_seq1
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_queue_resource_id_seq1; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_queue_resource_id_seq1 OWNED BY call_center.cc_queue_resource.id;


--
-- Name: cc_queue_resource_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_queue_resource_view AS
 SELECT q.id,
    q.queue_id,
    call_center.cc_get_lookup(g.id, ((g.name)::text)::character varying) AS resource_group,
    call_center.cc_get_lookup((c.id)::bigint, ((c.name)::text)::character varying) AS communication,
    g.name AS resource_group_name,
    g.domain_id
   FROM ((call_center.cc_queue_resource q
     LEFT JOIN call_center.cc_outbound_resource_group g ON ((q.resource_group_id = g.id)))
     LEFT JOIN call_center.cc_communication c ON ((c.id = g.communication_id)));


--
-- Name: cc_queue_skill_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_queue_skill_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_queue_skill_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_queue_skill_id_seq OWNED BY call_center.cc_queue_skill.id;


--
-- Name: cc_queue_skill_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_queue_skill_list AS
 SELECT s.id,
    call_center.cc_get_lookup((cs.id)::bigint, cs.name) AS skill,
    ( SELECT jsonb_agg(call_center.cc_get_lookup(b.id, (b.name)::character varying)) AS jsonb_agg
           FROM call_center.cc_bucket b
          WHERE (b.id = ANY (s.bucket_ids))) AS buckets,
    s.lvl,
    s.min_capacity,
    s.max_capacity,
    s.enabled,
    s.bucket_ids,
    s.queue_id,
    s.skill_id,
    cq.domain_id
   FROM ((call_center.cc_queue_skill s
     JOIN call_center.cc_queue cq ON ((cq.id = s.queue_id)))
     JOIN call_center.cc_skill cs ON ((s.skill_id = cs.id)));


--
-- Name: cc_queue_skill_statistics; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_queue_skill_statistics (
    queue_id integer NOT NULL,
    skill_id integer NOT NULL,
    member_count integer DEFAULT 0 NOT NULL,
    member_waiting integer DEFAULT 0 NOT NULL
);


--
-- Name: cc_skill_in_agent_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_skill_in_agent_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_skill_in_agent_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_skill_in_agent_id_seq OWNED BY call_center.cc_skill_in_agent.id;


--
-- Name: cc_skill_in_agent_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_skill_in_agent_view AS
 SELECT sa.id,
    call_center.cc_get_lookup(c.id, (c.name)::character varying) AS created_by,
    sa.created_at,
    call_center.cc_get_lookup(u.id, (u.name)::character varying) AS updated_by,
    sa.updated_at,
    call_center.cc_get_lookup((cs.id)::bigint, cs.name) AS skill,
    call_center.cc_get_lookup((ca.id)::bigint, (COALESCE(uu.name, (uu.username)::text))::character varying) AS agent,
    call_center.cc_get_lookup(t.id, t.name) AS team,
    sa.capacity,
    sa.enabled,
    ca.domain_id,
    sa.skill_id,
    cs.name AS skill_name,
    sa.agent_id,
    COALESCE(((uu.name)::character varying)::name, (uu.username COLLATE "default")) AS agent_name
   FROM ((((((call_center.cc_skill_in_agent sa
     LEFT JOIN call_center.cc_agent ca ON ((sa.agent_id = ca.id)))
     LEFT JOIN call_center.cc_team t ON ((t.id = ca.team_id)))
     LEFT JOIN directory.wbt_user uu ON ((uu.id = ca.user_id)))
     LEFT JOIN call_center.cc_skill cs ON ((sa.skill_id = cs.id)))
     LEFT JOIN directory.wbt_user c ON ((c.id = sa.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = sa.updated_by)));


--
-- Name: cc_skill_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_skill_view AS
 SELECT c.id,
    c.name,
    c.description,
    c.domain_id,
    agents.active_agents,
    agents.total_agents
   FROM (call_center.cc_skill c
     LEFT JOIN LATERAL ( SELECT count(DISTINCT sa.agent_id) FILTER (WHERE sa.enabled) AS active_agents,
            count(DISTINCT sa.agent_id) AS total_agents
           FROM call_center.cc_skill_in_agent sa
          WHERE (sa.skill_id = c.id)) agents ON (true));


--
-- Name: cc_skils_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_skils_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_skils_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_skils_id_seq OWNED BY call_center.cc_skill.id;


--
-- Name: cc_sys_distribute_queue_bucket_seg; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_sys_distribute_queue_bucket_seg AS
 SELECT s.queue_id,
    s.bucket_id,
    (s.member_waiting)::integer AS member_waiting,
        CASE
            WHEN ((s.bucket_id IS NULL) OR (s.member_waiting < 2)) THEN s.member_waiting
            ELSE (((ceil((((s.member_count * cbiq.ratio) / 100))::double precision))::integer - log.log))::bigint
        END AS lim,
    cbiq.ratio
   FROM ((( SELECT s_1.queue_id,
            s_1.bucket_id,
            sum(s_1.member_waiting) AS member_waiting,
            sum(s_1.member_count) AS member_count
           FROM call_center.cc_queue_statistics s_1
          GROUP BY s_1.queue_id, s_1.bucket_id) s
     LEFT JOIN call_center.cc_bucket_in_queue cbiq ON (((s.queue_id = cbiq.queue_id) AND (s.bucket_id = cbiq.bucket_id))))
     LEFT JOIN LATERAL call_center.cc_member_attempt_log_day_f((s.queue_id)::integer, (s.bucket_id)::integer) log(log) ON ((s.bucket_id IS NOT NULL)))
  WHERE ((s.member_waiting > 0) AND ((
        CASE
            WHEN ((s.bucket_id IS NULL) OR (s.member_waiting < 2)) THEN s.member_waiting
            ELSE (((round((((s.member_count * cbiq.ratio) / 100))::double precision))::integer - COALESCE(log.log, 0)))::bigint
        END)::numeric > (0)::numeric));


--
-- Name: cc_sys_distribute_queue; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_sys_distribute_queue AS
 SELECT q.domain_id,
    q.id,
    q.type,
    q.strategy,
    q.team_id,
    q.calendar_id,
    cqs.bucket_id,
    cqs.lim AS buckets_cnt,
    cqs.ratio
   FROM (call_center.cc_queue q
     JOIN call_center.cc_sys_distribute_queue_bucket_seg cqs ON ((q.id = cqs.queue_id)))
  WHERE (q.enabled AND (cqs.member_waiting > 0) AND (cqs.lim > 0) AND (q.type > 1))
  ORDER BY q.domain_id, q.priority DESC, cqs.ratio DESC NULLS LAST;


--
-- Name: cc_sys_queue_distribute_resources; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_sys_queue_distribute_resources AS
SELECT
    NULL::bigint AS queue_id,
    NULL::call_center.cc_sys_distribute_type[] AS types,
    NULL::call_center.cc_sys_distribute_resource[] AS resources,
    NULL::smallint[] AS ran;


--
-- Name: cc_team_acl; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_team_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL,
    object bigint NOT NULL
);


--
-- Name: cc_team_acl_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_team_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_team_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_team_acl_id_seq OWNED BY call_center.cc_team_acl.id;


--
-- Name: cc_team_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_team_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_team_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_team_id_seq OWNED BY call_center.cc_team.id;


--
-- Name: cc_team_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_team_list AS
 SELECT t.id,
    t.name,
    t.description,
    t.strategy,
    t.max_no_answer,
    t.wrap_up_time,
    t.no_answer_delay_time,
    t.call_timeout,
    t.updated_at,
    ( SELECT jsonb_agg(adm."user") AS jsonb_agg
           FROM call_center.cc_agent_with_user adm
          WHERE (adm.id = ANY (t.admin_ids))) AS admin,
    t.domain_id,
    t.admin_ids,
    t.invite_chat_timeout,
    t.task_accept_timeout
   FROM call_center.cc_team t;


--
-- Name: cc_trigger; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_trigger (
    id integer NOT NULL,
    domain_id bigint NOT NULL,
    name character varying NOT NULL,
    enabled boolean DEFAULT false NOT NULL,
    type character varying DEFAULT 'cron'::character varying NOT NULL,
    schema_id integer NOT NULL,
    variables jsonb,
    description text,
    expression character varying NOT NULL,
    timezone_id integer NOT NULL,
    created_by bigint,
    updated_by bigint,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    updated_at timestamp with time zone DEFAULT now() NOT NULL,
    timeout_sec integer DEFAULT 0 NOT NULL,
    schedule_at timestamp without time zone DEFAULT (now())::timestamp without time zone
);


--
-- Name: cc_trigger_acl; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_trigger_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL,
    object bigint NOT NULL
);


--
-- Name: cc_trigger_acl_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_trigger_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_trigger_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_trigger_acl_id_seq OWNED BY call_center.cc_trigger_acl.id;


--
-- Name: cc_trigger_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_trigger_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_trigger_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_trigger_id_seq OWNED BY call_center.cc_trigger.id;


--
-- Name: cc_trigger_job; Type: TABLE; Schema: call_center; Owner: -
--

CREATE UNLOGGED TABLE call_center.cc_trigger_job (
    id bigint NOT NULL,
    trigger_id integer NOT NULL,
    state integer DEFAULT 0 NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    started_at timestamp with time zone,
    stopped_at timestamp with time zone,
    parameters jsonb,
    error text,
    result jsonb,
    node_id character varying,
    domain_id bigint
);


--
-- Name: cc_trigger_job_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.cc_trigger_job_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cc_trigger_job_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.cc_trigger_job_id_seq OWNED BY call_center.cc_trigger_job.id;


--
-- Name: cc_trigger_job_log; Type: TABLE; Schema: call_center; Owner: -
--

CREATE TABLE call_center.cc_trigger_job_log (
    id bigint,
    trigger_id integer NOT NULL,
    state integer,
    created_at timestamp with time zone,
    started_at timestamp with time zone NOT NULL,
    stopped_at timestamp with time zone,
    parameters jsonb,
    error text,
    result jsonb,
    node_id character varying,
    domain_id bigint NOT NULL
);


--
-- Name: cc_trigger_job_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_trigger_job_list AS
 SELECT j.id,
    j.domain_id,
    call_center.cc_get_lookup((t.id)::bigint, t.name) AS trigger,
    j.state,
    j.created_at,
    j.started_at,
    j.stopped_at,
    j.parameters,
    j.error,
    j.result,
    j.trigger_id
   FROM (call_center.cc_trigger_job j
     LEFT JOIN call_center.cc_trigger t ON ((t.id = j.trigger_id)))
UNION ALL
 SELECT j.id,
    j.domain_id,
    call_center.cc_get_lookup((t.id)::bigint, t.name) AS trigger,
    j.state,
    j.created_at,
    j.started_at,
    j.stopped_at,
    j.parameters,
    j.error,
    j.result,
    j.trigger_id
   FROM (call_center.cc_trigger_job_log j
     LEFT JOIN call_center.cc_trigger t ON ((t.id = j.trigger_id)));


--
-- Name: cc_trigger_job_log_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_trigger_job_log_list AS
 SELECT j.id,
    j.domain_id,
    call_center.cc_get_lookup((t.id)::bigint, t.name) AS trigger,
    j.state,
    j.created_at,
    j.started_at,
    j.stopped_at,
    j.parameters,
    j.error,
    j.result
   FROM (call_center.cc_trigger_job_log j
     LEFT JOIN call_center.cc_trigger t ON ((t.id = j.trigger_id)));


--
-- Name: cc_trigger_list; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_trigger_list AS
 SELECT t.domain_id,
    t.schema_id,
    t.timezone_id,
    t.id,
    t.name,
    t.enabled,
    t.type,
    call_center.cc_get_lookup(s.id, s.name) AS schema,
    COALESCE(t.variables, '{}'::jsonb) AS variables,
    t.description,
    t.expression,
    call_center.cc_get_lookup((tz.id)::bigint, tz.name) AS timezone,
    t.timeout_sec AS timeout,
    call_center.cc_get_lookup(uc.id, (COALESCE(uc.name, (uc.username)::text))::character varying) AS created_by,
    call_center.cc_get_lookup(uu.id, (COALESCE(uu.name, (uu.username)::text))::character varying) AS updated_by,
    t.created_at,
    t.updated_at
   FROM ((((call_center.cc_trigger t
     LEFT JOIN flow.acr_routing_scheme s ON ((s.id = t.schema_id)))
     LEFT JOIN flow.calendar_timezones tz ON ((tz.id = t.timezone_id)))
     LEFT JOIN directory.wbt_user uc ON ((uc.id = t.created_by)))
     LEFT JOIN directory.wbt_user uu ON ((uu.id = t.updated_by)));


--
-- Name: wbt_user_presence; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_user_presence (
    user_id bigint NOT NULL,
    status name NOT NULL,
    note text,
    open integer DEFAULT 1 NOT NULL,
    cseq integer DEFAULT 1 NOT NULL,
    prior smallint DEFAULT 0 NOT NULL,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    expires_at timestamp without time zone,
    channel_id name
);


--
-- Name: TABLE wbt_user_presence; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_user_presence IS 'User presence tuples';


--
-- Name: COLUMN wbt_user_presence.user_id; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.user_id IS 'user identity';


--
-- Name: COLUMN wbt_user_presence.status; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.status IS '{offline,online,away,dnd|call,chat,reg,wss}';


--
-- Name: COLUMN wbt_user_presence.note; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.note IS 'human readable comment';


--
-- Name: COLUMN wbt_user_presence.open; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.open IS 'tracking active channels count';


--
-- Name: COLUMN wbt_user_presence.cseq; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.cseq IS 'tuple current version';


--
-- Name: COLUMN wbt_user_presence.prior; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.prior IS 'importance of this within user''s other tracking tuples';


--
-- Name: COLUMN wbt_user_presence.created_at; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.created_at IS 'this opened at';


--
-- Name: COLUMN wbt_user_presence.updated_at; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.updated_at IS '(open > 0) ? last updated time : closed time ;';


--
-- Name: COLUMN wbt_user_presence.expires_at; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.expires_at IS 'optional expiry time';


--
-- Name: COLUMN wbt_user_presence.channel_id; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_presence.channel_id IS 'optional: this updated from/by session ident';


--
-- Name: wbt_user_status; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_user_status (
    user_id bigint NOT NULL,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP,
    channel_id character varying(64),
    status text,
    dnd boolean DEFAULT false NOT NULL
);


--
-- Name: TABLE wbt_user_status; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_user_status IS 'User status note';


--
-- Name: COLUMN wbt_user_status.user_id; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_status.user_id IS 'this is presentity';


--
-- Name: COLUMN wbt_user_status.status; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_status.status IS 'this is the status <note>, short description';


--
-- Name: cc_user_status_view; Type: VIEW; Schema: call_center; Owner: -
--

CREATE VIEW call_center.cc_user_status_view AS
 SELECT u.dc AS domain_id,
    u.id,
    COALESCE(u.name, (u.username)::text) AS name,
    pr.status AS presence,
    a.status,
    COALESCE(u.extension, ''::name) AS extension,
    row_number() OVER (PARTITION BY u.dc ORDER BY
        CASE
            WHEN ((a.status)::text = 'online'::text) THEN 0
            WHEN ((a.status)::text = 'pause'::text) THEN 1
            WHEN ((a.status)::text = 'offline'::text) THEN 2
            ELSE 3
        END, pr.status, COALESCE(u.name, (u.username)::text)) AS "position"
   FROM ((directory.wbt_user u
     LEFT JOIN call_center.cc_agent a ON ((a.user_id = u.id)))
     LEFT JOIN LATERAL ( SELECT array_agg(status.open) AS array_agg
           FROM ( SELECT 'dnd'::name AS "?column?"
                   FROM directory.wbt_user_status stt
                  WHERE ((stt.user_id = u.id) AND stt.dnd)
                UNION ALL
                ( SELECT stt.status
                   FROM directory.wbt_user_presence stt
                  WHERE ((stt.user_id = u.id) AND (stt.status IS NOT NULL) AND (stt.open > 0))
                  ORDER BY stt.prior, stt.status)) status(open)) pr(status) ON (true));


--
-- Name: systemc_settings_id_seq; Type: SEQUENCE; Schema: call_center; Owner: -
--

CREATE SEQUENCE call_center.systemc_settings_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: systemc_settings_id_seq; Type: SEQUENCE OWNED BY; Schema: call_center; Owner: -
--

ALTER SEQUENCE call_center.systemc_settings_id_seq OWNED BY call_center.system_settings.id;


--
-- Name: bot; Type: TABLE; Schema: chat; Owner: -
--

CREATE TABLE chat.bot (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    uri text NOT NULL,
    name text NOT NULL,
    flow_id bigint NOT NULL,
    enabled boolean DEFAULT false NOT NULL,
    provider name NOT NULL,
    metadata jsonb,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    created_by bigint,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_by bigint,
    updates jsonb
);


--
-- Name: TABLE bot; Type: COMMENT; Schema: chat; Owner: -
--

COMMENT ON TABLE chat.bot IS 'Chat-BOT Profiles';


--
-- Name: channel; Type: TABLE; Schema: chat; Owner: -
--

CREATE TABLE chat.channel (
    id uuid NOT NULL,
    type text NOT NULL,
    conversation_id uuid NOT NULL,
    user_id bigint NOT NULL,
    connection text,
    created_at timestamp with time zone NOT NULL,
    internal boolean NOT NULL,
    closed_at timestamp with time zone,
    domain_id bigint NOT NULL,
    flow_bridge boolean DEFAULT false NOT NULL,
    updated_at timestamp with time zone NOT NULL,
    name text NOT NULL,
    joined_at timestamp with time zone,
    closed_cause character varying,
    host name,
    props jsonb
);


--
-- Name: COLUMN channel.props; Type: COMMENT; Schema: chat; Owner: -
--

COMMENT ON COLUMN chat.channel.props IS 'Chat.StartConversation(.message.variables)';


--
-- Name: client; Type: TABLE; Schema: chat; Owner: -
--

CREATE TABLE chat.client (
    id bigint NOT NULL,
    name text,
    number text,
    created_at timestamp with time zone NOT NULL,
    external_id text,
    first_name text,
    last_name text
);


--
-- Name: client_id_seq; Type: SEQUENCE; Schema: chat; Owner: -
--

CREATE SEQUENCE chat.client_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: client_id_seq; Type: SEQUENCE OWNED BY; Schema: chat; Owner: -
--

ALTER SEQUENCE chat.client_id_seq OWNED BY chat.client.id;


--
-- Name: conversation; Type: TABLE; Schema: chat; Owner: -
--

CREATE TABLE chat.conversation (
    id uuid NOT NULL,
    title text,
    created_at timestamp with time zone,
    closed_at timestamp with time zone,
    updated_at timestamp with time zone NOT NULL,
    domain_id bigint NOT NULL,
    props jsonb
);


--
-- Name: conversation_confirmation; Type: TABLE; Schema: chat; Owner: -
--

CREATE UNLOGGED TABLE chat.conversation_confirmation (
    conversation_id uuid NOT NULL,
    confirmation_id character varying NOT NULL
);


--
-- Name: conversation_node; Type: TABLE; Schema: chat; Owner: -
--

CREATE UNLOGGED TABLE chat.conversation_node (
    conversation_id uuid NOT NULL,
    node_id character varying NOT NULL
);


--
-- Name: invite; Type: TABLE; Schema: chat; Owner: -
--

CREATE TABLE chat.invite (
    id uuid NOT NULL,
    conversation_id uuid NOT NULL,
    user_id bigint NOT NULL,
    title text,
    timeout_sec bigint DEFAULT 0 NOT NULL,
    inviter_channel_id uuid,
    closed_at timestamp with time zone,
    created_at timestamp with time zone NOT NULL,
    domain_id bigint NOT NULL,
    props jsonb
);


--
-- Name: message; Type: TABLE; Schema: chat; Owner: -
--

CREATE TABLE chat.message (
    id bigint NOT NULL,
    channel_id uuid,
    conversation_id uuid NOT NULL,
    text text,
    created_at timestamp with time zone NOT NULL,
    updated_at timestamp with time zone,
    type text NOT NULL,
    variables jsonb,
    file_id bigint,
    file_size bigint,
    file_type text,
    file_name text,
    reply_to bigint,
    forward_id bigint,
    file_url text
);


--
-- Name: COLUMN message.reply_to; Type: COMMENT; Schema: chat; Owner: -
--

COMMENT ON COLUMN chat.message.reply_to IS 'reply_to_message_id';


--
-- Name: COLUMN message.forward_id; Type: COMMENT; Schema: chat; Owner: -
--

COMMENT ON COLUMN chat.message.forward_id IS 'forward_from_message_id';


--
-- Name: message_id_seq; Type: SEQUENCE; Schema: chat; Owner: -
--

CREATE SEQUENCE chat.message_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: message_id_seq; Type: SEQUENCE OWNED BY; Schema: chat; Owner: -
--

ALTER SEQUENCE chat.message_id_seq OWNED BY chat.message.id;


--
-- Name: profile_id_seq; Type: SEQUENCE; Schema: chat; Owner: -
--

CREATE SEQUENCE chat.profile_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: profile_id_seq; Type: SEQUENCE OWNED BY; Schema: chat; Owner: -
--

ALTER SEQUENCE chat.profile_id_seq OWNED BY chat.bot.id;


--
-- Name: contact_acl; Type: TABLE; Schema: contacts; Owner: -
--

CREATE TABLE contacts.contact_acl (
    dc bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    object bigint NOT NULL,
    access smallint NOT NULL
);


--
-- Name: contact_email; Type: TABLE; Schema: contacts; Owner: -
--

CREATE TABLE contacts.contact_email (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    ver integer DEFAULT 0 NOT NULL,
    contact_id bigint NOT NULL,
    updated_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    updated_by bigint NOT NULL,
    created_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    created_by bigint NOT NULL,
    "primary" boolean DEFAULT false NOT NULL,
    verified boolean DEFAULT false NOT NULL,
    type_id integer,
    type_of text NOT NULL,
    email character varying(255) NOT NULL,
    "from" text
);


--
-- Name: contact_email_id_seq; Type: SEQUENCE; Schema: contacts; Owner: -
--

CREATE SEQUENCE contacts.contact_email_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: contact_email_id_seq; Type: SEQUENCE OWNED BY; Schema: contacts; Owner: -
--

ALTER SEQUENCE contacts.contact_email_id_seq OWNED BY contacts.contact_email.id;


--
-- Name: contact_id_seq; Type: SEQUENCE; Schema: contacts; Owner: -
--

CREATE SEQUENCE contacts.contact_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: contact_id_seq; Type: SEQUENCE OWNED BY; Schema: contacts; Owner: -
--

ALTER SEQUENCE contacts.contact_id_seq OWNED BY contacts.contact.id;


--
-- Name: contact_label; Type: TABLE; Schema: contacts; Owner: -
--

CREATE TABLE contacts.contact_label (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    ver integer DEFAULT 0 NOT NULL,
    contact_id bigint NOT NULL,
    updated_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    updated_by bigint NOT NULL,
    created_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    created_by bigint NOT NULL,
    label text NOT NULL
);


--
-- Name: contact_label_id_seq; Type: SEQUENCE; Schema: contacts; Owner: -
--

CREATE SEQUENCE contacts.contact_label_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: contact_label_id_seq; Type: SEQUENCE OWNED BY; Schema: contacts; Owner: -
--

ALTER SEQUENCE contacts.contact_label_id_seq OWNED BY contacts.contact_label.id;


--
-- Name: contact_manager; Type: TABLE; Schema: contacts; Owner: -
--

CREATE TABLE contacts.contact_manager (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    ver integer DEFAULT 0 NOT NULL,
    contact_id bigint NOT NULL,
    updated_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    updated_by bigint NOT NULL,
    created_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    created_by bigint NOT NULL,
    "primary" boolean DEFAULT false NOT NULL,
    user_id bigint NOT NULL
);


--
-- Name: contact_manager_id_seq; Type: SEQUENCE; Schema: contacts; Owner: -
--

CREATE SEQUENCE contacts.contact_manager_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: contact_manager_id_seq; Type: SEQUENCE OWNED BY; Schema: contacts; Owner: -
--

ALTER SEQUENCE contacts.contact_manager_id_seq OWNED BY contacts.contact_manager.id;


--
-- Name: contact_phone; Type: TABLE; Schema: contacts; Owner: -
--

CREATE TABLE contacts.contact_phone (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    ver integer DEFAULT 0 NOT NULL,
    contact_id bigint NOT NULL,
    updated_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    updated_by bigint NOT NULL,
    created_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    created_by bigint NOT NULL,
    "primary" boolean DEFAULT false NOT NULL,
    verified boolean DEFAULT false NOT NULL,
    type_id integer,
    type_of text NOT NULL,
    digits character varying(16) COLLATE pg_catalog."C",
    number character varying(32) NOT NULL COLLATE pg_catalog."C"
);


--
-- Name: contact_phone_id_seq; Type: SEQUENCE; Schema: contacts; Owner: -
--

CREATE SEQUENCE contacts.contact_phone_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: contact_phone_id_seq; Type: SEQUENCE OWNED BY; Schema: contacts; Owner: -
--

ALTER SEQUENCE contacts.contact_phone_id_seq OWNED BY contacts.contact_phone.id;


--
-- Name: contact_timezone; Type: TABLE; Schema: contacts; Owner: -
--

CREATE TABLE contacts.contact_timezone (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    ver integer DEFAULT 0 NOT NULL,
    contact_id bigint NOT NULL,
    updated_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    updated_by bigint NOT NULL,
    created_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    created_by bigint NOT NULL,
    "primary" boolean DEFAULT false NOT NULL,
    timezone_id integer NOT NULL,
    zone_offset interval,
    zone_name character varying(100)
);


--
-- Name: contact_timezone_id_seq; Type: SEQUENCE; Schema: contacts; Owner: -
--

CREATE SEQUENCE contacts.contact_timezone_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: contact_timezone_id_seq; Type: SEQUENCE OWNED BY; Schema: contacts; Owner: -
--

ALTER SEQUENCE contacts.contact_timezone_id_seq OWNED BY contacts.contact_timezone.id;


--
-- Name: contact_variable; Type: TABLE; Schema: contacts; Owner: -
--

CREATE TABLE contacts.contact_variable (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    ver integer DEFAULT 0 NOT NULL,
    contact_id bigint NOT NULL,
    updated_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    updated_by bigint NOT NULL,
    created_at timestamp without time zone DEFAULT CURRENT_TIMESTAMP NOT NULL,
    created_by bigint NOT NULL,
    key text NOT NULL,
    value jsonb
);


--
-- Name: contact_variable_id_seq; Type: SEQUENCE; Schema: contacts; Owner: -
--

CREATE SEQUENCE contacts.contact_variable_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: contact_variable_id_seq; Type: SEQUENCE OWNED BY; Schema: contacts; Owner: -
--

ALTER SEQUENCE contacts.contact_variable_id_seq OWNED BY contacts.contact_variable.id;


--
-- Name: license; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.license (
    serial uuid NOT NULL,
    user_id bigint NOT NULL,
    issued_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    expires_at timestamp without time zone,
    signature bytea
);


--
-- Name: product; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.product (
    pid uuid NOT NULL,
    cid uuid NOT NULL,
    name name,
    "limit" integer,
    scope name[] NOT NULL,
    not_before timestamp without time zone,
    not_after timestamp without time zone
);


--
-- Name: sip_gateway_allow; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.sip_gateway_allow (
    id bigint NOT NULL,
    ip inet NOT NULL,
    port smallint DEFAULT 0 NOT NULL,
    proto character varying(4) DEFAULT 'any'::character varying NOT NULL
);


--
-- Name: sip_address_allow; Type: VIEW; Schema: directory; Owner: -
--

CREATE VIEW directory.sip_address_allow AS
 SELECT sv.id,
    sv.dc,
    sv.name,
    sv.host,
    (sa.ip)::cidr AS cidr,
    sa.port,
    sa.proto,
    1 AS grp,
    (host(sa.ip))::character varying(50) AS ip,
    (masklen(sa.ip))::smallint AS mask,
    NULL::character varying(64) AS pattern,
    NULL::character varying(32) AS context_info
   FROM (directory.sip_gateway sv
     JOIN directory.sip_gateway_allow sa USING (id))
  WHERE (sv.enable AND (NOT sv.register));


--
-- Name: sip_gateway_id_seq; Type: SEQUENCE; Schema: directory; Owner: -
--

CREATE SEQUENCE directory.sip_gateway_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: sip_gateway_id_seq; Type: SEQUENCE OWNED BY; Schema: directory; Owner: -
--

ALTER SEQUENCE directory.sip_gateway_id_seq OWNED BY directory.sip_gateway.id;


--
-- Name: sip_gateway_register; Type: TABLE; Schema: directory; Owner: -
--

CREATE UNLOGGED TABLE directory.sip_gateway_register (
    id bigint NOT NULL,
    attempt smallint DEFAULT 0 NOT NULL,
    state smallint DEFAULT 0 NOT NULL,
    sync timestamp without time zone,
    last timestamp without time zone,
    next timestamp without time zone,
    ip inet
);


--
-- Name: COLUMN sip_gateway_register.state; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.sip_gateway_register.state IS 'registration state';


--
-- Name: COLUMN sip_gateway_register.sync; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.sip_gateway_register.sync IS 'last state updated';


--
-- Name: COLUMN sip_gateway_register.last; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.sip_gateway_register.last IS 'last register sent';


--
-- Name: COLUMN sip_gateway_register.next; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.sip_gateway_register.next IS 'next register send';


--
-- Name: sip_registrant_tobe_dropped; Type: VIEW; Schema: directory; Owner: -
--

CREATE VIEW directory.sip_registrant_tobe_dropped AS
 SELECT sip_gateway.id,
    sip_gateway.dc,
    sip_gateway.name,
    sip_gateway.registrar,
    NULLIF(('sip:'::text || (sip_gateway.proxy)::text), (sip_gateway.registrar)::text) AS proxy,
    sip_gateway.account AS aor,
    NULL::text AS third_party_registrant,
    COALESCE(sip_gateway.username, 'anonymous'::character varying) AS username,
    sip_gateway.password,
    sip_gateway.binding_uri,
    sip_gateway.binding_params,
    sip_gateway.expires,
    COALESCE((sip_gateway_register.state)::integer, 0) AS state,
    NULL::text AS forced_socket,
    NULL::text AS cluster_shtag
   FROM (directory.sip_gateway
     LEFT JOIN directory.sip_gateway_register USING (id))
  WHERE (sip_gateway.enable AND sip_gateway.register);


--
-- Name: wbt_auth_member; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_auth_member (
    dc integer NOT NULL,
    role_id integer NOT NULL,
    member_id integer NOT NULL,
    role_admin boolean DEFAULT false NOT NULL
);


--
-- Name: TABLE wbt_auth_member; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_auth_member IS 'Webitel Group of members';


--
-- Name: wbt_class; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_class (
    id integer NOT NULL,
    dc integer NOT NULL,
    name name NOT NULL,
    abac boolean DEFAULT false NOT NULL,
    obac boolean DEFAULT false NOT NULL,
    rbac boolean DEFAULT false NOT NULL,
    usage text,
    not_before timestamp without time zone,
    not_after timestamp without time zone
);


--
-- Name: TABLE wbt_class; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_class IS 'Webitel Object Classes';


--
-- Name: COLUMN wbt_class.abac; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_class.abac IS '[a]ttribute-[b]ased [a]ccess [c]ontrol';


--
-- Name: COLUMN wbt_class.obac; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_class.obac IS '[o]peration-[b]ased [a]ccess [c]ontrol';


--
-- Name: COLUMN wbt_class.rbac; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_class.rbac IS '[r]ecord-[b]ased [a]ccess [c]ontrol';


--
-- Name: COLUMN wbt_class.not_before; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_class.not_before IS 'LOWER validity boundary';


--
-- Name: COLUMN wbt_class.not_after; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_class.not_after IS 'UPPER validity boundary';


--
-- Name: wbt_class_acl; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_class_acl (
    dc integer NOT NULL,
    object integer NOT NULL,
    grantor integer,
    subject integer NOT NULL,
    access smallint NOT NULL
);


--
-- Name: TABLE wbt_class_acl; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_class_acl IS 'Object Class Access List';


--
-- Name: COLUMN wbt_class_acl.access; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_class_acl.access IS 'access level mask: [ ---- ---- ---- crud ]';


--
-- Name: wbt_domain; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_domain (
    dc bigint NOT NULL,
    name character varying(255) NOT NULL,
    organization text,
    country name,
    locality name,
    province name,
    street text,
    timezone_id bigint,
    customer_id uuid NOT NULL,
    attrs character varying(255) DEFAULT NULL::character varying
);


--
-- Name: TABLE wbt_domain; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_domain IS 'Webitel Organizational Domains';


--
-- Name: users; Type: VIEW; Schema: directory; Owner: -
--

CREATE VIEW directory.users AS
 WITH cte_bitmask(mode, "char") AS (
         SELECT ((1 << (generate_subscripts("char"."char", 1) - 1)))::smallint AS mode,
            unnest("char"."char") AS "char"
           FROM string_to_array(reverse('xrwdxrwd'::text), NULL::text) "char"("char")
          ORDER BY (((1 << (generate_subscripts("char"."char", 1) - 1)))::smallint) DESC
        )
 SELECT ua.id,
    ua.dc,
    srv.name AS domain,
    COALESCE(ua.name, (ua.username)::text) AS fullname,
    ua.extension,
    array_to_string(roles.auth, ','::text) AS roles,
    array_to_string(grants.id, ','::text) AS grants,
    array_to_string(scope.oc, ' '::text) AS scope
   FROM ((((directory.wbt_user ua
     JOIN directory.wbt_domain srv USING (dc))
     JOIN LATERAL ( SELECT array_agg(ou.id) AS array_agg,
            array_agg(ou.auth) AS array_agg
           FROM ( SELECT ua.id,
                    COALESCE(ua.name, (ua.username)::text) AS "coalesce"
                UNION ALL
                 SELECT sub.role_id,
                    COALESCE(sup.name, (sup.auth)::text) AS "coalesce"
                   FROM (directory.wbt_auth_member sub
                     JOIN directory.wbt_auth sup ON ((sup.id = sub.role_id)))
                  WHERE (sub.member_id = ua.id)) ou(id, auth)) roles(id, auth) ON (true))
     JOIN LATERAL ( SELECT array_agg(grants_1.id) AS array_agg,
            COALESCE(bit_or(sys.ac), 0) AS "coalesce"
           FROM (( SELECT DISTINCT unnest(wbt_auth.grants) AS unnest
                   FROM directory.wbt_auth
                  WHERE (wbt_auth.id = ANY (roles.id))) grants_1(id)
             LEFT JOIN ( VALUES ('delete'::name,(17)::smallint), ('write'::name,34), ('read'::name,68), ('add'::name,136)) sys(id, ac) USING (id))) grants(id, ac) ON (true))
     LEFT JOIN LATERAL ( SELECT array_agg(oc.id) AS array_agg,
            array_agg((COALESCE((NULLIF(privs.ls, 'xrwdxrwd'::text) || ':'::text), ''::text) || (oc.name)::text)) AS array_agg
           FROM ((directory.wbt_class oc
             LEFT JOIN directory.wbt_class_acl acl ON ((oc.obac AND (acl.object = oc.id) AND (acl.subject = ANY (roles.id)))))
             LEFT JOIN LATERAL ( SELECT (
                        CASE
                            WHEN oc.obac THEN grants.ac
                            ELSE 0
                        END | COALESCE((bit_or(mode.mask))::integer, 0)) AS "?column?",
                    array_to_string(array_agg(mode."char"), ''::text) AS array_to_string
                   FROM cte_bitmask mode(mask, "char")
                  WHERE (((
                        CASE
                            WHEN oc.obac THEN grants.ac
                            ELSE 0
                        END | COALESCE((acl.access)::integer, 0)) & (mode.mask)::integer) = mode.mask)) privs(mode, ls) ON (true))
          WHERE ((oc.dc = ua.dc) AND ((NOT oc.obac) OR (NULLIF(privs.ls, ''::text) IS NOT NULL)))) scope(id, oc) ON (true))
  ORDER BY ua.dc, ua.id;


--
-- Name: wbt_auth_acl; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_auth_acl (
    dc bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    object bigint NOT NULL,
    access smallint NOT NULL
);


--
-- Name: TABLE wbt_auth_acl; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_auth_acl IS 'Roles [R]ecord-[b]ased [A]ccess [C]ontrol List';


--
-- Name: COLUMN wbt_auth_acl.access; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_auth_acl.access IS 'AccessLvl[0x77]: [ ---- ---- -RUD -RUD ]
Grantable[0x70]: [ -RUD ---- ]
Privilege[0x07]: [ ---- -RUD ]';


--
-- Name: wbt_class_id_seq; Type: SEQUENCE; Schema: directory; Owner: -
--

CREATE SEQUENCE directory.wbt_class_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: wbt_class_id_seq; Type: SEQUENCE OWNED BY; Schema: directory; Owner: -
--

ALTER SEQUENCE directory.wbt_class_id_seq OWNED BY directory.wbt_class.id;


--
-- Name: wbt_customer; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_customer (
    id uuid NOT NULL,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    deleted_at timestamp without time zone,
    issued_at timestamp without time zone NOT NULL,
    not_before timestamp without time zone NOT NULL,
    not_after timestamp without time zone NOT NULL,
    this_update timestamp without time zone,
    next_update timestamp without time zone,
    competitive integer DEFAULT 0 NOT NULL,
    organization text,
    logo text,
    cert bytea NOT NULL
);


--
-- Name: wbt_default_acl; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_default_acl (
    dc bigint NOT NULL,
    object bigint NOT NULL,
    grantor bigint NOT NULL,
    subject bigint NOT NULL,
    access smallint NOT NULL
);


--
-- Name: COLUMN wbt_default_acl.object; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_default_acl.object IS '[ON] objclass';


--
-- Name: COLUMN wbt_default_acl.grantor; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_default_acl.grantor IS '[FROM] author role';


--
-- Name: COLUMN wbt_default_acl.subject; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_default_acl.subject IS '[TO] grantee role';


--
-- Name: COLUMN wbt_default_acl.access; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_default_acl.access IS 'default rights';


--
-- Name: wbt_device; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_device (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    account name NOT NULL,
    password text NOT NULL,
    logged_in timestamp without time zone,
    user_id bigint,
    brand name,
    model name,
    mac macaddr,
    ip inet,
    vars jsonb,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    created_by bigint,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_by bigint,
    deleted_at timestamp without time zone,
    deleted_by bigint,
    name text NOT NULL,
    hotdesk boolean DEFAULT false NOT NULL
);


--
-- Name: COLUMN wbt_device.hotdesk; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_device.hotdesk IS 'type: `hotdesk`';


--
-- Name: wbt_device_acl; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_device_acl (
    dc integer NOT NULL,
    grantor integer,
    subject integer NOT NULL,
    object integer NOT NULL,
    access smallint NOT NULL
);


--
-- Name: TABLE wbt_device_acl; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_device_acl IS 'Device [R]ecord-[b]ased [A]ccess [C]ontrol List';


--
-- Name: COLUMN wbt_device_acl.access; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_device_acl.access IS 'AccessLvl[0x77]: [ ---- ---- -RUD -RUD ]
Grantable[0x70]: [ -RUD ---- ]
Privilege[0x07]: [ ---- -RUD ]';


--
-- Name: wbt_device_audit; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_device_audit (
    dc bigint NOT NULL,
    hotdesk name,
    user_id bigint,
    username text NOT NULL,
    device_id bigint,
    account text NOT NULL,
    logged_in timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    logged_out timestamp without time zone
);


--
-- Name: wbt_device_id_seq; Type: SEQUENCE; Schema: directory; Owner: -
--

CREATE SEQUENCE directory.wbt_device_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: wbt_device_id_seq; Type: SEQUENCE OWNED BY; Schema: directory; Owner: -
--

ALTER SEQUENCE directory.wbt_device_id_seq OWNED BY directory.wbt_device.id;


--
-- Name: wbt_hotdesk; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_hotdesk (
    dc bigint NOT NULL,
    name name NOT NULL,
    device_id bigint NOT NULL
);


--
-- Name: wbt_ldap; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_ldap (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    name text,
    url text NOT NULL,
    tls_client_cert bytea,
    tls_client_key bytea,
    tls_client_ca bytea,
    bind name NOT NULL,
    base_dn text,
    username text,
    password text,
    entry_uuid name NOT NULL,
    entry_modify name NOT NULL,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    created_by bigint,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_by bigint,
    schedule text,
    sync_opts jsonb
);


--
-- Name: COLUMN wbt_ldap.dc; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.dc IS 'required: domain internal reference';


--
-- Name: COLUMN wbt_ldap.name; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.name IS 'meaningfull human-readable catalog title';


--
-- Name: COLUMN wbt_ldap.url; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.url IS 'required: LDAP connection URL: [ldap[s]://]host[:port]';


--
-- Name: COLUMN wbt_ldap.tls_client_cert; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.tls_client_cert IS 'optional: TLS client certificate';


--
-- Name: COLUMN wbt_ldap.tls_client_key; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.tls_client_key IS 'optional: TLS client private/public key';


--
-- Name: COLUMN wbt_ldap.tls_client_ca; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.tls_client_ca IS 'optional: TLS CA''s authority certificate';


--
-- Name: COLUMN wbt_ldap.bind; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.bind IS 'optional: well-known bind mechanism; anonymous if blank';


--
-- Name: COLUMN wbt_ldap.base_dn; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.base_dn IS 'base_dn -or- part of credentials for specific bind mechanism(s); e.g.: example.com -or- DC=example,DC=com';


--
-- Name: COLUMN wbt_ldap.username; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.username IS 'part of credentials for bind operation';


--
-- Name: COLUMN wbt_ldap.password; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.password IS 'user secret; keep it confidential';


--
-- Name: COLUMN wbt_ldap.entry_uuid; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.entry_uuid IS 'required: LDAP attributeType that holds a server-assigned Universally Unique Identifier UUID for the entry. Typical: entryUUID, MSAD: objectGUID';


--
-- Name: COLUMN wbt_ldap.entry_modify; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.entry_modify IS 'required: LDAP attributeType that holds the time an entry was last modified. Typical: modifyTimestamp, MSAD: whenChanged';


--
-- Name: COLUMN wbt_ldap.schedule; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.schedule IS '[CRON]OS Spec.';


--
-- Name: COLUMN wbt_ldap.sync_opts; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap.sync_opts IS 'Preconfigured background SYNC Options for this LDAPCatalog';


--
-- Name: wbt_ldap_id_seq; Type: SEQUENCE; Schema: directory; Owner: -
--

CREATE SEQUENCE directory.wbt_ldap_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: wbt_ldap_id_seq; Type: SEQUENCE OWNED BY; Schema: directory; Owner: -
--

ALTER SEQUENCE directory.wbt_ldap_id_seq OWNED BY directory.wbt_ldap.id;


--
-- Name: wbt_ldap_proc; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_ldap_proc (
    id bigint NOT NULL,
    app text NOT NULL,
    catalog_id bigint NOT NULL,
    execute_by bigint,
    execute_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    complete_at timestamp without time zone,
    code integer,
    status text,
    opts jsonb
);


--
-- Name: COLUMN wbt_ldap_proc.app; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_proc.app IS 'Application node that is running this process';


--
-- Name: COLUMN wbt_ldap_proc.catalog_id; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_proc.catalog_id IS 'Preconfigured LDAP catalog configuration';


--
-- Name: COLUMN wbt_ldap_proc.execute_by; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_proc.execute_by IS 'Optional. Has been started manually by the user or role';


--
-- Name: COLUMN wbt_ldap_proc.execute_at; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_proc.execute_at IS 'Timestamp when this process has been started';


--
-- Name: COLUMN wbt_ldap_proc.updated_at; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_proc.updated_at IS 'Periodical process hearbeat to be able to indicate crash or zombie state';


--
-- Name: COLUMN wbt_ldap_proc.complete_at; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_proc.complete_at IS 'Timestamp when this process was completed';


--
-- Name: COLUMN wbt_ldap_proc.opts; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_proc.opts IS 'Options';


--
-- Name: wbt_ldap_proc_id_seq; Type: SEQUENCE; Schema: directory; Owner: -
--

CREATE SEQUENCE directory.wbt_ldap_proc_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: wbt_ldap_proc_id_seq; Type: SEQUENCE OWNED BY; Schema: directory; Owner: -
--

ALTER SEQUENCE directory.wbt_ldap_proc_id_seq OWNED BY directory.wbt_ldap_proc.id;


--
-- Name: wbt_ldap_sync; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_ldap_sync (
    process_id bigint,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    catalog_id bigint,
    template_id bigint,
    entry_uuid uuid NOT NULL,
    entry_dn text NOT NULL,
    entry jsonb NOT NULL,
    objclass name NOT NULL,
    object_id bigint,
    object jsonb,
    process name,
    warns text[],
    errs text[]
);


--
-- Name: COLUMN wbt_ldap_sync.entry; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_sync.entry IS 'Fetched external LDAP entry; DUMP';


--
-- Name: COLUMN wbt_ldap_sync.objclass; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_sync.objclass IS 'ANY(role,device,user,agent)';


--
-- Name: COLUMN wbt_ldap_sync.object; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_sync.object IS 'Process internal object; DUMP';


--
-- Name: COLUMN wbt_ldap_sync.process; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_sync.process IS 'ANY(create,update,delete)';


--
-- Name: COLUMN wbt_ldap_sync.warns; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_sync.warns IS 'NON-CRITICAL: Warnings';


--
-- Name: COLUMN wbt_ldap_sync.errs; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_sync.errs IS 'CRITICAL: Errors; NOT empty indicates failure';


--
-- Name: wbt_ldap_tmpl; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_ldap_tmpl (
    id bigint NOT NULL,
    name text NOT NULL,
    catalog_id bigint NOT NULL,
    base_dn text NOT NULL,
    search text NOT NULL,
    enabled boolean DEFAULT false NOT NULL,
    role jsonb,
    device jsonb,
    "user" jsonb,
    agent jsonb,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    created_by bigint,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_by bigint
);


--
-- Name: TABLE wbt_ldap_tmpl; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_ldap_tmpl IS 'LDAP Sync Object''s Template';


--
-- Name: COLUMN wbt_ldap_tmpl.id; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_tmpl.id IS 'This Template Unique IDentifier';


--
-- Name: COLUMN wbt_ldap_tmpl.name; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_tmpl.name IS 'LDAP Objects group associated name';


--
-- Name: COLUMN wbt_ldap_tmpl.catalog_id; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_tmpl.catalog_id IS 'LDAP Catalog Connection';


--
-- Name: COLUMN wbt_ldap_tmpl.base_dn; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_tmpl.base_dn IS 'Optional. LDAP Search Base DN';


--
-- Name: COLUMN wbt_ldap_tmpl.search; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_ldap_tmpl.search IS 'Required. LDAP Search Filter';


--
-- Name: wbt_ldap_tmpl_id_seq; Type: SEQUENCE; Schema: directory; Owner: -
--

CREATE SEQUENCE directory.wbt_ldap_tmpl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: wbt_ldap_tmpl_id_seq; Type: SEQUENCE OWNED BY; Schema: directory; Owner: -
--

ALTER SEQUENCE directory.wbt_ldap_tmpl_id_seq OWNED BY directory.wbt_ldap_tmpl.id;


--
-- Name: wbt_oauth_service; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_oauth_service (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    name text,
    type name NOT NULL,
    enabled boolean DEFAULT true NOT NULL,
    picture text,
    client_id text,
    client_secret text,
    scopes name[],
    claims jsonb,
    auth_url text,
    token_url text,
    userinfo_url text,
    discovery_url text,
    metadata jsonb,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    created_by bigint,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_by bigint
);


--
-- Name: TABLE wbt_oauth_service; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_oauth_service IS 'OAuth [S]ervice [P]rovider Configuration';


--
-- Name: COLUMN wbt_oauth_service.dc; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.dc IS 'Primary Domain Compponent reference';


--
-- Name: COLUMN wbt_oauth_service.name; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.name IS 'Meaningfull Display Name';


--
-- Name: COLUMN wbt_oauth_service.type; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.type IS 'Well-known [S]ervice [P]rovider protocol type e.g.: OpenID, Google, Facebook';


--
-- Name: COLUMN wbt_oauth_service.enabled; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.enabled IS 'Is enabled ?';


--
-- Name: COLUMN wbt_oauth_service.picture; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.picture IS 'Logo picture URL';


--
-- Name: COLUMN wbt_oauth_service.client_id; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.client_id IS 'OAuth 2.0 Client IDentifier';


--
-- Name: COLUMN wbt_oauth_service.client_secret; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.client_secret IS 'OAuth 2.0 Client Secret';


--
-- Name: COLUMN wbt_oauth_service.scopes; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.scopes IS 'OAuth 2.0 Client Scope(s)';


--
-- Name: COLUMN wbt_oauth_service.claims; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.claims IS 'SP Identity Claims Mapping Policy Rules';


--
-- Name: COLUMN wbt_oauth_service.auth_url; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.auth_url IS 'OAuth 2.0 Authorization Endpoint URL';


--
-- Name: COLUMN wbt_oauth_service.token_url; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.token_url IS 'OAuth 2.0 Token Endpoint URL';


--
-- Name: COLUMN wbt_oauth_service.userinfo_url; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.userinfo_url IS 'OpenIDConnect Userinfo Endpoint URL';


--
-- Name: COLUMN wbt_oauth_service.discovery_url; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.discovery_url IS 'Issuer OR /.well-known/openid-configuration';


--
-- Name: COLUMN wbt_oauth_service.metadata; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_oauth_service.metadata IS 'Extra SP-specific configuration';


--
-- Name: wbt_oauth_service_id_seq; Type: SEQUENCE; Schema: directory; Owner: -
--

CREATE SEQUENCE directory.wbt_oauth_service_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: wbt_oauth_service_id_seq; Type: SEQUENCE OWNED BY; Schema: directory; Owner: -
--

ALTER SEQUENCE directory.wbt_oauth_service_id_seq OWNED BY directory.wbt_oauth_service.id;


--
-- Name: wbt_user_socket; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_user_socket (
    id character varying(64) NOT NULL,
    app character varying(64),
    socket character varying(64),
    user_id bigint NOT NULL,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL
);


--
-- Name: TABLE wbt_user_socket; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_user_socket IS 'User presence {web} tuples';


--
-- Name: location; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.location (
    contact_id bigint NOT NULL,
    username character varying(64) DEFAULT ''::character varying NOT NULL,
    domain character varying(64) DEFAULT NULL::character varying,
    contact character varying(255) DEFAULT ''::character varying NOT NULL,
    received character varying(255) DEFAULT NULL::character varying,
    path character varying(255) DEFAULT NULL::character varying,
    expires integer NOT NULL,
    q real DEFAULT 1.0 NOT NULL,
    callid character varying(255) DEFAULT 'Default-Call-ID'::character varying NOT NULL,
    cseq integer DEFAULT 13 NOT NULL,
    last_modified timestamp without time zone DEFAULT '1900-01-01 00:00:01'::timestamp without time zone NOT NULL,
    flags integer DEFAULT 0 NOT NULL,
    cflags character varying(255) DEFAULT NULL::character varying,
    user_agent character varying(255) DEFAULT ''::character varying NOT NULL,
    socket character varying(64) DEFAULT NULL::character varying,
    methods integer,
    sip_instance character varying(255) DEFAULT NULL::character varying,
    kv_store text,
    attr character varying(255) DEFAULT NULL::character varying,
    device_id character varying(255)
);


--
-- Name: wbt_presence_dump; Type: VIEW; Schema: directory; Owner: -
--

CREATE VIEW directory.wbt_presence_dump AS
 SELECT usr.dc,
    srv.name AS domain,
    usr.id,
    COALESCE(usr.extension, usr.username) AS username,
    presence.event,
    presence.open,
    presence.created_at,
    presence.updated_at
   FROM ((directory.wbt_user usr
     JOIN directory.wbt_domain srv USING (dc))
     JOIN LATERAL ( SELECT 'dlg'::text AS text,
            COALESCE(count(dialog_1.user_id), (0)::bigint) AS "coalesce",
            min(dialog_1.created_at) AS min,
            max(dialog_1."timestamp") AS max
           FROM call_center.cc_calls dialog_1
          WHERE ((dialog_1.hangup_at IS NULL) AND (dialog_1.user_id = usr.id))
        UNION ALL
         SELECT 'sip'::text AS text,
            count(DISTINCT dev.hotdesk) AS count,
            NULL::timestamp with time zone AS timestamptz,
            max(loc.last_modified) AS max
           FROM directory.wbt_device dev,
            public.location loc
          WHERE ((dev.user_id = usr.id) AND ((loc.device_id)::text = (dev.id)::text))
        UNION ALL
         SELECT 'web'::text AS text,
            count(web.user_id) AS count,
            min(web.created_at) AS min,
            max(web.updated_at) AS max
           FROM directory.wbt_user_socket web
          WHERE (web.user_id = usr.id)) presence(event, open, created_at, updated_at) ON (true));


--
-- Name: wbt_session; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_session (
    uuid uuid DEFAULT gen_random_uuid() NOT NULL,
    scope name[],
    user_id integer,
    domain_id integer,
    client_id name,
    network_ip inet,
    redirect_uri text,
    code text,
    access text,
    refresh text,
    accessed timestamp without time zone,
    created timestamp without time zone,
    rotated timestamp without time zone,
    expires timestamp without time zone,
    max_age timestamp without time zone,
    props jsonb
);


--
-- Name: wbt_subscriber_tobe_dropped; Type: VIEW; Schema: directory; Owner: -
--

CREATE VIEW directory.wbt_subscriber_tobe_dropped AS
 SELECT auth.dc,
    auth.id AS oid,
    caller.id AS uid,
    lower((realm.name)::text) AS realm,
    auth.account AS auth_id,
    COALESCE(caller.extension, auth.account) AS user_id,
    COALESCE(display.name, (caller.extension)::text, (auth.account)::text) AS caller_id_name,
    md5((((((auth.account)::text || ':'::text) || lower((realm.name)::text)) || ':'::text) || auth.password)) AS digest_ha1,
    loc.contacts
   FROM ((((directory.wbt_device auth
     JOIN directory.wbt_domain realm USING (dc))
     LEFT JOIN directory.wbt_user caller ON ((auth.user_id = caller.id)))
     LEFT JOIN directory.wbt_auth display ON ((auth.user_id = display.id)))
     CROSS JOIN LATERAL ( SELECT count(c.contact_id) AS contacts
           FROM public.location c
          WHERE ((c.device_id)::bigint = auth.id)) loc)
  WHERE ((auth.deleted_at IS NULL) AND (auth.hotdesk OR (auth.user_id IS NOT NULL)));


--
-- Name: wbt_user_setting; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_user_setting (
    user_id bigint NOT NULL,
    name text NOT NULL,
    value jsonb
);


--
-- Name: TABLE wbt_user_setting; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON TABLE directory.wbt_user_setting IS 'Users Settings Store';


--
-- Name: COLUMN wbt_user_setting.name; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_setting.name IS 'Document name (path)';


--
-- Name: COLUMN wbt_user_setting.value; Type: COMMENT; Schema: directory; Owner: -
--

COMMENT ON COLUMN directory.wbt_user_setting.value IS 'Document content(s)';


--
-- Name: wbt_user_token; Type: TABLE; Schema: directory; Owner: -
--

CREATE TABLE directory.wbt_user_token (
    id uuid NOT NULL,
    dc bigint NOT NULL,
    token name NOT NULL,
    usage text,
    user_id bigint NOT NULL,
    created_at timestamp without time zone DEFAULT LOCALTIMESTAMP,
    created_by bigint,
    updated_at timestamp without time zone DEFAULT LOCALTIMESTAMP,
    updated_by bigint,
    deleted_at timestamp without time zone,
    deleted_by bigint
);


--
-- Name: acr_chat_plan; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.acr_chat_plan (
    id integer NOT NULL,
    domain_id bigint NOT NULL,
    enabled boolean DEFAULT true NOT NULL,
    name character varying NOT NULL,
    schema_id integer NOT NULL,
    description text
);


--
-- Name: acr_chat_plan_id_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.acr_chat_plan_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: acr_chat_plan_id_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.acr_chat_plan_id_seq OWNED BY flow.acr_chat_plan.id;


--
-- Name: acr_chat_plan_list; Type: VIEW; Schema: flow; Owner: -
--

CREATE VIEW flow.acr_chat_plan_list AS
 SELECT c.id,
    c.enabled,
    c.name,
    flow.get_lookup(s.id, s.name) AS schema,
    c.description,
    c.domain_id
   FROM (flow.acr_chat_plan c
     LEFT JOIN flow.acr_routing_scheme s ON ((s.id = c.schema_id)));


--
-- Name: acr_routing_outbound_call; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.acr_routing_outbound_call (
    id bigint NOT NULL,
    domain_id bigint NOT NULL,
    name character varying(100) NOT NULL,
    description character varying(200) DEFAULT ''::character varying NOT NULL,
    created_at bigint NOT NULL,
    created_by bigint,
    updated_at bigint NOT NULL,
    updated_by bigint,
    pattern character varying NOT NULL,
    priority integer DEFAULT 0 NOT NULL,
    disabled boolean DEFAULT false,
    scheme_id bigint NOT NULL,
    pos integer NOT NULL
);


--
-- Name: acr_routing_outbound_call_id_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.acr_routing_outbound_call_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: acr_routing_outbound_call_id_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.acr_routing_outbound_call_id_seq OWNED BY flow.acr_routing_outbound_call.id;


--
-- Name: acr_routing_outbound_call_pos_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.acr_routing_outbound_call_pos_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: acr_routing_outbound_call_pos_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.acr_routing_outbound_call_pos_seq OWNED BY flow.acr_routing_outbound_call.pos;


--
-- Name: acr_routing_outbound_call_view; Type: VIEW; Schema: flow; Owner: -
--

CREATE VIEW flow.acr_routing_outbound_call_view AS
 SELECT tmp.id,
    tmp.domain_id,
    tmp.scheme_id AS schema_id,
    tmp.name,
    tmp.description,
    tmp.created_at,
    flow.get_lookup(c.id, (c.name)::character varying) AS created_by,
    flow.get_lookup(u.id, (u.name)::character varying) AS updated_by,
    tmp.pattern,
    tmp.disabled,
    flow.get_lookup(arst.id, arst.name) AS schema,
    row_number() OVER (PARTITION BY tmp.domain_id ORDER BY tmp.pos DESC) AS "position"
   FROM (((flow.acr_routing_outbound_call tmp
     JOIN flow.acr_routing_scheme arst ON ((tmp.scheme_id = arst.id)))
     LEFT JOIN directory.wbt_user c ON ((c.id = tmp.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = tmp.updated_by)));


--
-- Name: acr_routing_scheme_id_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.acr_routing_scheme_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: acr_routing_scheme_id_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.acr_routing_scheme_id_seq OWNED BY flow.acr_routing_scheme.id;


--
-- Name: acr_routing_scheme_view; Type: VIEW; Schema: flow; Owner: -
--

CREATE VIEW flow.acr_routing_scheme_view AS
 SELECT s.id,
    s.domain_id,
    s.name,
    s.created_at,
    flow.get_lookup(c.id, (c.name)::character varying) AS created_by,
    s.updated_at,
    flow.get_lookup(u.id, (u.name)::character varying) AS updated_by,
    s.debug,
    s.scheme AS schema,
    s.payload,
    s.type,
    s.editor,
    s.tags
   FROM ((flow.acr_routing_scheme s
     LEFT JOIN directory.wbt_user c ON ((c.id = s.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = s.updated_by)));


--
-- Name: acr_routing_variables; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.acr_routing_variables (
    id bigint NOT NULL,
    domain_id bigint NOT NULL,
    key character varying(20) NOT NULL,
    value character varying(100) DEFAULT ''::character varying NOT NULL
);


--
-- Name: acr_routing_variables_id_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.acr_routing_variables_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: acr_routing_variables_id_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.acr_routing_variables_id_seq OWNED BY flow.acr_routing_variables.id;


--
-- Name: calendar_acl; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.calendar_acl (
    dc bigint NOT NULL,
    object bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL,
    id bigint NOT NULL
);


--
-- Name: calendar_acl_id_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.calendar_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: calendar_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.calendar_acl_id_seq OWNED BY flow.calendar_acl.id;


--
-- Name: calendar_id_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.calendar_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: calendar_id_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.calendar_id_seq OWNED BY flow.calendar.id;


--
-- Name: calendar_timezone_offsets; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.calendar_timezone_offsets (
    id smallint NOT NULL,
    utc_offset interval,
    names text[]
);


--
-- Name: calendar_timezones_by_interval; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.calendar_timezones_by_interval (
    id bigint,
    utc_offset interval,
    names character varying[]
);


--
-- Name: calendar_timezones_id_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.calendar_timezones_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: calendar_timezones_id_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.calendar_timezones_id_seq OWNED BY flow.calendar_timezones.id;


--
-- Name: calendar_timezones_view; Type: VIEW; Schema: flow; Owner: -
--

CREATE VIEW flow.calendar_timezones_view AS
 SELECT t.id,
    t.name,
    (t.utc_offset)::text AS "offset"
   FROM flow.calendar_timezones t;


--
-- Name: calendar_view; Type: VIEW; Schema: flow; Owner: -
--

CREATE VIEW flow.calendar_view AS
 SELECT c.id,
    c.name,
    c.start_at,
    c.end_at,
    c.description,
    c.domain_id,
    flow.get_lookup((ct.id)::bigint, ct.name) AS timezone,
    c.created_at,
    flow.get_lookup(uc.id, (uc.name)::character varying) AS created_by,
    c.updated_at,
    flow.get_lookup(u.id, (u.name)::character varying) AS updated_by,
    flow.calendar_accepts_to_jsonb(c.accepts) AS accepts,
    flow.arr_type_to_jsonb(c.excepts) AS excepts
   FROM (((flow.calendar c
     LEFT JOIN flow.calendar_timezones ct ON ((c.timezone_id = ct.id)))
     LEFT JOIN directory.wbt_user uc ON ((uc.id = c.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = c.updated_by)));


--
-- Name: region_id_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.region_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: region_id_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.region_id_seq OWNED BY flow.region.id;


--
-- Name: region_list; Type: VIEW; Schema: flow; Owner: -
--

CREATE VIEW flow.region_list AS
 SELECT r.id,
    r.name,
    r.description,
    flow.get_lookup((t.id)::bigint, t.name) AS timezone,
    r.timezone_id,
    r.domain_id
   FROM (flow.region r
     LEFT JOIN flow.calendar_timezones t ON ((t.id = r.timezone_id)));


--
-- Name: scheme_log; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.scheme_log (
    id bigint NOT NULL,
    schema_id integer NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    log jsonb NOT NULL,
    conn_id character varying(100) NOT NULL
);


--
-- Name: scheme_log_id_seq; Type: SEQUENCE; Schema: flow; Owner: -
--

CREATE SEQUENCE flow.scheme_log_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: scheme_log_id_seq; Type: SEQUENCE OWNED BY; Schema: flow; Owner: -
--

ALTER SEQUENCE flow.scheme_log_id_seq OWNED BY flow.scheme_log.id;


--
-- Name: web_hook; Type: TABLE; Schema: flow; Owner: -
--

CREATE TABLE flow.web_hook (
    id character varying NOT NULL,
    name character varying NOT NULL,
    domain_id bigint NOT NULL,
    description character varying,
    origin character varying[],
    rps integer DEFAULT 5 NOT NULL,
    schema_id integer NOT NULL,
    enabled boolean DEFAULT true NOT NULL,
    "authorization" character varying
);


--
-- Name: log; Type: TABLE; Schema: logger; Owner: -
--

CREATE TABLE logger.log (
    id integer NOT NULL,
    date timestamp with time zone NOT NULL,
    user_id integer NOT NULL,
    user_ip text NOT NULL,
    record_id bigint NOT NULL,
    new_state jsonb,
    action text NOT NULL,
    config_id integer NOT NULL,
    object_name name
);


--
-- Name: log_id_seq; Type: SEQUENCE; Schema: logger; Owner: -
--

CREATE SEQUENCE logger.log_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: log_id_seq; Type: SEQUENCE OWNED BY; Schema: logger; Owner: -
--

ALTER SEQUENCE logger.log_id_seq OWNED BY logger.log.id;


--
-- Name: object_config; Type: TABLE; Schema: logger; Owner: -
--

CREATE TABLE logger.object_config (
    id integer NOT NULL,
    enabled boolean NOT NULL,
    days_to_store bigint NOT NULL,
    period integer NOT NULL,
    next_upload_on timestamp without time zone,
    object_id bigint NOT NULL,
    storage_id bigint,
    domain_id bigint NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    created_by bigint NOT NULL,
    updated_at timestamp with time zone,
    updated_by bigint,
    description text,
    last_uploaded_log_id integer
);


--
-- Name: COLUMN object_config.last_uploaded_log_id; Type: COMMENT; Schema: logger; Owner: -
--

COMMENT ON COLUMN logger.object_config.last_uploaded_log_id IS 'id of the last uploaded log to storage';


--
-- Name: object_config_acl; Type: TABLE; Schema: logger; Owner: -
--

CREATE TABLE logger.object_config_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    object integer NOT NULL,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL
);


--
-- Name: object_config_acl_id_seq; Type: SEQUENCE; Schema: logger; Owner: -
--

CREATE SEQUENCE logger.object_config_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: object_config_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: logger; Owner: -
--

ALTER SEQUENCE logger.object_config_acl_id_seq OWNED BY logger.object_config_acl.id;


--
-- Name: object_config_id_seq; Type: SEQUENCE; Schema: logger; Owner: -
--

CREATE SEQUENCE logger.object_config_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: object_config_id_seq; Type: SEQUENCE OWNED BY; Schema: logger; Owner: -
--

ALTER SEQUENCE logger.object_config_id_seq OWNED BY logger.object_config.id;


--
-- Name: acc; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.acc (
    id integer NOT NULL,
    method character varying(16) DEFAULT ''::character varying NOT NULL,
    from_tag character varying(64) DEFAULT ''::character varying NOT NULL,
    to_tag character varying(64) DEFAULT ''::character varying NOT NULL,
    callid character varying(64) DEFAULT ''::character varying NOT NULL,
    sip_code character varying(3) DEFAULT ''::character varying NOT NULL,
    sip_reason character varying(32) DEFAULT ''::character varying NOT NULL,
    "time" timestamp without time zone NOT NULL,
    duration integer DEFAULT 0 NOT NULL,
    ms_duration integer DEFAULT 0 NOT NULL,
    setuptime integer DEFAULT 0 NOT NULL,
    created timestamp without time zone
);


--
-- Name: acc_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.acc_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: acc_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.acc_id_seq OWNED BY public.acc.id;


--
-- Name: active_watchers; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.active_watchers (
    id integer NOT NULL,
    presentity_uri character varying(255) NOT NULL,
    watcher_username character varying(64) NOT NULL,
    watcher_domain character varying(64) NOT NULL,
    to_user character varying(64) NOT NULL,
    to_domain character varying(64) NOT NULL,
    event character varying(64) DEFAULT 'presence'::character varying NOT NULL,
    event_id character varying(64),
    to_tag character varying(64) NOT NULL,
    from_tag character varying(64) NOT NULL,
    callid character varying(64) NOT NULL,
    local_cseq integer NOT NULL,
    remote_cseq integer NOT NULL,
    contact character varying(255) NOT NULL,
    record_route text,
    expires integer NOT NULL,
    status integer DEFAULT 2 NOT NULL,
    reason character varying(64),
    version integer DEFAULT 0 NOT NULL,
    socket_info character varying(64) NOT NULL,
    local_contact character varying(255) NOT NULL,
    sharing_tag character varying(32) DEFAULT NULL::character varying
);


--
-- Name: active_watchers_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.active_watchers_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: active_watchers_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.active_watchers_id_seq OWNED BY public.active_watchers.id;


--
-- Name: address; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.address (
    id integer NOT NULL,
    grp smallint DEFAULT 0 NOT NULL,
    ip character varying(50) NOT NULL,
    mask smallint DEFAULT 32 NOT NULL,
    port smallint DEFAULT 0 NOT NULL,
    proto character varying(4) DEFAULT 'any'::character varying NOT NULL,
    pattern character varying(64) DEFAULT NULL::character varying,
    context_info character varying(32) DEFAULT NULL::character varying
);


--
-- Name: address_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.address_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: address_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.address_id_seq OWNED BY public.address.id;


--
-- Name: b2b_entities; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.b2b_entities (
    id integer NOT NULL,
    type integer NOT NULL,
    state integer NOT NULL,
    ruri character varying(255),
    from_uri character varying(255) NOT NULL,
    to_uri character varying(255) NOT NULL,
    from_dname character varying(64),
    to_dname character varying(64),
    tag0 character varying(64) NOT NULL,
    tag1 character varying(64),
    callid character varying(64) NOT NULL,
    cseq0 integer NOT NULL,
    cseq1 integer,
    contact0 character varying(255) NOT NULL,
    contact1 character varying(255),
    route0 text,
    route1 text,
    sockinfo_srv character varying(64),
    param character varying(255) NOT NULL,
    lm integer NOT NULL,
    lrc integer,
    lic integer,
    leg_cseq integer,
    leg_route text,
    leg_tag character varying(64),
    leg_contact character varying(255),
    leg_sockinfo character varying(255)
);


--
-- Name: b2b_entities_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.b2b_entities_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: b2b_entities_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.b2b_entities_id_seq OWNED BY public.b2b_entities.id;


--
-- Name: b2b_logic; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.b2b_logic (
    id integer NOT NULL,
    si_key character varying(64) NOT NULL,
    scenario character varying(64),
    sstate integer NOT NULL,
    next_sstate integer NOT NULL,
    sparam0 character varying(64),
    sparam1 character varying(64),
    sparam2 character varying(64),
    sparam3 character varying(64),
    sparam4 character varying(64),
    sdp text,
    lifetime integer DEFAULT 0 NOT NULL,
    e1_type integer NOT NULL,
    e1_sid character varying(64),
    e1_from character varying(255) NOT NULL,
    e1_to character varying(255) NOT NULL,
    e1_key character varying(64) NOT NULL,
    e2_type integer NOT NULL,
    e2_sid character varying(64),
    e2_from character varying(255) NOT NULL,
    e2_to character varying(255) NOT NULL,
    e2_key character varying(64) NOT NULL,
    e3_type integer,
    e3_sid character varying(64),
    e3_from character varying(255),
    e3_to character varying(255),
    e3_key character varying(64)
);


--
-- Name: b2b_logic_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.b2b_logic_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: b2b_logic_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.b2b_logic_id_seq OWNED BY public.b2b_logic.id;


--
-- Name: cachedb; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.cachedb (
    keyname character varying(255) NOT NULL,
    value text NOT NULL,
    counter integer DEFAULT 0 NOT NULL,
    expires integer DEFAULT 0 NOT NULL
);


--
-- Name: carrierfailureroute; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.carrierfailureroute (
    id integer NOT NULL,
    carrier integer DEFAULT 0 NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    scan_prefix character varying(64) DEFAULT ''::character varying NOT NULL,
    host_name character varying(255) DEFAULT ''::character varying NOT NULL,
    reply_code character varying(3) DEFAULT ''::character varying NOT NULL,
    flags integer DEFAULT 0 NOT NULL,
    mask integer DEFAULT 0 NOT NULL,
    next_domain character varying(64) DEFAULT ''::character varying NOT NULL,
    description character varying(255) DEFAULT NULL::character varying
);


--
-- Name: carrierfailureroute_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.carrierfailureroute_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: carrierfailureroute_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.carrierfailureroute_id_seq OWNED BY public.carrierfailureroute.id;


--
-- Name: carrierroute; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.carrierroute (
    id integer NOT NULL,
    carrier integer DEFAULT 0 NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    scan_prefix character varying(64) DEFAULT ''::character varying NOT NULL,
    flags integer DEFAULT 0 NOT NULL,
    mask integer DEFAULT 0 NOT NULL,
    prob real DEFAULT 0 NOT NULL,
    strip integer DEFAULT 0 NOT NULL,
    rewrite_host character varying(255) DEFAULT ''::character varying NOT NULL,
    rewrite_prefix character varying(64) DEFAULT ''::character varying NOT NULL,
    rewrite_suffix character varying(64) DEFAULT ''::character varying NOT NULL,
    description character varying(255) DEFAULT NULL::character varying
);


--
-- Name: carrierroute_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.carrierroute_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: carrierroute_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.carrierroute_id_seq OWNED BY public.carrierroute.id;


--
-- Name: cc_agents; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.cc_agents (
    id integer NOT NULL,
    agentid character varying(128) NOT NULL,
    location character varying(128) NOT NULL,
    logstate integer DEFAULT 0 NOT NULL,
    skills character varying(255) NOT NULL,
    last_call_end integer DEFAULT 0 NOT NULL
);


--
-- Name: cc_agents_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.cc_agents_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: cc_agents_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.cc_agents_id_seq OWNED BY public.cc_agents.id;


--
-- Name: cc_calls; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.cc_calls (
    id integer NOT NULL,
    state integer NOT NULL,
    ig_cback integer NOT NULL,
    no_rej integer NOT NULL,
    setup_time integer NOT NULL,
    eta integer NOT NULL,
    last_start integer NOT NULL,
    recv_time integer NOT NULL,
    caller_dn character varying(128) NOT NULL,
    caller_un character varying(128) NOT NULL,
    b2buaid character varying(128) DEFAULT ''::character varying NOT NULL,
    flow character varying(128) NOT NULL,
    agent character varying(128) NOT NULL
);


--
-- Name: cc_calls_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.cc_calls_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: cc_calls_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.cc_calls_id_seq OWNED BY public.cc_calls.id;


--
-- Name: cc_cdrs; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.cc_cdrs (
    id integer NOT NULL,
    caller character varying(64) NOT NULL,
    received_timestamp timestamp without time zone NOT NULL,
    wait_time integer DEFAULT 0 NOT NULL,
    pickup_time integer DEFAULT 0 NOT NULL,
    talk_time integer DEFAULT 0 NOT NULL,
    flow_id character varying(128) NOT NULL,
    agent_id character varying(128) DEFAULT NULL::character varying,
    call_type integer DEFAULT '-1'::integer NOT NULL,
    rejected integer DEFAULT 0 NOT NULL,
    fstats integer DEFAULT 0 NOT NULL,
    cid integer DEFAULT 0
);


--
-- Name: cc_cdrs_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.cc_cdrs_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: cc_cdrs_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.cc_cdrs_id_seq OWNED BY public.cc_cdrs.id;


--
-- Name: cc_flows; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.cc_flows (
    id integer NOT NULL,
    flowid character varying(64) NOT NULL,
    priority integer DEFAULT 256 NOT NULL,
    skill character varying(64) NOT NULL,
    prependcid character varying(32) NOT NULL,
    message_welcome character varying(128) DEFAULT NULL::character varying,
    message_queue character varying(128) NOT NULL
);


--
-- Name: cc_flows_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.cc_flows_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: cc_flows_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.cc_flows_id_seq OWNED BY public.cc_flows.id;


--
-- Name: clusterer; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.clusterer (
    id integer NOT NULL,
    cluster_id integer NOT NULL,
    node_id integer NOT NULL,
    url character varying(64) NOT NULL,
    state integer DEFAULT 1 NOT NULL,
    no_ping_retries integer DEFAULT 3 NOT NULL,
    priority integer DEFAULT 50 NOT NULL,
    sip_addr character varying(64),
    flags character varying(64),
    description character varying(64)
);


--
-- Name: clusterer_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.clusterer_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: clusterer_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.clusterer_id_seq OWNED BY public.clusterer.id;


--
-- Name: cpl; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.cpl (
    id integer NOT NULL,
    username character varying(64) NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    cpl_xml text,
    cpl_bin text
);


--
-- Name: cpl_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.cpl_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: cpl_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.cpl_id_seq OWNED BY public.cpl.id;


--
-- Name: dbaliases; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dbaliases (
    id integer NOT NULL,
    alias_username character varying(64) DEFAULT ''::character varying NOT NULL,
    alias_domain character varying(64) DEFAULT ''::character varying NOT NULL,
    username character varying(64) DEFAULT ''::character varying NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL
);


--
-- Name: dbaliases_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dbaliases_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: dbaliases_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dbaliases_id_seq OWNED BY public.dbaliases.id;


--
-- Name: dialog; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dialog (
    dlg_id bigint NOT NULL,
    callid character varying(255) NOT NULL,
    from_uri character varying(255) NOT NULL,
    from_tag character varying(64) NOT NULL,
    to_uri character varying(255) NOT NULL,
    to_tag character varying(64) NOT NULL,
    mangled_from_uri character varying(64) DEFAULT NULL::character varying,
    mangled_to_uri character varying(64) DEFAULT NULL::character varying,
    caller_cseq character varying(11) NOT NULL,
    callee_cseq character varying(11) NOT NULL,
    caller_ping_cseq integer NOT NULL,
    callee_ping_cseq integer NOT NULL,
    caller_route_set text,
    callee_route_set text,
    caller_contact character varying(255),
    callee_contact character varying(255),
    caller_sock character varying(64) NOT NULL,
    callee_sock character varying(64) NOT NULL,
    state integer NOT NULL,
    start_time integer NOT NULL,
    timeout integer NOT NULL,
    vars bytea,
    profiles text,
    script_flags integer DEFAULT 0 NOT NULL,
    module_flags integer DEFAULT 0 NOT NULL,
    flags integer DEFAULT 0 NOT NULL
);


--
-- Name: dialplan; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dialplan (
    id integer NOT NULL,
    dpid integer NOT NULL,
    pr integer NOT NULL,
    match_op integer NOT NULL,
    match_exp character varying(64) NOT NULL,
    match_flags integer NOT NULL,
    subst_exp character varying(64),
    repl_exp character varying(32),
    timerec character varying(255),
    disabled integer DEFAULT 0 NOT NULL,
    attrs character varying(255)
);


--
-- Name: dialplan_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dialplan_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: dialplan_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dialplan_id_seq OWNED BY public.dialplan.id;


--
-- Name: dispatcher; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dispatcher (
    id integer NOT NULL,
    setid integer DEFAULT 0 NOT NULL,
    destination character varying(192) DEFAULT ''::character varying NOT NULL,
    socket character varying(128) DEFAULT NULL::character varying,
    state integer DEFAULT 0 NOT NULL,
    weight character varying(64) DEFAULT 1 NOT NULL,
    priority integer DEFAULT 0 NOT NULL,
    attrs character varying(128) DEFAULT ''::character varying NOT NULL,
    description character varying(64) DEFAULT ''::character varying NOT NULL,
    probe_mode integer DEFAULT 0
);


--
-- Name: dispatcher_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dispatcher_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: dispatcher_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dispatcher_id_seq OWNED BY public.dispatcher.id;


--
-- Name: domain; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.domain (
    id integer NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    attrs character varying(255) DEFAULT NULL::character varying,
    last_modified timestamp without time zone DEFAULT '1900-01-01 00:00:01'::timestamp without time zone NOT NULL
);


--
-- Name: domain_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.domain_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: domain_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.domain_id_seq OWNED BY public.domain.id;


--
-- Name: domainpolicy; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.domainpolicy (
    id integer NOT NULL,
    rule character varying(255) NOT NULL,
    type character varying(255) NOT NULL,
    att character varying(255),
    val character varying(128),
    description character varying(255) NOT NULL
);


--
-- Name: domainpolicy_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.domainpolicy_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: domainpolicy_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.domainpolicy_id_seq OWNED BY public.domainpolicy.id;


--
-- Name: dr_carriers; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dr_carriers (
    id integer NOT NULL,
    carrierid character varying(64) NOT NULL,
    gwlist character varying(255) NOT NULL,
    flags integer DEFAULT 0 NOT NULL,
    state integer DEFAULT 0 NOT NULL,
    attrs character varying(255) DEFAULT NULL::character varying,
    description character varying(128) DEFAULT NULL::character varying
);


--
-- Name: dr_carriers_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dr_carriers_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: dr_carriers_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dr_carriers_id_seq OWNED BY public.dr_carriers.id;


--
-- Name: dr_gateways; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dr_gateways (
    id integer NOT NULL,
    gwid character varying(64) NOT NULL,
    type integer DEFAULT 0 NOT NULL,
    address character varying(128) NOT NULL,
    strip integer DEFAULT 0 NOT NULL,
    pri_prefix character varying(16) DEFAULT NULL::character varying,
    attrs character varying(255) DEFAULT NULL::character varying,
    probe_mode integer DEFAULT 0 NOT NULL,
    state integer DEFAULT 0 NOT NULL,
    socket character varying(128) DEFAULT NULL::character varying,
    description character varying(128) DEFAULT NULL::character varying
);


--
-- Name: dr_gateways_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dr_gateways_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: dr_gateways_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dr_gateways_id_seq OWNED BY public.dr_gateways.id;


--
-- Name: dr_groups; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dr_groups (
    id integer NOT NULL,
    username character varying(64) NOT NULL,
    domain character varying(128) DEFAULT NULL::character varying,
    groupid integer DEFAULT 0 NOT NULL,
    description character varying(128) DEFAULT NULL::character varying
);


--
-- Name: dr_groups_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dr_groups_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: dr_groups_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dr_groups_id_seq OWNED BY public.dr_groups.id;


--
-- Name: dr_partitions; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dr_partitions (
    id integer NOT NULL,
    partition_name character varying(255) NOT NULL,
    db_url character varying(255) NOT NULL,
    drd_table character varying(255),
    drr_table character varying(255),
    drg_table character varying(255),
    drc_table character varying(255),
    ruri_avp character varying(255),
    gw_id_avp character varying(255),
    gw_priprefix_avp character varying(255),
    gw_sock_avp character varying(255),
    rule_id_avp character varying(255),
    rule_prefix_avp character varying(255),
    carrier_id_avp character varying(255)
);


--
-- Name: dr_partitions_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dr_partitions_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: dr_partitions_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dr_partitions_id_seq OWNED BY public.dr_partitions.id;


--
-- Name: dr_rules; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.dr_rules (
    ruleid integer NOT NULL,
    groupid character varying(255) NOT NULL,
    prefix character varying(64) NOT NULL,
    timerec character varying(255) DEFAULT NULL::character varying,
    priority integer DEFAULT 0 NOT NULL,
    routeid character varying(255) DEFAULT NULL::character varying,
    gwlist character varying(255) NOT NULL,
    attrs character varying(255) DEFAULT NULL::character varying,
    description character varying(128) DEFAULT NULL::character varying
);


--
-- Name: dr_rules_ruleid_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.dr_rules_ruleid_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: dr_rules_ruleid_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.dr_rules_ruleid_seq OWNED BY public.dr_rules.ruleid;


--
-- Name: emergency_report; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.emergency_report (
    id integer NOT NULL,
    callid character varying(25) NOT NULL,
    selectiveroutingid character varying(11) NOT NULL,
    routingesn integer DEFAULT 0 NOT NULL,
    npa integer DEFAULT 0 NOT NULL,
    esgwri character varying(50) NOT NULL,
    lro character varying(20) NOT NULL,
    vpc_organizationname character varying(50) NOT NULL,
    vpc_hostname character varying(50) NOT NULL,
    vpc_timestamp character varying(30) NOT NULL,
    result character varying(4) NOT NULL,
    disposition character varying(10) NOT NULL
);


--
-- Name: emergency_report_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.emergency_report_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: emergency_report_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.emergency_report_id_seq OWNED BY public.emergency_report.id;


--
-- Name: emergency_routing; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.emergency_routing (
    id integer NOT NULL,
    selectiveroutingid character varying(11) NOT NULL,
    routingesn integer DEFAULT 0 NOT NULL,
    npa integer DEFAULT 0 NOT NULL,
    esgwri character varying(50) NOT NULL
);


--
-- Name: emergency_routing_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.emergency_routing_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: emergency_routing_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.emergency_routing_id_seq OWNED BY public.emergency_routing.id;


--
-- Name: emergency_service_provider; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.emergency_service_provider (
    id integer NOT NULL,
    organizationname character varying(50) NOT NULL,
    hostid character varying(30) NOT NULL,
    nenaid character varying(50) NOT NULL,
    contact character varying(20) NOT NULL,
    certuri character varying(50) NOT NULL,
    nodeip character varying(20) NOT NULL,
    attribution integer NOT NULL
);


--
-- Name: emergency_service_provider_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.emergency_service_provider_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: emergency_service_provider_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.emergency_service_provider_id_seq OWNED BY public.emergency_service_provider.id;


--
-- Name: fraud_detection; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.fraud_detection (
    ruleid integer NOT NULL,
    profileid integer NOT NULL,
    prefix character varying(64) NOT NULL,
    start_hour character varying(5) NOT NULL,
    end_hour character varying(5) NOT NULL,
    daysoftheweek character varying(64) NOT NULL,
    cpm_warning integer NOT NULL,
    cpm_critical integer NOT NULL,
    call_duration_warning integer NOT NULL,
    call_duration_critical integer NOT NULL,
    total_calls_warning integer NOT NULL,
    total_calls_critical integer NOT NULL,
    concurrent_calls_warning integer NOT NULL,
    concurrent_calls_critical integer NOT NULL,
    sequential_calls_warning integer NOT NULL,
    sequential_calls_critical integer NOT NULL
);


--
-- Name: fraud_detection_ruleid_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.fraud_detection_ruleid_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: fraud_detection_ruleid_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.fraud_detection_ruleid_seq OWNED BY public.fraud_detection.ruleid;


--
-- Name: freeswitch; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.freeswitch (
    id integer NOT NULL,
    username character varying(64),
    password character varying(64) NOT NULL,
    ip character varying(20) NOT NULL,
    port integer DEFAULT 8021 NOT NULL,
    events_csv character varying(255)
);


--
-- Name: freeswitch_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.freeswitch_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: freeswitch_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.freeswitch_id_seq OWNED BY public.freeswitch.id;


--
-- Name: globalblacklist; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.globalblacklist (
    id integer NOT NULL,
    prefix character varying(64) DEFAULT ''::character varying NOT NULL,
    whitelist smallint DEFAULT 0 NOT NULL,
    description character varying(255) DEFAULT NULL::character varying
);


--
-- Name: globalblacklist_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.globalblacklist_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: globalblacklist_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.globalblacklist_id_seq OWNED BY public.globalblacklist.id;


--
-- Name: grp; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.grp (
    id integer NOT NULL,
    username character varying(64) DEFAULT ''::character varying NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    grp character varying(64) DEFAULT ''::character varying NOT NULL,
    last_modified timestamp without time zone DEFAULT '1900-01-01 00:00:01'::timestamp without time zone NOT NULL
);


--
-- Name: grp_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.grp_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: grp_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.grp_id_seq OWNED BY public.grp.id;


--
-- Name: imc_members; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.imc_members (
    id integer NOT NULL,
    username character varying(64) NOT NULL,
    domain character varying(64) NOT NULL,
    room character varying(64) NOT NULL,
    flag integer NOT NULL
);


--
-- Name: imc_members_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.imc_members_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: imc_members_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.imc_members_id_seq OWNED BY public.imc_members.id;


--
-- Name: imc_rooms; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.imc_rooms (
    id integer NOT NULL,
    name character varying(64) NOT NULL,
    domain character varying(64) NOT NULL,
    flag integer NOT NULL
);


--
-- Name: imc_rooms_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.imc_rooms_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: imc_rooms_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.imc_rooms_id_seq OWNED BY public.imc_rooms.id;


--
-- Name: load_balancer; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.load_balancer (
    id integer NOT NULL,
    group_id integer DEFAULT 0 NOT NULL,
    dst_uri character varying(128) NOT NULL,
    resources character varying(255) NOT NULL,
    probe_mode integer DEFAULT 0 NOT NULL,
    description character varying(128) DEFAULT NULL::character varying,
    attrs character varying(255)
);


--
-- Name: load_balancer_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.load_balancer_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: load_balancer_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.load_balancer_id_seq OWNED BY public.load_balancer.id;


--
-- Name: location_contact_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.location_contact_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    MAXVALUE 2147483647
    CACHE 1
    CYCLE;


--
-- Name: location_contact_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.location_contact_id_seq OWNED BY public.location.contact_id;


--
-- Name: log; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.log (
    id integer NOT NULL,
    date timestamp without time zone NOT NULL,
    user_id integer NOT NULL,
    user_ip text NOT NULL,
    record_id bigint NOT NULL,
    new_state jsonb,
    action text NOT NULL,
    config_id integer NOT NULL
);


--
-- Name: log_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.log_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: log_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.log_id_seq OWNED BY public.log.id;


--
-- Name: missed_calls; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.missed_calls (
    id integer NOT NULL,
    method character varying(16) DEFAULT ''::character varying NOT NULL,
    from_tag character varying(64) DEFAULT ''::character varying NOT NULL,
    to_tag character varying(64) DEFAULT ''::character varying NOT NULL,
    callid character varying(64) DEFAULT ''::character varying NOT NULL,
    sip_code character varying(3) DEFAULT ''::character varying NOT NULL,
    sip_reason character varying(32) DEFAULT ''::character varying NOT NULL,
    "time" timestamp without time zone NOT NULL,
    setuptime integer DEFAULT 0 NOT NULL,
    created timestamp without time zone
);


--
-- Name: missed_calls_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.missed_calls_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: missed_calls_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.missed_calls_id_seq OWNED BY public.missed_calls.id;


--
-- Name: presentity; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.presentity (
    id integer NOT NULL,
    username character varying(64) NOT NULL,
    domain character varying(64) NOT NULL,
    event character varying(64) NOT NULL,
    etag character varying(64) NOT NULL,
    expires integer NOT NULL,
    received_time integer NOT NULL,
    body bytea,
    extra_hdrs bytea,
    sender character varying(255) DEFAULT NULL::character varying
);


--
-- Name: presentity_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.presentity_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: presentity_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.presentity_id_seq OWNED BY public.presentity.id;


--
-- Name: pua; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.pua (
    id integer NOT NULL,
    pres_uri character varying(255) NOT NULL,
    pres_id character varying(255) NOT NULL,
    event integer NOT NULL,
    expires integer NOT NULL,
    desired_expires integer NOT NULL,
    flag integer NOT NULL,
    etag character varying(64),
    tuple_id character varying(64),
    watcher_uri character varying(255),
    to_uri character varying(255),
    call_id character varying(64),
    to_tag character varying(64),
    from_tag character varying(64),
    cseq integer,
    record_route text,
    contact character varying(255),
    remote_contact character varying(255),
    version integer,
    extra_headers text
);


--
-- Name: pua_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.pua_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: pua_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.pua_id_seq OWNED BY public.pua.id;


--
-- Name: re_grp; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.re_grp (
    id integer NOT NULL,
    reg_exp character varying(128) DEFAULT ''::character varying NOT NULL,
    group_id integer DEFAULT 0 NOT NULL
);


--
-- Name: re_grp_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.re_grp_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: re_grp_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.re_grp_id_seq OWNED BY public.re_grp.id;


--
-- Name: registrant; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.registrant (
    id integer NOT NULL,
    registrar character varying(255) DEFAULT ''::character varying NOT NULL,
    proxy character varying(255) DEFAULT NULL::character varying,
    aor character varying(255) DEFAULT ''::character varying NOT NULL,
    third_party_registrant character varying(255) DEFAULT NULL::character varying,
    username character varying(64) DEFAULT NULL::character varying,
    password character varying(64) DEFAULT NULL::character varying,
    binding_uri character varying(255) DEFAULT ''::character varying NOT NULL,
    binding_params character varying(64) DEFAULT NULL::character varying,
    expiry integer,
    forced_socket character varying(64) DEFAULT NULL::character varying,
    cluster_shtag character varying(64) DEFAULT NULL::character varying
);


--
-- Name: registrant_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.registrant_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: registrant_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.registrant_id_seq OWNED BY public.registrant.id;


--
-- Name: res; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.res (
    name character varying,
    excepted character varying,
    accept boolean,
    expire boolean
);


--
-- Name: rls_presentity; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rls_presentity (
    id integer NOT NULL,
    rlsubs_did character varying(255) NOT NULL,
    resource_uri character varying(255) NOT NULL,
    content_type character varying(255) NOT NULL,
    presence_state bytea NOT NULL,
    expires integer NOT NULL,
    updated integer NOT NULL,
    auth_state integer NOT NULL,
    reason character varying(64) NOT NULL
);


--
-- Name: rls_presentity_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.rls_presentity_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: rls_presentity_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.rls_presentity_id_seq OWNED BY public.rls_presentity.id;


--
-- Name: rls_watchers; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rls_watchers (
    id integer NOT NULL,
    presentity_uri character varying(255) NOT NULL,
    to_user character varying(64) NOT NULL,
    to_domain character varying(64) NOT NULL,
    watcher_username character varying(64) NOT NULL,
    watcher_domain character varying(64) NOT NULL,
    event character varying(64) DEFAULT 'presence'::character varying NOT NULL,
    event_id character varying(64),
    to_tag character varying(64) NOT NULL,
    from_tag character varying(64) NOT NULL,
    callid character varying(64) NOT NULL,
    local_cseq integer NOT NULL,
    remote_cseq integer NOT NULL,
    contact character varying(64) NOT NULL,
    record_route text,
    expires integer NOT NULL,
    status integer DEFAULT 2 NOT NULL,
    reason character varying(64) NOT NULL,
    version integer DEFAULT 0 NOT NULL,
    socket_info character varying(64) NOT NULL,
    local_contact character varying(255) NOT NULL
);


--
-- Name: rls_watchers_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.rls_watchers_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: rls_watchers_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.rls_watchers_id_seq OWNED BY public.rls_watchers.id;


--
-- Name: route_tree; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.route_tree (
    id integer NOT NULL,
    carrier character varying(64) DEFAULT NULL::character varying
);


--
-- Name: route_tree_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.route_tree_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: route_tree_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.route_tree_id_seq OWNED BY public.route_tree.id;


--
-- Name: rtpengine; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rtpengine (
    id integer NOT NULL,
    socket text NOT NULL,
    set_id integer NOT NULL
);


--
-- Name: rtpengine_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.rtpengine_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: rtpengine_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.rtpengine_id_seq OWNED BY public.rtpengine.id;


--
-- Name: rtpproxy_sockets; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.rtpproxy_sockets (
    id integer NOT NULL,
    rtpproxy_sock text NOT NULL,
    set_id integer NOT NULL
);


--
-- Name: rtpproxy_sockets_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.rtpproxy_sockets_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: rtpproxy_sockets_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.rtpproxy_sockets_id_seq OWNED BY public.rtpproxy_sockets.id;


--
-- Name: silo; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.silo (
    id integer NOT NULL,
    src_addr character varying(255) DEFAULT ''::character varying NOT NULL,
    dst_addr character varying(255) DEFAULT ''::character varying NOT NULL,
    username character varying(64) DEFAULT ''::character varying NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    inc_time integer DEFAULT 0 NOT NULL,
    exp_time integer DEFAULT 0 NOT NULL,
    snd_time integer DEFAULT 0 NOT NULL,
    ctype character varying(255) DEFAULT NULL::character varying,
    body bytea
);


--
-- Name: silo_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.silo_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: silo_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.silo_id_seq OWNED BY public.silo.id;


--
-- Name: sip_address_allow; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW public.sip_address_allow AS
 SELECT srv.id,
    srv.dc,
    srv.name,
    srv.host,
    (uas.ip)::cidr AS cidr,
        CASE
            WHEN (uas.port < 0) THEN ((uas.port)::integer # ('-1'::integer << 16))
            ELSE (uas.port)::integer
        END AS port,
    uas.proto,
    1 AS grp,
    (host(uas.ip))::character varying(50) AS ip,
    (masklen(uas.ip))::smallint AS mask,
    NULL::character varying(64) AS pattern,
    NULL::character varying(32) AS context_info
   FROM (directory.sip_gateway srv
     JOIN directory.sip_gateway_allow uas USING (id))
  WHERE (srv.enable AND (NOT srv.register));


--
-- Name: sip_authentication; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.sip_authentication (
    nonce character varying(255),
    expires bigint,
    profile_name character varying(255),
    hostname character varying(255),
    last_nc integer
);


--
-- Name: sip_dialogs; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.sip_dialogs (
    call_id character varying(255),
    uuid character varying(255),
    sip_to_user character varying(255),
    sip_to_host character varying(255),
    sip_from_user character varying(255),
    sip_from_host character varying(255),
    contact_user character varying(255),
    contact_host character varying(255),
    state character varying(255),
    direction character varying(255),
    user_agent character varying(255),
    profile_name character varying(255),
    hostname character varying(255),
    contact character varying(255),
    presence_id character varying(255),
    presence_data character varying(255),
    call_info character varying(255),
    call_info_state character varying(255) DEFAULT ''::character varying,
    expires bigint DEFAULT 0,
    status character varying(255),
    rpid character varying(255),
    sip_to_tag character varying(255),
    sip_from_tag character varying(255),
    rcd integer DEFAULT 0 NOT NULL
);


--
-- Name: sip_presence; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.sip_presence (
    sip_user character varying(255),
    sip_host character varying(255),
    status character varying(255),
    rpid character varying(255),
    expires bigint,
    user_agent character varying(255),
    profile_name character varying(255),
    hostname character varying(255),
    network_ip character varying(255),
    network_port character varying(6),
    open_closed character varying(255)
);


--
-- Name: sip_registrant; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW public.sip_registrant AS
 SELECT uac.id,
    uac.dc,
    uac.name,
    (COALESCE(uac.registrar, ''::character varying))::character varying(255) AS registrar,
    (NULLIF((uac.proxy)::text, (uac.registrar)::text))::character varying(255) AS proxy,
    (COALESCE(uac.account, ''::character varying))::character varying(255) AS aor,
    NULL::character varying(255) AS third_party_registrant,
    (COALESCE(uac.username, 'anonymous'::character varying))::character varying(64) AS username,
    uac.password,
    (COALESCE(uac.binding_uri, ''::character varying))::character varying(255) AS binding_uri,
    uac.binding_params,
    uac.expires,
    (date_part('epoch'::text, reg.next))::integer AS expiry,
    COALESCE((reg.state)::integer, 0) AS reg_state,
    uac.forced_socket,
    NULL::character varying(64) AS cluster_shtag,
    0 AS status
   FROM (directory.sip_gateway uac
     LEFT JOIN directory.sip_gateway_register reg USING (id))
  WHERE (uac.enable AND uac.register AND (EXISTS ( SELECT true AS bool
           FROM directory.wbt_class c
          WHERE ((c.dc = uac.dc) AND (lower((c.name)::text) = 'gateways'::text) AND (timezone('UTC'::text, now()) >= c.not_before) AND (timezone('UTC'::text, now()) < c.not_after)))));


--
-- Name: sip_shared_appearance_dialogs; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.sip_shared_appearance_dialogs (
    profile_name character varying(255),
    hostname character varying(255),
    contact_str character varying(255),
    call_id character varying(255),
    network_ip character varying(255),
    expires bigint
);


--
-- Name: sip_shared_appearance_subscriptions; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.sip_shared_appearance_subscriptions (
    subscriber character varying(255),
    call_id character varying(255),
    aor character varying(255),
    profile_name character varying(255),
    hostname character varying(255),
    contact_str character varying(255),
    network_ip character varying(255)
);


--
-- Name: sip_subscriber; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW public.sip_subscriber AS
 SELECT auth.dc,
    auth.id AS oid,
    caller.id AS uid,
    lower((realm.name)::text) AS realm,
    auth.account AS auth_id,
        CASE
            WHEN auth.hotdesk THEN auth.account
            ELSE COALESCE(caller.extension, auth.account)
        END AS user_id,
    auth.hotdesk,
    COALESCE(caller.extension, caller.username) AS extension,
    COALESCE(caller.name, (caller.extension)::text, auth.name, (auth.account)::text) AS caller_id_name,
    md5((((((auth.account)::text || ':'::text) || lower((realm.name)::text)) || ':'::text) || auth.password)) AS digest_ha1,
    push.config AS push
   FROM (((directory.wbt_device auth
     JOIN directory.wbt_domain realm ON ((realm.dc = auth.dc)))
     LEFT JOIN directory.wbt_user caller ON (((caller.id = auth.user_id) AND (caller.deleted_at IS NULL) AND (EXISTS ( SELECT true AS bool
           FROM (directory.license lic
             JOIN directory.product prod ON ((lic.serial = prod.pid)))
          WHERE ((lic.user_id = caller.id) AND ('devices'::name = ANY (prod.scope)) AND (prod.not_before <= timezone('UTC'::text, now())) AND (timezone('UTC'::text, now()) < prod.not_after)))))))
     LEFT JOIN LATERAL ( SELECT json_object_agg(pn.typ, pn.key) AS json_object_agg
           FROM ( SELECT (s.props ->> 'pn-type'::text) AS typ,
                    array_agg(DISTINCT (s.props ->> 'pn-rpid'::text)) AS key
                   FROM directory.wbt_session s
                  WHERE ((s.user_id IS NOT NULL) AND (NULLIF((s.props ->> 'pn-rpid'::text), ''::text) IS NOT NULL) AND (s.user_id = caller.id) AND (timezone('UTC'::text, now()) < s.expires))
                  GROUP BY s.user_id, (s.props ->> 'pn-type'::text)) pn) push(config) ON (true))
  WHERE ((auth.deleted_at IS NULL) AND (EXISTS ( SELECT true AS bool
           FROM directory.wbt_class c
          WHERE ((c.dc = auth.dc) AND (lower((c.name)::text) = 'devices'::text) AND (c.not_before <= timezone('UTC'::text, now())) AND (timezone('UTC'::text, now()) < c.not_after)))) AND COALESCE(NULLIF(auth.hotdesk, false), (caller.id IS NOT NULL)));


--
-- Name: sip_subscriptions; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.sip_subscriptions (
    proto character varying(255),
    sip_user character varying(255),
    sip_host character varying(255),
    sub_to_user character varying(255),
    sub_to_host character varying(255),
    presence_hosts character varying(255),
    event character varying(255),
    contact character varying(1024),
    call_id character varying(255),
    full_from character varying(255),
    full_via character varying(255),
    expires bigint,
    user_agent character varying(255),
    accept character varying(255),
    profile_name character varying(255),
    hostname character varying(255),
    network_port character varying(6),
    network_ip character varying(255),
    version integer DEFAULT 0 NOT NULL,
    orig_proto character varying(255),
    full_to character varying(255)
);


--
-- Name: sip_trace; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.sip_trace (
    id integer NOT NULL,
    time_stamp timestamp without time zone DEFAULT '1900-01-01 00:00:01'::timestamp without time zone NOT NULL,
    callid character varying(255) DEFAULT ''::character varying NOT NULL,
    trace_attrs character varying(255) DEFAULT NULL::character varying,
    msg text NOT NULL,
    method character varying(32) DEFAULT ''::character varying NOT NULL,
    status character varying(255) DEFAULT NULL::character varying,
    from_proto character varying(5) NOT NULL,
    from_ip character varying(50) DEFAULT ''::character varying NOT NULL,
    from_port integer NOT NULL,
    to_proto character varying(5) NOT NULL,
    to_ip character varying(50) DEFAULT ''::character varying NOT NULL,
    to_port integer NOT NULL,
    fromtag character varying(64) DEFAULT ''::character varying NOT NULL,
    direction character varying(4) DEFAULT ''::character varying NOT NULL
);


--
-- Name: sip_trace_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.sip_trace_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: sip_trace_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.sip_trace_id_seq OWNED BY public.sip_trace.id;


--
-- Name: speed_dial; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.speed_dial (
    id integer NOT NULL,
    username character varying(64) DEFAULT ''::character varying NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    sd_username character varying(64) DEFAULT ''::character varying NOT NULL,
    sd_domain character varying(64) DEFAULT ''::character varying NOT NULL,
    new_uri character varying(255) DEFAULT ''::character varying NOT NULL,
    fname character varying(64) DEFAULT ''::character varying NOT NULL,
    lname character varying(64) DEFAULT ''::character varying NOT NULL,
    description character varying(64) DEFAULT ''::character varying NOT NULL
);


--
-- Name: speed_dial_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.speed_dial_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: speed_dial_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.speed_dial_id_seq OWNED BY public.speed_dial.id;


--
-- Name: subscriber; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.subscriber (
    id integer NOT NULL,
    username character varying(64) DEFAULT ''::character varying NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    password character varying(25) DEFAULT ''::character varying NOT NULL,
    email_address character varying(64) DEFAULT ''::character varying NOT NULL,
    ha1 character varying(64) DEFAULT ''::character varying NOT NULL,
    ha1b character varying(64) DEFAULT ''::character varying NOT NULL,
    rpid character varying(64) DEFAULT NULL::character varying
);


--
-- Name: subscriber_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.subscriber_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: subscriber_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.subscriber_id_seq OWNED BY public.subscriber.id;


--
-- Name: tls_mgm; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.tls_mgm (
    id integer NOT NULL,
    domain character varying(64) NOT NULL,
    address character varying(64) DEFAULT NULL::character varying,
    type integer DEFAULT 1 NOT NULL,
    method character varying(16) DEFAULT 'SSLv23'::character varying,
    verify_cert integer DEFAULT 1,
    require_cert integer DEFAULT 1,
    certificate bytea,
    private_key bytea,
    crl_check_all integer DEFAULT 0,
    crl_dir character varying(255) DEFAULT NULL::character varying,
    ca_list bytea,
    ca_dir character varying(255) DEFAULT NULL::character varying,
    cipher_list character varying(255) DEFAULT NULL::character varying,
    dh_params bytea,
    ec_curve character varying(255) DEFAULT NULL::character varying
);


--
-- Name: tls_mgm_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.tls_mgm_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: tls_mgm_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.tls_mgm_id_seq OWNED BY public.tls_mgm.id;


--
-- Name: uri; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.uri (
    id integer NOT NULL,
    username character varying(64) DEFAULT ''::character varying NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    uri_user character varying(64) DEFAULT ''::character varying NOT NULL,
    last_modified timestamp without time zone DEFAULT '1900-01-01 00:00:01'::timestamp without time zone NOT NULL
);


--
-- Name: uri_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.uri_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: uri_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.uri_id_seq OWNED BY public.uri.id;


--
-- Name: userblacklist; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.userblacklist (
    id integer NOT NULL,
    username character varying(64) DEFAULT ''::character varying NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    prefix character varying(64) DEFAULT ''::character varying NOT NULL,
    whitelist smallint DEFAULT 0 NOT NULL
);


--
-- Name: userblacklist_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.userblacklist_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: userblacklist_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.userblacklist_id_seq OWNED BY public.userblacklist.id;


--
-- Name: usr_preferences; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.usr_preferences (
    id integer NOT NULL,
    uuid character varying(64) DEFAULT ''::character varying NOT NULL,
    username character varying(64) DEFAULT 0 NOT NULL,
    domain character varying(64) DEFAULT ''::character varying NOT NULL,
    attribute character varying(32) DEFAULT ''::character varying NOT NULL,
    type integer DEFAULT 0 NOT NULL,
    value character varying(128) DEFAULT ''::character varying NOT NULL,
    last_modified timestamp without time zone DEFAULT '1900-01-01 00:00:01'::timestamp without time zone NOT NULL
);


--
-- Name: usr_preferences_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.usr_preferences_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: usr_preferences_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.usr_preferences_id_seq OWNED BY public.usr_preferences.id;


--
-- Name: version; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.version (
    table_name character varying(32) NOT NULL,
    table_version integer DEFAULT 0 NOT NULL
);


--
-- Name: watchers; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.watchers (
    id integer NOT NULL,
    presentity_uri character varying(255) NOT NULL,
    watcher_username character varying(64) NOT NULL,
    watcher_domain character varying(64) NOT NULL,
    event character varying(64) DEFAULT 'presence'::character varying NOT NULL,
    status integer NOT NULL,
    reason character varying(64),
    inserted_time integer NOT NULL
);


--
-- Name: watchers_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.watchers_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: watchers_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.watchers_id_seq OWNED BY public.watchers.id;


--
-- Name: wbt_registrant; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW public.wbt_registrant AS
 SELECT uac.id,
    uac.dc,
    uac.name,
    uac.registrar,
    NULLIF(('sip:'::text || (uac.proxy)::text), (uac.registrar)::text) AS proxy,
    uac.account AS aor,
    NULL::text AS third_party_registrant,
    COALESCE(uac.username, 'anonymous'::character varying) AS username,
    uac.password,
    uac.binding_uri,
    uac.binding_params,
    uac.expires,
    COALESCE((reg.state)::integer, 0) AS state,
    NULL::text AS forced_socket,
    NULL::text AS cluster_shtag
   FROM (directory.sip_gateway uac
     LEFT JOIN directory.sip_gateway_register reg USING (id))
  WHERE (uac.enable AND uac.register);


--
-- Name: wbt_subscriber; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW public.wbt_subscriber AS
 SELECT auth.dc,
    auth.id AS oid,
    caller.id AS uid,
    lower((realm.name)::text) AS realm,
    auth.account AS auth_id,
        CASE
            WHEN auth.hotdesk THEN auth.account
            ELSE COALESCE(caller.extension, auth.account)
        END AS user_id,
    auth.hotdesk,
    COALESCE(caller.extension, caller.username) AS extension,
    COALESCE(display.name, (caller.extension)::text, (auth.account)::text) AS caller_id_name,
    md5((((((auth.account)::text || ':'::text) || lower((realm.name)::text)) || ':'::text) || auth.password)) AS digest_ha1,
    loc.contacts
   FROM ((((directory.wbt_device auth
     JOIN directory.wbt_domain realm USING (dc))
     LEFT JOIN directory.wbt_user caller ON ((auth.user_id = caller.id)))
     LEFT JOIN directory.wbt_auth display ON ((auth.user_id = display.id)))
     CROSS JOIN LATERAL ( SELECT count(c.contact_id) AS contacts
           FROM public.location c
          WHERE ((c.device_id)::bigint = auth.id)) loc)
  WHERE ((auth.deleted_at IS NULL) AND (auth.hotdesk OR (auth.user_id IS NOT NULL)));


--
-- Name: xcap; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.xcap (
    id integer NOT NULL,
    username character varying(64) NOT NULL,
    domain character varying(64) NOT NULL,
    doc bytea NOT NULL,
    doc_type integer NOT NULL,
    etag character varying(64) NOT NULL,
    source integer NOT NULL,
    doc_uri character varying(255) NOT NULL,
    port integer NOT NULL
);


--
-- Name: xcap_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.xcap_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1
    CYCLE;


--
-- Name: xcap_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.xcap_id_seq OWNED BY public.xcap.id;


--
-- Name: cognitive_profile_services; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.cognitive_profile_services (
    id integer NOT NULL,
    domain_id bigint NOT NULL,
    provider character varying(15) NOT NULL,
    properties jsonb NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    updated_at timestamp with time zone DEFAULT now() NOT NULL,
    created_by bigint,
    updated_by bigint,
    enabled boolean DEFAULT true NOT NULL,
    name character varying(50) NOT NULL,
    description character varying DEFAULT ''::character varying,
    service character varying(10) NOT NULL,
    "default" boolean DEFAULT false NOT NULL
);


--
-- Name: cognitive_profile_services_acl; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.cognitive_profile_services_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL,
    object bigint NOT NULL
);


--
-- Name: cognitive_profile_services_acl_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.cognitive_profile_services_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cognitive_profile_services_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.cognitive_profile_services_acl_id_seq OWNED BY storage.cognitive_profile_services_acl.id;


--
-- Name: cognitive_profile_services_view; Type: VIEW; Schema: storage; Owner: -
--

CREATE VIEW storage.cognitive_profile_services_view AS
 SELECT p.id,
    p.domain_id,
    p.provider,
    p.properties,
    p.created_at,
    storage.get_lookup(c.id, (COALESCE(c.name, (c.username)::text))::character varying) AS created_by,
    p.updated_at,
    storage.get_lookup(u.id, (COALESCE(u.name, (u.username)::text))::character varying) AS updated_by,
    p.enabled,
    p.name,
    p.description,
    p.service,
    p."default"
   FROM ((storage.cognitive_profile_services p
     LEFT JOIN directory.wbt_user c ON ((c.id = p.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = p.updated_by)));


--
-- Name: cognitive_profiles_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.cognitive_profiles_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: cognitive_profiles_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.cognitive_profiles_id_seq OWNED BY storage.cognitive_profile_services.id;


--
-- Name: file_backend_profiles; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.file_backend_profiles (
    id bigint NOT NULL,
    name character varying(100) NOT NULL,
    expire_day integer DEFAULT 0 NOT NULL,
    priority integer DEFAULT 0 NOT NULL,
    disabled boolean,
    max_size_mb integer DEFAULT 0 NOT NULL,
    properties jsonb NOT NULL,
    created_at bigint NOT NULL,
    updated_at bigint NOT NULL,
    data_size double precision DEFAULT 0 NOT NULL,
    data_count bigint DEFAULT 0 NOT NULL,
    created_by bigint,
    updated_by bigint,
    domain_id bigint,
    description character varying DEFAULT ''::character varying,
    type character varying(10) NOT NULL
);


--
-- Name: file_backend_profiles_acl; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.file_backend_profiles_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL,
    object bigint NOT NULL
);


--
-- Name: file_backend_profiles_acl_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.file_backend_profiles_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: file_backend_profiles_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.file_backend_profiles_acl_id_seq OWNED BY storage.file_backend_profiles_acl.id;


--
-- Name: file_backend_profiles_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.file_backend_profiles_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: file_backend_profiles_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.file_backend_profiles_id_seq OWNED BY storage.file_backend_profiles.id;


--
-- Name: files_statistics; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.files_statistics (
    id integer NOT NULL,
    domain_id bigint NOT NULL,
    profile_id integer,
    mime_type character varying NOT NULL,
    count bigint DEFAULT 0 NOT NULL,
    size bigint DEFAULT 0 NOT NULL,
    not_exists_count integer DEFAULT 0 NOT NULL
);


--
-- Name: file_backend_profiles_view; Type: VIEW; Schema: storage; Owner: -
--

CREATE VIEW storage.file_backend_profiles_view AS
 SELECT p.id,
    storage.get_lookup(c.id, (c.name)::character varying) AS created_by,
    p.created_at,
    storage.get_lookup(u.id, (u.name)::character varying) AS updated_by,
    p.updated_at,
    p.name,
    p.description,
    p.expire_day AS expire_days,
    p.priority,
    p.disabled,
    p.max_size_mb AS max_size,
    p.properties,
    p.type,
    COALESCE(s.size, (0)::numeric) AS data_size,
    COALESCE(s.cnt, (0)::numeric) AS data_count,
    p.domain_id
   FROM (((storage.file_backend_profiles p
     LEFT JOIN LATERAL ( SELECT sum(s_1.size) AS size,
            sum(s_1.count) AS cnt
           FROM storage.files_statistics s_1
          WHERE (s_1.profile_id = p.id)) s ON (true))
     LEFT JOIN directory.wbt_user c ON ((c.id = p.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = p.updated_by)));


--
-- Name: file_jobs_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.file_jobs_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: file_jobs_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.file_jobs_id_seq OWNED BY storage.file_jobs.id;


--
-- Name: file_transcript_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.file_transcript_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: file_transcript_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.file_transcript_id_seq OWNED BY storage.file_transcript.id;


--
-- Name: files_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.files_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: files_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.files_id_seq OWNED BY storage.files.id;


--
-- Name: files_statistics_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.files_statistics_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: files_statistics_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.files_statistics_id_seq OWNED BY storage.files_statistics.id;


--
-- Name: import_template; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.import_template (
    id integer NOT NULL,
    domain_id bigint NOT NULL,
    name text NOT NULL,
    description text,
    source_type character varying(50) NOT NULL,
    source_id bigint NOT NULL,
    parameters jsonb NOT NULL,
    created_at timestamp with time zone DEFAULT now() NOT NULL,
    created_by bigint,
    updated_at timestamp with time zone DEFAULT now() NOT NULL,
    updated_by bigint
);


--
-- Name: import_template_acl; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.import_template_acl (
    id bigint NOT NULL,
    dc bigint NOT NULL,
    grantor bigint,
    subject bigint NOT NULL,
    access smallint DEFAULT 0 NOT NULL,
    object bigint NOT NULL
);


--
-- Name: import_template_acl_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.import_template_acl_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: import_template_acl_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.import_template_acl_id_seq OWNED BY storage.import_template_acl.id;


--
-- Name: import_template_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.import_template_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: import_template_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.import_template_id_seq OWNED BY storage.import_template.id;


--
-- Name: import_template_view; Type: VIEW; Schema: storage; Owner: -
--

CREATE VIEW storage.import_template_view AS
 SELECT t.id,
    t.name,
    t.description,
    t.source_type,
    t.source_id,
    t.parameters,
    jsonb_build_object('id', s.id, 'name', s.name) AS source,
    t.domain_id,
    t.created_at,
    storage.get_lookup(c.id, (COALESCE(c.name, (c.username)::text))::character varying) AS created_by,
    t.updated_at,
    storage.get_lookup(u.id, (COALESCE(u.name, (u.username)::text))::character varying) AS updated_by
   FROM (((storage.import_template t
     LEFT JOIN directory.wbt_user c ON ((c.id = t.created_by)))
     LEFT JOIN directory.wbt_user u ON ((u.id = t.updated_by)))
     LEFT JOIN LATERAL ( SELECT q.id,
            q.name
           FROM call_center.cc_queue q
          WHERE ((q.id = t.source_id) AND (q.domain_id = t.domain_id))
         LIMIT 1) s ON (true));


--
-- Name: jobs; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.jobs (
    id character varying(26) NOT NULL,
    type character varying(32),
    priority bigint,
    schedule_id bigint,
    schedule_time bigint,
    create_at bigint,
    start_at bigint,
    last_activity_at bigint,
    status character varying(32),
    progress bigint,
    data character varying
);


--
-- Name: media_files_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.media_files_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: media_files_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.media_files_id_seq OWNED BY storage.media_files.id;


--
-- Name: media_files_view; Type: VIEW; Schema: storage; Owner: -
--

CREATE VIEW storage.media_files_view AS
 SELECT f.id,
    f.name,
    f.created_at,
    storage.get_lookup(c.id, (c.name)::character varying) AS created_by,
    f.updated_at,
    storage.get_lookup(u.id, (u.name)::character varying) AS updated_by,
    f.mime_type,
    f.size,
    f.properties,
    f.domain_id
   FROM ((storage.media_files f
     LEFT JOIN directory.wbt_user c ON ((f.created_by = c.id)))
     LEFT JOIN directory.wbt_user u ON ((f.updated_by = u.id)));


--
-- Name: schedulers; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.schedulers (
    id bigint NOT NULL,
    cron_expression character varying(50) NOT NULL,
    type character varying(50) NOT NULL,
    name character varying(50) NOT NULL,
    description character varying(500),
    time_zone character varying(50),
    created_at bigint NOT NULL,
    enabled boolean NOT NULL
);


--
-- Name: schedulers_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.schedulers_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: schedulers_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.schedulers_id_seq OWNED BY storage.schedulers.id;


--
-- Name: upload_file_jobs; Type: TABLE; Schema: storage; Owner: -
--

CREATE TABLE storage.upload_file_jobs (
    id bigint NOT NULL,
    state integer DEFAULT 0 NOT NULL,
    name character varying NOT NULL,
    uuid character varying NOT NULL,
    mime_type character varying,
    size bigint NOT NULL,
    email_msg character varying(500) DEFAULT ''::character varying NOT NULL,
    email_sub character varying(150) DEFAULT ''::character varying NOT NULL,
    instance character varying,
    created_at bigint NOT NULL,
    updated_at bigint,
    attempts integer DEFAULT 0 NOT NULL,
    domain_id bigint NOT NULL,
    view_name character varying,
    props jsonb
);


--
-- Name: upload_file_jobs_id_seq; Type: SEQUENCE; Schema: storage; Owner: -
--

CREATE SEQUENCE storage.upload_file_jobs_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: upload_file_jobs_id_seq; Type: SEQUENCE OWNED BY; Schema: storage; Owner: -
--

ALTER SEQUENCE storage.upload_file_jobs_id_seq OWNED BY storage.upload_file_jobs.id;


--
-- Name: cc_agent id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent ALTER COLUMN id SET DEFAULT nextval('call_center.cc_agent_id_seq'::regclass);


--
-- Name: cc_agent_acl id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_acl ALTER COLUMN id SET DEFAULT nextval('call_center.cc_agent_acl_id_seq'::regclass);


--
-- Name: cc_agent_attempt id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_attempt ALTER COLUMN id SET DEFAULT nextval('call_center.cc_agent_attempt_id_seq'::regclass);


--
-- Name: cc_agent_state_history id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_state_history ALTER COLUMN id SET DEFAULT nextval('call_center.cc_agent_history_id_seq'::regclass);


--
-- Name: cc_agent_status_log id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_status_log ALTER COLUMN id SET DEFAULT nextval('call_center.cc_agent_status_log_id_seq'::regclass);


--
-- Name: cc_audit_form id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form ALTER COLUMN id SET DEFAULT nextval('call_center.cc_audit_form_id_seq'::regclass);


--
-- Name: cc_audit_form_acl id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form_acl ALTER COLUMN id SET DEFAULT nextval('call_center.cc_audit_form_acl_id_seq'::regclass);


--
-- Name: cc_audit_rate id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_rate ALTER COLUMN id SET DEFAULT nextval('call_center.cc_audit_rate_id_seq'::regclass);


--
-- Name: cc_bucket id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket ALTER COLUMN id SET DEFAULT nextval('call_center.cc_bucket_id_seq'::regclass);


--
-- Name: cc_bucket_in_queue id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_in_queue ALTER COLUMN id SET DEFAULT nextval('call_center.cc_bucket_in_queue_id_seq'::regclass);


--
-- Name: cc_calls_annotation id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls_annotation ALTER COLUMN id SET DEFAULT nextval('call_center.cc_call_annotation_id_seq'::regclass);


--
-- Name: cc_calls_transcribe id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls_transcribe ALTER COLUMN id SET DEFAULT nextval('call_center.cc_calls_transcribe_id_seq'::regclass);


--
-- Name: cc_cluster id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_cluster ALTER COLUMN id SET DEFAULT nextval('call_center.cc_cluster_id_seq'::regclass);


--
-- Name: cc_communication id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_communication ALTER COLUMN id SET DEFAULT nextval('call_center.cc_communication_id_seq'::regclass);


--
-- Name: cc_email id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email ALTER COLUMN id SET DEFAULT nextval('call_center.cc_email_id_seq'::regclass);


--
-- Name: cc_email_profile id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email_profile ALTER COLUMN id SET DEFAULT nextval('call_center.cc_email_profiles_id_seq'::regclass);


--
-- Name: cc_list id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list ALTER COLUMN id SET DEFAULT nextval('call_center.cc_call_list_id_seq'::regclass);


--
-- Name: cc_list_acl id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_acl ALTER COLUMN id SET DEFAULT nextval('call_center.cc_list_acl_id_seq'::regclass);


--
-- Name: cc_list_communications id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_communications ALTER COLUMN id SET DEFAULT nextval('call_center.cc_list_communications_id_seq'::regclass);


--
-- Name: cc_member id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member ALTER COLUMN id SET DEFAULT nextval('call_center.cc_member_id_seq'::regclass);


--
-- Name: cc_member_attempt id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_attempt ALTER COLUMN id SET DEFAULT nextval('call_center.cc_member_attempt_id_seq'::regclass);


--
-- Name: cc_member_attempt_transferred id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_attempt_transferred ALTER COLUMN id SET DEFAULT nextval('call_center.cc_attempt_transferred_id_seq'::regclass);


--
-- Name: cc_member_messages id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_messages ALTER COLUMN id SET DEFAULT nextval('call_center.cc_member_messages_id_seq'::regclass);


--
-- Name: cc_notification id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_notification ALTER COLUMN id SET DEFAULT nextval('call_center.cc_notification_id_seq'::regclass);


--
-- Name: cc_outbound_resource id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource ALTER COLUMN id SET DEFAULT nextval('call_center.cc_queue_resource_id_seq'::regclass);


--
-- Name: cc_outbound_resource_acl id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_acl ALTER COLUMN id SET DEFAULT nextval('call_center.cc_outbound_resource_acl_id_seq'::regclass);


--
-- Name: cc_outbound_resource_display id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_display ALTER COLUMN id SET DEFAULT nextval('call_center.cc_outbound_resource_display_id_seq'::regclass);


--
-- Name: cc_outbound_resource_group id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group ALTER COLUMN id SET DEFAULT nextval('call_center.cc_outbound_resource_group_id_seq'::regclass);


--
-- Name: cc_outbound_resource_group_acl id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group_acl ALTER COLUMN id SET DEFAULT nextval('call_center.cc_outbound_resource_group_acl_id_seq'::regclass);


--
-- Name: cc_outbound_resource_in_group id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_in_group ALTER COLUMN id SET DEFAULT nextval('call_center.cc_outbound_resource_in_group_id_seq'::regclass);


--
-- Name: cc_pause_cause id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_pause_cause ALTER COLUMN id SET DEFAULT nextval('call_center.cc_pause_cause_id_seq'::regclass);


--
-- Name: cc_preset_query id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_preset_query ALTER COLUMN id SET DEFAULT nextval('call_center.cc_preset_query_id_seq'::regclass);


--
-- Name: cc_queue id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue ALTER COLUMN id SET DEFAULT nextval('call_center.cc_queue_id_seq'::regclass);


--
-- Name: cc_queue_acl id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_acl ALTER COLUMN id SET DEFAULT nextval('call_center.cc_queue_acl_id_seq'::regclass);


--
-- Name: cc_queue_events id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_events ALTER COLUMN id SET DEFAULT nextval('call_center.cc_queue_events_id_seq'::regclass);


--
-- Name: cc_queue_resource id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_resource ALTER COLUMN id SET DEFAULT nextval('call_center.cc_queue_resource_id_seq1'::regclass);


--
-- Name: cc_queue_skill id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_skill ALTER COLUMN id SET DEFAULT nextval('call_center.cc_queue_skill_id_seq'::regclass);


--
-- Name: cc_skill id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_skill ALTER COLUMN id SET DEFAULT nextval('call_center.cc_skils_id_seq'::regclass);


--
-- Name: cc_skill_in_agent id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_skill_in_agent ALTER COLUMN id SET DEFAULT nextval('call_center.cc_skill_in_agent_id_seq'::regclass);


--
-- Name: cc_team id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team ALTER COLUMN id SET DEFAULT nextval('call_center.cc_team_id_seq'::regclass);


--
-- Name: cc_team_acl id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team_acl ALTER COLUMN id SET DEFAULT nextval('call_center.cc_team_acl_id_seq'::regclass);


--
-- Name: cc_trigger id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger ALTER COLUMN id SET DEFAULT nextval('call_center.cc_trigger_id_seq'::regclass);


--
-- Name: cc_trigger_acl id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_acl ALTER COLUMN id SET DEFAULT nextval('call_center.cc_trigger_acl_id_seq'::regclass);


--
-- Name: cc_trigger_job id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_job ALTER COLUMN id SET DEFAULT nextval('call_center.cc_trigger_job_id_seq'::regclass);


--
-- Name: system_settings id; Type: DEFAULT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.system_settings ALTER COLUMN id SET DEFAULT nextval('call_center.systemc_settings_id_seq'::regclass);


--
-- Name: bot id; Type: DEFAULT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.bot ALTER COLUMN id SET DEFAULT nextval('chat.profile_id_seq'::regclass);


--
-- Name: client id; Type: DEFAULT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.client ALTER COLUMN id SET DEFAULT nextval('chat.client_id_seq'::regclass);


--
-- Name: message id; Type: DEFAULT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.message ALTER COLUMN id SET DEFAULT nextval('chat.message_id_seq'::regclass);


--
-- Name: contact id; Type: DEFAULT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact ALTER COLUMN id SET DEFAULT nextval('contacts.contact_id_seq'::regclass);


--
-- Name: contact_email id; Type: DEFAULT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_email ALTER COLUMN id SET DEFAULT nextval('contacts.contact_email_id_seq'::regclass);


--
-- Name: contact_label id; Type: DEFAULT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_label ALTER COLUMN id SET DEFAULT nextval('contacts.contact_label_id_seq'::regclass);


--
-- Name: contact_manager id; Type: DEFAULT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_manager ALTER COLUMN id SET DEFAULT nextval('contacts.contact_manager_id_seq'::regclass);


--
-- Name: contact_phone id; Type: DEFAULT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_phone ALTER COLUMN id SET DEFAULT nextval('contacts.contact_phone_id_seq'::regclass);


--
-- Name: contact_timezone id; Type: DEFAULT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_timezone ALTER COLUMN id SET DEFAULT nextval('contacts.contact_timezone_id_seq'::regclass);


--
-- Name: contact_variable id; Type: DEFAULT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_variable ALTER COLUMN id SET DEFAULT nextval('contacts.contact_variable_id_seq'::regclass);


--
-- Name: sip_gateway id; Type: DEFAULT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway ALTER COLUMN id SET DEFAULT nextval('directory.sip_gateway_id_seq'::regclass);


--
-- Name: wbt_auth id; Type: DEFAULT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth ALTER COLUMN id SET DEFAULT nextval('directory.wbt_auth_id_seq'::regclass);


--
-- Name: wbt_class id; Type: DEFAULT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_class ALTER COLUMN id SET DEFAULT nextval('directory.wbt_class_id_seq'::regclass);


--
-- Name: wbt_device id; Type: DEFAULT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device ALTER COLUMN id SET DEFAULT nextval('directory.wbt_device_id_seq'::regclass);


--
-- Name: wbt_ldap id; Type: DEFAULT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap ALTER COLUMN id SET DEFAULT nextval('directory.wbt_ldap_id_seq'::regclass);


--
-- Name: wbt_ldap_proc id; Type: DEFAULT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_proc ALTER COLUMN id SET DEFAULT nextval('directory.wbt_ldap_proc_id_seq'::regclass);


--
-- Name: wbt_ldap_tmpl id; Type: DEFAULT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_tmpl ALTER COLUMN id SET DEFAULT nextval('directory.wbt_ldap_tmpl_id_seq'::regclass);


--
-- Name: wbt_oauth_service id; Type: DEFAULT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_oauth_service ALTER COLUMN id SET DEFAULT nextval('directory.wbt_oauth_service_id_seq'::regclass);


--
-- Name: acr_chat_plan id; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_chat_plan ALTER COLUMN id SET DEFAULT nextval('flow.acr_chat_plan_id_seq'::regclass);


--
-- Name: acr_routing_outbound_call id; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_outbound_call ALTER COLUMN id SET DEFAULT nextval('flow.acr_routing_outbound_call_id_seq'::regclass);


--
-- Name: acr_routing_outbound_call pos; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_outbound_call ALTER COLUMN pos SET DEFAULT nextval('flow.acr_routing_outbound_call_pos_seq'::regclass);


--
-- Name: acr_routing_scheme id; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_scheme ALTER COLUMN id SET DEFAULT nextval('flow.acr_routing_scheme_id_seq'::regclass);


--
-- Name: acr_routing_variables id; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_variables ALTER COLUMN id SET DEFAULT nextval('flow.acr_routing_variables_id_seq'::regclass);


--
-- Name: calendar id; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar ALTER COLUMN id SET DEFAULT nextval('flow.calendar_id_seq'::regclass);


--
-- Name: calendar_acl id; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_acl ALTER COLUMN id SET DEFAULT nextval('flow.calendar_acl_id_seq'::regclass);


--
-- Name: calendar_timezones id; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_timezones ALTER COLUMN id SET DEFAULT nextval('flow.calendar_timezones_id_seq'::regclass);


--
-- Name: region id; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.region ALTER COLUMN id SET DEFAULT nextval('flow.region_id_seq'::regclass);


--
-- Name: scheme_log id; Type: DEFAULT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.scheme_log ALTER COLUMN id SET DEFAULT nextval('flow.scheme_log_id_seq'::regclass);


--
-- Name: log id; Type: DEFAULT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.log ALTER COLUMN id SET DEFAULT nextval('logger.log_id_seq'::regclass);


--
-- Name: object_config id; Type: DEFAULT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config ALTER COLUMN id SET DEFAULT nextval('logger.object_config_id_seq'::regclass);


--
-- Name: object_config_acl id; Type: DEFAULT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config_acl ALTER COLUMN id SET DEFAULT nextval('logger.object_config_acl_id_seq'::regclass);


--
-- Name: acc id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.acc ALTER COLUMN id SET DEFAULT nextval('public.acc_id_seq'::regclass);


--
-- Name: active_watchers id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.active_watchers ALTER COLUMN id SET DEFAULT nextval('public.active_watchers_id_seq'::regclass);


--
-- Name: address id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.address ALTER COLUMN id SET DEFAULT nextval('public.address_id_seq'::regclass);


--
-- Name: b2b_entities id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.b2b_entities ALTER COLUMN id SET DEFAULT nextval('public.b2b_entities_id_seq'::regclass);


--
-- Name: b2b_logic id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.b2b_logic ALTER COLUMN id SET DEFAULT nextval('public.b2b_logic_id_seq'::regclass);


--
-- Name: carrierfailureroute id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.carrierfailureroute ALTER COLUMN id SET DEFAULT nextval('public.carrierfailureroute_id_seq'::regclass);


--
-- Name: carrierroute id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.carrierroute ALTER COLUMN id SET DEFAULT nextval('public.carrierroute_id_seq'::regclass);


--
-- Name: cc_agents id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_agents ALTER COLUMN id SET DEFAULT nextval('public.cc_agents_id_seq'::regclass);


--
-- Name: cc_calls id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_calls ALTER COLUMN id SET DEFAULT nextval('public.cc_calls_id_seq'::regclass);


--
-- Name: cc_cdrs id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_cdrs ALTER COLUMN id SET DEFAULT nextval('public.cc_cdrs_id_seq'::regclass);


--
-- Name: cc_flows id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_flows ALTER COLUMN id SET DEFAULT nextval('public.cc_flows_id_seq'::regclass);


--
-- Name: clusterer id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.clusterer ALTER COLUMN id SET DEFAULT nextval('public.clusterer_id_seq'::regclass);


--
-- Name: cpl id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cpl ALTER COLUMN id SET DEFAULT nextval('public.cpl_id_seq'::regclass);


--
-- Name: dbaliases id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dbaliases ALTER COLUMN id SET DEFAULT nextval('public.dbaliases_id_seq'::regclass);


--
-- Name: dialplan id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dialplan ALTER COLUMN id SET DEFAULT nextval('public.dialplan_id_seq'::regclass);


--
-- Name: dispatcher id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dispatcher ALTER COLUMN id SET DEFAULT nextval('public.dispatcher_id_seq'::regclass);


--
-- Name: domain id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.domain ALTER COLUMN id SET DEFAULT nextval('public.domain_id_seq'::regclass);


--
-- Name: domainpolicy id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.domainpolicy ALTER COLUMN id SET DEFAULT nextval('public.domainpolicy_id_seq'::regclass);


--
-- Name: dr_carriers id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_carriers ALTER COLUMN id SET DEFAULT nextval('public.dr_carriers_id_seq'::regclass);


--
-- Name: dr_gateways id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_gateways ALTER COLUMN id SET DEFAULT nextval('public.dr_gateways_id_seq'::regclass);


--
-- Name: dr_groups id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_groups ALTER COLUMN id SET DEFAULT nextval('public.dr_groups_id_seq'::regclass);


--
-- Name: dr_partitions id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_partitions ALTER COLUMN id SET DEFAULT nextval('public.dr_partitions_id_seq'::regclass);


--
-- Name: dr_rules ruleid; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_rules ALTER COLUMN ruleid SET DEFAULT nextval('public.dr_rules_ruleid_seq'::regclass);


--
-- Name: emergency_report id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.emergency_report ALTER COLUMN id SET DEFAULT nextval('public.emergency_report_id_seq'::regclass);


--
-- Name: emergency_routing id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.emergency_routing ALTER COLUMN id SET DEFAULT nextval('public.emergency_routing_id_seq'::regclass);


--
-- Name: emergency_service_provider id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.emergency_service_provider ALTER COLUMN id SET DEFAULT nextval('public.emergency_service_provider_id_seq'::regclass);


--
-- Name: fraud_detection ruleid; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.fraud_detection ALTER COLUMN ruleid SET DEFAULT nextval('public.fraud_detection_ruleid_seq'::regclass);


--
-- Name: freeswitch id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.freeswitch ALTER COLUMN id SET DEFAULT nextval('public.freeswitch_id_seq'::regclass);


--
-- Name: globalblacklist id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.globalblacklist ALTER COLUMN id SET DEFAULT nextval('public.globalblacklist_id_seq'::regclass);


--
-- Name: grp id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.grp ALTER COLUMN id SET DEFAULT nextval('public.grp_id_seq'::regclass);


--
-- Name: imc_members id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.imc_members ALTER COLUMN id SET DEFAULT nextval('public.imc_members_id_seq'::regclass);


--
-- Name: imc_rooms id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.imc_rooms ALTER COLUMN id SET DEFAULT nextval('public.imc_rooms_id_seq'::regclass);


--
-- Name: load_balancer id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.load_balancer ALTER COLUMN id SET DEFAULT nextval('public.load_balancer_id_seq'::regclass);


--
-- Name: location contact_id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.location ALTER COLUMN contact_id SET DEFAULT nextval('public.location_contact_id_seq'::regclass);


--
-- Name: log id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.log ALTER COLUMN id SET DEFAULT nextval('public.log_id_seq'::regclass);


--
-- Name: missed_calls id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.missed_calls ALTER COLUMN id SET DEFAULT nextval('public.missed_calls_id_seq'::regclass);


--
-- Name: presentity id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.presentity ALTER COLUMN id SET DEFAULT nextval('public.presentity_id_seq'::regclass);


--
-- Name: pua id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.pua ALTER COLUMN id SET DEFAULT nextval('public.pua_id_seq'::regclass);


--
-- Name: re_grp id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.re_grp ALTER COLUMN id SET DEFAULT nextval('public.re_grp_id_seq'::regclass);


--
-- Name: registrant id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.registrant ALTER COLUMN id SET DEFAULT nextval('public.registrant_id_seq'::regclass);


--
-- Name: rls_presentity id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rls_presentity ALTER COLUMN id SET DEFAULT nextval('public.rls_presentity_id_seq'::regclass);


--
-- Name: rls_watchers id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rls_watchers ALTER COLUMN id SET DEFAULT nextval('public.rls_watchers_id_seq'::regclass);


--
-- Name: route_tree id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.route_tree ALTER COLUMN id SET DEFAULT nextval('public.route_tree_id_seq'::regclass);


--
-- Name: rtpengine id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rtpengine ALTER COLUMN id SET DEFAULT nextval('public.rtpengine_id_seq'::regclass);


--
-- Name: rtpproxy_sockets id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rtpproxy_sockets ALTER COLUMN id SET DEFAULT nextval('public.rtpproxy_sockets_id_seq'::regclass);


--
-- Name: silo id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.silo ALTER COLUMN id SET DEFAULT nextval('public.silo_id_seq'::regclass);


--
-- Name: sip_trace id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.sip_trace ALTER COLUMN id SET DEFAULT nextval('public.sip_trace_id_seq'::regclass);


--
-- Name: speed_dial id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.speed_dial ALTER COLUMN id SET DEFAULT nextval('public.speed_dial_id_seq'::regclass);


--
-- Name: subscriber id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.subscriber ALTER COLUMN id SET DEFAULT nextval('public.subscriber_id_seq'::regclass);


--
-- Name: tls_mgm id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.tls_mgm ALTER COLUMN id SET DEFAULT nextval('public.tls_mgm_id_seq'::regclass);


--
-- Name: uri id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.uri ALTER COLUMN id SET DEFAULT nextval('public.uri_id_seq'::regclass);


--
-- Name: userblacklist id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.userblacklist ALTER COLUMN id SET DEFAULT nextval('public.userblacklist_id_seq'::regclass);


--
-- Name: usr_preferences id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.usr_preferences ALTER COLUMN id SET DEFAULT nextval('public.usr_preferences_id_seq'::regclass);


--
-- Name: watchers id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.watchers ALTER COLUMN id SET DEFAULT nextval('public.watchers_id_seq'::regclass);


--
-- Name: xcap id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.xcap ALTER COLUMN id SET DEFAULT nextval('public.xcap_id_seq'::regclass);


--
-- Name: cognitive_profile_services id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.cognitive_profile_services ALTER COLUMN id SET DEFAULT nextval('storage.cognitive_profiles_id_seq'::regclass);


--
-- Name: cognitive_profile_services_acl id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.cognitive_profile_services_acl ALTER COLUMN id SET DEFAULT nextval('storage.cognitive_profile_services_acl_id_seq'::regclass);


--
-- Name: file_backend_profiles id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_backend_profiles ALTER COLUMN id SET DEFAULT nextval('storage.file_backend_profiles_id_seq'::regclass);


--
-- Name: file_backend_profiles_acl id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_backend_profiles_acl ALTER COLUMN id SET DEFAULT nextval('storage.file_backend_profiles_acl_id_seq'::regclass);


--
-- Name: file_jobs id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_jobs ALTER COLUMN id SET DEFAULT nextval('storage.file_jobs_id_seq'::regclass);


--
-- Name: file_transcript id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_transcript ALTER COLUMN id SET DEFAULT nextval('storage.file_transcript_id_seq'::regclass);


--
-- Name: files_statistics id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.files_statistics ALTER COLUMN id SET DEFAULT nextval('storage.files_statistics_id_seq'::regclass);


--
-- Name: import_template id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template ALTER COLUMN id SET DEFAULT nextval('storage.import_template_id_seq'::regclass);


--
-- Name: import_template_acl id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template_acl ALTER COLUMN id SET DEFAULT nextval('storage.import_template_acl_id_seq'::regclass);


--
-- Name: media_files id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.media_files ALTER COLUMN id SET DEFAULT nextval('storage.media_files_id_seq'::regclass);


--
-- Name: schedulers id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.schedulers ALTER COLUMN id SET DEFAULT nextval('storage.schedulers_id_seq'::regclass);


--
-- Name: upload_file_jobs id; Type: DEFAULT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.upload_file_jobs ALTER COLUMN id SET DEFAULT nextval('storage.upload_file_jobs_id_seq'::regclass);


--
-- Name: cc_agent_acl cc_agent_acl_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_acl
    ADD CONSTRAINT cc_agent_acl_pk PRIMARY KEY (id);


--
-- Name: cc_agent_attempt cc_agent_attempt_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_attempt
    ADD CONSTRAINT cc_agent_attempt_pk PRIMARY KEY (id);


--
-- Name: cc_agent_channel cc_agent_channel_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_channel
    ADD CONSTRAINT cc_agent_channel_pk PRIMARY KEY (agent_id, channel);


--
-- Name: cc_agent cc_agent_pkey; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent
    ADD CONSTRAINT cc_agent_pkey PRIMARY KEY (id);


--
-- Name: cc_agent_state_history cc_agent_status_history_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_state_history
    ADD CONSTRAINT cc_agent_status_history_pk PRIMARY KEY (id);


--
-- Name: cc_agent_status_log cc_agent_status_log_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_status_log
    ADD CONSTRAINT cc_agent_status_log_pk PRIMARY KEY (agent_id, joined_at);


--
-- Name: cc_pause_cause cc_agent_status_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_pause_cause
    ADD CONSTRAINT cc_agent_status_pk PRIMARY KEY (id);


--
-- Name: cc_member_attempt_transferred cc_attempt_transferred_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_attempt_transferred
    ADD CONSTRAINT cc_attempt_transferred_pk PRIMARY KEY (id);


--
-- Name: cc_audit_form_acl cc_audit_form_acl_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form_acl
    ADD CONSTRAINT cc_audit_form_acl_pk PRIMARY KEY (id);


--
-- Name: cc_audit_form cc_audit_form_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form
    ADD CONSTRAINT cc_audit_form_pk PRIMARY KEY (id);


--
-- Name: cc_audit_rate cc_audit_rate_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_rate
    ADD CONSTRAINT cc_audit_rate_pk PRIMARY KEY (id);


--
-- Name: cc_bucket_in_queue cc_bucket_in_queue_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_in_queue
    ADD CONSTRAINT cc_bucket_in_queue_pk PRIMARY KEY (id);


--
-- Name: cc_bucket cc_bucket_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket
    ADD CONSTRAINT cc_bucket_pk PRIMARY KEY (id);


--
-- Name: cc_calls_annotation cc_call_annotation_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls_annotation
    ADD CONSTRAINT cc_call_annotation_pk PRIMARY KEY (id);


--
-- Name: cc_list cc_call_list_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list
    ADD CONSTRAINT cc_call_list_pk PRIMARY KEY (id);


--
-- Name: cc_calls_history cc_calls_history_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls_history
    ADD CONSTRAINT cc_calls_history_pk PRIMARY KEY (id, domain_id);


--
-- Name: cc_calls cc_calls_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls
    ADD CONSTRAINT cc_calls_pk UNIQUE (id);


--
-- Name: cc_calls_transcribe cc_calls_transcribe_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls_transcribe
    ADD CONSTRAINT cc_calls_transcribe_pk PRIMARY KEY (id);


--
-- Name: cc_cluster cc_cluster_pkey; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_cluster
    ADD CONSTRAINT cc_cluster_pkey PRIMARY KEY (id);


--
-- Name: cc_communication cc_communication_pkey; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_communication
    ADD CONSTRAINT cc_communication_pkey PRIMARY KEY (id);


--
-- Name: cc_email cc_email_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email
    ADD CONSTRAINT cc_email_pk PRIMARY KEY (id);


--
-- Name: cc_email_profile cc_email_profiles_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email_profile
    ADD CONSTRAINT cc_email_profiles_pk PRIMARY KEY (id);


--
-- Name: cc_list_acl cc_list_acl_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_acl
    ADD CONSTRAINT cc_list_acl_pk PRIMARY KEY (id);


--
-- Name: cc_list_communications cc_list_communications_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_communications
    ADD CONSTRAINT cc_list_communications_pk PRIMARY KEY (id);


--
-- Name: cc_list_statistics cc_list_statistics_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_statistics
    ADD CONSTRAINT cc_list_statistics_pk UNIQUE (list_id);


--
-- Name: cc_member_attempt_history cc_member_attempt_history_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_attempt_history
    ADD CONSTRAINT cc_member_attempt_history_pk PRIMARY KEY (id);


--
-- Name: cc_member_attempt cc_member_attempt_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_attempt
    ADD CONSTRAINT cc_member_attempt_pk PRIMARY KEY (id);


--
-- Name: cc_member_messages cc_member_messages_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_messages
    ADD CONSTRAINT cc_member_messages_pk PRIMARY KEY (id);


--
-- Name: cc_member cc_member_pkey; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member
    ADD CONSTRAINT cc_member_pkey PRIMARY KEY (id);


--
-- Name: cc_notification cc_notification_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_notification
    ADD CONSTRAINT cc_notification_pk PRIMARY KEY (id);


--
-- Name: cc_outbound_resource_acl cc_outbound_resource_acl_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_acl
    ADD CONSTRAINT cc_outbound_resource_acl_pk PRIMARY KEY (id);


--
-- Name: cc_outbound_resource_display cc_outbound_resource_display_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_display
    ADD CONSTRAINT cc_outbound_resource_display_pk PRIMARY KEY (id);


--
-- Name: cc_outbound_resource_group_acl cc_outbound_resource_group_acl_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group_acl
    ADD CONSTRAINT cc_outbound_resource_group_acl_pk PRIMARY KEY (id);


--
-- Name: cc_outbound_resource_group cc_outbound_resource_group_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group
    ADD CONSTRAINT cc_outbound_resource_group_pk PRIMARY KEY (id);


--
-- Name: cc_outbound_resource_in_group cc_outbound_resource_in_group_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_in_group
    ADD CONSTRAINT cc_outbound_resource_in_group_pk PRIMARY KEY (id);


--
-- Name: cc_preset_query cc_preset_query_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_preset_query
    ADD CONSTRAINT cc_preset_query_pk PRIMARY KEY (id);


--
-- Name: cc_queue_acl cc_queue_acl_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_acl
    ADD CONSTRAINT cc_queue_acl_pk PRIMARY KEY (id);


--
-- Name: cc_queue_events cc_queue_events_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_events
    ADD CONSTRAINT cc_queue_events_pk PRIMARY KEY (id);


--
-- Name: cc_queue cc_queue_pkey; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_pkey PRIMARY KEY (id);


--
-- Name: cc_queue_resource cc_queue_resource_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_resource
    ADD CONSTRAINT cc_queue_resource_pk PRIMARY KEY (id);


--
-- Name: cc_outbound_resource cc_queue_resource_pkey; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource
    ADD CONSTRAINT cc_queue_resource_pkey PRIMARY KEY (id);


--
-- Name: cc_queue_skill cc_queue_skill_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_skill
    ADD CONSTRAINT cc_queue_skill_pk PRIMARY KEY (id);


--
-- Name: cc_queue_skill_statistics cc_queue_skill_statistics_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_skill_statistics
    ADD CONSTRAINT cc_queue_skill_statistics_pk PRIMARY KEY (queue_id, skill_id);


--
-- Name: cc_queue_statistics cc_queue_statistics_pk_queue_id_bucket_id_skill_id; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_statistics
    ADD CONSTRAINT cc_queue_statistics_pk_queue_id_bucket_id_skill_id UNIQUE (queue_id, bucket_id);


--
-- Name: cc_skill_in_agent cc_skill_in_agent_pkey; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_skill_in_agent
    ADD CONSTRAINT cc_skill_in_agent_pkey PRIMARY KEY (id);


--
-- Name: cc_skill cc_skils_pkey; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_skill
    ADD CONSTRAINT cc_skils_pkey PRIMARY KEY (id);


--
-- Name: cc_team_acl cc_team_acl_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team_acl
    ADD CONSTRAINT cc_team_acl_pk PRIMARY KEY (id);


--
-- Name: cc_team cc_team_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team
    ADD CONSTRAINT cc_team_pk PRIMARY KEY (id);


--
-- Name: cc_trigger_acl cc_trigger_acl_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_acl
    ADD CONSTRAINT cc_trigger_acl_pk PRIMARY KEY (id);


--
-- Name: cc_trigger_job cc_trigger_job_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_job
    ADD CONSTRAINT cc_trigger_job_pk PRIMARY KEY (id);


--
-- Name: cc_trigger cc_trigger_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger
    ADD CONSTRAINT cc_trigger_pk PRIMARY KEY (id);


--
-- Name: system_settings systemc_settings_pk; Type: CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.system_settings
    ADD CONSTRAINT systemc_settings_pk PRIMARY KEY (id);


--
-- Name: bot bot_pk; Type: CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.bot
    ADD CONSTRAINT bot_pk PRIMARY KEY (id);


--
-- Name: channel channel_pk; Type: CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.channel
    ADD CONSTRAINT channel_pk PRIMARY KEY (id);


--
-- Name: client client_pk; Type: CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.client
    ADD CONSTRAINT client_pk PRIMARY KEY (id);


--
-- Name: conversation_confirmation conversation_confirmation_pk; Type: CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.conversation_confirmation
    ADD CONSTRAINT conversation_confirmation_pk PRIMARY KEY (conversation_id);


--
-- Name: conversation_node conversation_node_pk; Type: CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.conversation_node
    ADD CONSTRAINT conversation_node_pk PRIMARY KEY (conversation_id);


--
-- Name: conversation conversation_pk; Type: CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.conversation
    ADD CONSTRAINT conversation_pk PRIMARY KEY (id);


--
-- Name: invite invite_pk; Type: CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.invite
    ADD CONSTRAINT invite_pk PRIMARY KEY (id);


--
-- Name: message message_pk; Type: CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.message
    ADD CONSTRAINT message_pk PRIMARY KEY (id);


--
-- Name: contact_email contact_email_pk; Type: CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_email
    ADD CONSTRAINT contact_email_pk PRIMARY KEY (id);


--
-- Name: contact contact_fk; Type: CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_fk UNIQUE (id, dc);


--
-- Name: contact_label contact_label_pk; Type: CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_label
    ADD CONSTRAINT contact_label_pk PRIMARY KEY (id);


--
-- Name: contact_manager contact_manager_pk; Type: CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_manager
    ADD CONSTRAINT contact_manager_pk PRIMARY KEY (id);


--
-- Name: contact_manager contact_manager_user_uk; Type: CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_manager
    ADD CONSTRAINT contact_manager_user_uk UNIQUE (contact_id, user_id);


--
-- Name: contact_phone contact_phone_pk; Type: CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_phone
    ADD CONSTRAINT contact_phone_pk PRIMARY KEY (id);


--
-- Name: contact contact_pk; Type: CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_pk PRIMARY KEY (id);


--
-- Name: contact_timezone contact_timezone_pk; Type: CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_timezone
    ADD CONSTRAINT contact_timezone_pk PRIMARY KEY (id);


--
-- Name: contact_variable contact_variable_pk; Type: CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_variable
    ADD CONSTRAINT contact_variable_pk PRIMARY KEY (id);


--
-- Name: license license_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.license
    ADD CONSTRAINT license_pk PRIMARY KEY (serial, user_id);


--
-- Name: product product_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.product
    ADD CONSTRAINT product_pk PRIMARY KEY (pid);


--
-- Name: sip_gateway sip_gateway_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway
    ADD CONSTRAINT sip_gateway_pk PRIMARY KEY (id);


--
-- Name: sip_gateway_register sip_gateway_register_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway_register
    ADD CONSTRAINT sip_gateway_register_pk PRIMARY KEY (id);


--
-- Name: wbt_auth_member wbt_auth_member_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth_member
    ADD CONSTRAINT wbt_auth_member_pk PRIMARY KEY (member_id, role_id);


--
-- Name: wbt_auth wbt_auth_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth
    ADD CONSTRAINT wbt_auth_pk PRIMARY KEY (id);


--
-- Name: wbt_user_socket wbt_channel_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_socket
    ADD CONSTRAINT wbt_channel_pk PRIMARY KEY (id);


--
-- Name: wbt_class wbt_class_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_class
    ADD CONSTRAINT wbt_class_pk PRIMARY KEY (id);


--
-- Name: wbt_customer wbt_customer_id_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_customer
    ADD CONSTRAINT wbt_customer_id_pk PRIMARY KEY (id);


--
-- Name: wbt_default_acl wbt_default_acl_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_default_acl
    ADD CONSTRAINT wbt_default_acl_pk PRIMARY KEY (object, grantor, subject);


--
-- Name: wbt_device wbt_device_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_pk PRIMARY KEY (id);


--
-- Name: wbt_device wbt_device_user_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_user_pk UNIQUE (id, user_id, dc);


--
-- Name: wbt_auth wbt_domain_auth_fk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth
    ADD CONSTRAINT wbt_domain_auth_fk UNIQUE (id, dc);


--
-- Name: wbt_domain wbt_domain_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_domain
    ADD CONSTRAINT wbt_domain_pk PRIMARY KEY (dc);


--
-- Name: wbt_ldap wbt_ldap_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap
    ADD CONSTRAINT wbt_ldap_pk PRIMARY KEY (id);


--
-- Name: wbt_ldap_proc wbt_ldap_proc_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_proc
    ADD CONSTRAINT wbt_ldap_proc_pk PRIMARY KEY (id);


--
-- Name: wbt_ldap_tmpl wbt_ldap_tmpl_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_tmpl
    ADD CONSTRAINT wbt_ldap_tmpl_pk PRIMARY KEY (id);


--
-- Name: wbt_oauth_service wbt_oauth_service_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_oauth_service
    ADD CONSTRAINT wbt_oauth_service_pk PRIMARY KEY (id);


--
-- Name: wbt_session wbt_session_token_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_session
    ADD CONSTRAINT wbt_session_token_pk PRIMARY KEY (uuid);


--
-- Name: wbt_user wbt_user_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_pk PRIMARY KEY (id);


--
-- Name: wbt_user_presence wbt_user_presence_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_presence
    ADD CONSTRAINT wbt_user_presence_pk PRIMARY KEY (user_id, status);


--
-- Name: wbt_user_setting wbt_user_setting_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_setting
    ADD CONSTRAINT wbt_user_setting_pk PRIMARY KEY (user_id, name);


--
-- Name: wbt_user_status wbt_user_status_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_status
    ADD CONSTRAINT wbt_user_status_pk PRIMARY KEY (user_id);


--
-- Name: wbt_user_token wbt_user_token_pk; Type: CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_token
    ADD CONSTRAINT wbt_user_token_pk PRIMARY KEY (id);


--
-- Name: acr_chat_plan acr_chat_plan_pk; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_chat_plan
    ADD CONSTRAINT acr_chat_plan_pk PRIMARY KEY (id);


--
-- Name: acr_routing_outbound_call acr_routing_outbound_call_pk; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_outbound_call
    ADD CONSTRAINT acr_routing_outbound_call_pk PRIMARY KEY (id);


--
-- Name: acr_routing_scheme acr_routing_scheme_pk; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_scheme
    ADD CONSTRAINT acr_routing_scheme_pk PRIMARY KEY (id);


--
-- Name: acr_routing_variables acr_routing_variables_pk; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_variables
    ADD CONSTRAINT acr_routing_variables_pk PRIMARY KEY (id);


--
-- Name: calendar_acl calendar_acl_pk; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_acl
    ADD CONSTRAINT calendar_acl_pk PRIMARY KEY (id);


--
-- Name: calendar calendar_pkey; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar
    ADD CONSTRAINT calendar_pkey PRIMARY KEY (id);


--
-- Name: calendar_timezones calendar_timezones_pk; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_timezones
    ADD CONSTRAINT calendar_timezones_pk PRIMARY KEY (name);


--
-- Name: calendar_timezones calendar_timezones_pk_2; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_timezones
    ADD CONSTRAINT calendar_timezones_pk_2 UNIQUE (id);


--
-- Name: region region_pk; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.region
    ADD CONSTRAINT region_pk PRIMARY KEY (id);


--
-- Name: scheme_log scheme_log_pk; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.scheme_log
    ADD CONSTRAINT scheme_log_pk PRIMARY KEY (id);


--
-- Name: web_hook web_hook_pk; Type: CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.web_hook
    ADD CONSTRAINT web_hook_pk PRIMARY KEY (id);


--
-- Name: log log_pkey; Type: CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.log
    ADD CONSTRAINT log_pkey PRIMARY KEY (id);


--
-- Name: object_config_acl object_config_acl_pk; Type: CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config_acl
    ADD CONSTRAINT object_config_acl_pk PRIMARY KEY (id);


--
-- Name: object_config object_config_pk; Type: CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config
    ADD CONSTRAINT object_config_pk UNIQUE (id, domain_id);


--
-- Name: object_config object_config_pk2; Type: CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config
    ADD CONSTRAINT object_config_pk2 UNIQUE (object_id);


--
-- Name: object_config object_config_pkey; Type: CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config
    ADD CONSTRAINT object_config_pkey PRIMARY KEY (id);


--
-- Name: acc acc_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.acc
    ADD CONSTRAINT acc_pkey PRIMARY KEY (id);


--
-- Name: active_watchers active_watchers_active_watchers_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.active_watchers
    ADD CONSTRAINT active_watchers_active_watchers_idx UNIQUE (presentity_uri, callid, to_tag, from_tag);


--
-- Name: active_watchers active_watchers_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.active_watchers
    ADD CONSTRAINT active_watchers_pkey PRIMARY KEY (id);


--
-- Name: address address_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.address
    ADD CONSTRAINT address_pkey PRIMARY KEY (id);


--
-- Name: b2b_entities b2b_entities_b2b_entities_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.b2b_entities
    ADD CONSTRAINT b2b_entities_b2b_entities_idx UNIQUE (type, tag0, tag1, callid);


--
-- Name: b2b_entities b2b_entities_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.b2b_entities
    ADD CONSTRAINT b2b_entities_pkey PRIMARY KEY (id);


--
-- Name: b2b_logic b2b_logic_b2b_logic_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.b2b_logic
    ADD CONSTRAINT b2b_logic_b2b_logic_idx UNIQUE (si_key);


--
-- Name: b2b_logic b2b_logic_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.b2b_logic
    ADD CONSTRAINT b2b_logic_pkey PRIMARY KEY (id);


--
-- Name: cachedb cachedb_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cachedb
    ADD CONSTRAINT cachedb_pkey PRIMARY KEY (keyname);


--
-- Name: carrierfailureroute carrierfailureroute_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.carrierfailureroute
    ADD CONSTRAINT carrierfailureroute_pkey PRIMARY KEY (id);


--
-- Name: carrierroute carrierroute_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.carrierroute
    ADD CONSTRAINT carrierroute_pkey PRIMARY KEY (id);


--
-- Name: cc_agents cc_agents_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_agents
    ADD CONSTRAINT cc_agents_pkey PRIMARY KEY (id);


--
-- Name: cc_agents cc_agents_unique_agentid; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_agents
    ADD CONSTRAINT cc_agents_unique_agentid UNIQUE (agentid);


--
-- Name: cc_calls cc_calls_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_calls
    ADD CONSTRAINT cc_calls_pkey PRIMARY KEY (id);


--
-- Name: cc_calls cc_calls_unique_id; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_calls
    ADD CONSTRAINT cc_calls_unique_id UNIQUE (b2buaid);


--
-- Name: cc_cdrs cc_cdrs_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_cdrs
    ADD CONSTRAINT cc_cdrs_pkey PRIMARY KEY (id);


--
-- Name: cc_flows cc_flows_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_flows
    ADD CONSTRAINT cc_flows_pkey PRIMARY KEY (id);


--
-- Name: cc_flows cc_flows_unique_flowid; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cc_flows
    ADD CONSTRAINT cc_flows_unique_flowid UNIQUE (flowid);


--
-- Name: clusterer clusterer_clusterer_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.clusterer
    ADD CONSTRAINT clusterer_clusterer_idx UNIQUE (cluster_id, node_id);


--
-- Name: clusterer clusterer_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.clusterer
    ADD CONSTRAINT clusterer_pkey PRIMARY KEY (id);


--
-- Name: cpl cpl_account_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cpl
    ADD CONSTRAINT cpl_account_idx UNIQUE (username, domain);


--
-- Name: cpl cpl_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.cpl
    ADD CONSTRAINT cpl_pkey PRIMARY KEY (id);


--
-- Name: dbaliases dbaliases_alias_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dbaliases
    ADD CONSTRAINT dbaliases_alias_idx UNIQUE (alias_username, alias_domain);


--
-- Name: dbaliases dbaliases_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dbaliases
    ADD CONSTRAINT dbaliases_pkey PRIMARY KEY (id);


--
-- Name: dialog dialog_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dialog
    ADD CONSTRAINT dialog_pkey PRIMARY KEY (dlg_id);


--
-- Name: dialplan dialplan_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dialplan
    ADD CONSTRAINT dialplan_pkey PRIMARY KEY (id);


--
-- Name: dispatcher dispatcher_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dispatcher
    ADD CONSTRAINT dispatcher_pkey PRIMARY KEY (id);


--
-- Name: domain domain_domain_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.domain
    ADD CONSTRAINT domain_domain_idx UNIQUE (domain);


--
-- Name: domain domain_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.domain
    ADD CONSTRAINT domain_pkey PRIMARY KEY (id);


--
-- Name: domainpolicy domainpolicy_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.domainpolicy
    ADD CONSTRAINT domainpolicy_pkey PRIMARY KEY (id);


--
-- Name: domainpolicy domainpolicy_rav_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.domainpolicy
    ADD CONSTRAINT domainpolicy_rav_idx UNIQUE (rule, att, val);


--
-- Name: dr_carriers dr_carriers_dr_carrier_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_carriers
    ADD CONSTRAINT dr_carriers_dr_carrier_idx UNIQUE (carrierid);


--
-- Name: dr_carriers dr_carriers_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_carriers
    ADD CONSTRAINT dr_carriers_pkey PRIMARY KEY (id);


--
-- Name: dr_gateways dr_gateways_dr_gw_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_gateways
    ADD CONSTRAINT dr_gateways_dr_gw_idx UNIQUE (gwid);


--
-- Name: dr_gateways dr_gateways_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_gateways
    ADD CONSTRAINT dr_gateways_pkey PRIMARY KEY (id);


--
-- Name: dr_groups dr_groups_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_groups
    ADD CONSTRAINT dr_groups_pkey PRIMARY KEY (id);


--
-- Name: dr_partitions dr_partitions_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_partitions
    ADD CONSTRAINT dr_partitions_pkey PRIMARY KEY (id);


--
-- Name: dr_rules dr_rules_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.dr_rules
    ADD CONSTRAINT dr_rules_pkey PRIMARY KEY (ruleid);


--
-- Name: emergency_report emergency_report_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.emergency_report
    ADD CONSTRAINT emergency_report_pkey PRIMARY KEY (id);


--
-- Name: emergency_routing emergency_routing_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.emergency_routing
    ADD CONSTRAINT emergency_routing_pkey PRIMARY KEY (id);


--
-- Name: emergency_service_provider emergency_service_provider_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.emergency_service_provider
    ADD CONSTRAINT emergency_service_provider_pkey PRIMARY KEY (id);


--
-- Name: fraud_detection fraud_detection_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.fraud_detection
    ADD CONSTRAINT fraud_detection_pkey PRIMARY KEY (ruleid);


--
-- Name: freeswitch freeswitch_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.freeswitch
    ADD CONSTRAINT freeswitch_pkey PRIMARY KEY (id);


--
-- Name: globalblacklist globalblacklist_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.globalblacklist
    ADD CONSTRAINT globalblacklist_pkey PRIMARY KEY (id);


--
-- Name: grp grp_account_group_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.grp
    ADD CONSTRAINT grp_account_group_idx UNIQUE (username, domain, grp);


--
-- Name: grp grp_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.grp
    ADD CONSTRAINT grp_pkey PRIMARY KEY (id);


--
-- Name: imc_members imc_members_account_room_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.imc_members
    ADD CONSTRAINT imc_members_account_room_idx UNIQUE (username, domain, room);


--
-- Name: imc_members imc_members_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.imc_members
    ADD CONSTRAINT imc_members_pkey PRIMARY KEY (id);


--
-- Name: imc_rooms imc_rooms_name_domain_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.imc_rooms
    ADD CONSTRAINT imc_rooms_name_domain_idx UNIQUE (name, domain);


--
-- Name: imc_rooms imc_rooms_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.imc_rooms
    ADD CONSTRAINT imc_rooms_pkey PRIMARY KEY (id);


--
-- Name: load_balancer load_balancer_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.load_balancer
    ADD CONSTRAINT load_balancer_pkey PRIMARY KEY (id);


--
-- Name: location location_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.location
    ADD CONSTRAINT location_pkey PRIMARY KEY (contact_id);


--
-- Name: log log_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.log
    ADD CONSTRAINT log_pkey PRIMARY KEY (id);


--
-- Name: missed_calls missed_calls_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.missed_calls
    ADD CONSTRAINT missed_calls_pkey PRIMARY KEY (id);


--
-- Name: presentity presentity_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.presentity
    ADD CONSTRAINT presentity_pkey PRIMARY KEY (id);


--
-- Name: presentity presentity_presentity_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.presentity
    ADD CONSTRAINT presentity_presentity_idx UNIQUE (username, domain, event, etag);


--
-- Name: pua pua_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.pua
    ADD CONSTRAINT pua_pkey PRIMARY KEY (id);


--
-- Name: re_grp re_grp_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.re_grp
    ADD CONSTRAINT re_grp_pkey PRIMARY KEY (id);


--
-- Name: registrant registrant_aor_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.registrant
    ADD CONSTRAINT registrant_aor_idx UNIQUE (aor);


--
-- Name: registrant registrant_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.registrant
    ADD CONSTRAINT registrant_pkey PRIMARY KEY (id);


--
-- Name: rls_presentity rls_presentity_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rls_presentity
    ADD CONSTRAINT rls_presentity_pkey PRIMARY KEY (id);


--
-- Name: rls_presentity rls_presentity_rls_presentity_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rls_presentity
    ADD CONSTRAINT rls_presentity_rls_presentity_idx UNIQUE (rlsubs_did, resource_uri);


--
-- Name: rls_watchers rls_watchers_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rls_watchers
    ADD CONSTRAINT rls_watchers_pkey PRIMARY KEY (id);


--
-- Name: rls_watchers rls_watchers_rls_watcher_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rls_watchers
    ADD CONSTRAINT rls_watchers_rls_watcher_idx UNIQUE (presentity_uri, callid, to_tag, from_tag);


--
-- Name: route_tree route_tree_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.route_tree
    ADD CONSTRAINT route_tree_pkey PRIMARY KEY (id);


--
-- Name: rtpengine rtpengine_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rtpengine
    ADD CONSTRAINT rtpengine_pkey PRIMARY KEY (id);


--
-- Name: rtpproxy_sockets rtpproxy_sockets_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.rtpproxy_sockets
    ADD CONSTRAINT rtpproxy_sockets_pkey PRIMARY KEY (id);


--
-- Name: silo silo_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.silo
    ADD CONSTRAINT silo_pkey PRIMARY KEY (id);


--
-- Name: sip_trace sip_trace_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.sip_trace
    ADD CONSTRAINT sip_trace_pkey PRIMARY KEY (id);


--
-- Name: speed_dial speed_dial_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.speed_dial
    ADD CONSTRAINT speed_dial_pkey PRIMARY KEY (id);


--
-- Name: speed_dial speed_dial_speed_dial_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.speed_dial
    ADD CONSTRAINT speed_dial_speed_dial_idx UNIQUE (username, domain, sd_domain, sd_username);


--
-- Name: subscriber subscriber_account_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.subscriber
    ADD CONSTRAINT subscriber_account_idx UNIQUE (username, domain);


--
-- Name: subscriber subscriber_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.subscriber
    ADD CONSTRAINT subscriber_pkey PRIMARY KEY (id);


--
-- Name: tls_mgm tls_mgm_domain_type_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.tls_mgm
    ADD CONSTRAINT tls_mgm_domain_type_idx UNIQUE (domain, type);


--
-- Name: tls_mgm tls_mgm_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.tls_mgm
    ADD CONSTRAINT tls_mgm_pkey PRIMARY KEY (id);


--
-- Name: uri uri_account_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.uri
    ADD CONSTRAINT uri_account_idx UNIQUE (username, domain, uri_user);


--
-- Name: uri uri_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.uri
    ADD CONSTRAINT uri_pkey PRIMARY KEY (id);


--
-- Name: userblacklist userblacklist_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.userblacklist
    ADD CONSTRAINT userblacklist_pkey PRIMARY KEY (id);


--
-- Name: usr_preferences usr_preferences_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.usr_preferences
    ADD CONSTRAINT usr_preferences_pkey PRIMARY KEY (id);


--
-- Name: version version_t_name_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.version
    ADD CONSTRAINT version_t_name_idx UNIQUE (table_name);


--
-- Name: watchers watchers_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.watchers
    ADD CONSTRAINT watchers_pkey PRIMARY KEY (id);


--
-- Name: watchers watchers_watcher_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.watchers
    ADD CONSTRAINT watchers_watcher_idx UNIQUE (presentity_uri, watcher_username, watcher_domain, event);


--
-- Name: xcap xcap_account_doc_type_idx; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.xcap
    ADD CONSTRAINT xcap_account_doc_type_idx UNIQUE (username, domain, doc_type, doc_uri);


--
-- Name: xcap xcap_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.xcap
    ADD CONSTRAINT xcap_pkey PRIMARY KEY (id);


--
-- Name: cognitive_profile_services_acl cognitive_profile_services_acl_pk; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.cognitive_profile_services_acl
    ADD CONSTRAINT cognitive_profile_services_acl_pk PRIMARY KEY (id);


--
-- Name: file_backend_profiles_acl file_backend_profiles_acl_pk; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_backend_profiles_acl
    ADD CONSTRAINT file_backend_profiles_acl_pk PRIMARY KEY (id);


--
-- Name: file_backend_profiles file_backend_profiles_pkey; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_backend_profiles
    ADD CONSTRAINT file_backend_profiles_pkey PRIMARY KEY (id);


--
-- Name: file_jobs file_jobs_pkey; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_jobs
    ADD CONSTRAINT file_jobs_pkey PRIMARY KEY (id);


--
-- Name: file_transcript file_transcript_pk; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_transcript
    ADD CONSTRAINT file_transcript_pk PRIMARY KEY (id);


--
-- Name: files files_pkey; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.files
    ADD CONSTRAINT files_pkey PRIMARY KEY (id);


--
-- Name: files_statistics files_statistics_pk; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.files_statistics
    ADD CONSTRAINT files_statistics_pk PRIMARY KEY (id);


--
-- Name: import_template_acl import_template_acl_pk; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template_acl
    ADD CONSTRAINT import_template_acl_pk PRIMARY KEY (id);


--
-- Name: import_template import_template_pk; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template
    ADD CONSTRAINT import_template_pk PRIMARY KEY (id);


--
-- Name: jobs jobs_pkey; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.jobs
    ADD CONSTRAINT jobs_pkey PRIMARY KEY (id);


--
-- Name: media_files media_files_pkey; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.media_files
    ADD CONSTRAINT media_files_pkey PRIMARY KEY (id);


--
-- Name: schedulers schedulers_pkey; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.schedulers
    ADD CONSTRAINT schedulers_pkey PRIMARY KEY (id);


--
-- Name: cognitive_profile_services stt_profiles_pk; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.cognitive_profile_services
    ADD CONSTRAINT stt_profiles_pk PRIMARY KEY (id);


--
-- Name: upload_file_jobs upload_file_jobs_pkey; Type: CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.upload_file_jobs
    ADD CONSTRAINT upload_file_jobs_pkey PRIMARY KEY (id);


--
-- Name: cc_agent_acl_grantor_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_acl_grantor_idx ON call_center.cc_agent_acl USING btree (grantor);


--
-- Name: cc_agent_acl_object_subject_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_agent_acl_object_subject_udx ON call_center.cc_agent_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cc_agent_acl_subject_object_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_agent_acl_subject_object_udx ON call_center.cc_agent_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cc_agent_attempt_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_agent_attempt_id_uindex ON call_center.cc_agent_attempt USING btree (id);


--
-- Name: cc_agent_created_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_created_by_index ON call_center.cc_agent USING btree (created_by);


--
-- Name: cc_agent_domain_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_domain_id_index ON call_center.cc_agent USING btree (domain_id);


--
-- Name: cc_agent_domain_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_agent_domain_udx ON call_center.cc_agent USING btree (id, domain_id);


--
-- Name: cc_agent_state_history_dev_g; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_state_history_dev_g ON call_center.cc_agent_state_history USING btree (agent_id, joined_at DESC) INCLUDE (state, payload) WHERE ((channel IS NULL) AND ((state)::text = ANY (ARRAY[('pause'::character varying)::text, ('online'::character varying)::text, ('offline'::character varying)::text])));


--
-- Name: cc_agent_state_history_joined_at_agent_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_state_history_joined_at_agent_id_index ON call_center.cc_agent_state_history USING btree (channel, joined_at DESC, agent_id, state DESC) INCLUDE (duration);


--
-- Name: cc_agent_state_history_joined_at_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_state_history_joined_at_idx ON call_center.cc_agent_state_history USING btree (joined_at DESC, agent_id DESC) INCLUDE (state, duration);

ALTER TABLE call_center.cc_agent_state_history CLUSTER ON cc_agent_state_history_joined_at_idx;


--
-- Name: cc_agent_status_distribute_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_status_distribute_index ON call_center.cc_agent USING btree (status) INCLUDE (user_id, id);


--
-- Name: cc_agent_status_log_agent_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_status_log_agent_id_index ON call_center.cc_agent_status_log USING btree (agent_id);


--
-- Name: cc_agent_status_log_joined_at_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_status_log_joined_at_index ON call_center.cc_agent_status_log USING btree (joined_at DESC);


--
-- Name: cc_agent_today_pause_cause_agent_uidx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_agent_today_pause_cause_agent_uidx ON call_center.cc_agent_today_pause_cause USING btree (id, today, cause);


--
-- Name: cc_agent_today_stats_usr_uidx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_agent_today_stats_usr_uidx ON call_center.cc_agent_today_stats USING btree (user_id);


--
-- Name: cc_agent_updated_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_agent_updated_by_index ON call_center.cc_agent USING btree (updated_by);


--
-- Name: cc_agent_user_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_agent_user_id_uindex ON call_center.cc_agent USING btree (user_id);


--
-- Name: cc_audit_form_acl_grantor_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_audit_form_acl_grantor_idx ON call_center.cc_audit_form_acl USING btree (grantor);


--
-- Name: cc_audit_form_acl_object_subject_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_audit_form_acl_object_subject_udx ON call_center.cc_audit_form_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cc_audit_form_acl_subject_object_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_audit_form_acl_subject_object_udx ON call_center.cc_audit_form_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cc_audit_form_domain_id_name_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_audit_form_domain_id_name_uindex ON call_center.cc_audit_form USING btree (domain_id, name);


--
-- Name: cc_audit_form_id_domain_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_audit_form_id_domain_id_uindex ON call_center.cc_audit_form USING btree (id, domain_id);


--
-- Name: cc_audit_rate_call_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_audit_rate_call_id_uindex ON call_center.cc_audit_rate USING btree (call_id) WHERE (call_id IS NOT NULL);


--
-- Name: cc_audit_rate_created_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_audit_rate_created_by_index ON call_center.cc_audit_rate USING btree (created_by DESC);


--
-- Name: cc_audit_rate_domain_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_audit_rate_domain_id_index ON call_center.cc_audit_rate USING btree (domain_id);


--
-- Name: cc_audit_rate_form_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_audit_rate_form_id_index ON call_center.cc_audit_rate USING btree (form_id);


--
-- Name: cc_audit_rate_updated_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_audit_rate_updated_by_index ON call_center.cc_audit_rate USING btree (updated_by);


--
-- Name: cc_bucket_acl_grantor_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_bucket_acl_grantor_idx ON call_center.cc_bucket_acl USING btree (grantor);


--
-- Name: cc_bucket_acl_object_subject_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_bucket_acl_object_subject_udx ON call_center.cc_bucket_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cc_bucket_acl_subject_object_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_bucket_acl_subject_object_udx ON call_center.cc_bucket_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cc_bucket_created_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_bucket_created_by_index ON call_center.cc_bucket USING btree (created_by);


--
-- Name: cc_bucket_domain_id_name_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_bucket_domain_id_name_index ON call_center.cc_bucket USING btree (domain_id, name);


--
-- Name: cc_bucket_domain_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_bucket_domain_udx ON call_center.cc_bucket USING btree (id, domain_id);


--
-- Name: cc_bucket_in_queue_bucket_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_bucket_in_queue_bucket_id_index ON call_center.cc_bucket_in_queue USING btree (bucket_id);


--
-- Name: cc_bucket_in_queue_queue_id_bucket_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_bucket_in_queue_queue_id_bucket_id_uindex ON call_center.cc_bucket_in_queue USING btree (queue_id, bucket_id);


--
-- Name: cc_bucket_updated_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_bucket_updated_by_index ON call_center.cc_bucket USING btree (updated_by);


--
-- Name: cc_calls_annotation_call_id_note_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_annotation_call_id_note_index ON call_center.cc_calls_annotation USING btree (call_id, note);


--
-- Name: cc_calls_history_agent_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_agent_id_index ON call_center.cc_calls_history USING btree (agent_id);


--
-- Name: cc_calls_history_agent_ids_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_agent_ids_index ON call_center.cc_calls_history USING gin (agent_ids gin__int_ops) WHERE (agent_ids IS NOT NULL);


--
-- Name: cc_calls_history_amd_result; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_amd_result ON call_center.cc_calls_history USING btree (amd_result) WHERE (amd_result IS NOT NULL);


--
-- Name: cc_calls_history_attempt_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_attempt_id_index ON call_center.cc_calls_history USING btree (attempt_id DESC NULLS LAST);


--
-- Name: cc_calls_history_contact_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_contact_id_index ON call_center.cc_calls_history USING btree (contact_id);


--
-- Name: cc_calls_history_destination_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_destination_idx ON call_center.cc_calls_history USING gin (domain_id, destination gin_trgm_ops);


--
-- Name: cc_calls_history_dev_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_dev_idx ON call_center.cc_calls_history USING btree (hangup_at DESC, parent_id);


--
-- Name: cc_calls_history_direction_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_direction_index ON call_center.cc_calls_history USING btree (direction);


--
-- Name: cc_calls_history_domain_id_created_at_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_domain_id_created_at_index ON call_center.cc_calls_history USING btree (domain_id, created_at DESC);

ALTER TABLE call_center.cc_calls_history CLUSTER ON cc_calls_history_domain_id_created_at_index;


--
-- Name: cc_calls_history_domain_id_store_at_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_domain_id_store_at_index ON call_center.cc_calls_history USING btree (domain_id, stored_at DESC);


--
-- Name: cc_calls_history_from_number_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_from_number_idx ON call_center.cc_calls_history USING gin (domain_id, from_number gin_trgm_ops);


--
-- Name: cc_calls_history_gateway_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_gateway_id_index ON call_center.cc_calls_history USING btree (gateway_id) WHERE (gateway_id IS NOT NULL);


--
-- Name: cc_calls_history_gateway_ids_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_gateway_ids_index ON call_center.cc_calls_history USING gin (((gateway_ids)::integer[]) gin__int_ops) WHERE (gateway_ids IS NOT NULL);


--
-- Name: cc_calls_history_grantee_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_grantee_id_index ON call_center.cc_calls_history USING btree (grantee_id);


--
-- Name: cc_calls_history_mat_view_agent; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_mat_view_agent ON call_center.cc_calls_history USING btree (user_id, domain_id, created_at);


--
-- Name: cc_calls_history_member_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_member_id_index ON call_center.cc_calls_history USING btree (member_id);


--
-- Name: cc_calls_history_parent_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_parent_id_index ON call_center.cc_calls_history USING btree (parent_id);


--
-- Name: cc_calls_history_payload_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_payload_idx ON call_center.cc_calls_history USING gin (domain_id, payload jsonb_path_ops) WHERE (payload IS NOT NULL);


--
-- Name: cc_calls_history_queue_id_dom; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_queue_id_dom ON call_center.cc_calls_history USING btree (domain_id, created_at, user_id, queue_id);


--
-- Name: cc_calls_history_queue_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_queue_id_index ON call_center.cc_calls_history USING btree (queue_id);


--
-- Name: cc_calls_history_queue_ids_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_queue_ids_index ON call_center.cc_calls_history USING gin (queue_ids gin__int_ops) WHERE (queue_ids IS NOT NULL);


drop function if exists call_center.cc_array_to_string;
CREATE OR REPLACE FUNCTION call_center.cc_array_to_string(text[], text)
  RETURNS text LANGUAGE sql IMMUTABLE AS $$SELECT array_to_string($1, $2)$$;

--
-- Name: cc_calls_history_sn_ops_idx; Type: INDEX; Schema: call_center; Owner: -
--

create index cc_calls_history_sn_ops_idx
    on call_center.cc_calls_history using gin (coalesce(search_number, call_center.cc_array_to_string(array[destination, from_number, to_number], '|')) gin_trgm_ops);


--
-- Name: cc_calls_history_team_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_team_id_index ON call_center.cc_calls_history USING btree (team_id);


--
-- Name: cc_calls_history_team_ids_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_team_ids_index ON call_center.cc_calls_history USING gin (team_ids gin__int_ops) WHERE (team_ids IS NOT NULL);


--
-- Name: cc_calls_history_to_number_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_to_number_idx ON call_center.cc_calls_history USING gin (domain_id, to_number gin_trgm_ops);


--
-- Name: cc_calls_history_transfer_from_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_transfer_from_index ON call_center.cc_calls_history USING btree (transfer_from) WHERE (transfer_from IS NOT NULL);


--
-- Name: cc_calls_history_transfer_to_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_transfer_to_index ON call_center.cc_calls_history USING btree (transfer_to) WHERE (transfer_to IS NOT NULL);


--
-- Name: cc_calls_history_user_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_user_id_index ON call_center.cc_calls_history USING btree (user_id);


--
-- Name: cc_calls_history_user_ids_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_user_ids_index ON call_center.cc_calls_history USING gin (((user_ids)::integer[]) gin__int_ops) WHERE (user_ids IS NOT NULL);


--
-- Name: cc_calls_history_user_ids_index3; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_history_user_ids_index3 ON call_center.cc_calls_history USING gin (created_at, ((user_ids)::integer[]));


--
-- Name: cc_calls_transcribe_call_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_transcribe_call_id_index ON call_center.cc_calls_transcribe USING btree (call_id);


--
-- Name: cc_calls_transcribe_created_at_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_calls_transcribe_created_at_index ON call_center.cc_calls_transcribe USING btree (created_at DESC);


--
-- Name: cc_calls_transcribe_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_calls_transcribe_id_uindex ON call_center.cc_calls_transcribe USING btree (id);


--
-- Name: cc_cluster_node_name_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_cluster_node_name_uindex ON call_center.cc_cluster USING btree (node_name);


--
-- Name: cc_communication_domain_id_code_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_communication_domain_id_code_uindex ON call_center.cc_communication USING btree (domain_id, code);


--
-- Name: cc_distribute_stats_uidx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_distribute_stats_uidx ON call_center.cc_distribute_stats USING btree (queue_id, bucket_id);


--
-- Name: cc_email_in_reply_to_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_email_in_reply_to_index ON call_center.cc_email USING btree (in_reply_to) WHERE (in_reply_to IS NOT NULL);


--
-- Name: cc_email_message_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_email_message_id_index ON call_center.cc_email USING btree (message_id);


--
-- Name: cc_email_profile_domain_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_email_profile_domain_id_index ON call_center.cc_email_profile USING btree (domain_id);


--
-- Name: cc_inbound_stats_uidx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_inbound_stats_uidx ON call_center.cc_inbound_stats USING btree (queue_id, bucket_id);


--
-- Name: cc_list_acl_grantor_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_list_acl_grantor_idx ON call_center.cc_list_acl USING btree (grantor);


--
-- Name: cc_list_acl_object_subject_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_list_acl_object_subject_udx ON call_center.cc_list_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cc_list_acl_subject_object_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_list_acl_subject_object_udx ON call_center.cc_list_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cc_list_communications_expire_at_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_list_communications_expire_at_index ON call_center.cc_list_communications USING btree (expire_at) WHERE (expire_at IS NOT NULL);


--
-- Name: cc_list_communications_list_id_number_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_list_communications_list_id_number_uindex ON call_center.cc_list_communications USING btree (list_id, number);


--
-- Name: cc_list_created_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_list_created_by_index ON call_center.cc_list USING btree (created_by);


--
-- Name: cc_list_domain_id_name_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_list_domain_id_name_index ON call_center.cc_list USING btree (domain_id, name);


--
-- Name: cc_list_domain_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_list_domain_udx ON call_center.cc_list USING btree (id, domain_id);


--
-- Name: cc_list_statistics_list_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_list_statistics_list_id_uindex ON call_center.cc_list_statistics USING btree (list_id);


--
-- Name: cc_list_updated_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_list_updated_by_index ON call_center.cc_list USING btree (updated_by);


--
-- Name: cc_member_agent_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_agent_id_index ON call_center.cc_member USING btree (agent_id);


--
-- Name: cc_member_appointments_queue_id_ready; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_appointments_queue_id_ready ON call_center.cc_member USING btree (queue_id, COALESCE(ready_at, created_at)) WHERE (stop_at IS NULL);


--
-- Name: cc_member_attempt_history_agent_call_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_agent_call_id_index ON call_center.cc_member_attempt_history USING btree (agent_call_id);


--
-- Name: cc_member_attempt_history_agent_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_agent_id_index ON call_center.cc_member_attempt_history USING btree (agent_id);


--
-- Name: cc_member_attempt_history_descript_s; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_descript_s ON call_center.cc_member_attempt_history USING btree (id, description) WHERE (description IS NOT NULL);


--
-- Name: cc_member_attempt_history_domain_id_joined_at_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_domain_id_joined_at_index ON call_center.cc_member_attempt_history USING btree (domain_id, joined_at DESC);


--
-- Name: cc_member_attempt_history_domain_id_queue_id_joined_at_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_domain_id_queue_id_joined_at_index ON call_center.cc_member_attempt_history USING btree (domain_id, queue_id, joined_at DESC);


--
-- Name: cc_member_attempt_history_joined_at_agent_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_joined_at_agent_id_index ON call_center.cc_member_attempt_history USING btree (joined_at DESC, agent_id);


--
-- Name: cc_member_attempt_history_mat_view_agent; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_mat_view_agent ON call_center.cc_member_attempt_history USING btree (agent_id, domain_id, joined_at, channel);


--
-- Name: cc_member_attempt_history_member_call_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_member_call_id_index ON call_center.cc_member_attempt_history USING btree (member_call_id);


--
-- Name: cc_member_attempt_history_member_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_member_id_index ON call_center.cc_member_attempt_history USING btree (member_id);


--
-- Name: cc_member_attempt_history_member_id_index_drop; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_member_id_index_drop ON call_center.cc_member_attempt_history USING btree (member_id) WHERE (member_id IS NOT NULL);


--
-- Name: cc_member_attempt_history_parent_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_parent_id_index ON call_center.cc_member_attempt_history USING btree (parent_id) WHERE (parent_id IS NOT NULL);


--
-- Name: cc_member_attempt_history_queue_id_leaving_at_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_history_queue_id_leaving_at_index ON call_center.cc_member_attempt_history USING btree (queue_id, leaving_at DESC);


--
-- Name: cc_member_attempt_member_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_member_id_index ON call_center.cc_member_attempt USING btree (member_id);


--
-- Name: cc_member_attempt_queue_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_attempt_queue_id_index ON call_center.cc_member_attempt USING btree (queue_id);


--
-- Name: cc_member_dis_fifo; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_dis_fifo ON call_center.cc_member USING btree (queue_id, bucket_id, skill_id, agent_id, priority DESC, ready_at, id) INCLUDE (sys_offset_id, sys_destinations, expire_at, search_destinations) WHERE (stop_at IS NULL);


--
-- Name: cc_member_dis_fifo_desc; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_dis_fifo_desc ON call_center.cc_member USING btree (queue_id, bucket_id, skill_id, agent_id, priority DESC, ready_at DESC NULLS LAST, id) INCLUDE (sys_offset_id, sys_destinations, expire_at, search_destinations) WHERE (stop_at IS NULL);


--
-- Name: cc_member_dis_lifo; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_dis_lifo ON call_center.cc_member USING btree (queue_id, bucket_id, skill_id, agent_id, priority DESC, ready_at, id DESC) INCLUDE (sys_offset_id, sys_destinations, expire_at, search_destinations) WHERE (stop_at IS NULL);


--
-- Name: cc_member_dis_lifo_desc; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_dis_lifo_desc ON call_center.cc_member USING btree (queue_id, bucket_id, skill_id, agent_id, priority DESC, ready_at DESC NULLS LAST, id DESC) INCLUDE (sys_offset_id, sys_destinations, expire_at, search_destinations) WHERE (stop_at IS NULL);


--
-- Name: cc_member_dis_strict_fifo_asc; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_dis_strict_fifo_asc ON call_center.cc_member USING btree (queue_id, bucket_id, skill_id, agent_id, attempts, priority DESC, ready_at, id) INCLUDE (sys_offset_id, sys_destinations, expire_at, search_destinations) WHERE (stop_at IS NULL);


--
-- Name: cc_member_distribute_check_sys_offset_id; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_distribute_check_sys_offset_id ON call_center.cc_member USING btree (queue_id, bucket_id, sys_offset_id);


--
-- Name: cc_member_domain_id_search_destinations_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_domain_id_search_destinations_index ON call_center.cc_member USING gin (domain_id, search_destinations);


--
-- Name: cc_member_expire; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_expire ON call_center.cc_member USING btree (expire_at) WHERE ((expire_at IS NOT NULL) AND (stop_at IS NULL));


--
-- Name: cc_member_messages_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_member_messages_id_uindex ON call_center.cc_member_messages USING btree (id);


--
-- Name: cc_member_queue_id_created_at; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_queue_id_created_at ON call_center.cc_member USING btree (queue_id, created_at DESC);


--
-- Name: cc_member_queue_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_queue_id_index ON call_center.cc_member USING btree (queue_id);


--
-- Name: cc_member_search_destination_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_search_destination_idx ON call_center.cc_member USING gin (domain_id, communications jsonb_path_ops);


--
-- Name: cc_member_variable_message_id; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_member_variable_message_id ON call_center.cc_member USING btree (((variables ->> 'message_id'::text))) WHERE ((variables ->> 'message_id'::text) IS NOT NULL);


--
-- Name: cc_outbound_resource_acl_grantor_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_acl_grantor_idx ON call_center.cc_outbound_resource_acl USING btree (grantor);


--
-- Name: cc_outbound_resource_acl_object_subject_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_acl_object_subject_udx ON call_center.cc_outbound_resource_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cc_outbound_resource_acl_subject_object_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_acl_subject_object_udx ON call_center.cc_outbound_resource_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cc_outbound_resource_created_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_created_by_index ON call_center.cc_outbound_resource USING btree (created_by);


--
-- Name: cc_outbound_resource_display_resource_id_display_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_display_resource_id_display_uindex ON call_center.cc_outbound_resource_display USING btree (resource_id, display);


--
-- Name: cc_outbound_resource_display_resource_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_display_resource_id_index ON call_center.cc_outbound_resource_display USING btree (resource_id);


--
-- Name: cc_outbound_resource_domain_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_domain_id_index ON call_center.cc_outbound_resource USING btree (domain_id);


--
-- Name: cc_outbound_resource_domain_id_name_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_domain_id_name_index ON call_center.cc_outbound_resource USING btree (domain_id, name);


--
-- Name: cc_outbound_resource_domain_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_domain_udx ON call_center.cc_outbound_resource USING btree (id, domain_id);


--
-- Name: cc_outbound_resource_gateway_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_gateway_id_index ON call_center.cc_outbound_resource USING btree (gateway_id);


--
-- Name: cc_outbound_resource_group_acl_grantor_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_group_acl_grantor_idx ON call_center.cc_outbound_resource_group_acl USING btree (grantor);


--
-- Name: cc_outbound_resource_group_acl_object_subject_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_group_acl_object_subject_udx ON call_center.cc_outbound_resource_group_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cc_outbound_resource_group_acl_subject_object_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_group_acl_subject_object_udx ON call_center.cc_outbound_resource_group_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cc_outbound_resource_group_communication_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_group_communication_id_index ON call_center.cc_outbound_resource_group USING btree (communication_id);


--
-- Name: cc_outbound_resource_group_created_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_group_created_by_index ON call_center.cc_outbound_resource_group USING btree (created_by);


--
-- Name: cc_outbound_resource_group_distr_res_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_group_distr_res_idx ON call_center.cc_outbound_resource_group USING btree (id, domain_id) INCLUDE (name);


--
-- Name: cc_outbound_resource_group_domain_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_group_domain_id_index ON call_center.cc_outbound_resource_group USING btree (domain_id);


--
-- Name: cc_outbound_resource_group_domain_id_name_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_group_domain_id_name_uindex ON call_center.cc_outbound_resource_group USING btree (domain_id, name);


--
-- Name: cc_outbound_resource_group_domain_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_group_domain_udx ON call_center.cc_outbound_resource_group USING btree (id, domain_id);


--
-- Name: cc_outbound_resource_group_updated_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_group_updated_by_index ON call_center.cc_outbound_resource_group USING btree (updated_by);


--
-- Name: cc_outbound_resource_in_group_group_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_in_group_group_id_index ON call_center.cc_outbound_resource_in_group USING btree (group_id);


--
-- Name: cc_outbound_resource_in_group_reserve_resource_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_in_group_reserve_resource_id_index ON call_center.cc_outbound_resource_in_group USING btree (reserve_resource_id);


--
-- Name: cc_outbound_resource_in_group_resource_id_group_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_outbound_resource_in_group_resource_id_group_id_uindex ON call_center.cc_outbound_resource_in_group USING btree (resource_id, group_id);


--
-- Name: cc_outbound_resource_updated_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_outbound_resource_updated_by_index ON call_center.cc_outbound_resource USING btree (updated_by);


--
-- Name: cc_pause_cause_domain_id_name_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_pause_cause_domain_id_name_uindex ON call_center.cc_pause_cause USING btree (domain_id, name);


--
-- Name: cc_preset_query_user_id_name_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_preset_query_user_id_name_uindex ON call_center.cc_preset_query USING btree (user_id, name);


--
-- Name: cc_queue_acl_grantor_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_queue_acl_grantor_idx ON call_center.cc_queue_acl USING btree (grantor);


--
-- Name: cc_queue_acl_object_subject_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_queue_acl_object_subject_udx ON call_center.cc_queue_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cc_queue_acl_subject_object_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_queue_acl_subject_object_udx ON call_center.cc_queue_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cc_queue_distribute_res_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_queue_distribute_res_idx ON call_center.cc_queue USING btree (domain_id, priority DESC) INCLUDE (id, name, calendar_id, type) WHERE (enabled IS TRUE);


--
-- Name: cc_queue_domain_id_name_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_queue_domain_id_name_index ON call_center.cc_queue USING btree (domain_id, name);


--
-- Name: cc_queue_domain_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_queue_domain_udx ON call_center.cc_queue USING btree (id, domain_id);


--
-- Name: cc_queue_enabled_priority_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_queue_enabled_priority_index ON call_center.cc_queue USING btree (enabled, priority DESC);


--
-- Name: cc_queue_events_queue_id_event_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_queue_events_queue_id_event_uindex ON call_center.cc_queue_events USING btree (queue_id, event) WHERE enabled;


--
-- Name: cc_queue_events_queue_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_queue_events_queue_id_index ON call_center.cc_queue_events USING btree (queue_id);


--
-- Name: cc_queue_events_schema_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_queue_events_schema_id_index ON call_center.cc_queue_events USING btree (schema_id);


--
-- Name: cc_queue_resource_queue_id_resource_group_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_queue_resource_queue_id_resource_group_id_uindex ON call_center.cc_queue_resource USING btree (queue_id, resource_group_id);


--
-- Name: cc_queue_resource_resource_group_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_queue_resource_resource_group_id_index ON call_center.cc_queue_resource USING btree (resource_group_id);


--
-- Name: cc_queue_skill_lvl_queue_id_skill_id_bucket_ids_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_queue_skill_lvl_queue_id_skill_id_bucket_ids_uindex ON call_center.cc_queue_skill USING btree (lvl, queue_id, skill_id, bucket_ids);


--
-- Name: cc_queue_skill_queue_id_skill_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_queue_skill_queue_id_skill_id_index ON call_center.cc_queue_skill USING btree (queue_id) INCLUDE (skill_id, min_capacity, max_capacity) WHERE enabled;


--
-- Name: cc_queue_skill_skill_id_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_queue_skill_skill_id_index ON call_center.cc_queue_skill USING btree (skill_id);


--
-- Name: cc_queue_statistics_queue_id_bucket_id_skill_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_queue_statistics_queue_id_bucket_id_skill_id_uindex ON call_center.cc_queue_statistics USING btree (queue_id, COALESCE(bucket_id, (0)::bigint));


--
-- Name: cc_skill_domain_id_name_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_skill_domain_id_name_index ON call_center.cc_skill USING btree (domain_id, name);


--
-- Name: cc_skill_in_agent_agent_id_capacity_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_skill_in_agent_agent_id_capacity_index ON call_center.cc_skill_in_agent USING btree (agent_id, capacity);


--
-- Name: cc_skill_in_agent_agent_id_skill_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_skill_in_agent_agent_id_skill_id_uindex ON call_center.cc_skill_in_agent USING btree (agent_id, skill_id);


--
-- Name: cc_skill_in_agent_created_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_skill_in_agent_created_by_index ON call_center.cc_skill_in_agent USING btree (created_by);


--
-- Name: cc_skill_in_agent_skill_id_agent_id_capacity_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_skill_in_agent_skill_id_agent_id_capacity_uindex ON call_center.cc_skill_in_agent USING btree (skill_id, capacity DESC, agent_id);


--
-- Name: cc_skill_in_agent_updated_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_skill_in_agent_updated_by_index ON call_center.cc_skill_in_agent USING btree (updated_by);


--
-- Name: cc_stat_agent_awt_dev; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_stat_agent_awt_dev ON call_center.cc_member_attempt_history USING btree (leaving_at DESC, agent_id, queue_id, bucket_id) INCLUDE (bridged_at, joined_at, reporting_at) WHERE ((agent_id IS NOT NULL) AND (bridged_at IS NOT NULL));


--
-- Name: cc_team_acl_grantor_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_team_acl_grantor_idx ON call_center.cc_team_acl USING btree (grantor);


--
-- Name: cc_team_acl_object_subject_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_team_acl_object_subject_udx ON call_center.cc_team_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cc_team_acl_subject_object_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_team_acl_subject_object_udx ON call_center.cc_team_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cc_team_admin_ids_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_team_admin_ids_index ON call_center.cc_team USING gin (admin_ids gin__int_ops);


--
-- Name: cc_team_created_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_team_created_by_index ON call_center.cc_team USING btree (created_by);


--
-- Name: cc_team_domain_id_name_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_team_domain_id_name_index ON call_center.cc_team USING btree (domain_id, name);


--
-- Name: cc_team_domain_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_team_domain_udx ON call_center.cc_team USING btree (id, domain_id);


--
-- Name: cc_team_updated_by_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_team_updated_by_index ON call_center.cc_team USING btree (updated_by);


--
-- Name: cc_trigger_acl_grantor_idx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_trigger_acl_grantor_idx ON call_center.cc_trigger_acl USING btree (grantor);


--
-- Name: cc_trigger_acl_object_subject_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_trigger_acl_object_subject_udx ON call_center.cc_trigger_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cc_trigger_acl_subject_object_udx; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_trigger_acl_subject_object_udx ON call_center.cc_trigger_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cc_trigger_id_domain_id_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX cc_trigger_id_domain_id_uindex ON call_center.cc_trigger USING btree (id, domain_id);


--
-- Name: cc_trigger_job_log_trigger_id_started_at_index; Type: INDEX; Schema: call_center; Owner: -
--

CREATE INDEX cc_trigger_job_log_trigger_id_started_at_index ON call_center.cc_trigger_job_log USING btree (trigger_id, started_at DESC);


--
-- Name: system_settings_domain_id_name_uindex; Type: INDEX; Schema: call_center; Owner: -
--

CREATE UNIQUE INDEX system_settings_domain_id_name_uindex ON call_center.system_settings USING btree (domain_id, name) INCLUDE (value);


--
-- Name: bot_dc; Type: INDEX; Schema: chat; Owner: -
--

CREATE UNIQUE INDEX bot_dc ON chat.bot USING btree (id) INCLUDE (dc);


--
-- Name: bot_uri_uindex; Type: INDEX; Schema: chat; Owner: -
--

CREATE UNIQUE INDEX bot_uri_uindex ON chat.bot USING btree (uri);


--
-- Name: channel_conversation_id_index; Type: INDEX; Schema: chat; Owner: -
--

CREATE INDEX channel_conversation_id_index ON chat.channel USING btree (conversation_id);


--
-- Name: channel_conversation_id_user_id_type_uindex; Type: INDEX; Schema: chat; Owner: -
--

CREATE UNIQUE INDEX channel_conversation_id_user_id_type_uindex ON chat.channel USING btree (conversation_id, user_id, type) WHERE (closed_at IS NULL);


--
-- Name: channel_user_id_conversation_id_uindex; Type: INDEX; Schema: chat; Owner: -
--

CREATE INDEX channel_user_id_conversation_id_uindex ON chat.channel USING btree (user_id, closed_at DESC);


--
-- Name: channel_user_id_index; Type: INDEX; Schema: chat; Owner: -
--

CREATE INDEX channel_user_id_index ON chat.channel USING btree (user_id, internal) INCLUDE (closed_at);


--
-- Name: conversation_domain_id_created_at_index; Type: INDEX; Schema: chat; Owner: -
--

CREATE INDEX conversation_domain_id_created_at_index ON chat.conversation USING btree (domain_id, created_at) WHERE (closed_at IS NULL);


--
-- Name: invite_conversation_id_user_id_uindex; Type: INDEX; Schema: chat; Owner: -
--

CREATE UNIQUE INDEX invite_conversation_id_user_id_uindex ON chat.invite USING btree (conversation_id, user_id) WHERE (closed_at IS NULL);


--
-- Name: message_conversation_id_created_at_index; Type: INDEX; Schema: chat; Owner: -
--

CREATE INDEX message_conversation_id_created_at_index ON chat.message USING btree (conversation_id, created_at DESC);


--
-- Name: message_sender_index; Type: INDEX; Schema: chat; Owner: -
--

CREATE INDEX message_sender_index ON chat.message USING btree (COALESCE(channel_id, conversation_id)) INCLUDE (created_at);


--
-- Name: contact_acl_grantor_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_acl_grantor_index ON contacts.contact_acl USING btree (grantor);


--
-- Name: contact_acl_object_subject_pk; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_acl_object_subject_pk ON contacts.contact_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: contact_acl_subject_object_uindex; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_acl_subject_object_uindex ON contacts.contact_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: contact_dc; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_dc ON contacts.contact USING btree (dc);


--
-- Name: contact_email_address_unique; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_email_address_unique ON contacts.contact_email USING btree (email, contact_id);


--
-- Name: contact_email_primary_unique; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_email_primary_unique ON contacts.contact_email USING btree (contact_id) WHERE "primary";


--
-- Name: contact_email_search_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_email_search_index ON contacts.contact_email USING btree (dc) INCLUDE (email);


--
-- Name: contact_email_source_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_email_source_index ON contacts.contact_email USING btree (contact_id);


--
-- Name: contact_label_search_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_label_search_index ON contacts.contact_label USING btree (dc) INCLUDE (label);


--
-- Name: contact_label_source_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_label_source_index ON contacts.contact_label USING btree (contact_id);


--
-- Name: contact_label_tag_unique; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_label_tag_unique ON contacts.contact_label USING btree (contact_id, label);


--
-- Name: contact_manager_primary_unique; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_manager_primary_unique ON contacts.contact_manager USING btree (contact_id) WHERE "primary";


--
-- Name: contact_manager_search_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_manager_search_index ON contacts.contact_manager USING btree (dc) INCLUDE (user_id);


--
-- Name: contact_manager_source_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_manager_source_index ON contacts.contact_manager USING btree (contact_id);


--
-- Name: contact_manager_user_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_manager_user_index ON contacts.contact_manager USING btree (user_id) INCLUDE (dc);


--
-- Name: contact_phone_number_unique; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_phone_number_unique ON contacts.contact_phone USING btree (digits, contact_id);


--
-- Name: contact_phone_primary_unique; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_phone_primary_unique ON contacts.contact_phone USING btree (contact_id) WHERE "primary";


--
-- Name: contact_phone_search_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_phone_search_index ON contacts.contact_phone USING btree (dc) INCLUDE (digits);


--
-- Name: contact_phone_source_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_phone_source_index ON contacts.contact_phone USING btree (contact_id);


--
-- Name: contact_timezone_primary_unique; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_timezone_primary_unique ON contacts.contact_timezone USING btree (contact_id) WHERE "primary";


--
-- Name: contact_timezone_search_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_timezone_search_index ON contacts.contact_timezone USING btree (dc) INCLUDE (zone_name);


--
-- Name: contact_timezone_source_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_timezone_source_index ON contacts.contact_timezone USING btree (contact_id);


--
-- Name: contact_timezone_unique; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_timezone_unique ON contacts.contact_timezone USING btree (contact_id, timezone_id);


--
-- Name: contact_variable_key_unique; Type: INDEX; Schema: contacts; Owner: -
--

CREATE UNIQUE INDEX contact_variable_key_unique ON contacts.contact_variable USING btree (contact_id, key);


--
-- Name: contact_variable_search_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_variable_search_index ON contacts.contact_variable USING btree (dc) INCLUDE (key, value);


--
-- Name: contact_variable_source_index; Type: INDEX; Schema: contacts; Owner: -
--

CREATE INDEX contact_variable_source_index ON contacts.contact_variable USING btree (contact_id);


--
-- Name: hotdesk_dc_name_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX hotdesk_dc_name_uindex ON directory.wbt_hotdesk USING btree (dc, lower((name)::text));


--
-- Name: hotdesk_device_id_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX hotdesk_device_id_index ON directory.wbt_hotdesk USING btree (device_id);


--
-- Name: license_user_id_serial_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX license_user_id_serial_index ON directory.license USING btree (user_id) INCLUDE (serial);


--
-- Name: license_user_serial_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX license_user_serial_uindex ON directory.license USING btree (user_id, serial);


--
-- Name: product_cid_idx; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX product_cid_idx ON directory.product USING btree (cid);


--
-- Name: sip_gateway_allow_inet_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX sip_gateway_allow_inet_uindex ON directory.sip_gateway_allow USING btree (id, ip, port, proto);


--
-- Name: sip_gateway_dc_udx; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX sip_gateway_dc_udx ON directory.sip_gateway USING btree (id, dc);


--
-- Name: sip_gateway_register_state_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX sip_gateway_register_state_index ON directory.sip_gateway_register USING btree (id, state);


--
-- Name: sip_proxy_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX sip_proxy_uindex ON directory.sip_gateway USING btree (host, proxy) WHERE (NOT register);


--
-- Name: sip_registrant_aor_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX sip_registrant_aor_uindex ON directory.sip_gateway USING btree (account) WHERE register;


--
-- Name: wbt_auth_acl_grantor_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_auth_acl_grantor_index ON directory.wbt_auth_acl USING btree (grantor);


--
-- Name: wbt_auth_acl_object_subject_pkx; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_auth_acl_object_subject_pkx ON directory.wbt_auth_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: wbt_auth_acl_subject_object_udx; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_auth_acl_subject_object_udx ON directory.wbt_auth_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: wbt_class_acl_grantor_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_class_acl_grantor_index ON directory.wbt_class_acl USING btree (grantor);


--
-- Name: wbt_class_acl_object_subject_pk; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_class_acl_object_subject_pk ON directory.wbt_class_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: wbt_class_acl_subject_object_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_class_acl_subject_object_uindex ON directory.wbt_class_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: wbt_class_dcx; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_class_dcx ON directory.wbt_class USING btree (id, dc);


--
-- Name: wbt_dc_domain_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_dc_domain_index ON directory.wbt_domain USING btree (dc, name);


--
-- Name: wbt_device_acl_grantor_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_device_acl_grantor_index ON directory.wbt_device_acl USING btree (grantor);


--
-- Name: wbt_device_acl_object_subject_pk; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_device_acl_object_subject_pk ON directory.wbt_device_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: wbt_device_acl_subject_object_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_device_acl_subject_object_uindex ON directory.wbt_device_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: wbt_device_audit_device_idx; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_device_audit_device_idx ON directory.wbt_device_audit USING btree (device_id);


--
-- Name: wbt_device_audit_udx; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_device_audit_udx ON directory.wbt_device_audit USING btree (device_id, user_id, logged_in);


--
-- Name: wbt_device_audit_user_idx; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_device_audit_user_idx ON directory.wbt_device_audit USING btree (user_id);


--
-- Name: wbt_device_dc_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_device_dc_uindex ON directory.wbt_device USING btree (id, dc);


--
-- Name: wbt_device_id_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_device_id_uindex ON directory.wbt_device USING btree (lower((account)::text), dc);


--
-- Name: wbt_device_ip_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_device_ip_uindex ON directory.wbt_device USING btree (ip, dc) WHERE (ip IS NOT NULL);


--
-- Name: wbt_device_mac_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_device_mac_uindex ON directory.wbt_device USING btree (mac, dc) WHERE (mac IS NOT NULL);


--
-- Name: wbt_device_user_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_device_user_index ON directory.wbt_device USING btree (user_id) WHERE (user_id IS NOT NULL);


--
-- Name: wbt_domain_auth_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_domain_auth_uindex ON directory.wbt_auth USING btree (lower((auth)::text), dc);


--
-- Name: wbt_domain_class_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_domain_class_uindex ON directory.wbt_class USING btree (dc, lower((name)::text)) INCLUDE (not_before, not_after);


--
-- Name: wbt_domain_dc_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_domain_dc_index ON directory.wbt_domain USING btree (name, dc);


--
-- Name: wbt_domain_name_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_domain_name_uindex ON directory.wbt_domain USING btree (lower((name)::text));


--
-- Name: wbt_domain_tel_number_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_domain_tel_number_uindex ON directory.wbt_auth USING btree (dc, tel_number) WHERE (tel_number IS NOT NULL);


--
-- Name: wbt_ldap_dc; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_ldap_dc ON directory.wbt_ldap USING btree (dc, id);


--
-- Name: wbt_ldap_proc_catalog_id_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_ldap_proc_catalog_id_uindex ON directory.wbt_ldap_proc USING btree (catalog_id, id);


--
-- Name: wbt_ldap_sync_objentry_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_ldap_sync_objentry_uindex ON directory.wbt_ldap_sync USING btree (process_id, template_id, entry_uuid, objclass);


--
-- Name: wbt_ldap_sync_process_id_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_ldap_sync_process_id_index ON directory.wbt_ldap_sync USING btree (process_id, template_id);


--
-- Name: wbt_ldap_tmpl_catalog_id_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_ldap_tmpl_catalog_id_uindex ON directory.wbt_ldap_tmpl USING btree (catalog_id, id);


--
-- Name: wbt_ldap_tmpl_search_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_ldap_tmpl_search_uindex ON directory.wbt_ldap_tmpl USING btree (catalog_id, base_dn, search);


--
-- Name: wbt_oauth_service_client_id_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_oauth_service_client_id_uindex ON directory.wbt_oauth_service USING btree (client_id);


--
-- Name: wbt_oauth_service_dc_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_oauth_service_dc_index ON directory.wbt_oauth_service USING btree (dc);


--
-- Name: wbt_oauth_service_discovery_url_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_oauth_service_discovery_url_uindex ON directory.wbt_oauth_service USING btree (discovery_url, dc) WHERE (discovery_url IS NOT NULL);


--
-- Name: wbt_role_member_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_role_member_uindex ON directory.wbt_auth_member USING btree (role_id, member_id);


--
-- Name: wbt_session_access_token_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_session_access_token_uindex ON directory.wbt_session USING btree (access) WHERE (access IS NOT NULL);


--
-- Name: wbt_session_code_token_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_session_code_token_uindex ON directory.wbt_session USING btree (code) WHERE (code IS NOT NULL);


--
-- Name: wbt_session_refresh_token_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_session_refresh_token_uindex ON directory.wbt_session USING btree (refresh) WHERE (refresh IS NOT NULL);


--
-- Name: wbt_session_sub_push; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_session_sub_push ON directory.wbt_session USING btree (user_id, ((props ->> 'pn-type'::text)), ((props ->> 'pn-rpid'::text))) INCLUDE (expires) WHERE ((user_id IS NOT NULL) AND (NULLIF((props ->> 'pn-rpid'::text), ''::text) IS NOT NULL));


--
-- Name: wbt_session_user_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_session_user_index ON directory.wbt_session USING btree (user_id) INCLUDE (expires);


--
-- Name: wbt_user_dc_udx; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_user_dc_udx ON directory.wbt_user USING btree (id, dc);


--
-- Name: wbt_user_dc_username_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_user_dc_username_uindex ON directory.wbt_user USING btree (dc, lower((username)::text));


--
-- Name: wbt_user_email_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_user_email_uindex ON directory.wbt_user USING btree (lower((email)::text));


--
-- Name: wbt_user_extension_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_user_extension_uindex ON directory.wbt_user USING btree (dc, extension) WHERE (extension IS NOT NULL);


--
-- Name: wbt_user_id_enabled_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_user_id_enabled_uindex ON directory.wbt_user USING btree (id) WHERE (deleted_at IS NULL);


--
-- Name: wbt_user_id_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_user_id_uindex ON directory.wbt_user USING btree (lower((username)::text), dc);


--
-- Name: wbt_user_setting_user_id_index; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_user_setting_user_id_index ON directory.wbt_user_setting USING btree (user_id);


--
-- Name: wbt_user_socket_socket_uindex; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_user_socket_socket_uindex ON directory.wbt_user_socket USING btree (socket);


--
-- Name: wbt_user_token_domain_id_idx; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_user_token_domain_id_idx ON directory.wbt_user_token USING btree (dc);


--
-- Name: wbt_user_token_udx; Type: INDEX; Schema: directory; Owner: -
--

CREATE UNIQUE INDEX wbt_user_token_udx ON directory.wbt_user_token USING btree (token);


--
-- Name: wbt_user_token_user_id_idx; Type: INDEX; Schema: directory; Owner: -
--

CREATE INDEX wbt_user_token_user_id_idx ON directory.wbt_user_token USING btree (user_id);


--
-- Name: acr_chat_plan_domain_id_name_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX acr_chat_plan_domain_id_name_uindex ON flow.acr_chat_plan USING btree (domain_id, name);


--
-- Name: acr_routing_outbound_call_created_by_index; Type: INDEX; Schema: flow; Owner: -
--

CREATE INDEX acr_routing_outbound_call_created_by_index ON flow.acr_routing_outbound_call USING btree (created_by);


--
-- Name: acr_routing_outbound_call_domain_id_name_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX acr_routing_outbound_call_domain_id_name_uindex ON flow.acr_routing_outbound_call USING btree (domain_id, name);


--
-- Name: acr_routing_outbound_call_pattern; Type: INDEX; Schema: flow; Owner: -
--

CREATE INDEX acr_routing_outbound_call_pattern ON flow.acr_routing_outbound_call USING btree (domain_id, pos DESC, id, name, pattern, scheme_id) WHERE (NOT disabled);


--
-- Name: acr_routing_outbound_call_updated_by_index; Type: INDEX; Schema: flow; Owner: -
--

CREATE INDEX acr_routing_outbound_call_updated_by_index ON flow.acr_routing_outbound_call USING btree (updated_by);


--
-- Name: acr_routing_scheme_created_by_index; Type: INDEX; Schema: flow; Owner: -
--

CREATE INDEX acr_routing_scheme_created_by_index ON flow.acr_routing_scheme USING btree (created_by);


--
-- Name: acr_routing_scheme_domain_id_name_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX acr_routing_scheme_domain_id_name_uindex ON flow.acr_routing_scheme USING btree (domain_id, name);


--
-- Name: acr_routing_scheme_domain_id_udx; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX acr_routing_scheme_domain_id_udx ON flow.acr_routing_scheme USING btree (id, domain_id);


--
-- Name: acr_routing_scheme_updated_by_index; Type: INDEX; Schema: flow; Owner: -
--

CREATE INDEX acr_routing_scheme_updated_by_index ON flow.acr_routing_scheme USING btree (updated_by);


--
-- Name: acr_routing_variables_domain_id_key_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX acr_routing_variables_domain_id_key_uindex ON flow.acr_routing_variables USING btree (domain_id, key);


--
-- Name: calendar_acl_grantor_idx; Type: INDEX; Schema: flow; Owner: -
--

CREATE INDEX calendar_acl_grantor_idx ON flow.calendar_acl USING btree (grantor);


--
-- Name: calendar_acl_object_subject_udx; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX calendar_acl_object_subject_udx ON flow.calendar_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: calendar_acl_subject_object_udx; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX calendar_acl_subject_object_udx ON flow.calendar_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: calendar_created_by_index; Type: INDEX; Schema: flow; Owner: -
--

CREATE INDEX calendar_created_by_index ON flow.calendar USING btree (created_by);


--
-- Name: calendar_domain_id_name_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX calendar_domain_id_name_uindex ON flow.calendar USING btree (domain_id, name);


--
-- Name: calendar_domain_udx; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX calendar_domain_udx ON flow.calendar USING btree (id, domain_id);


--
-- Name: calendar_timezone_offsets_id_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX calendar_timezone_offsets_id_uindex ON flow.calendar_timezone_offsets USING btree (id);


--
-- Name: calendar_timezones_id_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX calendar_timezones_id_uindex ON flow.calendar_timezones USING btree (id);


--
-- Name: calendar_timezones_name_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX calendar_timezones_name_uindex ON flow.calendar_timezones USING btree (name);


--
-- Name: calendar_timezones_sys_name_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX calendar_timezones_sys_name_uindex ON flow.calendar_timezones USING btree (sys_name);


--
-- Name: calendar_timezones_utc_offset_index; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX calendar_timezones_utc_offset_index ON flow.calendar_timezones USING btree (id, utc_offset, name);


--
-- Name: calendar_updated_by_index; Type: INDEX; Schema: flow; Owner: -
--

CREATE INDEX calendar_updated_by_index ON flow.calendar USING btree (updated_by);


--
-- Name: region_domain_id_name_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX region_domain_id_name_uindex ON flow.region USING btree (domain_id, name);


--
-- Name: scheme_log_conn_id_uindex; Type: INDEX; Schema: flow; Owner: -
--

CREATE UNIQUE INDEX scheme_log_conn_id_uindex ON flow.scheme_log USING btree (conn_id);


--
-- Name: log_config_id_index; Type: INDEX; Schema: logger; Owner: -
--

CREATE INDEX log_config_id_index ON logger.log USING btree (config_id);


--
-- Name: log_date_index; Type: INDEX; Schema: logger; Owner: -
--

CREATE INDEX log_date_index ON logger.log USING btree (date);


--
-- Name: log_user_id_index; Type: INDEX; Schema: logger; Owner: -
--

CREATE INDEX log_user_id_index ON logger.log USING btree (user_id);


--
-- Name: object_config_acl_grantor_idx; Type: INDEX; Schema: logger; Owner: -
--

CREATE INDEX object_config_acl_grantor_idx ON logger.object_config_acl USING btree (grantor);


--
-- Name: object_config_acl_object_subject_udx; Type: INDEX; Schema: logger; Owner: -
--

CREATE UNIQUE INDEX object_config_acl_object_subject_udx ON logger.object_config_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: object_config_acl_subject_object_udx; Type: INDEX; Schema: logger; Owner: -
--

CREATE UNIQUE INDEX object_config_acl_subject_object_udx ON logger.object_config_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: object_config_id_uindex; Type: INDEX; Schema: logger; Owner: -
--

CREATE UNIQUE INDEX object_config_id_uindex ON logger.object_config USING btree (id);


--
-- Name: object_config_object_id_domain_id_uindex; Type: INDEX; Schema: logger; Owner: -
--

CREATE UNIQUE INDEX object_config_object_id_domain_id_uindex ON logger.object_config USING btree (object_id, domain_id);


--
-- Name: acc_callid_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX acc_callid_idx ON public.acc USING btree (callid);


--
-- Name: b2b_entities_b2b_entities_param; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX b2b_entities_b2b_entities_param ON public.b2b_entities USING btree (param);


--
-- Name: cc_calls_b2buaid_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX cc_calls_b2buaid_idx ON public.cc_calls USING btree (b2buaid);


--
-- Name: dbaliases_target_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX dbaliases_target_idx ON public.dbaliases USING btree (username, domain);


--
-- Name: domain_id_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX domain_id_uindex ON public.domain USING btree (id);


--
-- Name: domainpolicy_rule_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX domainpolicy_rule_idx ON public.domainpolicy USING btree (rule);


--
-- Name: globalblacklist_globalblacklist_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX globalblacklist_globalblacklist_idx ON public.globalblacklist USING btree (prefix);


--
-- Name: load_balancer_dsturi_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX load_balancer_dsturi_idx ON public.load_balancer USING btree (dst_uri);


--
-- Name: location_device_id_index; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX location_device_id_index ON public.location USING btree (device_id);


--
-- Name: log_config_id_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX log_config_id_uindex ON public.log USING btree (config_id);


--
-- Name: log_user_id_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX log_user_id_uindex ON public.log USING btree (user_id);


--
-- Name: missed_calls_callid_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX missed_calls_callid_idx ON public.missed_calls USING btree (callid);


--
-- Name: pua_del1_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX pua_del1_idx ON public.pua USING btree (pres_uri, event);


--
-- Name: pua_del2_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX pua_del2_idx ON public.pua USING btree (expires);


--
-- Name: pua_update_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX pua_update_idx ON public.pua USING btree (pres_uri, pres_id, flag, event);


--
-- Name: re_grp_group_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX re_grp_group_idx ON public.re_grp USING btree (group_id);


--
-- Name: rls_presentity_updated_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX rls_presentity_updated_idx ON public.rls_presentity USING btree (updated);


--
-- Name: sa_expires; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sa_expires ON public.sip_authentication USING btree (expires);


--
-- Name: sa_hostname; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sa_hostname ON public.sip_authentication USING btree (hostname);


--
-- Name: sa_last_nc; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sa_last_nc ON public.sip_authentication USING btree (last_nc);


--
-- Name: sa_nonce; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sa_nonce ON public.sip_authentication USING btree (nonce);


--
-- Name: sd_call_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_call_id ON public.sip_dialogs USING btree (call_id);


--
-- Name: sd_call_info; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_call_info ON public.sip_dialogs USING btree (call_info);


--
-- Name: sd_call_info_state; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_call_info_state ON public.sip_dialogs USING btree (call_info_state);


--
-- Name: sd_expires; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_expires ON public.sip_dialogs USING btree (expires);


--
-- Name: sd_hostname; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_hostname ON public.sip_dialogs USING btree (hostname);


--
-- Name: sd_presence_data; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_presence_data ON public.sip_dialogs USING btree (presence_data);


--
-- Name: sd_presence_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_presence_id ON public.sip_dialogs USING btree (presence_id);


--
-- Name: sd_rcd; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_rcd ON public.sip_dialogs USING btree (rcd);


--
-- Name: sd_sip_from_host; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_sip_from_host ON public.sip_dialogs USING btree (sip_from_host);


--
-- Name: sd_sip_from_tag; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_sip_from_tag ON public.sip_dialogs USING btree (sip_from_tag);


--
-- Name: sd_sip_from_user; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_sip_from_user ON public.sip_dialogs USING btree (sip_from_user);


--
-- Name: sd_sip_to_host; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_sip_to_host ON public.sip_dialogs USING btree (sip_to_host);


--
-- Name: sd_sip_to_tag; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_sip_to_tag ON public.sip_dialogs USING btree (sip_to_tag);


--
-- Name: sd_uuid; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sd_uuid ON public.sip_dialogs USING btree (uuid);


--
-- Name: silo_account_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX silo_account_idx ON public.silo USING btree (username, domain);


--
-- Name: sip_trace_callid_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sip_trace_callid_idx ON public.sip_trace USING btree (callid);


--
-- Name: sip_trace_date_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sip_trace_date_idx ON public.sip_trace USING btree (time_stamp);


--
-- Name: sip_trace_fromip_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sip_trace_fromip_idx ON public.sip_trace USING btree (from_ip);


--
-- Name: sip_trace_trace_attrs_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sip_trace_trace_attrs_idx ON public.sip_trace USING btree (trace_attrs);


--
-- Name: sp_expires; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sp_expires ON public.sip_presence USING btree (expires);


--
-- Name: sp_hostname; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sp_hostname ON public.sip_presence USING btree (hostname);


--
-- Name: sp_open_closed; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sp_open_closed ON public.sip_presence USING btree (open_closed);


--
-- Name: sp_profile_name; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sp_profile_name ON public.sip_presence USING btree (profile_name);


--
-- Name: sp_sip_host; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sp_sip_host ON public.sip_presence USING btree (sip_host);


--
-- Name: sp_sip_user; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX sp_sip_user ON public.sip_presence USING btree (sip_user);


--
-- Name: ss_call_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_call_id ON public.sip_subscriptions USING btree (call_id);


--
-- Name: ss_contact; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_contact ON public.sip_subscriptions USING btree (contact);


--
-- Name: ss_event; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_event ON public.sip_subscriptions USING btree (event);


--
-- Name: ss_expires; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_expires ON public.sip_subscriptions USING btree (expires);


--
-- Name: ss_full_from; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_full_from ON public.sip_subscriptions USING btree (full_from);


--
-- Name: ss_hostname; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_hostname ON public.sip_subscriptions USING btree (hostname);


--
-- Name: ss_multi; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_multi ON public.sip_subscriptions USING btree (call_id, profile_name, hostname);


--
-- Name: ss_network_ip; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_network_ip ON public.sip_subscriptions USING btree (network_ip);


--
-- Name: ss_network_port; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_network_port ON public.sip_subscriptions USING btree (network_port);


--
-- Name: ss_orig_proto; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_orig_proto ON public.sip_subscriptions USING btree (orig_proto);


--
-- Name: ss_presence_hosts; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_presence_hosts ON public.sip_subscriptions USING btree (presence_hosts);


--
-- Name: ss_profile_name; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_profile_name ON public.sip_subscriptions USING btree (profile_name);


--
-- Name: ss_proto; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_proto ON public.sip_subscriptions USING btree (proto);


--
-- Name: ss_sip_host; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_sip_host ON public.sip_subscriptions USING btree (sip_host);


--
-- Name: ss_sip_user; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_sip_user ON public.sip_subscriptions USING btree (sip_user);


--
-- Name: ss_sub_to_host; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_sub_to_host ON public.sip_subscriptions USING btree (sub_to_host);


--
-- Name: ss_sub_to_user; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_sub_to_user ON public.sip_subscriptions USING btree (sub_to_user);


--
-- Name: ss_version; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ss_version ON public.sip_subscriptions USING btree (version);


--
-- Name: ssa_aor; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssa_aor ON public.sip_shared_appearance_subscriptions USING btree (aor);


--
-- Name: ssa_hostname; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssa_hostname ON public.sip_shared_appearance_subscriptions USING btree (hostname);


--
-- Name: ssa_network_ip; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssa_network_ip ON public.sip_shared_appearance_subscriptions USING btree (network_ip);


--
-- Name: ssa_profile_name; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssa_profile_name ON public.sip_shared_appearance_subscriptions USING btree (profile_name);


--
-- Name: ssa_subscriber; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssa_subscriber ON public.sip_shared_appearance_subscriptions USING btree (subscriber);


--
-- Name: ssd_call_id; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssd_call_id ON public.sip_shared_appearance_dialogs USING btree (call_id);


--
-- Name: ssd_contact_str; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssd_contact_str ON public.sip_shared_appearance_dialogs USING btree (contact_str);


--
-- Name: ssd_expires; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssd_expires ON public.sip_shared_appearance_dialogs USING btree (expires);


--
-- Name: ssd_hostname; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssd_hostname ON public.sip_shared_appearance_dialogs USING btree (hostname);


--
-- Name: ssd_profile_name; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX ssd_profile_name ON public.sip_shared_appearance_dialogs USING btree (profile_name);


--
-- Name: subscriber_username_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX subscriber_username_idx ON public.subscriber USING btree (username);


--
-- Name: userblacklist_userblacklist_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX userblacklist_userblacklist_idx ON public.userblacklist USING btree (username, domain, prefix);


--
-- Name: usr_preferences_ua_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX usr_preferences_ua_idx ON public.usr_preferences USING btree (uuid, attribute);


--
-- Name: usr_preferences_uda_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX usr_preferences_uda_idx ON public.usr_preferences USING btree (username, domain, attribute);


--
-- Name: usr_preferences_value_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX usr_preferences_value_idx ON public.usr_preferences USING btree (value);


--
-- Name: xcap_source_idx; Type: INDEX; Schema: public; Owner: -
--

CREATE INDEX xcap_source_idx ON public.xcap USING btree (source);


--
-- Name: cognitive_profile_services_acl_grantor_idx; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX cognitive_profile_services_acl_grantor_idx ON storage.cognitive_profile_services_acl USING btree (grantor);


--
-- Name: cognitive_profile_services_acl_id_uindex; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX cognitive_profile_services_acl_id_uindex ON storage.cognitive_profile_services_acl USING btree (id);


--
-- Name: cognitive_profile_services_acl_object_subject_udx; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX cognitive_profile_services_acl_object_subject_udx ON storage.cognitive_profile_services_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: cognitive_profile_services_acl_subject_object_udx; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX cognitive_profile_services_acl_subject_object_udx ON storage.cognitive_profile_services_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: cognitive_profile_services_domain_udx; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX cognitive_profile_services_domain_udx ON storage.cognitive_profile_services USING btree (id, domain_id DESC);


--
-- Name: file_backend_profiles_acl_grantor_idx; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX file_backend_profiles_acl_grantor_idx ON storage.file_backend_profiles_acl USING btree (grantor);


--
-- Name: file_backend_profiles_acl_id_uindex; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX file_backend_profiles_acl_id_uindex ON storage.file_backend_profiles_acl USING btree (id);


--
-- Name: file_backend_profiles_acl_object_subject_udx; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX file_backend_profiles_acl_object_subject_udx ON storage.file_backend_profiles_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: file_backend_profiles_acl_subject_object_udx; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX file_backend_profiles_acl_subject_object_udx ON storage.file_backend_profiles_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: file_backend_profiles_domain_udx; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX file_backend_profiles_domain_udx ON storage.file_backend_profiles USING btree (id, domain_id);


--
-- Name: file_jobs_file_id_uindex; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX file_jobs_file_id_uindex ON storage.file_jobs USING btree (file_id);


--
-- Name: file_transcript_file_id_profile_id_locale_uindex; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX file_transcript_file_id_profile_id_locale_uindex ON storage.file_transcript USING btree (file_id, profile_id, locale);


--
-- Name: file_transcript_fts_idx; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX file_transcript_fts_idx ON storage.file_transcript USING gin (setweight(to_tsvector('english'::regconfig, transcript), 'A'::"char"));


--
-- Name: file_transcript_fts_ru_idx; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX file_transcript_fts_ru_idx ON storage.file_transcript USING gin (setweight(to_tsvector('russian'::regconfig, transcript), 'A'::"char"));


--
-- Name: file_transcript_profile_id_index; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX file_transcript_profile_id_index ON storage.file_transcript USING btree (profile_id);


--
-- Name: file_transcript_uuid_index; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX file_transcript_uuid_index ON storage.file_transcript USING btree (((uuid)::character varying(50)));


--
-- Name: files_created_at_index; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX files_created_at_index ON storage.files USING btree (created_at) INCLUDE (profile_id, id);


--
-- Name: files_created_at_not_removed_index; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX files_created_at_not_removed_index ON storage.files USING btree (created_at) INCLUDE (id) WHERE removed;


--
-- Name: files_created_at_removed_index; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX files_created_at_removed_index ON storage.files USING btree (created_at) INCLUDE (id) WHERE removed;


--
-- Name: files_domain_id_uuid_index; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX files_domain_id_uuid_index ON storage.files USING btree (domain_id, uuid);


--
-- Name: files_profile_id_created_at_index; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX files_profile_id_created_at_index ON storage.files USING btree (created_at, COALESCE(profile_id, 0)) INCLUDE (id);


--
-- Name: files_statistics_domain_id_profile_id_mime_type_uindex; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX files_statistics_domain_id_profile_id_mime_type_uindex ON storage.files_statistics USING btree (domain_id, COALESCE(profile_id, 0), mime_type);


--
-- Name: files_statistics_id_uindex; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX files_statistics_id_uindex ON storage.files_statistics USING btree (id);


--
-- Name: import_template_acl_grantor_idx; Type: INDEX; Schema: storage; Owner: -
--

CREATE INDEX import_template_acl_grantor_idx ON storage.import_template_acl USING btree (grantor);


--
-- Name: import_template_acl_object_subject_udx; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX import_template_acl_object_subject_udx ON storage.import_template_acl USING btree (object, subject) INCLUDE (access);


--
-- Name: import_template_acl_subject_object_udx; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX import_template_acl_subject_object_udx ON storage.import_template_acl USING btree (subject, object) INCLUDE (access);


--
-- Name: import_template_id_domain_id_uindex; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX import_template_id_domain_id_uindex ON storage.import_template USING btree (id, domain_id);


--
-- Name: media_files_domain_id_name_uindex; Type: INDEX; Schema: storage; Owner: -
--

CREATE UNIQUE INDEX media_files_domain_id_name_uindex ON storage.media_files USING btree (domain_id, name);


--
-- Name: cc_calls_history_domain_created_user_ids_st; Type: STATISTICS; Schema: call_center; Owner: -
--

CREATE STATISTICS call_center.cc_calls_history_domain_created_user_ids_st ON domain_id, created_at, user_ids FROM call_center.cc_calls_history;


--
-- Name: cc_calls_history_user_id_st; Type: STATISTICS; Schema: call_center; Owner: -
--

CREATE STATISTICS call_center.cc_calls_history_user_id_st ON domain_id, user_id, created_at FROM call_center.cc_calls_history;


--
-- Name: cc_calls_history_user_ids_st; Type: STATISTICS; Schema: call_center; Owner: -
--

CREATE STATISTICS call_center.cc_calls_history_user_ids_st ON domain_id, user_ids FROM call_center.cc_calls_history;


--
-- Name: cc_agent_in_queue_view _RETURN; Type: RULE; Schema: call_center; Owner: -
--

CREATE OR REPLACE VIEW call_center.cc_agent_in_queue_view AS
 SELECT q.queue,
    q.priority,
    q.type,
    q.strategy,
    q.enabled,
    q.count_members,
    q.waiting_members,
    q.active_members,
    q.queue_id,
    q.queue_name,
    q.team_id,
    q.domain_id,
    q.agent_id,
    jsonb_build_object('online', COALESCE(array_length(a.agent_on_ids, 1), 0), 'pause', COALESCE(array_length(a.agent_p_ids, 1), 0), 'offline', COALESCE(array_length(a.agent_off_ids, 1), 0), 'free', COALESCE(array_length(a.free, 1), 0), 'total', COALESCE(array_length(a.total, 1), 0), 'allow_pause',
        CASE
            WHEN (q.min_online_agents > 0) THEN GREATEST(((COALESCE(array_length(a.agent_p_ids, 1), 0) + COALESCE(array_length(a.agent_on_ids, 1), 0)) - q.min_online_agents), 0)
            ELSE NULL::integer
        END) AS agents
   FROM (( SELECT call_center.cc_get_lookup((q_1.id)::bigint, q_1.name) AS queue,
            q_1.priority,
            q_1.type,
            q_1.strategy,
            q_1.enabled,
            COALESCE(((q_1.payload -> 'min_online_agents'::text))::integer, 0) AS min_online_agents,
            COALESCE(sum(cqs.member_count), (0)::bigint) AS count_members,
                CASE
                    WHEN (q_1.type = ANY (ARRAY[1, 6])) THEN ( SELECT count(*) AS count
                       FROM call_center.cc_member_attempt a_1_1
                      WHERE ((a_1_1.queue_id = q_1.id) AND ((a_1_1.state)::text = ANY (ARRAY[('wait_agent'::character varying)::text, ('offering'::character varying)::text])) AND (a_1_1.leaving_at IS NULL)))
                    ELSE COALESCE(sum(cqs.member_waiting), (0)::bigint)
                END AS waiting_members,
            ( SELECT count(*) AS count
                   FROM call_center.cc_member_attempt a_1_1
                  WHERE (a_1_1.queue_id = q_1.id)) AS active_members,
            q_1.id AS queue_id,
            q_1.name AS queue_name,
            q_1.team_id,
            a_1.domain_id,
            a_1.id AS agent_id,
                CASE
                    WHEN ((q_1.type >= 0) AND (q_1.type <= 5)) THEN 'call'::text
                    WHEN (q_1.type = 6) THEN 'chat'::text
                    ELSE 'task'::text
                END AS chan_name
           FROM ((call_center.cc_agent a_1
             JOIN call_center.cc_queue q_1 ON ((q_1.domain_id = a_1.domain_id)))
             LEFT JOIN call_center.cc_queue_statistics cqs ON ((q_1.id = cqs.queue_id)))
          WHERE (((q_1.team_id IS NULL) OR (a_1.team_id = q_1.team_id)) AND (EXISTS ( SELECT qs.queue_id
                   FROM (call_center.cc_queue_skill qs
                     JOIN call_center.cc_skill_in_agent csia ON ((csia.skill_id = qs.skill_id)))
                  WHERE (qs.enabled AND csia.enabled AND (csia.agent_id = a_1.id) AND (qs.queue_id = q_1.id) AND (csia.capacity >= qs.min_capacity) AND (csia.capacity <= qs.max_capacity)))))
          GROUP BY a_1.id, q_1.id, q_1.priority) q
     LEFT JOIN LATERAL ( SELECT DISTINCT array_agg(DISTINCT a_1.id) FILTER (WHERE ((a_1.status)::text = 'online'::text)) AS agent_on_ids,
            array_agg(DISTINCT a_1.id) FILTER (WHERE ((a_1.status)::text = 'offline'::text)) AS agent_off_ids,
            array_agg(DISTINCT a_1.id) FILTER (WHERE ((a_1.status)::text = ANY (ARRAY[('pause'::character varying)::text, ('break_out'::character varying)::text]))) AS agent_p_ids,
            array_agg(DISTINCT a_1.id) FILTER (WHERE (((a_1.status)::text = 'online'::text) AND ((ac.state)::text = 'waiting'::text))) AS free,
            array_agg(DISTINCT a_1.id) AS total
           FROM (((call_center.cc_agent a_1
             JOIN call_center.cc_agent_channel ac ON (((ac.agent_id = a_1.id) AND ((ac.channel)::text = q.chan_name))))
             JOIN call_center.cc_queue_skill qs ON (((qs.queue_id = q.queue_id) AND qs.enabled)))
             JOIN call_center.cc_skill_in_agent sia ON (((sia.agent_id = a_1.id) AND sia.enabled)))
          WHERE ((a_1.domain_id = q.domain_id) AND ((q.team_id IS NULL) OR (a_1.team_id = q.team_id)) AND (qs.skill_id = sia.skill_id) AND (sia.capacity >= qs.min_capacity) AND (sia.capacity <= qs.max_capacity))
          GROUP BY ROLLUP(q.queue_id)) a ON (true));


--
-- Name: cc_distribute_stage_1 _RETURN; Type: RULE; Schema: call_center; Owner: -
--

CREATE OR REPLACE VIEW call_center.cc_distribute_stage_1 AS
 WITH queues AS MATERIALIZED (
         SELECT q_1.domain_id,
            q_1.id,
            q_1.calendar_id,
            q_1.type,
            q_1.sticky_agent,
            q_1.recall_calendar,
                CASE
                    WHEN q_1.sticky_agent THEN COALESCE(((q_1.payload -> 'sticky_agent_sec'::text))::integer, 30)
                    ELSE NULL::integer
                END AS sticky_agent_sec,
                CASE
                    WHEN ((q_1.strategy)::text = 'lifo'::text) THEN 1
                    WHEN ((q_1.strategy)::text = 'strict_fifo'::text) THEN 2
                    ELSE 0
                END AS strategy,
            q_1.priority,
            q_1.team_id,
            ((q_1.payload -> 'max_calls'::text))::integer AS lim,
            ((q_1.payload -> 'wait_between_retries_desc'::text))::boolean AS wait_between_retries_desc,
            COALESCE(((q_1.payload -> 'strict_circuit'::text))::boolean, false) AS strict_circuit,
            array_agg(ROW((m.bucket_id)::integer, (m.member_waiting)::integer, m.op)::call_center.cc_sys_distribute_bucket ORDER BY cbiq.priority DESC NULLS LAST, cbiq.ratio DESC NULLS LAST, m.bucket_id) AS buckets,
            m.op,
            min(m.min_wt) AS min_wt
           FROM ((( WITH mem AS MATERIALIZED (
                         SELECT a.queue_id,
                            a.bucket_id,
                            count(*) AS member_waiting,
                            false AS op,
                            min((EXTRACT(epoch FROM a.joined_at))::bigint) AS min_wt
                           FROM call_center.cc_member_attempt a
                          WHERE ((a.bridged_at IS NULL) AND (a.leaving_at IS NULL) AND ((a.state)::text = 'wait_agent'::text))
                          GROUP BY a.queue_id, a.bucket_id
                        UNION ALL
                         SELECT q_2.queue_id,
                            q_2.bucket_id,
                            q_2.member_waiting,
                            true AS op,
                            0 AS min_wt
                           FROM call_center.cc_queue_statistics q_2
                          WHERE (q_2.member_waiting > 0)
                        )
                 SELECT rank() OVER (PARTITION BY mem.queue_id ORDER BY mem.op) AS pos,
                    mem.queue_id,
                    mem.bucket_id,
                    mem.member_waiting,
                    mem.op,
                    mem.min_wt
                   FROM mem) m
             JOIN call_center.cc_queue q_1 ON ((q_1.id = m.queue_id)))
             LEFT JOIN call_center.cc_bucket_in_queue cbiq ON (((cbiq.queue_id = m.queue_id) AND (cbiq.bucket_id = m.bucket_id))))
          WHERE ((m.member_waiting > 0) AND q_1.enabled AND (q_1.type > 0) AND (NOT COALESCE(((q_1.payload -> 'manual_distribution'::text))::boolean, false)) AND ((cbiq.bucket_id IS NULL) OR (NOT cbiq.disabled)))
          GROUP BY q_1.domain_id, q_1.id, q_1.calendar_id, q_1.type, m.op
         LIMIT 1024
        ), calend AS MATERIALIZED (
         SELECT c.id AS calendar_id,
            queues.id AS queue_id,
                CASE
                    WHEN (queues.recall_calendar AND (NOT (tz.offset_id = ANY (array_agg(DISTINCT o1.id))))) THEN ((array_agg(DISTINCT o1.id))::integer[] + (tz.offset_id)::integer)
                    ELSE (array_agg(DISTINCT o1.id))::integer[]
                END AS l,
            (queues.recall_calendar AND (NOT (tz.offset_id = ANY (array_agg(DISTINCT o1.id))))) AS recall_calendar
           FROM ((((flow.calendar c
             LEFT JOIN flow.calendar_timezones tz ON ((tz.id = c.timezone_id)))
             JOIN queues ON ((queues.calendar_id = c.id)))
             JOIN LATERAL unnest(c.accepts) a(disabled, day, start_time_of_day, end_time_of_day) ON (true))
             JOIN flow.calendar_timezone_offsets o1 ON ((((a.day + 1) = (date_part('isodow'::text, timezone(o1.names[1], now())))::integer) AND (((to_char(timezone(o1.names[1], now()), 'SSSS'::text))::integer / 60) >= a.start_time_of_day) AND (((to_char(timezone(o1.names[1], now()), 'SSSS'::text))::integer / 60) <= a.end_time_of_day))))
          WHERE ((NOT (a.disabled IS TRUE)) AND (NOT (EXISTS ( SELECT 1
                   FROM unnest(c.excepts) x(disabled, date, name, repeat)
                  WHERE ((NOT (x.disabled IS TRUE)) AND
                        CASE
                            WHEN (x.repeat IS TRUE) THEN (to_char((((CURRENT_TIMESTAMP AT TIME ZONE tz.sys_name))::date)::timestamp with time zone, 'MM-DD'::text) = to_char((((to_timestamp(((x.date / 1000))::double precision) AT TIME ZONE tz.sys_name))::date)::timestamp with time zone, 'MM-DD'::text))
                            ELSE (((CURRENT_TIMESTAMP AT TIME ZONE tz.sys_name))::date = ((to_timestamp(((x.date / 1000))::double precision) AT TIME ZONE tz.sys_name))::date)
                        END)))))
          GROUP BY c.id, queues.id, queues.recall_calendar, tz.offset_id
        ), resources AS MATERIALIZED (
         SELECT l_1.queue_id,
            array_agg(ROW(cor.communication_id, (cor.id)::bigint, ((l_1.l & (l2.x)::integer[]))::smallint[], (cor.resource_group_id)::integer)::call_center.cc_sys_distribute_type) AS types,
            array_agg(ROW((cor.id)::bigint, ((cor."limit" - used.cnt))::integer, cor.patterns)::call_center.cc_sys_distribute_resource) AS resources,
            call_center.cc_array_merge_agg((l_1.l & (l2.x)::integer[])) AS offset_ids
           FROM (((calend l_1
             JOIN ( SELECT corg.queue_id,
                    corg.priority,
                    corg.resource_group_id,
                    corg.communication_id,
                    corg."time",
                    (corg.cor).id AS id,
                    (corg.cor)."limit" AS "limit",
                    (corg.cor).enabled AS enabled,
                    (corg.cor).updated_at AS updated_at,
                    (corg.cor).rps AS rps,
                    (corg.cor).domain_id AS domain_id,
                    (corg.cor).reserve AS reserve,
                    (corg.cor).variables AS variables,
                    (corg.cor).number AS number,
                    (corg.cor).max_successively_errors AS max_successively_errors,
                    (corg.cor).name AS name,
                    (corg.cor).last_error_id AS last_error_id,
                    (corg.cor).successively_errors AS successively_errors,
                    (corg.cor).created_at AS created_at,
                    (corg.cor).created_by AS created_by,
                    (corg.cor).updated_by AS updated_by,
                    (corg.cor).error_ids AS error_ids,
                    (corg.cor).gateway_id AS gateway_id,
                    (corg.cor).email_profile_id AS email_profile_id,
                    (corg.cor).payload AS payload,
                    (corg.cor).description AS description,
                    (corg.cor).patterns AS patterns,
                    (corg.cor).failure_dial_delay AS failure_dial_delay,
                    (corg.cor).last_error_at AS last_error_at
                   FROM (calend calend_1
                     JOIN ( SELECT DISTINCT cqr.queue_id,
                            corig.priority,
                            corg_1.id AS resource_group_id,
                            corg_1.communication_id,
                            corg_1."time",
                                CASE
                                    WHEN (cor_1.enabled AND gw.enable) THEN ROW(cor_1.id, cor_1."limit", cor_1.enabled, cor_1.updated_at, cor_1.rps, cor_1.domain_id, cor_1.reserve, cor_1.variables, cor_1.number, cor_1.max_successively_errors, cor_1.name, cor_1.last_error_id, cor_1.successively_errors, cor_1.created_at, cor_1.created_by, cor_1.updated_by, cor_1.error_ids, cor_1.gateway_id, cor_1.email_profile_id, cor_1.payload, cor_1.description, cor_1.patterns, cor_1.failure_dial_delay, cor_1.last_error_at, NULL::jsonb)::call_center.cc_outbound_resource
                                    WHEN (cor2.enabled AND gw2.enable) THEN ROW(cor2.id, cor2."limit", cor2.enabled, cor2.updated_at, cor2.rps, cor2.domain_id, cor2.reserve, cor2.variables, cor2.number, cor2.max_successively_errors, cor2.name, cor2.last_error_id, cor2.successively_errors, cor2.created_at, cor2.created_by, cor2.updated_by, cor2.error_ids, cor2.gateway_id, cor2.email_profile_id, cor2.payload, cor2.description, cor2.patterns, cor2.failure_dial_delay, cor2.last_error_at, NULL::jsonb)::call_center.cc_outbound_resource
                                    ELSE NULL::call_center.cc_outbound_resource
                                END AS cor
                           FROM ((((((call_center.cc_queue_resource cqr
                             JOIN call_center.cc_outbound_resource_group corg_1 ON ((cqr.resource_group_id = corg_1.id)))
                             JOIN call_center.cc_outbound_resource_in_group corig ON ((corg_1.id = corig.group_id)))
                             JOIN call_center.cc_outbound_resource cor_1 ON ((cor_1.id = (corig.resource_id)::integer)))
                             JOIN directory.sip_gateway gw ON ((gw.id = cor_1.gateway_id)))
                             LEFT JOIN call_center.cc_outbound_resource cor2 ON (((cor2.id = corig.reserve_resource_id) AND cor2.enabled)))
                             LEFT JOIN directory.sip_gateway gw2 ON (((gw2.id = cor2.gateway_id) AND cor2.enabled)))
                          WHERE (
                                CASE
                                    WHEN (cor_1.enabled AND gw.enable) THEN cor_1.id
                                    WHEN (cor2.enabled AND gw2.enable) THEN cor2.id
                                    ELSE NULL::integer
                                END IS NOT NULL)
                          ORDER BY cqr.queue_id, corig.priority DESC) corg ON ((corg.queue_id = calend_1.queue_id)))) cor ON ((cor.queue_id = l_1.queue_id)))
             JOIN LATERAL ( WITH times AS (
                         SELECT ((e.value -> 'start_time_of_day'::text))::integer AS start,
                            ((e.value -> 'end_time_of_day'::text))::integer AS "end"
                           FROM jsonb_array_elements(cor."time") e(value)
                        )
                 SELECT array_agg(DISTINCT t.id) AS x
                   FROM flow.calendar_timezone_offsets t,
                    times,
                    LATERAL ( SELECT timezone(t.names[1], CURRENT_TIMESTAMP) AS t) with_timezone
                  WHERE ((((to_char(with_timezone.t, 'SSSS'::text))::integer / 60) >= times.start) AND (((to_char(with_timezone.t, 'SSSS'::text))::integer / 60) <= times."end"))) l2 ON ((l2.* IS NOT NULL)))
             LEFT JOIN LATERAL ( SELECT count(*) AS cnt
                   FROM ( SELECT 1 AS cnt
                           FROM call_center.cc_member_attempt c_1
                          WHERE ((c_1.resource_id = cor.id) AND ((c_1.state)::text <> ALL (ARRAY[('leaving'::character varying)::text, ('processing'::character varying)::text])))) c) used ON (true))
          WHERE (cor.enabled AND ((cor.last_error_at IS NULL) OR (cor.last_error_at <= (now() - ((cor.failure_dial_delay || ' s'::text))::interval))) AND ((cor."limit" - used.cnt) > 0))
          GROUP BY l_1.queue_id
        )
 SELECT q.id,
    q.type,
    (q.strategy)::smallint AS strategy,
    q.team_id,
    q.buckets,
    r.types,
    r.resources,
        CASE
            WHEN (q.type = ANY ('{7,8}'::smallint[])) THEN calend.l
            ELSE r.offset_ids
        END AS offset_ids,
        CASE
            WHEN (q.lim = '-1'::integer) THEN NULL::integer
            ELSE GREATEST(((q.lim - COALESCE(l.usage, (0)::bigint)))::integer, 0)
        END AS lim,
    q.domain_id,
    q.priority,
    q.sticky_agent,
    q.sticky_agent_sec,
    calend.recall_calendar,
    q.wait_between_retries_desc,
    q.strict_circuit,
    q.op AS ins,
    q.min_wt
   FROM (((queues q
     LEFT JOIN calend ON ((calend.queue_id = q.id)))
     LEFT JOIN resources r ON ((q.op AND (r.queue_id = q.id))))
     LEFT JOIN LATERAL ( SELECT count(*) AS usage
           FROM call_center.cc_member_attempt a
          WHERE ((a.queue_id = q.id) AND ((a.state)::text <> 'leaving'::text))) l ON ((q.lim > 0)))
  WHERE ((q.type = ANY (ARRAY[1, 6, 7])) OR ((q.type = 8) AND (GREATEST(((q.lim - COALESCE(l.usage, (0)::bigint)))::integer, 0) > 0)) OR ((q.type = 5) AND (NOT q.op)) OR (q.op AND (q.type = ANY (ARRAY[2, 3, 4, 5])) AND (r.* IS NOT NULL)))
  ORDER BY q.domain_id, q.priority DESC, q.op;


--
-- Name: cc_queue_report_general _RETURN; Type: RULE; Schema: call_center; Owner: -
--

CREATE OR REPLACE VIEW call_center.cc_queue_report_general AS
 SELECT call_center.cc_get_lookup((q.id)::bigint, q.name) AS queue,
    call_center.cc_get_lookup(ct.id, ct.name) AS team,
    ( SELECT sum(s.member_waiting) AS sum
           FROM call_center.cc_queue_statistics s
          WHERE (s.queue_id = q.id)) AS waiting,
    ( SELECT count(*) AS count
           FROM call_center.cc_member_attempt a
          WHERE (a.queue_id = q.id)) AS processed,
    count(*) AS cnt,
    count(*) FILTER (WHERE (t.offering_at IS NOT NULL)) AS calls,
    count(*) FILTER (WHERE ((t.result)::text = 'abandoned'::text)) AS abandoned,
    date_part('epoch'::text, sum((t.leaving_at - t.bridged_at)) FILTER (WHERE (t.bridged_at IS NOT NULL))) AS bill_sec,
    date_part('epoch'::text, avg((t.leaving_at - t.reporting_at)) FILTER (WHERE (t.reporting_at IS NOT NULL))) AS avg_wrap_sec,
    date_part('epoch'::text, avg((t.bridged_at - t.offering_at)) FILTER (WHERE (t.bridged_at IS NOT NULL))) AS avg_awt_sec,
    date_part('epoch'::text, max((t.bridged_at - t.offering_at)) FILTER (WHERE (t.bridged_at IS NOT NULL))) AS max_awt_sec,
    date_part('epoch'::text, avg((t.bridged_at - t.joined_at)) FILTER (WHERE (t.bridged_at IS NOT NULL))) AS avg_asa_sec,
    date_part('epoch'::text, avg((GREATEST(t.leaving_at, t.reporting_at) - t.bridged_at)) FILTER (WHERE (t.bridged_at IS NOT NULL))) AS avg_aht_sec,
    q.id AS queue_id,
    q.team_id
   FROM ((call_center.cc_member_attempt_history t
     JOIN call_center.cc_queue q ON ((q.id = t.queue_id)))
     LEFT JOIN call_center.cc_team ct ON ((q.team_id = ct.id)))
  GROUP BY q.id, ct.id;


--
-- Name: cc_sys_queue_distribute_resources _RETURN; Type: RULE; Schema: call_center; Owner: -
--

CREATE OR REPLACE VIEW call_center.cc_sys_queue_distribute_resources AS
 WITH res AS (
         SELECT cqr.queue_id,
            corg.communication_id,
            cor.id,
            cor."limit",
            call_center.cc_outbound_resource_timing(corg."time") AS t,
            cor.patterns
           FROM (((call_center.cc_queue_resource cqr
             JOIN call_center.cc_outbound_resource_group corg ON ((cqr.resource_group_id = corg.id)))
             JOIN call_center.cc_outbound_resource_in_group corig ON ((corg.id = corig.group_id)))
             JOIN call_center.cc_outbound_resource cor ON ((corig.resource_id = cor.id)))
          WHERE (cor.enabled AND (NOT cor.reserve))
          GROUP BY cqr.queue_id, corg.communication_id, corg."time", cor.id, cor."limit"
        )
 SELECT res.queue_id,
    array_agg(DISTINCT ROW(res.communication_id, (res.id)::bigint, res.t, 0)::call_center.cc_sys_distribute_type) AS types,
    array_agg(DISTINCT ROW((res.id)::bigint, ((res."limit" - ac.count))::integer, res.patterns)::call_center.cc_sys_distribute_resource) AS resources,
    array_agg(DISTINCT f.f) AS ran
   FROM res,
    (LATERAL ( SELECT count(*) AS count
           FROM call_center.cc_member_attempt a
          WHERE (a.resource_id = res.id)) ac
     JOIN LATERAL ( SELECT f_1.f
           FROM unnest(res.t) f_1(f)) f ON (true))
  WHERE ((res."limit" - ac.count) > 0)
  GROUP BY res.queue_id;


--
-- Name: wbt_user wbt_user_delete_auth; Type: RULE; Schema: directory; Owner: -
--

CREATE RULE wbt_user_delete_auth AS
    ON DELETE TO directory.wbt_user DO  DELETE FROM directory.wbt_auth
  WHERE ((wbt_auth.id = old.id) AND (wbt_auth.dc = old.dc));


--
-- Name: cc_agent cc_agent_init_channel_ins; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_agent_init_channel_ins AFTER INSERT ON call_center.cc_agent FOR EACH ROW EXECUTE FUNCTION call_center.cc_agent_init_channel();


--
-- Name: cc_agent cc_agent_set_rbac_acl; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_agent_set_rbac_acl AFTER INSERT ON call_center.cc_agent FOR EACH ROW EXECUTE FUNCTION call_center.tg_obj_default_rbac('cc_agent');


--
-- Name: cc_audit_form cc_audit_form_set_rbac_acl; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_audit_form_set_rbac_acl AFTER INSERT ON call_center.cc_audit_form FOR EACH ROW EXECUTE FUNCTION call_center.tg_obj_default_rbac('cc_audit_form_acl');


--
-- Name: cc_calls cc_calls_set_timing_trigger_updated; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_calls_set_timing_trigger_updated BEFORE INSERT OR UPDATE ON call_center.cc_calls FOR EACH ROW EXECUTE FUNCTION call_center.cc_calls_set_timing();


--
-- Name: cc_communication cc_communication_set_def_tg; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_communication_set_def_tg BEFORE INSERT OR UPDATE ON call_center.cc_communication FOR EACH ROW WHEN (new."default") EXECUTE FUNCTION call_center.cc_communication_set_def();


--
-- Name: cc_list cc_list_set_rbac_acl; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_list_set_rbac_acl AFTER INSERT ON call_center.cc_list FOR EACH ROW EXECUTE FUNCTION call_center.tg_obj_default_rbac('cc_list');


--
-- Name: cc_member cc_member_set_sys_destinations_insert; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_set_sys_destinations_insert BEFORE INSERT ON call_center.cc_member FOR EACH ROW EXECUTE FUNCTION call_center.cc_member_set_sys_destinations_tg();


--
-- Name: cc_member cc_member_set_sys_destinations_update; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_set_sys_destinations_update BEFORE UPDATE ON call_center.cc_member FOR EACH ROW WHEN ((new.communications <> old.communications)) EXECUTE FUNCTION call_center.cc_member_set_sys_destinations_tg();


--
-- Name: cc_member cc_member_statistic_skill_trigger_deleted; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_statistic_skill_trigger_deleted AFTER DELETE ON call_center.cc_member REFERENCING OLD TABLE AS deleted FOR EACH STATEMENT EXECUTE FUNCTION call_center.cc_member_statistic_skill_trigger_deleted();


--
-- Name: cc_member cc_member_statistic_skill_trigger_inserted; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_statistic_skill_trigger_inserted AFTER INSERT ON call_center.cc_member REFERENCING NEW TABLE AS inserted FOR EACH STATEMENT EXECUTE FUNCTION call_center.cc_member_statistic_skill_trigger_inserted();


--
-- Name: cc_member cc_member_statistic_skill_trigger_updated; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_statistic_skill_trigger_updated AFTER UPDATE ON call_center.cc_member REFERENCING OLD TABLE AS old_data NEW TABLE AS new_data FOR EACH STATEMENT EXECUTE FUNCTION call_center.cc_member_statistic_skill_trigger_updated();


--
-- Name: cc_member cc_member_statistic_trigger_deleted; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_statistic_trigger_deleted AFTER DELETE ON call_center.cc_member REFERENCING OLD TABLE AS deleted FOR EACH STATEMENT EXECUTE FUNCTION call_center.cc_member_statistic_trigger_deleted();


--
-- Name: cc_member cc_member_statistic_trigger_inserted; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_statistic_trigger_inserted AFTER INSERT ON call_center.cc_member REFERENCING NEW TABLE AS inserted FOR EACH STATEMENT EXECUTE FUNCTION call_center.cc_member_statistic_trigger_inserted();


--
-- Name: cc_member cc_member_statistic_trigger_updated; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_statistic_trigger_updated AFTER UPDATE ON call_center.cc_member REFERENCING OLD TABLE AS old_data NEW TABLE AS new_data FOR EACH STATEMENT EXECUTE FUNCTION call_center.cc_member_statistic_trigger_updated();


--
-- Name: cc_member cc_member_sys_offset_id_trigger_inserted; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_sys_offset_id_trigger_inserted BEFORE INSERT ON call_center.cc_member FOR EACH ROW EXECUTE FUNCTION call_center.cc_member_sys_offset_id_trigger_inserted();


--
-- Name: cc_member cc_member_sys_offset_id_trigger_update; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_member_sys_offset_id_trigger_update BEFORE UPDATE ON call_center.cc_member FOR EACH ROW WHEN ((new.timezone_id <> old.timezone_id)) EXECUTE FUNCTION call_center.cc_member_sys_offset_id_trigger_update();


--
-- Name: cc_outbound_resource_display cc_outbound_resource_display_changed_iud; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_outbound_resource_display_changed_iud AFTER INSERT OR DELETE OR UPDATE ON call_center.cc_outbound_resource_display FOR EACH ROW EXECUTE FUNCTION call_center.cc_outbound_resource_display_changed();


--
-- Name: cc_outbound_resource_group cc_outbound_resource_group_resource_set_rbac_acl; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_outbound_resource_group_resource_set_rbac_acl AFTER INSERT ON call_center.cc_outbound_resource_group FOR EACH ROW EXECUTE FUNCTION call_center.tg_obj_default_rbac('cc_resource_group');


--
-- Name: cc_outbound_resource cc_outbound_resource_set_rbac_acl; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_outbound_resource_set_rbac_acl AFTER INSERT ON call_center.cc_outbound_resource FOR EACH ROW EXECUTE FUNCTION call_center.tg_obj_default_rbac('cc_resource');


--
-- Name: cc_queue_events cc_queue_events_changed; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_queue_events_changed AFTER INSERT OR DELETE OR UPDATE ON call_center.cc_queue_events FOR EACH ROW EXECUTE FUNCTION call_center.cc_queue_event_changed_tg();


--
-- Name: cc_queue cc_queue_resource_set_rbac_acl; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_queue_resource_set_rbac_acl AFTER INSERT ON call_center.cc_queue FOR EACH ROW EXECUTE FUNCTION call_center.tg_obj_default_rbac('cc_queue');


--
-- Name: cc_team cc_team_set_rbac_acl; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_team_set_rbac_acl AFTER INSERT ON call_center.cc_team FOR EACH ROW EXECUTE FUNCTION call_center.tg_obj_default_rbac('cc_team');


--
-- Name: cc_trigger cc_trigger_ins_upd_tg; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_trigger_ins_upd_tg BEFORE INSERT OR UPDATE ON call_center.cc_trigger FOR EACH ROW EXECUTE FUNCTION call_center.cc_trigger_ins_upd();


--
-- Name: cc_trigger cc_trigger_set_rbac_acl; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER cc_trigger_set_rbac_acl AFTER INSERT ON call_center.cc_trigger FOR EACH ROW EXECUTE FUNCTION call_center.tg_obj_default_rbac('cc_trigger');


--
-- Name: cc_list_communications tg_cc_list_statistics_deleted; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER tg_cc_list_statistics_deleted AFTER DELETE ON call_center.cc_list_communications REFERENCING OLD TABLE AS deleted FOR EACH STATEMENT EXECUTE FUNCTION call_center.cc_list_statistics_trigger_deleted();


--
-- Name: cc_list_communications tg_cc_list_statistics_inserted; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER tg_cc_list_statistics_inserted AFTER INSERT ON call_center.cc_list_communications REFERENCING NEW TABLE AS inserted FOR EACH STATEMENT EXECUTE FUNCTION call_center.cc_list_statistics_trigger_inserted();


--
-- Name: cc_agent tg_cc_set_agent_change_status_i; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER tg_cc_set_agent_change_status_i AFTER INSERT ON call_center.cc_agent FOR EACH ROW EXECUTE FUNCTION call_center.cc_set_agent_change_status();


--
-- Name: cc_agent tg_cc_set_agent_change_status_u; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER tg_cc_set_agent_change_status_u AFTER UPDATE ON call_center.cc_agent FOR EACH ROW WHEN ((((old.status)::text <> (new.status)::text) OR ((old.status_payload)::text <> (new.status_payload)::text))) EXECUTE FUNCTION call_center.cc_set_agent_change_status();


--
-- Name: cc_agent_channel tg_cc_set_agent_channel_change_status_u; Type: TRIGGER; Schema: call_center; Owner: -
--

CREATE TRIGGER tg_cc_set_agent_channel_change_status_u BEFORE UPDATE ON call_center.cc_agent_channel FOR EACH ROW WHEN ((((old.state)::text <> (new.state)::text) OR (old.online <> new.online))) EXECUTE FUNCTION call_center.cc_set_agent_channel_change_status();


--
-- Name: contact tg_contact_rbac; Type: TRIGGER; Schema: contacts; Owner: -
--

CREATE TRIGGER tg_contact_rbac AFTER INSERT ON contacts.contact REFERENCING NEW TABLE AS inserted FOR EACH STATEMENT EXECUTE FUNCTION directory.tg_stmt_default_rbac('contacts');


--
-- Name: wbt_device tg_device_rbac; Type: TRIGGER; Schema: directory; Owner: -
--

CREATE TRIGGER tg_device_rbac AFTER INSERT ON directory.wbt_device REFERENCING NEW TABLE AS inserted FOR EACH STATEMENT EXECUTE FUNCTION directory.tg_stmt_default_rbac('devices');


--
-- Name: wbt_auth tg_role_rbac; Type: TRIGGER; Schema: directory; Owner: -
--

CREATE TRIGGER tg_role_rbac AFTER INSERT ON directory.wbt_auth FOR EACH ROW WHEN ((NOT new.can_login)) EXECUTE FUNCTION directory.tg_obj_default_rbac('roles');


--
-- Name: wbt_auth tg_user_rbac; Type: TRIGGER; Schema: directory; Owner: -
--

CREATE TRIGGER tg_user_rbac AFTER INSERT ON directory.wbt_auth FOR EACH ROW WHEN (new.can_login) EXECUTE FUNCTION directory.tg_obj_default_rbac('users');


--
-- Name: calendar calendar_set_rbac_acl; Type: TRIGGER; Schema: flow; Owner: -
--

CREATE TRIGGER calendar_set_rbac_acl AFTER INSERT ON flow.calendar FOR EACH ROW EXECUTE FUNCTION flow.tg_obj_default_rbac('calendar');


--
-- Name: object_config cc_agent_set_rbac_acl; Type: TRIGGER; Schema: logger; Owner: -
--

CREATE TRIGGER cc_agent_set_rbac_acl AFTER INSERT ON logger.object_config FOR EACH ROW EXECUTE FUNCTION logger.tg_obj_default_rbac('logs');


--
-- Name: cognitive_profile_services cognitive_profile_services_set_def_tg; Type: TRIGGER; Schema: storage; Owner: -
--

CREATE TRIGGER cognitive_profile_services_set_def_tg BEFORE INSERT OR UPDATE ON storage.cognitive_profile_services FOR EACH ROW WHEN (new."default") EXECUTE FUNCTION storage.cognitive_profile_services_set_def();


--
-- Name: cognitive_profile_services cognitive_profile_services_set_rbac_acl; Type: TRIGGER; Schema: storage; Owner: -
--

CREATE TRIGGER cognitive_profile_services_set_rbac_acl AFTER INSERT ON storage.cognitive_profile_services FOR EACH ROW EXECUTE FUNCTION storage.tg_obj_default_rbac('cognitive_profile_services');


--
-- Name: file_backend_profiles file_backend_profiles_set_rbac_acl; Type: TRIGGER; Schema: storage; Owner: -
--

CREATE TRIGGER file_backend_profiles_set_rbac_acl AFTER INSERT ON storage.file_backend_profiles FOR EACH ROW EXECUTE FUNCTION storage.tg_obj_default_rbac('file_backend_profiles');


--
-- Name: import_template import_template_set_rbac_acl; Type: TRIGGER; Schema: storage; Owner: -
--

CREATE TRIGGER import_template_set_rbac_acl AFTER INSERT ON storage.import_template FOR EACH ROW EXECUTE FUNCTION storage.tg_obj_default_rbac('import_template');


--
-- Name: files tg_files_statistics_deleted; Type: TRIGGER; Schema: storage; Owner: -
--

CREATE TRIGGER tg_files_statistics_deleted AFTER DELETE ON storage.files REFERENCING OLD TABLE AS deleted FOR EACH STATEMENT EXECUTE FUNCTION storage.file_statistics_trigger_deleted();


--
-- Name: files tg_files_statistics_inserted; Type: TRIGGER; Schema: storage; Owner: -
--

CREATE TRIGGER tg_files_statistics_inserted AFTER INSERT ON storage.files REFERENCING NEW TABLE AS inserted FOR EACH STATEMENT EXECUTE FUNCTION storage.file_statistics_trigger_inserted();


--
-- Name: cc_agent_acl cc_agent_acl_cc_agent_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_acl
    ADD CONSTRAINT cc_agent_acl_cc_agent_id_fk FOREIGN KEY (object) REFERENCES call_center.cc_agent(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_agent_acl cc_agent_acl_domain_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_acl
    ADD CONSTRAINT cc_agent_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_agent_acl cc_agent_acl_grantor_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_acl
    ADD CONSTRAINT cc_agent_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_agent_acl cc_agent_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_acl
    ADD CONSTRAINT cc_agent_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_agent_acl cc_agent_acl_object_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_acl
    ADD CONSTRAINT cc_agent_acl_object_fk FOREIGN KEY (object, dc) REFERENCES call_center.cc_agent(id, domain_id) ON DELETE CASCADE;


--
-- Name: cc_agent_acl cc_agent_acl_subject_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_acl
    ADD CONSTRAINT cc_agent_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cc_agent_attempt cc_agent_attempt_cc_agent_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_attempt
    ADD CONSTRAINT cc_agent_attempt_cc_agent_id_fk FOREIGN KEY (agent_id) REFERENCES call_center.cc_agent(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_agent cc_agent_cc_team_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent
    ADD CONSTRAINT cc_agent_cc_team_id_fk FOREIGN KEY (team_id) REFERENCES call_center.cc_team(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cc_agent_channel cc_agent_channels_cc_agent_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_channel
    ADD CONSTRAINT cc_agent_channels_cc_agent_id_fk FOREIGN KEY (agent_id) REFERENCES call_center.cc_agent(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_agent cc_agent_media_files_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent
    ADD CONSTRAINT cc_agent_media_files_id_fk FOREIGN KEY (greeting_media_id) REFERENCES storage.media_files(id);


--
-- Name: cc_agent cc_agent_region_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent
    ADD CONSTRAINT cc_agent_region_id_fk FOREIGN KEY (region_id) REFERENCES flow.region(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cc_agent_state_history cc_agent_status_history_cc_agent_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_state_history
    ADD CONSTRAINT cc_agent_status_history_cc_agent_id_fk FOREIGN KEY (agent_id) REFERENCES call_center.cc_agent(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_agent_status_log cc_agent_status_log_cc_agent_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent_status_log
    ADD CONSTRAINT cc_agent_status_log_cc_agent_id_fk FOREIGN KEY (agent_id) REFERENCES call_center.cc_agent(id) ON DELETE CASCADE;


--
-- Name: cc_pause_cause cc_agent_status_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_pause_cause
    ADD CONSTRAINT cc_agent_status_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_pause_cause cc_agent_status_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_pause_cause
    ADD CONSTRAINT cc_agent_status_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_pause_cause cc_agent_status_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_pause_cause
    ADD CONSTRAINT cc_agent_status_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_agent cc_agent_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent
    ADD CONSTRAINT cc_agent_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: cc_agent cc_agent_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent
    ADD CONSTRAINT cc_agent_wbt_user_id_fk FOREIGN KEY (user_id) REFERENCES directory.wbt_user(id);


--
-- Name: cc_agent cc_agent_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent
    ADD CONSTRAINT cc_agent_wbt_user_id_fk_2 FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_agent cc_agent_wbt_user_id_fk_3; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_agent
    ADD CONSTRAINT cc_agent_wbt_user_id_fk_3 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_audit_form_acl cc_audit_form_acl_cc_audit_form_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form_acl
    ADD CONSTRAINT cc_audit_form_acl_cc_audit_form_id_fk FOREIGN KEY (object) REFERENCES call_center.cc_audit_form(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_audit_form_acl cc_audit_form_acl_domain_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form_acl
    ADD CONSTRAINT cc_audit_form_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_audit_form_acl cc_audit_form_acl_grantor_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form_acl
    ADD CONSTRAINT cc_audit_form_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_audit_form_acl cc_audit_form_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form_acl
    ADD CONSTRAINT cc_audit_form_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_audit_form_acl cc_audit_form_acl_object_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form_acl
    ADD CONSTRAINT cc_audit_form_acl_object_fk FOREIGN KEY (object, dc) REFERENCES call_center.cc_audit_form(id, domain_id) ON DELETE CASCADE;


--
-- Name: cc_audit_form_acl cc_audit_form_acl_subject_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form_acl
    ADD CONSTRAINT cc_audit_form_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cc_audit_form cc_audit_form_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form
    ADD CONSTRAINT cc_audit_form_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_audit_form cc_audit_form_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form
    ADD CONSTRAINT cc_audit_form_wbt_user_id_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_audit_form cc_audit_form_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_form
    ADD CONSTRAINT cc_audit_form_wbt_user_id_fk_2 FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_audit_rate cc_audit_rate_cc_audit_form_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_rate
    ADD CONSTRAINT cc_audit_rate_cc_audit_form_id_fk FOREIGN KEY (form_id) REFERENCES call_center.cc_audit_form(id) ON DELETE CASCADE;


--
-- Name: cc_audit_rate cc_audit_rate_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_rate
    ADD CONSTRAINT cc_audit_rate_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_audit_rate cc_audit_rate_wbt_domain_dc_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_rate
    ADD CONSTRAINT cc_audit_rate_wbt_domain_dc_fk_2 FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_audit_rate cc_audit_rate_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_rate
    ADD CONSTRAINT cc_audit_rate_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_audit_rate cc_audit_rate_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_audit_rate
    ADD CONSTRAINT cc_audit_rate_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_bucket_acl cc_bucket_acl_cc_bucket_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_acl
    ADD CONSTRAINT cc_bucket_acl_cc_bucket_id_fk FOREIGN KEY (object) REFERENCES call_center.cc_bucket(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_bucket_acl cc_bucket_acl_domain_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_acl
    ADD CONSTRAINT cc_bucket_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_bucket_acl cc_bucket_acl_grantor_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_acl
    ADD CONSTRAINT cc_bucket_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) ON UPDATE CASCADE ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_bucket_acl cc_bucket_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_acl
    ADD CONSTRAINT cc_bucket_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_bucket_acl cc_bucket_acl_object_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_acl
    ADD CONSTRAINT cc_bucket_acl_object_fk FOREIGN KEY (object, dc) REFERENCES call_center.cc_bucket(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_bucket_acl cc_bucket_acl_subject_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_acl
    ADD CONSTRAINT cc_bucket_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cc_bucket_in_queue cc_bucket_in_queue_cc_bucket_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_in_queue
    ADD CONSTRAINT cc_bucket_in_queue_cc_bucket_id_fk FOREIGN KEY (bucket_id) REFERENCES call_center.cc_bucket(id);


--
-- Name: cc_bucket_in_queue cc_bucket_in_queue_cc_queue_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket_in_queue
    ADD CONSTRAINT cc_bucket_in_queue_cc_queue_id_fk FOREIGN KEY (queue_id) REFERENCES call_center.cc_queue(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_bucket cc_bucket_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket
    ADD CONSTRAINT cc_bucket_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: cc_bucket cc_bucket_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket
    ADD CONSTRAINT cc_bucket_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_bucket cc_bucket_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_bucket
    ADD CONSTRAINT cc_bucket_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_calls_annotation cc_calls_annotation_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls_annotation
    ADD CONSTRAINT cc_calls_annotation_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_calls_annotation cc_calls_annotation_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls_annotation
    ADD CONSTRAINT cc_calls_annotation_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_calls_history cc_calls_history_cc_agent_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls_history
    ADD CONSTRAINT cc_calls_history_cc_agent_id_fk FOREIGN KEY (agent_id) REFERENCES call_center.cc_agent(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: cc_calls_history cc_calls_history_cc_team_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls_history
    ADD CONSTRAINT cc_calls_history_cc_team_id_fk FOREIGN KEY (team_id) REFERENCES call_center.cc_team(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: cc_calls cc_calls_wbt_auth_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_calls
    ADD CONSTRAINT cc_calls_wbt_auth_id_fk FOREIGN KEY (grantee_id) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_communication cc_communication_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_communication
    ADD CONSTRAINT cc_communication_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: cc_email cc_email_cc_email_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email
    ADD CONSTRAINT cc_email_cc_email_id_fk FOREIGN KEY (parent_id) REFERENCES call_center.cc_email(id);


--
-- Name: cc_email cc_email_cc_email_profiles_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email
    ADD CONSTRAINT cc_email_cc_email_profiles_id_fk FOREIGN KEY (profile_id) REFERENCES call_center.cc_email_profile(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_email_profile cc_email_profile_acr_routing_scheme_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email_profile
    ADD CONSTRAINT cc_email_profile_acr_routing_scheme_id_fk FOREIGN KEY (flow_id) REFERENCES flow.acr_routing_scheme(id);


--
-- Name: cc_email_profile cc_email_profile_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email_profile
    ADD CONSTRAINT cc_email_profile_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_email_profile cc_email_profile_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email_profile
    ADD CONSTRAINT cc_email_profile_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_email_profile cc_email_profile_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_email_profile
    ADD CONSTRAINT cc_email_profile_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_list_acl cc_list_acl_domain_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_acl
    ADD CONSTRAINT cc_list_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_list_acl cc_list_acl_grantor_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_acl
    ADD CONSTRAINT cc_list_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_list_acl cc_list_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_acl
    ADD CONSTRAINT cc_list_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_list_acl cc_list_acl_object_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_acl
    ADD CONSTRAINT cc_list_acl_object_fk FOREIGN KEY (object, dc) REFERENCES call_center.cc_list(id, domain_id) ON DELETE CASCADE;


--
-- Name: cc_list_acl cc_list_acl_subject_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_acl
    ADD CONSTRAINT cc_list_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cc_list_communications cc_list_communications_cc_list_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_communications
    ADD CONSTRAINT cc_list_communications_cc_list_id_fk FOREIGN KEY (list_id) REFERENCES call_center.cc_list(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_list_statistics cc_list_statistics_cc_list_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list_statistics
    ADD CONSTRAINT cc_list_statistics_cc_list_id_fk FOREIGN KEY (list_id) REFERENCES call_center.cc_list(id) ON UPDATE CASCADE ON DELETE CASCADE DEFERRABLE;


--
-- Name: cc_list cc_list_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list
    ADD CONSTRAINT cc_list_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_list cc_list_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list
    ADD CONSTRAINT cc_list_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_list cc_list_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_list
    ADD CONSTRAINT cc_list_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_member_attempt cc_member_attempt_cc_agent_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_attempt
    ADD CONSTRAINT cc_member_attempt_cc_agent_id_fk FOREIGN KEY (agent_id) REFERENCES call_center.cc_agent(id);


--
-- Name: cc_member_attempt cc_member_attempt_cc_bucket_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_attempt
    ADD CONSTRAINT cc_member_attempt_cc_bucket_id_fk FOREIGN KEY (bucket_id) REFERENCES call_center.cc_bucket(id);


--
-- Name: cc_member_attempt cc_member_attempt_cc_member_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_attempt
    ADD CONSTRAINT cc_member_attempt_cc_member_id_fk FOREIGN KEY (member_id) REFERENCES call_center.cc_member(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: cc_member_attempt cc_member_attempt_cc_queue_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_attempt
    ADD CONSTRAINT cc_member_attempt_cc_queue_id_fk FOREIGN KEY (queue_id) REFERENCES call_center.cc_queue(id);


--
-- Name: cc_member cc_member_calendar_timezones_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member
    ADD CONSTRAINT cc_member_calendar_timezones_id_fk FOREIGN KEY (timezone_id) REFERENCES flow.calendar_timezones(id);


--
-- Name: cc_member cc_member_cc_agent_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member
    ADD CONSTRAINT cc_member_cc_agent_id_fk FOREIGN KEY (agent_id) REFERENCES call_center.cc_agent(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: cc_member cc_member_cc_bucket_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member
    ADD CONSTRAINT cc_member_cc_bucket_id_fk FOREIGN KEY (bucket_id) REFERENCES call_center.cc_bucket(id);


--
-- Name: cc_member cc_member_cc_queue_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member
    ADD CONSTRAINT cc_member_cc_queue_id_fk FOREIGN KEY (queue_id) REFERENCES call_center.cc_queue(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_member cc_member_cc_skill_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member
    ADD CONSTRAINT cc_member_cc_skill_id_fk FOREIGN KEY (skill_id) REFERENCES call_center.cc_skill(id);


--
-- Name: cc_member_messages cc_member_messages_cc_member_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_member_messages
    ADD CONSTRAINT cc_member_messages_cc_member_id_fk FOREIGN KEY (member_id) REFERENCES call_center.cc_member(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_outbound_resource_acl cc_outbound_resource_acl_cc_outbound_resource_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_acl
    ADD CONSTRAINT cc_outbound_resource_acl_cc_outbound_resource_id_fk FOREIGN KEY (object) REFERENCES call_center.cc_outbound_resource(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_outbound_resource_acl cc_outbound_resource_acl_domain_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_acl
    ADD CONSTRAINT cc_outbound_resource_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_outbound_resource_acl cc_outbound_resource_acl_grantor_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_acl
    ADD CONSTRAINT cc_outbound_resource_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_outbound_resource_acl cc_outbound_resource_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_acl
    ADD CONSTRAINT cc_outbound_resource_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_outbound_resource_acl cc_outbound_resource_acl_object_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_acl
    ADD CONSTRAINT cc_outbound_resource_acl_object_fk FOREIGN KEY (object, dc) REFERENCES call_center.cc_outbound_resource(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_outbound_resource_acl cc_outbound_resource_acl_subject_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_acl
    ADD CONSTRAINT cc_outbound_resource_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cc_outbound_resource cc_outbound_resource_cc_email_profile_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource
    ADD CONSTRAINT cc_outbound_resource_cc_email_profile_id_fk FOREIGN KEY (email_profile_id) REFERENCES call_center.cc_email_profile(id);


--
-- Name: cc_outbound_resource_display cc_outbound_resource_display_cc_outbound_resource_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_display
    ADD CONSTRAINT cc_outbound_resource_display_cc_outbound_resource_id_fk FOREIGN KEY (resource_id) REFERENCES call_center.cc_outbound_resource(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_outbound_resource_group_acl cc_outbound_resource_group_acl_cc_outbound_resource_group_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group_acl
    ADD CONSTRAINT cc_outbound_resource_group_acl_cc_outbound_resource_group_id_fk FOREIGN KEY (object) REFERENCES call_center.cc_outbound_resource_group(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_outbound_resource_group_acl cc_outbound_resource_group_acl_domain_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group_acl
    ADD CONSTRAINT cc_outbound_resource_group_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_outbound_resource_group_acl cc_outbound_resource_group_acl_grantor_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group_acl
    ADD CONSTRAINT cc_outbound_resource_group_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_outbound_resource_group_acl cc_outbound_resource_group_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group_acl
    ADD CONSTRAINT cc_outbound_resource_group_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_outbound_resource_group_acl cc_outbound_resource_group_acl_object_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group_acl
    ADD CONSTRAINT cc_outbound_resource_group_acl_object_fk FOREIGN KEY (object, dc) REFERENCES call_center.cc_outbound_resource_group(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_outbound_resource_group_acl cc_outbound_resource_group_acl_subject_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group_acl
    ADD CONSTRAINT cc_outbound_resource_group_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cc_outbound_resource_group cc_outbound_resource_group_cc_communication_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group
    ADD CONSTRAINT cc_outbound_resource_group_cc_communication_id_fk FOREIGN KEY (communication_id) REFERENCES call_center.cc_communication(id);


--
-- Name: cc_outbound_resource_group cc_outbound_resource_group_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group
    ADD CONSTRAINT cc_outbound_resource_group_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: cc_outbound_resource_group cc_outbound_resource_group_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group
    ADD CONSTRAINT cc_outbound_resource_group_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_outbound_resource_group cc_outbound_resource_group_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_group
    ADD CONSTRAINT cc_outbound_resource_group_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_outbound_resource_in_group cc_outbound_resource_in_group_cc_outbound_resource_group_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_in_group
    ADD CONSTRAINT cc_outbound_resource_in_group_cc_outbound_resource_group_id_fk FOREIGN KEY (group_id) REFERENCES call_center.cc_outbound_resource_group(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_outbound_resource_in_group cc_outbound_resource_in_group_cc_outbound_resource_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_in_group
    ADD CONSTRAINT cc_outbound_resource_in_group_cc_outbound_resource_id_fk FOREIGN KEY (resource_id) REFERENCES call_center.cc_outbound_resource(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_outbound_resource_in_group cc_outbound_resource_in_group_cc_outbound_resource_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource_in_group
    ADD CONSTRAINT cc_outbound_resource_in_group_cc_outbound_resource_id_fk_2 FOREIGN KEY (reserve_resource_id) REFERENCES call_center.cc_outbound_resource(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: cc_outbound_resource cc_outbound_resource_sip_gateway_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource
    ADD CONSTRAINT cc_outbound_resource_sip_gateway_id_fk FOREIGN KEY (gateway_id) REFERENCES directory.sip_gateway(id);


--
-- Name: cc_outbound_resource cc_outbound_resource_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource
    ADD CONSTRAINT cc_outbound_resource_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: cc_outbound_resource cc_outbound_resource_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource
    ADD CONSTRAINT cc_outbound_resource_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_outbound_resource cc_outbound_resource_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_outbound_resource
    ADD CONSTRAINT cc_outbound_resource_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_preset_query cc_preset_query_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_preset_query
    ADD CONSTRAINT cc_preset_query_wbt_user_id_fk FOREIGN KEY (user_id) REFERENCES directory.wbt_user(id) ON DELETE CASCADE;


--
-- Name: cc_queue_acl cc_queue_acl_cc_queue_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_acl
    ADD CONSTRAINT cc_queue_acl_cc_queue_id_fk FOREIGN KEY (object) REFERENCES call_center.cc_queue(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_queue_acl cc_queue_acl_domain_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_acl
    ADD CONSTRAINT cc_queue_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_queue_acl cc_queue_acl_grantor_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_acl
    ADD CONSTRAINT cc_queue_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_queue_acl cc_queue_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_acl
    ADD CONSTRAINT cc_queue_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_queue_acl cc_queue_acl_object_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_acl
    ADD CONSTRAINT cc_queue_acl_object_fk FOREIGN KEY (object, dc) REFERENCES call_center.cc_queue(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_queue_acl cc_queue_acl_subject_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_acl
    ADD CONSTRAINT cc_queue_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cc_queue cc_queue_acr_routing_scheme_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_acr_routing_scheme_id_fk FOREIGN KEY (schema_id) REFERENCES flow.acr_routing_scheme(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cc_queue cc_queue_acr_routing_scheme_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_acr_routing_scheme_id_fk_2 FOREIGN KEY (after_schema_id) REFERENCES flow.acr_routing_scheme(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cc_queue cc_queue_acr_routing_scheme_id_fk_3; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_acr_routing_scheme_id_fk_3 FOREIGN KEY (do_schema_id) REFERENCES flow.acr_routing_scheme(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cc_queue cc_queue_acr_routing_scheme_id_fk_4; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_acr_routing_scheme_id_fk_4 FOREIGN KEY (form_schema_id) REFERENCES flow.acr_routing_scheme(id);


--
-- Name: cc_queue cc_queue_calendar_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_calendar_id_fk FOREIGN KEY (calendar_id) REFERENCES flow.calendar(id);


--
-- Name: cc_queue cc_queue_cc_list_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_cc_list_id_fk FOREIGN KEY (dnc_list_id) REFERENCES call_center.cc_list(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: cc_queue cc_queue_cc_team_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_cc_team_id_fk FOREIGN KEY (team_id) REFERENCES call_center.cc_team(id);


--
-- Name: cc_queue_events cc_queue_events_acr_routing_scheme_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_events
    ADD CONSTRAINT cc_queue_events_acr_routing_scheme_id_fk FOREIGN KEY (schema_id) REFERENCES flow.acr_routing_scheme(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cc_queue_events cc_queue_events_cc_queue_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_events
    ADD CONSTRAINT cc_queue_events_cc_queue_id_fk FOREIGN KEY (queue_id) REFERENCES call_center.cc_queue(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_queue cc_queue_media_files_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_media_files_id_fk FOREIGN KEY (ringtone_id) REFERENCES storage.media_files(id);


--
-- Name: cc_queue_resource cc_queue_resource_cc_outbound_resource_group_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_resource
    ADD CONSTRAINT cc_queue_resource_cc_outbound_resource_group_id_fk FOREIGN KEY (resource_group_id) REFERENCES call_center.cc_outbound_resource_group(id);


--
-- Name: cc_queue_resource cc_queue_resource_cc_queue_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_resource
    ADD CONSTRAINT cc_queue_resource_cc_queue_id_fk FOREIGN KEY (queue_id) REFERENCES call_center.cc_queue(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_queue_resource cc_queue_resource_cc_queue_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_resource
    ADD CONSTRAINT cc_queue_resource_cc_queue_id_fk_2 FOREIGN KEY (queue_id) REFERENCES call_center.cc_queue(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_queue_skill cc_queue_skill_cc_queue_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_skill
    ADD CONSTRAINT cc_queue_skill_cc_queue_id_fk FOREIGN KEY (queue_id) REFERENCES call_center.cc_queue(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_queue_skill cc_queue_skill_cc_skill_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_skill
    ADD CONSTRAINT cc_queue_skill_cc_skill_id_fk FOREIGN KEY (skill_id) REFERENCES call_center.cc_skill(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cc_queue_skill_statistics cc_queue_skill_statistics_cc_queue_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_skill_statistics
    ADD CONSTRAINT cc_queue_skill_statistics_cc_queue_id_fk FOREIGN KEY (queue_id) REFERENCES call_center.cc_queue(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_queue_skill_statistics cc_queue_skill_statistics_cc_skill_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_skill_statistics
    ADD CONSTRAINT cc_queue_skill_statistics_cc_skill_id_fk FOREIGN KEY (skill_id) REFERENCES call_center.cc_skill(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_queue_statistics cc_queue_statistics_cc_bucket_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_statistics
    ADD CONSTRAINT cc_queue_statistics_cc_bucket_id_fk FOREIGN KEY (bucket_id) REFERENCES call_center.cc_bucket(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_queue_statistics cc_queue_statistics_cc_queue_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue_statistics
    ADD CONSTRAINT cc_queue_statistics_cc_queue_id_fk FOREIGN KEY (queue_id) REFERENCES call_center.cc_queue(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_queue cc_queue_wbt_auth_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_wbt_auth_id_fk FOREIGN KEY (grantee_id) REFERENCES directory.wbt_auth(id);


--
-- Name: cc_queue cc_queue_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: cc_queue cc_queue_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_queue cc_queue_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_queue
    ADD CONSTRAINT cc_queue_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_skill_in_agent cc_skill_in_agent_cc_agent_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_skill_in_agent
    ADD CONSTRAINT cc_skill_in_agent_cc_agent_id_fk FOREIGN KEY (agent_id) REFERENCES call_center.cc_agent(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_skill_in_agent cc_skill_in_agent_cc_skils_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_skill_in_agent
    ADD CONSTRAINT cc_skill_in_agent_cc_skils_id_fk FOREIGN KEY (skill_id) REFERENCES call_center.cc_skill(id);


--
-- Name: cc_skill_in_agent cc_skill_in_agent_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_skill_in_agent
    ADD CONSTRAINT cc_skill_in_agent_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_skill_in_agent cc_skill_in_agent_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_skill_in_agent
    ADD CONSTRAINT cc_skill_in_agent_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: cc_skill cc_skill_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_skill
    ADD CONSTRAINT cc_skill_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: cc_team_acl cc_team_acl_cc_team_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team_acl
    ADD CONSTRAINT cc_team_acl_cc_team_id_fk FOREIGN KEY (object) REFERENCES call_center.cc_team(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_team_acl cc_team_acl_domain_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team_acl
    ADD CONSTRAINT cc_team_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_team_acl cc_team_acl_grantor_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team_acl
    ADD CONSTRAINT cc_team_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_team_acl cc_team_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team_acl
    ADD CONSTRAINT cc_team_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_team_acl cc_team_acl_object_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team_acl
    ADD CONSTRAINT cc_team_acl_object_fk FOREIGN KEY (object, dc) REFERENCES call_center.cc_team(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_team_acl cc_team_acl_subject_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team_acl
    ADD CONSTRAINT cc_team_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cc_team cc_team_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team
    ADD CONSTRAINT cc_team_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: cc_team cc_team_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team
    ADD CONSTRAINT cc_team_wbt_user_id_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: cc_team cc_team_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_team
    ADD CONSTRAINT cc_team_wbt_user_id_fk_2 FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: cc_trigger_acl cc_trigger_acl_cc_trigger_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_acl
    ADD CONSTRAINT cc_trigger_acl_cc_trigger_id_fk FOREIGN KEY (object) REFERENCES call_center.cc_trigger(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_trigger_acl cc_trigger_acl_domain_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_acl
    ADD CONSTRAINT cc_trigger_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cc_trigger_acl cc_trigger_acl_grantor_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_acl
    ADD CONSTRAINT cc_trigger_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_trigger_acl cc_trigger_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_acl
    ADD CONSTRAINT cc_trigger_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cc_trigger_acl cc_trigger_acl_object_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_acl
    ADD CONSTRAINT cc_trigger_acl_object_fk FOREIGN KEY (object, dc) REFERENCES call_center.cc_trigger(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cc_trigger_acl cc_trigger_acl_subject_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_acl
    ADD CONSTRAINT cc_trigger_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cc_trigger cc_trigger_acr_routing_scheme_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger
    ADD CONSTRAINT cc_trigger_acr_routing_scheme_id_fk FOREIGN KEY (schema_id) REFERENCES flow.acr_routing_scheme(id);


--
-- Name: cc_trigger cc_trigger_calendar_timezones_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger
    ADD CONSTRAINT cc_trigger_calendar_timezones_id_fk FOREIGN KEY (timezone_id) REFERENCES flow.calendar_timezones(id);


--
-- Name: cc_trigger_job cc_trigger_job_cc_trigger_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_job
    ADD CONSTRAINT cc_trigger_job_cc_trigger_id_fk FOREIGN KEY (trigger_id) REFERENCES call_center.cc_trigger(id);


--
-- Name: cc_trigger_job_log cc_trigger_job_log_cc_trigger_id_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger_job_log
    ADD CONSTRAINT cc_trigger_job_log_cc_trigger_id_fk FOREIGN KEY (trigger_id) REFERENCES call_center.cc_trigger(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cc_trigger cc_trigger_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.cc_trigger
    ADD CONSTRAINT cc_trigger_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: system_settings systemc_settings_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: call_center; Owner: -
--

ALTER TABLE ONLY call_center.system_settings
    ADD CONSTRAINT systemc_settings_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: bot bot_created_dc_fk; Type: FK CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.bot
    ADD CONSTRAINT bot_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: bot bot_created_id_fk; Type: FK CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.bot
    ADD CONSTRAINT bot_created_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: bot bot_dc_fk; Type: FK CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.bot
    ADD CONSTRAINT bot_dc_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: bot bot_flow_id_fk; Type: FK CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.bot
    ADD CONSTRAINT bot_flow_id_fk FOREIGN KEY (flow_id, dc) REFERENCES flow.acr_routing_scheme(id, domain_id);


--
-- Name: bot bot_updated_dc_fk; Type: FK CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.bot
    ADD CONSTRAINT bot_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: bot bot_updated_id_fk; Type: FK CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.bot
    ADD CONSTRAINT bot_updated_id_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: channel channel_conversation_fk; Type: FK CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.channel
    ADD CONSTRAINT channel_conversation_fk FOREIGN KEY (conversation_id) REFERENCES chat.conversation(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: invite invite_conversation_fk; Type: FK CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.invite
    ADD CONSTRAINT invite_conversation_fk FOREIGN KEY (conversation_id) REFERENCES chat.conversation(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: message message_conversation_fk; Type: FK CONSTRAINT; Schema: chat; Owner: -
--

ALTER TABLE ONLY chat.message
    ADD CONSTRAINT message_conversation_fk FOREIGN KEY (conversation_id) REFERENCES chat.conversation(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: contact_acl contact_acl_domain_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_acl
    ADD CONSTRAINT contact_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: contact_acl contact_acl_grantor_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_acl
    ADD CONSTRAINT contact_acl_grantor_dc_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_acl contact_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_acl
    ADD CONSTRAINT contact_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: contact_acl contact_acl_object_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_acl
    ADD CONSTRAINT contact_acl_object_fk FOREIGN KEY (object, dc) REFERENCES contacts.contact(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_acl contact_acl_subject_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_acl
    ADD CONSTRAINT contact_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: contact contact_created_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact contact_created_id_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_created_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact contact_deleted_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_deleted_dc_fk FOREIGN KEY (deleted_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact contact_deleted_id_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_deleted_id_fk FOREIGN KEY (deleted_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact contact_domain_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_email contact_email_created_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_email
    ADD CONSTRAINT contact_email_created_by_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_email contact_email_created_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_email
    ADD CONSTRAINT contact_email_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_email contact_email_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_email
    ADD CONSTRAINT contact_email_fk FOREIGN KEY (contact_id, dc) REFERENCES contacts.contact(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_email contact_email_type_id_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_email
    ADD CONSTRAINT contact_email_type_id_fk FOREIGN KEY (type_id) REFERENCES call_center.cc_communication(id) ON DELETE SET NULL;


--
-- Name: contact_email contact_email_updated_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_email
    ADD CONSTRAINT contact_email_updated_by_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_email contact_email_updated_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_email
    ADD CONSTRAINT contact_email_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_label contact_label_created_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_label
    ADD CONSTRAINT contact_label_created_by_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_label contact_label_created_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_label
    ADD CONSTRAINT contact_label_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_label contact_label_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_label
    ADD CONSTRAINT contact_label_fk FOREIGN KEY (contact_id, dc) REFERENCES contacts.contact(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_label contact_label_updated_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_label
    ADD CONSTRAINT contact_label_updated_by_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_label contact_label_updated_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_label
    ADD CONSTRAINT contact_label_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_manager contact_manager_created_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_manager
    ADD CONSTRAINT contact_manager_created_by_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_manager contact_manager_created_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_manager
    ADD CONSTRAINT contact_manager_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_manager contact_manager_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_manager
    ADD CONSTRAINT contact_manager_fk FOREIGN KEY (contact_id, dc) REFERENCES contacts.contact(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_manager contact_manager_updated_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_manager
    ADD CONSTRAINT contact_manager_updated_by_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_manager contact_manager_updated_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_manager
    ADD CONSTRAINT contact_manager_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_manager contact_manager_user_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_manager
    ADD CONSTRAINT contact_manager_user_fk FOREIGN KEY (user_id, dc) REFERENCES directory.wbt_user(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_phone contact_phone_created_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_phone
    ADD CONSTRAINT contact_phone_created_by_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_phone contact_phone_created_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_phone
    ADD CONSTRAINT contact_phone_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_phone contact_phone_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_phone
    ADD CONSTRAINT contact_phone_fk FOREIGN KEY (contact_id, dc) REFERENCES contacts.contact(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_phone contact_phone_type_id_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_phone
    ADD CONSTRAINT contact_phone_type_id_fk FOREIGN KEY (type_id) REFERENCES call_center.cc_communication(id) ON DELETE SET NULL;


--
-- Name: contact_phone contact_phone_updated_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_phone
    ADD CONSTRAINT contact_phone_updated_by_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_phone contact_phone_updated_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_phone
    ADD CONSTRAINT contact_phone_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact contact_source_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_source_fk FOREIGN KEY (contact_id) REFERENCES contacts.contact(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_timezone contact_timezone_created_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_timezone
    ADD CONSTRAINT contact_timezone_created_by_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_timezone contact_timezone_created_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_timezone
    ADD CONSTRAINT contact_timezone_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_timezone contact_timezone_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_timezone
    ADD CONSTRAINT contact_timezone_fk FOREIGN KEY (contact_id, dc) REFERENCES contacts.contact(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_timezone contact_timezone_timezone_id_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_timezone
    ADD CONSTRAINT contact_timezone_timezone_id_fk FOREIGN KEY (timezone_id) REFERENCES flow.calendar_timezones(id);


--
-- Name: contact_timezone contact_timezone_updated_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_timezone
    ADD CONSTRAINT contact_timezone_updated_by_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_timezone contact_timezone_updated_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_timezone
    ADD CONSTRAINT contact_timezone_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact contact_updated_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact contact_updated_id_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact
    ADD CONSTRAINT contact_updated_id_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_variable contact_variable_created_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_variable
    ADD CONSTRAINT contact_variable_created_by_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_variable contact_variable_created_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_variable
    ADD CONSTRAINT contact_variable_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_variable contact_variable_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_variable
    ADD CONSTRAINT contact_variable_fk FOREIGN KEY (contact_id, dc) REFERENCES contacts.contact(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_variable contact_variable_updated_by_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_variable
    ADD CONSTRAINT contact_variable_updated_by_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: contact_variable contact_variable_updated_dc_fk; Type: FK CONSTRAINT; Schema: contacts; Owner: -
--

ALTER TABLE ONLY contacts.contact_variable
    ADD CONSTRAINT contact_variable_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_hotdesk hotdesk_device_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_hotdesk
    ADD CONSTRAINT hotdesk_device_id_fk FOREIGN KEY (device_id, dc) REFERENCES directory.wbt_device(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: license license_user_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.license
    ADD CONSTRAINT license_user_id_fk FOREIGN KEY (user_id) REFERENCES directory.wbt_user(id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: sip_gateway sip_gateway_created_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway
    ADD CONSTRAINT sip_gateway_created_by_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: sip_gateway sip_gateway_created_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway
    ADD CONSTRAINT sip_gateway_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: sip_gateway sip_gateway_domain_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway
    ADD CONSTRAINT sip_gateway_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- Name: sip_gateway_allow sip_gateway_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway_allow
    ADD CONSTRAINT sip_gateway_id_fk FOREIGN KEY (id) REFERENCES directory.sip_gateway(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- Name: sip_gateway_register sip_gateway_register_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway_register
    ADD CONSTRAINT sip_gateway_register_id_fk FOREIGN KEY (id) REFERENCES directory.sip_gateway(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: sip_gateway sip_gateway_scheme_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway
    ADD CONSTRAINT sip_gateway_scheme_dc_fk FOREIGN KEY (scheme_id, dc) REFERENCES flow.acr_routing_scheme(id, domain_id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: sip_gateway sip_gateway_scheme_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway
    ADD CONSTRAINT sip_gateway_scheme_id_fk FOREIGN KEY (scheme_id) REFERENCES flow.acr_routing_scheme(id) ON DELETE SET NULL;


--
-- Name: sip_gateway sip_gateway_updated_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway
    ADD CONSTRAINT sip_gateway_updated_by_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: sip_gateway sip_gateway_updated_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.sip_gateway
    ADD CONSTRAINT sip_gateway_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_auth_acl wbt_auth_acl_domain_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth_acl
    ADD CONSTRAINT wbt_auth_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_auth_acl wbt_auth_acl_grantor_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth_acl
    ADD CONSTRAINT wbt_auth_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_auth_acl wbt_auth_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth_acl
    ADD CONSTRAINT wbt_auth_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_auth_acl wbt_auth_acl_object_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth_acl
    ADD CONSTRAINT wbt_auth_acl_object_fk FOREIGN KEY (object, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_auth_acl wbt_auth_acl_subject_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth_acl
    ADD CONSTRAINT wbt_auth_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_auth wbt_auth_created_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth
    ADD CONSTRAINT wbt_auth_created_by_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: wbt_auth wbt_auth_created_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth
    ADD CONSTRAINT wbt_auth_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_auth wbt_auth_deleted_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth
    ADD CONSTRAINT wbt_auth_deleted_by_fk FOREIGN KEY (deleted_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: wbt_auth wbt_auth_deleted_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth
    ADD CONSTRAINT wbt_auth_deleted_dc_fk FOREIGN KEY (deleted_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_auth wbt_auth_domain_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth
    ADD CONSTRAINT wbt_auth_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_auth_member wbt_auth_member_role_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth_member
    ADD CONSTRAINT wbt_auth_member_role_id_fk FOREIGN KEY (role_id, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_auth_member wbt_auth_member_user_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth_member
    ADD CONSTRAINT wbt_auth_member_user_fk FOREIGN KEY (member_id, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_auth wbt_auth_updated_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth
    ADD CONSTRAINT wbt_auth_updated_by_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: wbt_auth wbt_auth_updated_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth
    ADD CONSTRAINT wbt_auth_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_class_acl wbt_class_acl_domain_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_class_acl
    ADD CONSTRAINT wbt_class_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_class_acl wbt_class_acl_grantor_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_class_acl
    ADD CONSTRAINT wbt_class_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_class_acl wbt_class_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_class_acl
    ADD CONSTRAINT wbt_class_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_class_acl wbt_class_acl_object_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_class_acl
    ADD CONSTRAINT wbt_class_acl_object_fk FOREIGN KEY (object, dc) REFERENCES directory.wbt_class(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_class_acl wbt_class_acl_subject_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_class_acl
    ADD CONSTRAINT wbt_class_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: wbt_class wbt_class_domain_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_class
    ADD CONSTRAINT wbt_class_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_default_acl wbt_default_acl_domain_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_default_acl
    ADD CONSTRAINT wbt_default_acl_domain_dc_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_default_acl wbt_default_acl_grantee_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_default_acl
    ADD CONSTRAINT wbt_default_acl_grantee_dc_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: wbt_default_acl wbt_default_acl_grantor_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_default_acl
    ADD CONSTRAINT wbt_default_acl_grantor_dc_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: wbt_default_acl wbt_default_acl_object_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_default_acl
    ADD CONSTRAINT wbt_default_acl_object_dc_fk FOREIGN KEY (object, dc) REFERENCES directory.wbt_class(id, dc) ON DELETE CASCADE;


--
-- Name: wbt_device_acl wbt_device_acl_domain_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_acl
    ADD CONSTRAINT wbt_device_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_device_acl wbt_device_acl_grantor_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_acl
    ADD CONSTRAINT wbt_device_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device_acl wbt_device_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_acl
    ADD CONSTRAINT wbt_device_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_device_acl wbt_device_acl_object_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_acl
    ADD CONSTRAINT wbt_device_acl_object_fk FOREIGN KEY (object, dc) REFERENCES directory.wbt_device(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device_acl wbt_device_acl_subject_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_acl
    ADD CONSTRAINT wbt_device_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: wbt_device_audit wbt_device_audit_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_audit
    ADD CONSTRAINT wbt_device_audit_dc_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_device_audit wbt_device_audit_device_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_audit
    ADD CONSTRAINT wbt_device_audit_device_dc_fk FOREIGN KEY (device_id, dc) REFERENCES directory.wbt_device(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device_audit wbt_device_audit_device_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_audit
    ADD CONSTRAINT wbt_device_audit_device_id_fk FOREIGN KEY (device_id) REFERENCES directory.wbt_device(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device_audit wbt_device_audit_user_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_audit
    ADD CONSTRAINT wbt_device_audit_user_dc_fk FOREIGN KEY (user_id, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device_audit wbt_device_audit_user_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device_audit
    ADD CONSTRAINT wbt_device_audit_user_id_fk FOREIGN KEY (user_id) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device wbt_device_created_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device wbt_device_created_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_created_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device wbt_device_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_dc_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_device wbt_device_deleted_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_deleted_dc_fk FOREIGN KEY (deleted_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device wbt_device_deleted_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_deleted_id_fk FOREIGN KEY (deleted_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: wbt_device wbt_device_updated_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device wbt_device_updated_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_updated_id_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device wbt_device_user_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_user_dc_fk FOREIGN KEY (user_id, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_device wbt_device_user_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_device
    ADD CONSTRAINT wbt_device_user_id_fk FOREIGN KEY (user_id) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_auth_member wbt_domain_auth_member_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_auth_member
    ADD CONSTRAINT wbt_domain_auth_member_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_domain wbt_domain_calendar_timezones_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_domain
    ADD CONSTRAINT wbt_domain_calendar_timezones_id_fk FOREIGN KEY (timezone_id) REFERENCES flow.calendar_timezones(id);


--
-- Name: wbt_domain wbt_domain_cert_serial_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_domain
    ADD CONSTRAINT wbt_domain_cert_serial_fk FOREIGN KEY (customer_id) REFERENCES directory.wbt_customer(id) ON UPDATE CASCADE ON DELETE RESTRICT DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_ldap wbt_ldap_created_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap
    ADD CONSTRAINT wbt_ldap_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_ldap wbt_ldap_created_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap
    ADD CONSTRAINT wbt_ldap_created_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_ldap wbt_ldap_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap
    ADD CONSTRAINT wbt_ldap_dc_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_ldap_proc wbt_ldap_proc_auth_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_proc
    ADD CONSTRAINT wbt_ldap_proc_auth_id_fk FOREIGN KEY (execute_by) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_ldap_proc wbt_ldap_proc_catalog_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_proc
    ADD CONSTRAINT wbt_ldap_proc_catalog_id_fk FOREIGN KEY (catalog_id) REFERENCES directory.wbt_ldap(id) ON DELETE CASCADE;


--
-- Name: wbt_ldap_sync wbt_ldap_sync_catalog_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_sync
    ADD CONSTRAINT wbt_ldap_sync_catalog_id_fk FOREIGN KEY (template_id, catalog_id) REFERENCES directory.wbt_ldap_tmpl(id, catalog_id);


--
-- Name: wbt_ldap_sync wbt_ldap_sync_process_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_sync
    ADD CONSTRAINT wbt_ldap_sync_process_id_fk FOREIGN KEY (process_id, catalog_id) REFERENCES directory.wbt_ldap_proc(id, catalog_id) ON DELETE CASCADE;


--
-- Name: wbt_ldap_sync wbt_ldap_sync_template_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_sync
    ADD CONSTRAINT wbt_ldap_sync_template_id_fk FOREIGN KEY (template_id) REFERENCES directory.wbt_ldap_tmpl(id) ON DELETE SET NULL;


--
-- Name: wbt_ldap_tmpl wbt_ldap_tmpl_catalog_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_tmpl
    ADD CONSTRAINT wbt_ldap_tmpl_catalog_id_fk FOREIGN KEY (catalog_id) REFERENCES directory.wbt_ldap(id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_ldap_tmpl wbt_ldap_tmpl_created_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_tmpl
    ADD CONSTRAINT wbt_ldap_tmpl_created_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_ldap_tmpl wbt_ldap_tmpl_updated_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap_tmpl
    ADD CONSTRAINT wbt_ldap_tmpl_updated_id_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_ldap wbt_ldap_updated_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap
    ADD CONSTRAINT wbt_ldap_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_ldap wbt_ldap_updated_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_ldap
    ADD CONSTRAINT wbt_ldap_updated_id_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_oauth_service wbt_oauth_service_created_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_oauth_service
    ADD CONSTRAINT wbt_oauth_service_created_by_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_oauth_service wbt_oauth_service_created_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_oauth_service
    ADD CONSTRAINT wbt_oauth_service_created_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_oauth_service wbt_oauth_service_domain_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_oauth_service
    ADD CONSTRAINT wbt_oauth_service_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_oauth_service wbt_oauth_service_updated_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_oauth_service
    ADD CONSTRAINT wbt_oauth_service_updated_by_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_oauth_service wbt_oauth_service_updated_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_oauth_service
    ADD CONSTRAINT wbt_oauth_service_updated_id_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: wbt_session wbt_session_auth_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_session
    ADD CONSTRAINT wbt_session_auth_id_fk FOREIGN KEY (user_id, domain_id) REFERENCES directory.wbt_user(id, dc) ON DELETE CASCADE;


--
-- Name: wbt_session wbt_session_domain_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_session
    ADD CONSTRAINT wbt_session_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user_socket wbt_socket_user_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_socket
    ADD CONSTRAINT wbt_socket_user_id_fk FOREIGN KEY (user_id) REFERENCES directory.wbt_user(id) ON DELETE CASCADE;


--
-- Name: wbt_user wbt_user_auth_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_auth_id_fk FOREIGN KEY (id, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user wbt_user_created_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_created_dc_fk FOREIGN KEY (created_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user wbt_user_created_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_created_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: wbt_user wbt_user_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_dc_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: wbt_user wbt_user_deleted_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_deleted_dc_fk FOREIGN KEY (deleted_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user wbt_user_deleted_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_deleted_id_fk FOREIGN KEY (deleted_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: wbt_user wbt_user_device_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_device_id_fk FOREIGN KEY (device_id, id, dc) REFERENCES directory.wbt_device(id, user_id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user wbt_user_device_id_ref; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_device_id_ref FOREIGN KEY (device_id) REFERENCES directory.wbt_device(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user_presence wbt_user_presence_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_presence
    ADD CONSTRAINT wbt_user_presence_id_fk FOREIGN KEY (user_id) REFERENCES directory.wbt_user(id) ON DELETE CASCADE;


--
-- Name: wbt_user_setting wbt_user_setting_wbt_auth_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_setting
    ADD CONSTRAINT wbt_user_setting_wbt_auth_id_fk FOREIGN KEY (user_id) REFERENCES directory.wbt_auth(id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user_status wbt_user_status_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_status
    ADD CONSTRAINT wbt_user_status_id_fk FOREIGN KEY (user_id) REFERENCES directory.wbt_user(id) ON DELETE CASCADE;


--
-- Name: wbt_user_token wbt_user_token_created_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_token
    ADD CONSTRAINT wbt_user_token_created_by_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user_token wbt_user_token_disabled_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_token
    ADD CONSTRAINT wbt_user_token_disabled_by_fk FOREIGN KEY (deleted_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: wbt_user_token wbt_user_token_domain_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_token
    ADD CONSTRAINT wbt_user_token_domain_id_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user_token wbt_user_token_owner_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_token
    ADD CONSTRAINT wbt_user_token_owner_id_fk FOREIGN KEY (user_id, dc) REFERENCES directory.wbt_user(id, dc) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user_token wbt_user_token_updated_by_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user_token
    ADD CONSTRAINT wbt_user_token_updated_by_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user wbt_user_updated_dc_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_updated_dc_fk FOREIGN KEY (updated_by, dc) REFERENCES directory.wbt_user(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: wbt_user wbt_user_updated_id_fk; Type: FK CONSTRAINT; Schema: directory; Owner: -
--

ALTER TABLE ONLY directory.wbt_user
    ADD CONSTRAINT wbt_user_updated_id_fk FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: acr_chat_plan acr_chat_plan_acr_routing_scheme_id_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_chat_plan
    ADD CONSTRAINT acr_chat_plan_acr_routing_scheme_id_fk FOREIGN KEY (schema_id) REFERENCES flow.acr_routing_scheme(id);


--
-- Name: acr_routing_outbound_call acr_routing_outbound_call_acr_routing_scheme_id_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_outbound_call
    ADD CONSTRAINT acr_routing_outbound_call_acr_routing_scheme_id_fk FOREIGN KEY (scheme_id) REFERENCES flow.acr_routing_scheme(id);


--
-- Name: acr_routing_outbound_call acr_routing_outbound_call_acr_routing_scheme_id_fk_2; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_outbound_call
    ADD CONSTRAINT acr_routing_outbound_call_acr_routing_scheme_id_fk_2 FOREIGN KEY (scheme_id) REFERENCES flow.acr_routing_scheme(id);


--
-- Name: acr_routing_outbound_call acr_routing_outbound_call_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_outbound_call
    ADD CONSTRAINT acr_routing_outbound_call_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: acr_routing_outbound_call acr_routing_outbound_call_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_outbound_call
    ADD CONSTRAINT acr_routing_outbound_call_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: acr_routing_outbound_call acr_routing_outbound_call_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_outbound_call
    ADD CONSTRAINT acr_routing_outbound_call_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: acr_routing_scheme acr_routing_scheme_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_scheme
    ADD CONSTRAINT acr_routing_scheme_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: acr_routing_scheme acr_routing_scheme_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_scheme
    ADD CONSTRAINT acr_routing_scheme_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: acr_routing_scheme acr_routing_scheme_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_scheme
    ADD CONSTRAINT acr_routing_scheme_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: acr_routing_variables acr_routing_variables_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.acr_routing_variables
    ADD CONSTRAINT acr_routing_variables_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: calendar_acl calendar_acl_domain_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_acl
    ADD CONSTRAINT calendar_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: calendar_acl calendar_acl_grantor_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_acl
    ADD CONSTRAINT calendar_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: calendar_acl calendar_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_acl
    ADD CONSTRAINT calendar_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: calendar_acl calendar_acl_object_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_acl
    ADD CONSTRAINT calendar_acl_object_fk FOREIGN KEY (object, dc) REFERENCES flow.calendar(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: calendar_acl calendar_acl_subject_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar_acl
    ADD CONSTRAINT calendar_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: calendar calendar_calendar_timezones_id_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar
    ADD CONSTRAINT calendar_calendar_timezones_id_fk FOREIGN KEY (timezone_id) REFERENCES flow.calendar_timezones(id);


--
-- Name: calendar calendar_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar
    ADD CONSTRAINT calendar_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc);


--
-- Name: calendar calendar_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar
    ADD CONSTRAINT calendar_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: calendar calendar_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.calendar
    ADD CONSTRAINT calendar_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON DELETE SET NULL;


--
-- Name: region region_calendar_timezones_id_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.region
    ADD CONSTRAINT region_calendar_timezones_id_fk FOREIGN KEY (timezone_id) REFERENCES flow.calendar_timezones(id);


--
-- Name: region region_wbt_domain_dc_fk; Type: FK CONSTRAINT; Schema: flow; Owner: -
--

ALTER TABLE ONLY flow.region
    ADD CONSTRAINT region_wbt_domain_dc_fk FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: log log_config_id_fkey; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.log
    ADD CONSTRAINT log_config_id_fkey FOREIGN KEY (config_id) REFERENCES logger.object_config(id) ON DELETE CASCADE;


--
-- Name: object_config_acl object_config_acl_domain_fk; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config_acl
    ADD CONSTRAINT object_config_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: object_config_acl object_config_acl_grantor_fk; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config_acl
    ADD CONSTRAINT object_config_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: object_config_acl object_config_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config_acl
    ADD CONSTRAINT object_config_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: object_config_acl object_config_acl_object_config_id_fk; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config_acl
    ADD CONSTRAINT object_config_acl_object_config_id_fk FOREIGN KEY (object) REFERENCES logger.object_config(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: object_config_acl object_config_acl_object_fk; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config_acl
    ADD CONSTRAINT object_config_acl_object_fk FOREIGN KEY (object, dc) REFERENCES logger.object_config(id, domain_id) ON DELETE CASCADE;


--
-- Name: object_config_acl object_config_acl_subject_fk; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config_acl
    ADD CONSTRAINT object_config_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: object_config object_config_domain_id_fkey; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config
    ADD CONSTRAINT object_config_domain_id_fkey FOREIGN KEY (domain_id) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: object_config object_config_storage_id_fkey; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config
    ADD CONSTRAINT object_config_storage_id_fkey FOREIGN KEY (storage_id) REFERENCES storage.file_backend_profiles(id);


--
-- Name: object_config object_config_wbt_class_id_fk; Type: FK CONSTRAINT; Schema: logger; Owner: -
--

ALTER TABLE ONLY logger.object_config
    ADD CONSTRAINT object_config_wbt_class_id_fk FOREIGN KEY (object_id) REFERENCES directory.wbt_class(id);


--
-- Name: log log_config_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.log
    ADD CONSTRAINT log_config_id_fkey FOREIGN KEY (config_id) REFERENCES logger.object_config(id) ON DELETE CASCADE;


--
-- Name: file_backend_profiles_acl file_backend_profiles_acl_domain_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_backend_profiles_acl
    ADD CONSTRAINT file_backend_profiles_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: file_backend_profiles_acl file_backend_profiles_acl_grantor_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_backend_profiles_acl
    ADD CONSTRAINT file_backend_profiles_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: file_backend_profiles_acl file_backend_profiles_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_backend_profiles_acl
    ADD CONSTRAINT file_backend_profiles_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: file_backend_profiles_acl file_backend_profiles_acl_object_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_backend_profiles_acl
    ADD CONSTRAINT file_backend_profiles_acl_object_fk FOREIGN KEY (object, dc) REFERENCES storage.file_backend_profiles(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: file_backend_profiles_acl file_backend_profiles_acl_subject_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_backend_profiles_acl
    ADD CONSTRAINT file_backend_profiles_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: cognitive_profile_services_acl file_cognitive_profile_services_acl_domain_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.cognitive_profile_services_acl
    ADD CONSTRAINT file_cognitive_profile_services_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: cognitive_profile_services_acl file_cognitive_profile_services_acl_grantor_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.cognitive_profile_services_acl
    ADD CONSTRAINT file_cognitive_profile_services_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cognitive_profile_services_acl file_cognitive_profile_services_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.cognitive_profile_services_acl
    ADD CONSTRAINT file_cognitive_profile_services_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: cognitive_profile_services_acl file_cognitive_profile_services_acl_object_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.cognitive_profile_services_acl
    ADD CONSTRAINT file_cognitive_profile_services_acl_object_fk FOREIGN KEY (object, dc) REFERENCES storage.cognitive_profile_services(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: cognitive_profile_services_acl file_cognitive_profile_services_acl_subject_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.cognitive_profile_services_acl
    ADD CONSTRAINT file_cognitive_profile_services_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: file_transcript file_transcript_cognitive_profile_services_id_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_transcript
    ADD CONSTRAINT file_transcript_cognitive_profile_services_id_fk FOREIGN KEY (profile_id) REFERENCES storage.cognitive_profile_services(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: file_transcript file_transcript_files_id_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.file_transcript
    ADD CONSTRAINT file_transcript_files_id_fk FOREIGN KEY (file_id) REFERENCES storage.files(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: import_template_acl import_template_acl_domain_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template_acl
    ADD CONSTRAINT import_template_acl_domain_fk FOREIGN KEY (dc) REFERENCES directory.wbt_domain(dc) ON DELETE CASCADE;


--
-- Name: import_template_acl import_template_acl_grantor_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template_acl
    ADD CONSTRAINT import_template_acl_grantor_fk FOREIGN KEY (grantor, dc) REFERENCES directory.wbt_auth(id, dc) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: import_template_acl import_template_acl_grantor_id_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template_acl
    ADD CONSTRAINT import_template_acl_grantor_id_fk FOREIGN KEY (grantor) REFERENCES directory.wbt_auth(id) ON DELETE SET NULL;


--
-- Name: import_template_acl import_template_acl_import_template_id_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template_acl
    ADD CONSTRAINT import_template_acl_import_template_id_fk FOREIGN KEY (object) REFERENCES storage.import_template(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: import_template_acl import_template_acl_object_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template_acl
    ADD CONSTRAINT import_template_acl_object_fk FOREIGN KEY (object, dc) REFERENCES storage.import_template(id, domain_id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;


--
-- Name: import_template_acl import_template_acl_subject_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.import_template_acl
    ADD CONSTRAINT import_template_acl_subject_fk FOREIGN KEY (subject, dc) REFERENCES directory.wbt_auth(id, dc) ON DELETE CASCADE;


--
-- Name: media_files media_files_wbt_user_id_fk; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.media_files
    ADD CONSTRAINT media_files_wbt_user_id_fk FOREIGN KEY (created_by) REFERENCES directory.wbt_user(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: media_files media_files_wbt_user_id_fk_2; Type: FK CONSTRAINT; Schema: storage; Owner: -
--

ALTER TABLE ONLY storage.media_files
    ADD CONSTRAINT media_files_wbt_user_id_fk_2 FOREIGN KEY (updated_by) REFERENCES directory.wbt_user(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

-- 23.12.1 (email && task_count)

--
-- Name: cc_array_to_string(text[], text); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE or replace FUNCTION call_center.cc_array_to_string(text[], text) RETURNS text
    LANGUAGE sql IMMUTABLE
    AS $_$SELECT array_to_string($1, $2)$_$;



drop PROCEDURE call_center.cc_distribute;
--
-- Name: cc_distribute(boolean); Type: PROCEDURE; Schema: call_center; Owner: -
--

CREATE PROCEDURE call_center.cc_distribute(IN disable_omnichannel boolean)
    LANGUAGE plpgsql
    AS $$
begin
    if NOT pg_try_advisory_xact_lock(132132117) then
        raise exception 'LOCK';
    end if;

    with dis as MATERIALIZED (
        select x.*, a.team_id
        from call_center.cc_sys_distribute(disable_omnichannel) x (agent_id int, queue_id int, bucket_id int, ins bool, id int8, resource_id int,
                                                                   resource_group_id int, comm_idx int)
                 left join call_center.cc_agent a on a.id= x.agent_id
    )
       , ins as (
        insert into call_center.cc_member_attempt (channel, member_id, queue_id, resource_id, agent_id, bucket_id, destination,
                                                   communication_idx, member_call_id, team_id, resource_group_id, domain_id, import_id, sticky_agent_id)
            select case when q.type = 7 then 'task' else 'call' end, --todo
                   dis.id,
                   dis.queue_id,
                   dis.resource_id,
                   dis.agent_id,
                   dis.bucket_id,
                   x,
                   dis.comm_idx,
                   uuid_generate_v4(),
                   dis.team_id,
                   dis.resource_group_id,
                   q.domain_id,
                   m.import_id,
                   case when q.type = 5 and q.sticky_agent then dis.agent_id end
            from dis
                     inner join call_center.cc_queue q on q.id = dis.queue_id
                     inner join call_center.cc_member m on m.id = dis.id
                     inner join lateral jsonb_extract_path(m.communications, (dis.comm_idx)::text) x on true
            where dis.ins
    )
    update call_center.cc_member_attempt a
    set agent_id = t.agent_id,
        team_id = t.team_id
    from (
             select dis.id, dis.agent_id, dis.team_id
             from dis
                inner join call_center.cc_agent a on a.id = dis.agent_id
                left join call_center.cc_queue q on q.id = dis.queue_id
             where not dis.ins is true
                and (q.type is null or q.type in (6, 7) or not exists(select 1 from call_center.cc_calls cc where cc.user_id = a.user_id and cc.hangup_at isnull ))
         ) t
    where t.id = a.id
      and a.agent_id isnull;

end;
$$;



--
-- Name: cc_set_agent_channel_change_status(); Type: FUNCTION; Schema: call_center; Owner: -
--

CREATE or replace FUNCTION call_center.cc_set_agent_channel_change_status() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
        -- FIXME
    if TG_OP = 'INSERT' then
        return new;
    end if;
  if new.online != old.online and new.state = 'waiting' then
      new.joined_at := now();
      if new.online then
          return new;
      end if;
  end if;

  --
  if new.state = 'waiting' then
      new.lose_attempt = 0;
      new.queue_id := null;
      new.attempt_id := null;
  end if;

  --fixme error when agent set offline/pause in active call
  if new.joined_at - old.joined_at = interval '0' then
        return new;
  end if;

  new.channel_changed_at = now();

  insert into call_center.cc_agent_state_history (agent_id, joined_at, state, channel, duration, queue_id, attempt_id)
  values (old.agent_id, old.joined_at, old.state, old.channel, new.joined_at - old.joined_at, old.queue_id, old.attempt_id);

  RETURN new;
END;
$$;

alter table call_center.cc_agent add column task_count smallint DEFAULT 1 NOT NULL;


drop VIEW call_center.cc_agent_list;
CREATE VIEW call_center.cc_agent_list AS
 SELECT a.domain_id,
    a.id,
    (COALESCE(((ct.name)::character varying)::name, (ct.username COLLATE "default")))::character varying AS name,
    a.status,
    a.description,
    ((date_part('epoch'::text, a.last_state_change) * (1000)::double precision))::bigint AS last_status_change,
    (date_part('epoch'::text, (now() - a.last_state_change)))::bigint AS status_duration,
    a.progressive_count,
    ch.x AS channel,
    (json_build_object('id', ct.id, 'name', COALESCE(((ct.name)::character varying)::name, ct.username)))::jsonb AS "user",
    call_center.cc_get_lookup((a.greeting_media_id)::bigint, g.name) AS greeting_media,
    a.allow_channels,
    a.chat_count,
    ( SELECT jsonb_agg(sag."user") AS jsonb_agg
           FROM call_center.cc_agent_with_user sag
          WHERE (sag.id = ANY (a.supervisor_ids))) AS supervisor,
    ( SELECT jsonb_agg(call_center.cc_get_lookup(aud.id, (COALESCE(aud.name, (aud.username)::text))::character varying)) AS jsonb_agg
           FROM directory.wbt_user aud
          WHERE (aud.id = ANY (a.auditor_ids))) AS auditor,
    call_center.cc_get_lookup(t.id, t.name) AS team,
    call_center.cc_get_lookup((r.id)::bigint, r.name) AS region,
    a.supervisor AS is_supervisor,
    ( SELECT jsonb_agg(call_center.cc_get_lookup((sa.skill_id)::bigint, cs.name)) AS jsonb_agg
           FROM (call_center.cc_skill_in_agent sa
             JOIN call_center.cc_skill cs ON ((sa.skill_id = cs.id)))
          WHERE (sa.agent_id = a.id)) AS skills,
    a.team_id,
    a.region_id,
    a.supervisor_ids,
    a.auditor_ids,
    a.user_id,
    ct.extension,
    a.task_count
   FROM (((((call_center.cc_agent a
     LEFT JOIN directory.wbt_user ct ON ((ct.id = a.user_id)))
     LEFT JOIN storage.media_files g ON ((g.id = a.greeting_media_id)))
     LEFT JOIN call_center.cc_team t ON ((t.id = a.team_id)))
     LEFT JOIN flow.region r ON ((r.id = a.region_id)))
     LEFT JOIN LATERAL ( SELECT jsonb_agg(json_build_object('channel', c.channel, 'online', true, 'state', c.state, 'joined_at', ((date_part('epoch'::text, c.joined_at) * (1000)::double precision))::bigint)) AS x
           FROM call_center.cc_agent_channel c
          WHERE (c.agent_id = a.id)) ch ON (true));

alter table call_center.cc_email_profile add column token jsonb;

drop VIEW call_center.cc_email_profile_list;
CREATE VIEW call_center.cc_email_profile_list AS
 SELECT t.id,
    t.domain_id,
    call_center.cc_view_timestamp(t.created_at) AS created_at,
    call_center.cc_get_lookup(t.created_by, (cc.name)::character varying) AS created_by,
    call_center.cc_view_timestamp(t.updated_at) AS updated_at,
    call_center.cc_get_lookup(t.updated_by, (cu.name)::character varying) AS updated_by,
    call_center.cc_view_timestamp(t.last_activity_at) AS activity_at,
    t.name,
    t.imap_host,
    t.smtp_host,
    t.login,
    t.mailbox,
    t.smtp_port,
    t.imap_port,
    t.fetch_err AS fetch_error,
    t.fetch_interval,
    t.state,
    call_center.cc_get_lookup((t.flow_id)::bigint, s.name) AS schema,
    t.description,
    t.enabled,
    t.password,
    t.listen,
    (((t.token ->> 'expiry'::text) IS NOT NULL) AND ((t.token ->> 'access_token'::text) IS NOT NULL)) AS logged
   FROM (((call_center.cc_email_profile t
     LEFT JOIN directory.wbt_user cc ON ((cc.id = t.created_by)))
     LEFT JOIN directory.wbt_user cu ON ((cu.id = t.updated_by)))
     LEFT JOIN flow.acr_routing_scheme s ON ((s.id = t.flow_id)));


